/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Date;
import java.util.Locale;
import javax.swing.*;
import static DataEntryPrograms.SpreadSheet.dataentryframe;
import static DataEntryPrograms.DotingEntry.tablenameidentifier;

import static DataEntryPrograms.DotingEntry.FILESEPERATOR;

import static DataEntryPrograms.DotingEntry.ChosenNetDriveLetter;

import static DataEntryPrograms.DotingEntry.OPERATINGSYSTEM;
import static DataEntryPrograms.DotingEntry.HOME_EDITION;
import static DataEntryPrograms.DotingEntry.WINDOWS;
/*
 * WIRING DIAGRAM :
 *
 * Class Name : DataSheet
 * Methods : Look in Class definition
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class contains methods that display a Data Sheet of tables for data entry.
 * You choose one of these tables from a Choice Sheet and it pops up a SpreadSheet containing data rows for
 * the chosen table if any. From the SpreadSheet you choose an Action Edit or Add which pops up a data sheet
 * to make data entry/editings more convenient
 *
 * Technical References : 
 *
 * Musical Accompanyments : The Jimi Hendrix Experience -- Electric LadyLand.
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modified : 16th October 2011
 * Last Modifications : declared antoerh variable nextrow and set it in all Data Sheets
   String nextrow = null;
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class DataSheet {

    static JPanel datasheetpanel = null;
    JButton doneButton = new JButton ("DONE");
    GridBagConstraints constraints = new GridBagConstraints ();
    static JTextField tf1, tf2, tf3, tf4, tf5, tf6, tf7, tf8, tf9 = null;
   
    static JComboBox combo1, combo2, combo3, combo4 = null;
    static String [] tablenos =
    { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17" };
    static String nextrow = String.valueOf(SpreadSheet.cells.length);
    JLabel legends = new JLabel ("Color Legends: Green--> Valid Data, Red--> Maybe Erroneous Data,  Grey--> Data Not Validated");
    JLabel sheettitle = new JLabel(SpreadSheet.chosen_action + "ing" + " Table:" 
                   + SpreadSheet.chosen_table);    
    SpreadSheet dummy;
    static String usefont = null;
/*
 * WIRING DIAGRAM :
 * Constructor Name : public DataSheet (String p_table)
 * Parameters : None
 * Returns : None
 * Chained Methods : GridBagConstraints setConstraints (int X, int Y, int W, int H)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This constructor sets the size of the datasheetpanel which is the JPanel component
 * used to display a data sheet and depending on the table the user chose from the Choice Sheet contained
 * in chosen_table the constructor calls the appropriate DataSheet* () method to display that specific data
 * sheet for the chosen_table and at the very end calls System.gc(0 to clean up the garbage.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : Added this one line of code
          datasheetpanel.setVisible(true);
 *
 * Last Modification Date : July 5th 2012
 * Last Modifications : In all the DataSheets earlier I was adding an InputMethodListener implemented
 * using TxtFldLsnr.java. I have replaced all that by adding two listeners for each of the form field
 * in all DataSheets. Now for each form field there is addActionListener and addMouseListener as in the
 * sample code below.
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
 *
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    public DataSheet (String p_table){

          Insets insets = dataentryframe.getInsets();
          int X = dataentryframe.getX() + insets.left , Y = dataentryframe.getY() + insets.top,
              W = DotingEntry.DEFAULT_WIDTH - insets.left - insets.right,
              H = DotingEntry.DEFAULT_HEIGHT - insets.top - insets.bottom;
          
          
          if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
               nextrow = SpreadSheet.cells == null || SpreadSheet.cells[0][0] == null
                       ? "0" : String.valueOf(SpreadSheet.cells.length);
          else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
               nextrow = SpreadSheet.table.getSelectedRow() + " ".trim();

          legends.setForeground(Color.BLUE);
          
          datasheetpanel = datasheetpanel == null ? new JPanel (new GridBagLayout ()):datasheetpanel;
          
          datasheetpanel.setSize(new Dimension(W,H));
          datasheetpanel.setPreferredSize(new Dimension (W,H));
          datasheetpanel.setMinimumSize(new Dimension (W,H));
          datasheetpanel.setMaximumSize(new Dimension(W+3, H+3));
          datasheetpanel.setVisible(true);
          
          if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
          {
              
              DataSheetFileTableDataFileMap ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
          {
              DataSheetDefaultAdvertisingImages ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
          {
              DataSheetLanguageSupport ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
          {
              DataSheetLanguageTitles ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
          {
              DataSheetLanguageTransalations ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
          {
              DataSheetPaymentType ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
          {
              DataSheetPictureDatabase ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
          {
              DataSheetPictureOptions ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
          {
              DataSheetSearchDatabase ();
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("celebritytable"))
          {
              DataSheetCelebrityTable ();
          }
          
          System.gc();
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetFileTableDataFileMap ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * Last Modification Date : 16th June 2012
 * Last Modifications : Made some minor changes marked as 16th June 2012
 * Added the following patch of code to serve the user with a data file name
       defa_de_file = DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
        + tablenameidentifier[Integer.parseInt((String)combo1.getSelectedItem())][1].toLowerCase()
        + "_de" + ".de";  // Added on 16th June 2012
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetFileTableDataFileMap ()
    {        
        String ti =null;
        String defa_de_file = null;
                
        final Integer originalkey = SpreadSheet.SelectedRow == null ? -1 :
                Integer.parseInt(SpreadSheet.SelectedRow[0].toString());
        
        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();

        
        datasheetpanel.add(new JLabel ("Tableno :", JLabel.LEFT), setConstraints(2,1,2,1));
        datasheetpanel.add(combo1 = new JComboBox (tablenos), setConstraints(5,1,1,1));
        combo1.setForeground(Color.LIGHT_GRAY);
        combo1.setToolTipText("Table Numbers zero thru seventeen");
        combo1.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : tablenos[0]);  
        combo1.setEditable(false);
        combo1.setFocusTraversalKeysEnabled(false);
        combo1.addActionListener(new combo1TxtFldLsnr());
        combo1.addMouseListener(new combo1MouseAdapter());

        defa_de_file = DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
        + tablenameidentifier[Integer.parseInt((String)combo1.getSelectedItem())][1].toLowerCase()
        + "_de" + ".de";  // Added on 16th June 2012
        

        datasheetpanel.add(new JLabel ("Data File Name :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : defa_de_file, 30),
        setConstraints(5,2,2,1)); // Changed default from filetabledatafilemap.txt to above .de.txt 16th June 2012
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("Character Data File Name path for Upload at Install Time");
        tf1.setForeground(Color.LIGHT_GRAY);

        
        // Changed label from "File Name :" to "Persistent File Name :" 16th June 2012
        datasheetpanel.add(new JLabel ("Persistent File Name :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : 
                    tablenameidentifier[Integer.parseInt(String.valueOf(combo1.getSelectedItem()))][1], 20),
                setConstraints(4,3,2,1));  // Changed on 16th June 2012  
        
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("Persistent Storage File Name for Table without path/extension. Retain Same");
        tf2.setForeground(Color.LIGHT_GRAY);

        
        datasheetpanel.add(new JLabel ("Table Identifier Name :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : 
                    tablenameidentifier[Integer.parseInt(String.valueOf(combo1.getSelectedItem()))][1], 30),
                setConstraints(5,4,2,1));
        tf3.setFocusTraversalKeysEnabled(false);        
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("Table Identifier Name retain default "
                    + tablenameidentifier[Integer.parseInt(String.valueOf(combo1.getSelectedItem()))][1]);
        tf3.setForeground(Color.LIGHT_GRAY);

        
        datasheetpanel.add(new JLabel ("Class Name :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[4].toString() : 
           tablenameidentifier[Integer.parseInt(String.valueOf(combo1.getSelectedItem()))][1], 30),
                setConstraints(5,5,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr());
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("Class Name for Table retain default");
        tf4.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Table Lock :", JLabel.LEFT), setConstraints(2,6,2,1));
        datasheetpanel.add(tf5 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[5].toString() : "U", 2),
                setConstraints(5,6,2,1));
        tf5.setFocusTraversalKeysEnabled(false);
        tf5.addActionListener(new tf5TxtFldLsnr());
        tf5.addMouseListener(new tf5MouseAdapter());
        tf5.setToolTipText("Table Lock status retain as U");
        tf5.setForeground(Color.LIGHT_GRAY);
        
        datasheetpanel.add(new JLabel ("Process ID :", JLabel.LEFT), setConstraints(2,7,2,1));
        datasheetpanel.add(tf6 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[6].toString() : "0", 10),
                setConstraints(5,7,2,1));
        tf6.setFocusTraversalKeysEnabled(false);
        tf6.addActionListener(new tf6TxtFldLsnr());
        tf6.addMouseListener(new tf6MouseAdapter());
        tf6.setToolTipText("Process ID that Locked/Unlocked Table");
        tf6.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,8,2,1));
        datasheetpanel.add(tf7 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[7].toString() : nextrow, 3),
                setConstraints(5,8,2,1));
        tf7.setFocusTraversalKeysEnabled(false);
        tf7.addActionListener(new tf7TxtFldLsnr());
        tf7.addMouseListener(new tf7MouseAdapter());
        tf7.setToolTipText("Sequential Rowid");
        tf7.setForeground(Color.LIGHT_GRAY);

        
        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,10,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 8;

                    combo1TxtFldLsnr.Validate();
                    tf1TxtFldLsnr.Validate();
                    tf2TxtFldLsnr.Validate();
                    tf3TxtFldLsnr.Validate();
                    tf4TxtFldLsnr.Validate();
                    tf5TxtFldLsnr.Validate();
                    tf6TxtFldLsnr.Validate();
                    tf7TxtFldLsnr.Validate();
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    
                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;
                    
                    SpreadSheet.cells[index][0] = String.valueOf(combo1.getSelectedItem());

                    SpreadSheet.cells[index][1] = tf1.getText();

                    SpreadSheet.cells[index][2] = tf2.getText();
                   
                    SpreadSheet.cells[index][3] = tf3.getText();
                    
                    SpreadSheet.cells[index][4] = tf4.getText();
                    
                    SpreadSheet.cells[index][5] = tf5.getText();
                    
                    SpreadSheet.cells[index][6] = tf6.getText();
                    
                    SpreadSheet.cells[index][7] = tf7.getText();
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                    // Maintain those indexes here now that the user is done with editing
                        ChoiceSheet.indxfiletabledatafilemap.remove(originalkey);

                    }
                    // Now put the newly updated key value into the index
                    ChoiceSheet.indxfiletabledatafilemap.put(
                            Integer.parseInt(combo1.getSelectedItem().toString()),
                            Integer.parseInt(combo1.getSelectedItem().toString()));                    

                    dataentryframe.remove(datasheetpanel);
                    
                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });


        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetDefaultAdvertisingImages ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetDefaultAdvertisingImages (){


        final String originalkey = SpreadSheet.SelectedRow == null ? "":
                String.valueOf(SpreadSheet.SelectedRow[0]).trim();
        
        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();
        

        datasheetpanel.add(new JLabel ("Image Name :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "ADVERT01", 3),
                setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("Advertisement Image File Name on Disk without path");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Image Size :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : "200X100", 4),
                setConstraints(5,3,2,1));
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("200X100 meaning 200 pixels height 100 pixels width");
        tf2.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Directory Name :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : (HOME_EDITION ?
                    (OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? FILESEPERATOR : "C:\\") :
                    (OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? FILESEPERATOR : ChosenNetDriveLetter + ":\\")), 15),
                setConstraints(5,4,2,1));
        
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("Network Drive Path Name where Adverisement Image File resides");
        tf3.setForeground(Color.LIGHT_GRAY);

        
        datasheetpanel.add(new JLabel ("Directions :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(combo1 = new JComboBox (new String [] {"0", "1", "2", "3", "4", "5", "6", "7", "8"}),
                setConstraints(5,5,1,1));
        combo1.setForeground(Color.LIGHT_GRAY);
        combo1.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : "0");
        combo1.setEditable(true);
        combo1.setToolTipText("north=0,south=1,east=2,west=3,middle=4,northwest=5,northeast=6,southwest=7,southeast=8");
        combo1.setFocusTraversalKeysEnabled(false);
        combo1.addActionListener(new combo1TxtFldLsnr());
        combo1.addMouseListener(new combo1MouseAdapter());


        datasheetpanel.add(new JLabel ("Video :", JLabel.LEFT), setConstraints(2,6,2,1));
        datasheetpanel.add(combo2 = new JComboBox (new String [] {"0", "1"}), setConstraints(5,6,1,1));
        combo2.setForeground(Color.LIGHT_GRAY);
        combo2.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[4].toString() : "1");
        combo2.setEditable(false);
        combo2.setToolTipText("If Image = Video select 1 otherwise select 0");
        combo2.setFocusTraversalKeysEnabled(false);
        combo2.addActionListener(new combo2TxtFldLsnr());
        combo2.addMouseListener(new combo2MouseAdapter());



        datasheetpanel.add(new JLabel ("Audio :", JLabel.LEFT), setConstraints(2,7,2,1));
        datasheetpanel.add(combo3 = new JComboBox (new String [] {"0", "1"}), setConstraints(5,7,1,1));
        combo3.setForeground(Color.LIGHT_GRAY);
        combo3.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[5].toString() : "1");
        combo3.setEditable(false);
        combo3.setToolTipText("If Image = Audio select 1 otherwise select 0");
        combo3.setFocusTraversalKeysEnabled(false);
        combo3.addActionListener(new combo3TxtFldLsnr());
        combo3.addMouseListener(new combo3MouseAdapter());



        datasheetpanel.add(new JLabel ("XY Coordinates :", JLabel.LEFT), setConstraints(2,8,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[6].toString() : "1X10", 3), setConstraints(5,8,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr());
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("Enter as 1X10 meaning X=1, Y=10 Take Default Value Unused Field for now");
        tf4.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Child Safe ? :", JLabel.LEFT), setConstraints(2,9,2,1));
        datasheetpanel.add(combo4 = new JComboBox (new String [] {"0", "1"}), setConstraints(5,9,1,1));
        combo4.setForeground(Color.LIGHT_GRAY);
        combo4.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[7].toString() : "1");
        combo4.setEditable(false);
        combo4.setToolTipText("select 1 if Advertisement Image is childsafe zero otherwise");

        datasheetpanel.add(new JLabel ("Image Type :", JLabel.LEFT), setConstraints(2,10,2,1));
        datasheetpanel.add(tf5 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[8].toString() : "U", 2), setConstraints(5,10,2,1));
        tf5.setFocusTraversalKeysEnabled(false);
        tf5.addActionListener(new tf5TxtFldLsnr());
        tf5.addMouseListener(new tf5MouseAdapter());
        tf5.setToolTipText("Valid values 'U' loaded by User, 'D' Default Image");
        tf5.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,11,2,1));
        datasheetpanel.add(tf6 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[9].toString() : nextrow, 3), setConstraints(5,11,2,1));
        tf6.setFocusTraversalKeysEnabled(false);
        tf6.addActionListener(new tf6TxtFldLsnr());
        tf6.addMouseListener(new tf6MouseAdapter());
        tf6.setToolTipText("Sequential Rowid");
        tf6.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,11,6,1));
        datasheetpanel.add(legends, setConstraints (1,12,18,1));
        datasheetpanel.add(doneButton, setConstraints(6,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 10;

                    tf1TxtFldLsnr.Validate();
                    tf2TxtFldLsnr.Validate();
                    tf3TxtFldLsnr.Validate();
                    combo1TxtFldLsnr.Validate();
                    combo2TxtFldLsnr.Validate();
                    combo3TxtFldLsnr.Validate();
                    tf4TxtFldLsnr.Validate();
                    tf5TxtFldLsnr.Validate();
                    tf6TxtFldLsnr.Validate();
                    

                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;
                                        
                    
                    SpreadSheet.cells[index][0] = tf1.getText();
                    
                    SpreadSheet.cells[index][1] = tf2.getText();
                    
                    SpreadSheet.cells[index][2] = tf3.getText();
                    
                    SpreadSheet.cells[index][3] = String.valueOf(combo1.getSelectedItem());
                    
                    SpreadSheet.cells[index][4] = String.valueOf(combo2.getSelectedItem());
                    
                    SpreadSheet.cells[index][5] = String.valueOf(combo3.getSelectedItem());
                    
                    SpreadSheet.cells[index][6] = tf4.getText();
                    
                    SpreadSheet.cells[index][7] = String.valueOf(combo4.getSelectedItem());
                    
                    SpreadSheet.cells[index][8] = tf5.getText();
                    
                    SpreadSheet.cells[index][9] = tf6.getText();
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxdefaultadvertisingimages.remove(originalkey);

                    }
                        ChoiceSheet.indxdefaultadvertisingimages.put(tf1.getText().trim(),
                                tf1.getText().trim());
                        
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetLanguageSupport ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * Last Modifications Date : 26th June 2012
 * Last Modifications : Marked as 26th June 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetLanguageSupport ()
    {

        final String originalkey = SpreadSheet.SelectedRow == null ? "":
                String.valueOf(SpreadSheet.SelectedRow[1]).trim();

        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();

        
        datasheetpanel.add(new JLabel ("Language ID :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "1", 3),
                setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("Language ID from one thru 50");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Language Code :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : "de", 4),
                setConstraints(5,3,2,1));
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("two letter ISO Language Code");
        tf2.setForeground(Color.LIGHT_GRAY);
        tf2.setText(tf2.getText().trim().toLowerCase());  // Added on 26th June 2012

        datasheetpanel.add(new JLabel ("Display Name :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : new Locale(tf2.getText()).getDisplayName(), 20),
                setConstraints(5,4,2,1));
        tf3.setFocusTraversalKeysEnabled(false);
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("Display Name of Language Corresponding to Language Code");
        tf3.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : nextrow, 3), setConstraints(5,5,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr());
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("Sequential Rowid");
        tf4.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,11,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 4;
                    

                    
                    tf1TxtFldLsnr.Validate();
                    tf2TxtFldLsnr.Validate();
                    tf3TxtFldLsnr.Validate();
                    tf4TxtFldLsnr.Validate();

                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];                    

                    SpreadSheet.dummyrow = false;

                    SpreadSheet.cells[index][0] = tf1.getText();
                    
                    SpreadSheet.cells[index][1] = tf2.getText();
                    
                    SpreadSheet.cells[index][2] = tf3.getText();
                    
                    SpreadSheet.cells[index][3] = tf4.getText();
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxlanguagesupport.remove(originalkey);

                    }
                        ChoiceSheet.indxlanguagesupport.put(tf2.getText().trim(),
                                tf2.getText().trim());                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetLanguageTitles ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 5th 2012
 * Last Modifications : Added some more validations to ensure that duplicate key values are not entered
 * during data entry. Search for "ChoiceSheet". Also look at ChoiceSheet.java. I am using some indexes
 * for this purpose. These indexes hashmaps have been declared in ChoiceSheet.java
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetLanguageTitles (){


        final String originalkey = SpreadSheet.SelectedRow == null ? "":
                String.valueOf(SpreadSheet.SelectedRow[0]).trim()
                + SpreadSheet.SelectedRow[1];        

        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();
 

        datasheetpanel.add(new JLabel ("Language Code :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "sw", 4), setConstraints(5,4,2,1));
        tf3.setFocusTraversalKeysEnabled(false);
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("A Valid two or three letter Language Code");
        tf3.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("English Label :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : "Shop", 15), setConstraints(5,5,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr());
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("English text for Language");
        tf4.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Language Text :", JLabel.LEFT), setConstraints(2,6,2,1));
        datasheetpanel.add(tf5 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : "Shop", 25), setConstraints(5,6,2,1));
        // This should and will work
        tf5.setFont(new Font(usefont,Font.PLAIN, 14));
        tf5.setFocusTraversalKeysEnabled(false);
        //tf5.addActionListener(new tf5TxtFldLsnr());
        //tf5.addMouseListener(new tf5MouseAdapter());        
        tf5.setToolTipText("Transalated Language Text in Unicode");
        tf5.setForeground(Color.LIGHT_GRAY);

                
        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,7,2,1));
        datasheetpanel.add(tf6 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : nextrow, 3), setConstraints(5,7,2,1));
        tf6.setFocusTraversalKeysEnabled(false);
        tf6.addActionListener(new tf6TxtFldLsnr());
        tf6.addMouseListener(new tf6MouseAdapter());
        tf6.setToolTipText("Sequential Rowid");
        tf6.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,11,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 4;
                    
                    tf3TxtFldLsnr.Validate();
                    tf4TxtFldLsnr.Validate();
                    //tf5TxtFldLsnr.Validate();
                    tf6TxtFldLsnr.Validate();  
                    
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;

                    SpreadSheet.cells[index][0] = tf3.getText();
                    
                    SpreadSheet.cells[index][1] = tf4.getText();
                    
                    SpreadSheet.cells[index][2] = tf5.getText();                    
                    
                    SpreadSheet.cells[index][3] = tf6.getText();
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxlanguagetitles.remove(originalkey);

                    }
                        ChoiceSheet.indxlanguagetitles.put(
                                tf3.getText().trim() + tf4.getText(),
                                tf3.getText().trim() + tf4.getText());                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetLanguageTransalations ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetLanguageTransalations (){

        final String originalkey = SpreadSheet.SelectedRow == null ? "":
                String.valueOf(SpreadSheet.SelectedRow[0]).trim()
                + String.valueOf(SpreadSheet.SelectedRow[1]).trim();
        
        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();


        datasheetpanel.add(new JLabel ("Language ID :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "1", 3),
                setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("Language ID from one thru 36");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Code :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : "ST09", 6), setConstraints(5,3,2,1));
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("A Valid Picture Code from Picture Database");
        tf2.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("GUI Text Area Number :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : "1", 2),
                setConstraints(5,4,2,1));
        tf3.setFocusTraversalKeysEnabled(false);
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("GUI Text Area Number one thru nine, Un-used field for now");
        tf3.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("GUI Text Area Type :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : "JNarrative", 15), setConstraints(5,5,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr()); // Changed on 16th June 2012
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("GUI Text Area Type such as JNarrative etc use this default for now");
        tf4.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Language File Name :", JLabel.LEFT), setConstraints(2,6,2,1));
        datasheetpanel.add(tf5 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[4].toString() : HOME_EDITION ?
                    OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? FILESEPERATOR : "C:\\" :
                    OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? FILESEPERATOR : ChosenNetDriveLetter + ":\\", 30),
                setConstraints(5,6,2,1));
        tf5.setFocusTraversalKeysEnabled(false);
        tf5.addActionListener(new tf5TxtFldLsnr());
        tf5.addMouseListener(new tf5MouseAdapter());
        tf5.setToolTipText("Transalated Language File Name with complete path");
        tf5.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,7,2,1));
        datasheetpanel.add(tf6 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[5].toString() : nextrow, 3), setConstraints(5,7,2,1));
        tf6.setFocusTraversalKeysEnabled(false);
        tf6.addActionListener(new tf6TxtFldLsnr());
        tf6.addMouseListener(new tf6MouseAdapter());
        tf6.setToolTipText("Sequential Rowid");
        tf6.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,11,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 6;
                    
                    tf1TxtFldLsnr.Validate();
                    tf2TxtFldLsnr.Validate();
                    tf3TxtFldLsnr.Validate();
                    tf4TxtFldLsnr.Validate();
                    tf5TxtFldLsnr.Validate();
                    tf6TxtFldLsnr.Validate();
                    

                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    index = index == -1 ? 0: index;

                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;


                    
                    SpreadSheet.cells[index][0] = tf1.getText();
                    
                    SpreadSheet.cells[index][1] = tf2.getText();
                    
                    SpreadSheet.cells[index][2] = tf3.getText();
                    
                    SpreadSheet.cells[index][3] = tf4.getText();
                    
                    SpreadSheet.cells[index][4] = tf5.getText();
                    
                    SpreadSheet.cells[index][5] = tf6.getText();
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxlanguagetransalations.remove(originalkey);

                    }
                        ChoiceSheet.indxlanguagetransalations.put(
                                tf1.getText().trim() + tf2.getText().trim(),
                                tf1.getText().trim() + tf2.getText().trim());                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetPaymentType ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * Last Modification Date : 16th June 2012
 * Last Modifications : Added an extra declaration
       String [] paymentids = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};
 * And its usage below
   datasheetpanel.add(combo1 = new JComboBox (paymentids), setConstraints(5,1,1,1));
 *
 *
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetPaymentType ()
    {

        final String originalkey = SpreadSheet.SelectedRow == null ? "":
                SpreadSheet.SelectedRow[0] 
                + String.valueOf(SpreadSheet.SelectedRow[1]).trim();  
        
        String [] paymentids = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};

        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();


        datasheetpanel.add(new JLabel ("Payment ID :", JLabel.LEFT), setConstraints(2,1,2,1));
        datasheetpanel.add(combo1 = new JComboBox (paymentids), setConstraints(5,1,1,1));
        combo1.setForeground(Color.LIGHT_GRAY);
        combo1.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : paymentids[0]);
        combo1.setEditable(true);
        combo1.setFocusTraversalKeysEnabled(false);
        combo1.addActionListener(new combo1TxtFldLsnr());
        combo1.addMouseListener(new combo1MouseAdapter());
        


        datasheetpanel.add(new JLabel ("Payment Type :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : "CreditCard", 15),
                setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("Payment Type Description like WUMT, CASH, COD, Cheque, CreditCard");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : nextrow, 3),
                setConstraints(5,3,2,1));
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("Sequential Rowid");
        tf2.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,11,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 3;
                    
                    combo1TxtFldLsnr.Validate();
                    tf1TxtFldLsnr.Validate();
                    tf2TxtFldLsnr.Validate();
                    

                    

                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;
                    
                    
                    SpreadSheet.cells[index][0] = String.valueOf(combo1.getSelectedItem());
                    
                    SpreadSheet.cells[index][1] = tf1.getText();
                    
                    SpreadSheet.cells[index][2] = tf2.getText();
                    
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxpaymenttype.remove(originalkey);

                    }
                        ChoiceSheet.indxpaymenttype.put(combo1.getSelectedItem() + tf1.getText().trim(),
                                combo1.getSelectedItem() + tf1.getText().trim());                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetPictureDatabase ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetPictureDatabase ()
    {

        final String originalkey  =
               SpreadSheet.SelectedRow == null ? "":
                String.valueOf(SpreadSheet.SelectedRow[0]).trim();
        
        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();


        datasheetpanel.add(new JLabel ("Picture Code :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "ST09", 6), setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("A Valid Picture Code from Picture Database");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Add Date :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
            ? SpreadSheet.SelectedRow[1].toString() : new Date().toString(), 25), setConstraints(5,3,2,1));
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("Date Added to Database");
        tf2.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Last Access Date :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : new Date().toString(), 25), setConstraints(5,4,2,1));
        tf3.setFocusTraversalKeysEnabled(false);
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("Last Date of Access by Database Engine");
        tf3.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Category :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : "Expressions", 25), setConstraints(5,5,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr());
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("Picture Catalogue such as Expressions or Coorg Pavillion");
        tf4.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Title :", JLabel.LEFT), setConstraints(2,6,2,1));
        datasheetpanel.add(tf5 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[4].toString() : "", 25), setConstraints(5,6,2,1));
        tf5.setFocusTraversalKeysEnabled(false);
        tf5.addActionListener(new tf5TxtFldLsnr());
        tf5.addMouseListener(new tf5MouseAdapter());
        tf5.setToolTipText("One or Two or Three or Four Word Picture Title");
        tf5.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Price :", JLabel.LEFT), setConstraints(2,7,2,1));
        datasheetpanel.add(tf6 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[5].toString() : "250.00", 7), setConstraints(5,7,2,1));
        tf6.setFocusTraversalKeysEnabled(false);
        tf6.addActionListener(new tf6TxtFldLsnr());
        tf6.addMouseListener(new tf6MouseAdapter());
        tf6.setToolTipText("Picture Price without Discount");
        tf6.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Sale :", JLabel.LEFT), setConstraints(2,8,2,1));
        datasheetpanel.add(combo1 = new JComboBox (new String [] {"0", "1"}), setConstraints(5,8,1,1));
        combo1.setForeground(Color.LIGHT_GRAY);
        combo1.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[6].toString() : "1");
        combo1.setEditable(false);
        combo1.setToolTipText("select 1 if Sale item, select 0 if regular item");

        datasheetpanel.add(new JLabel ("Picture Discount :", JLabel.LEFT), setConstraints(2,9,2,1));
        datasheetpanel.add(tf7 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[7].toString() : "10.00", 7),
                setConstraints(5,9,2,1));
        tf7.setFocusTraversalKeysEnabled(false);
        tf7.addActionListener(new tf7TxtFldLsnr());
        tf7.addMouseListener(new tf7MouseAdapter());
        tf7.setToolTipText("Picture Discount in USD $ by default");
        tf7.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Image Location :", JLabel.LEFT), setConstraints(2,10,2,1));
        datasheetpanel.add(tf8 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[8].toString() : HOME_EDITION ?
                    OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? FILESEPERATOR : "C:\\" :
                    OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? FILESEPERATOR : ChosenNetDriveLetter + ":\\", 30),
                    setConstraints(5,10,2,1));
        tf8.setFocusTraversalKeysEnabled(false);
        tf8.addActionListener(new tf8TxtFldLsnr());
        tf8.addMouseListener(new tf8MouseAdapter());
        tf8.setToolTipText("Absolute Path with Image File Name on Disk");
        tf8.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,11,2,1));
        datasheetpanel.add(tf9 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[9].toString() : nextrow, 3), setConstraints(5,11,2,1));
        tf9.setFocusTraversalKeysEnabled(false);
        tf9.addActionListener(new tf9TxtFldLsnr());
        tf9.addMouseListener(new tf9MouseAdapter());
        tf9.setToolTipText("Sequential Rowid");
        tf9.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,11,6,1));
        datasheetpanel.add(legends, setConstraints (1,12,18,1));
        datasheetpanel.add(doneButton, setConstraints(6,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 10;
                    
                    tf1TxtFldLsnr.Validate();
                    tf2TxtFldLsnr.Validate();
                    tf3TxtFldLsnr.Validate();                    
                    tf4TxtFldLsnr.Validate();
                    tf5TxtFldLsnr.Validate();
                    tf6TxtFldLsnr.Validate();
                    combo1TxtFldLsnr.Validate();
                    tf7TxtFldLsnr.Validate();
                    tf8TxtFldLsnr.Validate();
                    tf9TxtFldLsnr.Validate();
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;

                    
                    SpreadSheet.cells[index][0] = tf1.getText();
                    
                    SpreadSheet.cells[index][1] = tf2.getText();
                    
                    SpreadSheet.cells[index][2] = tf3.getText();
                    
                    SpreadSheet.cells[index][3] = tf4.getText();
                    
                    SpreadSheet.cells[index][4] = tf5.getText();
                    
                    SpreadSheet.cells[index][5] = tf6.getText();
                    
                    SpreadSheet.cells[index][6] = String.valueOf(combo1.getSelectedItem());
                                        
                    SpreadSheet.cells[index][7] = tf7.getText();
                                        
                    SpreadSheet.cells[index][8] = tf8.getText();                    
                    
                    SpreadSheet.cells[index][9] = tf9.getText();
                    
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxpicturedatabase.remove(originalkey);

                    }
                        ChoiceSheet.indxpicturedatabase.put(tf1.getText().trim(),
                                tf1.getText().trim());                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetPictureOptions ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * Last Modification Date : 16th June 2012
 * Last Modifications : Added two extra declarations
        String [] optionnos = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};
        String [] suboptionnos =
        {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17"};
 * Check for the usage also of the above two declarations.
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetPictureOptions (){
        
 
        final String originalkey = SpreadSheet.SelectedRow == null ? "":
                String.valueOf(SpreadSheet.SelectedRow[0]).trim()
                + SpreadSheet.SelectedRow[1] + SpreadSheet.SelectedRow[2];
        
        String [] optionnos = {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};
        String [] suboptionnos =
        {"1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21"};

        
        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();

        
        datasheetpanel.add(new JLabel ("Language Code :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "en", 3), setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("A Valid two letter Language Code");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Option ID :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(combo1 = new JComboBox (optionnos), setConstraints(5,4,1,1));
        combo1.setForeground(Color.LIGHT_GRAY);
        combo1.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString().trim() : optionnos[0]);
        combo1.setFocusTraversalKeysEnabled(false);
        combo1.setEditable(true);
        combo1.setToolTipText("Option ID for Options such as Frame, Color starting 1,2,3...");
        combo1.addActionListener(new combo1TxtFldLsnr());
        combo1.addMouseListener(new combo1MouseAdapter());


        datasheetpanel.add(new JLabel ("Sub Option ID :", JLabel.LEFT), setConstraints(2,5,2,1));
        datasheetpanel.add(combo2= new JComboBox (suboptionnos), setConstraints(5,5,1,1));
        combo2.setForeground(Color.LIGHT_GRAY);
        combo2.setSelectedItem(SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString().trim() : suboptionnos[0]);
        combo2.setEditable(true);
        combo2.setFocusTraversalKeysEnabled(false);
        combo2.setToolTipText("Sub Opt ID Gold,Silver etc start 1,2,3.. AND (0) for Option ID text only row");
        combo2.addActionListener(new combo2TxtFldLsnr());
        combo2.addMouseListener(new combo2MouseAdapter());

        datasheetpanel.add(new JLabel ("Language Sub Text :", JLabel.LEFT), setConstraints(2,6,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[3].toString() : "Acrabacadra", 25), setConstraints(5,6,2,1));
        tf3.setFocusTraversalKeysEnabled(false);
        //tf3.addActionListener(new tf3TxtFldLsnr()); // Change 16th June 2012
        //tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("Transalated Language Sub Text in Unicode for SubOption/Option ID");
        tf3.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,7,2,1));
        datasheetpanel.add(tf4 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[4].toString() : nextrow, 3), setConstraints(5,7,2,1));
        tf4.setFocusTraversalKeysEnabled(false);
        tf4.addActionListener(new tf4TxtFldLsnr());
        tf4.addMouseListener(new tf4MouseAdapter());
        tf4.setToolTipText("Sequential Rowid");
        tf4.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,11,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 5;
                    
                    tf1TxtFldLsnr.Validate();
                    combo1TxtFldLsnr.Validate();
                    combo2TxtFldLsnr.Validate();                    
                    tf3TxtFldLsnr.Validate();
                    tf4TxtFldLsnr.Validate();

                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;
                    
                    
                    SpreadSheet.cells[index][0] = tf1.getText();                

                    SpreadSheet.cells[index][1] = String.valueOf(combo1.getSelectedItem());

                    SpreadSheet.cells[index][2] = String.valueOf(combo2.getSelectedItem());

                    SpreadSheet.cells[index][3] = tf3.getText();
                    
                    SpreadSheet.cells[index][4] = tf4.getText();
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxpictureoptions.remove(originalkey);

                    }
                    ChoiceSheet.indxpictureoptions.put(tf1.getText().trim() +
                                combo1.getSelectedItem() + combo2.getSelectedItem(),
                                tf1.getText().trim() +
                                combo1.getSelectedItem() + combo2.getSelectedItem());
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetSearchDatabase ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : I am maintaining some HashMaps in ChoiceSheet.java being used as indexes for
 * validations during data entry. I am updating those indexes even when the user Edits. Look at the
 * patch of code starting
   if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetSearchDatabase (){
        
        final String originalkey = SpreadSheet.SelectedRow == null ? "" :
                String.valueOf(SpreadSheet.SelectedRow[0]) + SpreadSheet.SelectedRow[1];
        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();


        datasheetpanel.add(new JLabel ("Search Keyword :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "PIC", 15),
                setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.setToolTipText("Keyword to Search for");
        tf1.setForeground(Color.LIGHT_GRAY);

        datasheetpanel.add(new JLabel ("Picture Code :", JLabel.LEFT), setConstraints(2,3,2,1));
        datasheetpanel.add(tf2 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[1].toString() : "PIC01", 6),
                setConstraints(5,3,2,1));
        tf2.setFocusTraversalKeysEnabled(false);
        tf2.addActionListener(new tf2TxtFldLsnr());
        tf2.addMouseListener(new tf2MouseAdapter());
        tf2.setToolTipText("A Valid Picture Code from Picture Database");
        tf2.setForeground(Color.LIGHT_GRAY);
        
        datasheetpanel.add(new JLabel ("Row ID :", JLabel.LEFT), setConstraints(2,4,2,1));
        datasheetpanel.add(tf3 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[2].toString() : nextrow, 3),
                setConstraints(5,4,2,1));
        tf3.setFocusTraversalKeysEnabled(false);
        tf3.addActionListener(new tf3TxtFldLsnr());
        tf3.addMouseListener(new tf3MouseAdapter());
        tf3.setToolTipText("Sequential Rowid");
        tf3.setForeground(Color.LIGHT_GRAY);

        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,10,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 3;
                    
                    
                    tf2TxtFldLsnr.Validate();
                    tf3TxtFldLsnr.Validate();
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    //nextrow = Integer.parseInt(nextrow) + 1 + " ".trim();
                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];

                    SpreadSheet.dummyrow = false;
                    
                    
                    SpreadSheet.cells[index][0] = tf1.getText();
                    
                    SpreadSheet.cells[index][1] = tf2.getText();
                    
                    SpreadSheet.cells[index][2] = tf3.getText();
                    // Update the Index here after the user is done with Edit
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                    {
                        ChoiceSheet.indxsearchdatabase.remove(originalkey);
                    }
                    ChoiceSheet.indxsearchdatabase.put(
                                tf1.getText() + tf2.getText(),
                                tf1.getText() + tf2.getText());                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:datasheetpanel, tablenameidentifier, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Method Name : void DataSheetCelebrityTable ()
 * Parameters : None
 * Returns : None
 *
 * Called From : Constructor public DataSheet (String p_table)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds components to a DataSheet for the chosen_table and then does a
 * setVisible on the datasheet and displays it for Data Entry/Editing. Other than components it also adds
 * tool tips for each data field in the DataSheet. At the bottom of the DataSheet it adds a "DONE" button.
 * When the user clicks on the DataSheet "DONE" Button it assigns the values entered by the user on the
 * DataSheet data entry form to the underlying data model array of Objects called SpreadSheet.cells.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    void DataSheetCelebrityTable (){

        dataentryframe.remove(ChoiceSheet.choicesheetpanel);
        dataentryframe.validate();
        

        datasheetpanel.add(new JLabel ("Celebrity Name :", JLabel.LEFT), setConstraints(2,2,2,1));
        datasheetpanel.add(tf1 = new JTextField (SpreadSheet.chosen_action.equalsIgnoreCase("Edit")
                ? SpreadSheet.SelectedRow[0].toString() : "Jennifer Annistone", 40),
                setConstraints(5,2,2,1));
        tf1.setFocusTraversalKeysEnabled(false);
        tf1.addActionListener(new tf1TxtFldLsnr());
        tf1.addMouseListener(new tf1MouseAdapter());
        tf1.setToolTipText("Name of Celebrity with Royal Titles prefix");
        tf1.setForeground(Color.LIGHT_GRAY);
        
        sheettitle.setForeground(Color.BLUE);
        datasheetpanel.add(sheettitle, setConstraints(1,9,6,1));
        datasheetpanel.add(legends, setConstraints (1,11,18,1));
        datasheetpanel.add(doneButton, setConstraints(5,12,2,2));
        doneButton.setToolTipText("Completed Entering this Data Entry Form ?");
        doneButton.addActionListener(new ActionListener ()
        {
              @Override
              public void actionPerformed (ActionEvent evnt){

                    int index = 0;
                    int flds = 1;

                    tf1TxtFldLsnr.Validate();
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                        index = SpreadSheet.cells.length - 1;
                    else if (SpreadSheet.chosen_action.equalsIgnoreCase("Edit"))
                        index = SpreadSheet.table.getSelectedRow();

                    Object prevrows [][] = null;
                    
                    prevrows = index < 0 ? new Object [1][flds]: new Object [index+1][flds];
                    
                    if (SpreadSheet.chosen_action.equalsIgnoreCase("Add"))
                    {
                        System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                        SpreadSheet.cells = null;
                        SpreadSheet.cells = SpreadSheet.dummyrow == true ? 
                                                     new Object [1][flds]:new Object [index+2][flds];                         
                        System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                        index = SpreadSheet.cells.length - 1;
                    }
                    else
                        SpreadSheet.cells[index] = new Object[flds];


                    SpreadSheet.dummyrow = false;
                    
                    SpreadSheet.cells[index][0] = tf1.getText();
                    
                    dataentryframe.remove(datasheetpanel);

                    dataentryframe.validate();
                    dataentryframe.repaint();
                    datasheetpanel = null;
                    ChoiceSheet.choicesheetpanel = null;
                    dummy = new SpreadSheet(SpreadSheet.chosen_table);
              }
          });

        dataentryframe.add(datasheetpanel);
        
        datasheetpanel.validate();
        dataentryframe.pack();
    }
/*
 * WIRING DIAGRAM :
 * Method Name : GridBagConstraints setConstraints (int X, int Y, int W, int H)
 * Parameters : int X -- gridX
 *              int Y -- gridY
 *              int W -- gridwidth
 *              int H -- gridheight
 *
 * Returns : GridBagConstraints  -- an instance of the constraints that you set
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method sets constraints as per your params and returns an instance of the same
 * to be used with datasheetpanel.add as in methods DataSheet* ().
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
