/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.awt.Insets;
import java.awt.GridBagLayout;
import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.ScrollPaneConstants;
import java.util.HashMap;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.File;
import java.awt.GridBagConstraints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.print.PrinterException;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import static DataEntryPrograms.DotingEntry.grassHopper;
import static DataEntryPrograms.DotingEntry.fieldseperator;
import static DataEntryPrograms.DotingEntry.FILESEPERATOR;
// keep these unused imports or it may have trouble constructing ErrorLogFile
import static DataEntryPrograms.DotingEntry.ErrorLogFile;
import static DataEntryPrograms.DotingEntry.ALRTLVL;
import static DataEntryPrograms.ChoiceSheet.choicesheetpanel;
import java.awt.*;
import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;


/*
 * WIRING DIAGRAM :
 *
 * Class Name : SpreadSheet
 * Methods : Look in Class definition
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class contains methods that display a Spread Sheet of rows belonging to a
 * your chosen table from ChoiceSheet. If the table does not contain any rows yet it will display a
 * blank spreadsheet and you can start the data entry.
 * NOTE:- Due to lack of time I have not plugged in code for some tables that are dumped by
 * MaintainData.Spy.dump(). Please cut and paste and add that code also for tables such as CustomerRegister
 * ShoppingCart InstalledTables ReportsTable, ChangeTracker
 *
 * Technical References : None
 *
 * Musical Accompanyments : Who the Fuck is Alice ? Alice Alice !!
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 *
 * Last Modifications Date : 22nd June 2012
 * Last Modifications : Thru out this source file whereever there is a System.exit(1) there is a
 * popup informing the user about the name of the log file for the current session. so I have added
 * the following source line everywhere
                      JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class SpreadSheet {    
    // the main data entry frame use always
    static DataEntry dataentryframe ;
    static Object cells [][];
    static Object [] SelectedRow = null;
    static Object [] columnnames;
    static JTable table;
    static boolean dummyrow = false;
    static JButton Edit, Add, Delete, AddFile, Save, Print, Cancel, ReNumber;
    static String chosen_table;
    static String chosen_action = "AddFile"; //let this initial value remain.Otherwise misbehaves
    static JScrollPane pane;
    static JTableHeader tblhdr = new JTableHeader();
    static ChoiceSheet dummy;
    
    static JLabel Note;
    static JLabel tbltitle;
    static DefaultTableModel dtm;
    static Object prevcells [][];
    
    
    public SpreadSheet (String p_table)
    { 
        System.gc();
        getColumns(p_table);
    }
/*
 * WIRING DIAGRAM :
 * Method Name : protected static void getColumns (String p_table)
 * Parameters : String p_table -- chosen_table from ChoiceSheet
 *              we accept a parameter because you might want to use this as a generic method for other tables.
 * Returns : None
 * Chained Methods : static void displaySheet ()
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method inserts values into array columnnames and then calls displaySheet()
 * which will in turn create a new Instance of Jtable with cells and columnnames.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static void getColumns (String p_table)
    {
        if (p_table.equalsIgnoreCase("filetabledatafilemap"))
        {
            // dont call toString here either it will make the reference final
            // ignore those warnings yellow bul on the side.
            columnnames = new Object [8];
            columnnames[0] = new String("Table Number");
            columnnames[1] = new String("Data File Name");
            columnnames [2] = new String("File Name");
            columnnames [3] = new String("Table Identifier Name");
            columnnames [4] = new String("Class Name");
            columnnames [5] = new String("Table Lock");
            columnnames [6] = new String("PID");
            columnnames [7] = new String("Row Id");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("defaultadvertisingimages"))
        {
            columnnames = new Object [10];
            columnnames[0] = new String("Image Name");
            columnnames[1] = new String("Image Size");
            columnnames [2] = new String("Directory Name");
            columnnames [3] = new String("Directions");
            columnnames [4] = new String("Video");
            columnnames [5] = new String("Audio");
            columnnames [6] = new String("XY Coordinates");
            columnnames[7] = new String("ChildSafe Advertising");
            columnnames[8] = new String("Image Type");
            columnnames [9] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("languagesupport"))
        {
            columnnames = new Object [4];
            columnnames[0] = new String("Language ID");
            columnnames[1] = new String("Language Code");
            columnnames [2] = new String("Language Name");
            columnnames [3] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("languagetitles"))
        {
            columnnames = new Object [4];
            columnnames[0] = new String("Language Code");
            columnnames[1] = new String("English Label");
            columnnames [2] = new String("Language Text");
            columnnames [3] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("languagetransalations"))
        {
            columnnames = new Object [6];
            columnnames[0] = new String("Language ID");
            columnnames [1] = new String("Picture Code");
            columnnames [2] = new String("GUI Text Area Number");
            columnnames [3] = new String("GUI Text Area Type");
            columnnames [4] = new String("Language File Name");
            columnnames [5] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("paymenttype"))
        {
            columnnames = new Object [3];
            
            columnnames[0] = new String("Payment ID");
            columnnames [1] = new String("Payment Type");
            columnnames [2] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("picturedatabase"))
        {
            columnnames = new Object [10];
            columnnames [0] = new String("Picture Code");
            columnnames [1] = new String("Add Date");
            columnnames [2] = new String("Last Access");
            columnnames [3] = new String("Picture Category");
            columnnames [4] = new String("Picture Title");
            columnnames [5] = new String("Picture Price");
            columnnames [6] = new String("Picture Sale");
            columnnames [7] = new String("Picture Discount");
            columnnames [8] = new String("Picture Image Location");
            columnnames [9] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("pictureoptions"))
        {
            columnnames = new Object [5];
            columnnames [0] = new String("Language Code");            
            columnnames [1] = new String("Option ID");
            columnnames [2] = new String("Sub Option ID");
            columnnames [3] = new String("Language Sub Text");
            columnnames [4] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("searchdatabase"))
        {
            columnnames = new Object [3];
            columnnames [0] = new String("Search Keyword");
            columnnames [1] = new String("Picture Code");
            columnnames [2] = new String("Rowid");
            displaySheet ();
        }
        else if (p_table .equalsIgnoreCase("celebritytable"))
        {
            columnnames = new Object[1];
            columnnames [0] = new String("Celebrity Name");
            displaySheet ();
        }
        
        System.gc();
    }
/*
 * WIRING DIAGRAM :
 * Method Name : static void displaySheet ()
 * Parameters : None
 * Returns : None
 * Chained Methods : static void displayButtons ()
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method instantiates a new JTable for a spread sheet display with cells and
 * columnnames and then calls method displayButtons();
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 * 
 * Last Modifications Date : 1,2nd,3rd,4th July2012
 * Last Modifications : Lots of bits and pieces modifications to this source file
 * 
 * Last Modifications Date : 16th July 2012
 * Last Modifications : Some itsy bitsy changes not worth explaining
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    static void displaySheet ()
    {
          Insets insets = dataentryframe.getInsets();
          int X = dataentryframe.getX() + insets.left , Y = dataentryframe.getY() + insets.top,
              W = DotingEntry.DEFAULT_WIDTH - insets.left - insets.right,
              H = DotingEntry.DEFAULT_HEIGHT - insets.top - insets.bottom;
           
           if (choicesheetpanel == null)
           {                 
               choicesheetpanel = new JPanel (new GridBagLayout(), true);
               choicesheetpanel.setPreferredSize(new Dimension (W,H));
               choicesheetpanel.setSize(new Dimension(W,H));
               choicesheetpanel.setMinimumSize(new Dimension (W,H));
               choicesheetpanel.setMaximumSize(new Dimension(W+3, H+3));               
           }
           else
           {
                choicesheetpanel.removeAll();
                choicesheetpanel.setPreferredSize(new Dimension (W,H));
                choicesheetpanel.setSize(new Dimension(W,H));
                choicesheetpanel.setMinimumSize(new Dimension (W,H));
                choicesheetpanel.setMaximumSize(new Dimension(W+3, H+3));

                choicesheetpanel.validate();
                // some problem it doesent display table without this asignment
                // The user has to minimize and maximize only then the table displays
                // sometimes it hangs
                
                if (cells == null)
                {
                    if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
                    {
                        cells = new Object [1][8];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
                    {
                        cells = new Object [1][10];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
                    {
                        cells = new Object [1][4];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
                    {
                        cells = new Object [1][4];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
                    {
                        cells = new Object [1][6];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
                    {
                        cells = new Object [1][3];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
                    {
                        cells = new Object [1][10];
                        dummyrow = true;                        
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
                    {
                        cells = new Object [1][5];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
                    {
                        cells = new Object [1][3];
                        dummyrow = true;
                    }
                    else if (SpreadSheet.chosen_table.equalsIgnoreCase("celebritytable"))
                    {
                        cells = new Object [1][1];
                        dummyrow = true;
                    }
                } 
           }
           

           choicesheetpanel.setVisible(true);
           dtm = new DefaultTableModel (cells, columnnames);
           //table = new JTable (cells, columnnames);
           table = new JTable(dtm);
          
           tblhdr = table.getTableHeader();

           table.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

         
           table.setRowHeight(50);
           table.setFillsViewportHeight(true);
           table.setEnabled(true);
           table.setSize(new Dimension(DotingEntry.DEFAULT_WIDTH/2 + 2, DotingEntry.DEFAULT_HEIGHT/2));
           //table.setPreferredSize(new Dimension(DotingEntry.DEFAULT_WIDTH/2 + 2, DotingEntry.DEFAULT_HEIGHT/2 + 4));           
           //table.setMinimumSize(new Dimension(DotingEntry.DEFAULT_WIDTH/2 + 2, DotingEntry.DEFAULT_HEIGHT/2 + 4));
           table.addMouseListener(new tablemouseAdapter()); 
           
         
           // HEEEELP I CANT GET THIS TO WORK. VERTICAL SCROLL BAR APPEARS BUT DOES NOT SCROLL
           // PLEASE SEND ME AN EMAIL TO pskris@sify.com with a solution
           // I have made it to work but if I use that call table.setPreferredSize 
           // and the call table.setMinimumSize above it stops working. Please HELP I am in 
           // suicidal tears !! This is a valid technical reason for me to attempt suicide.
           // The problem is Java Swing appears to have a very myopic view of things. It
           // sees X,Y coordinates somewhere on the screen and I see it elsewhere. Bad Software !
           // I mean Java
           
           
           //table.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
           table.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
           table.setLayout(new GridBagLayout());
           // Dont activate this for now because we will have to re-write some code
           // for ssDelete button and ssEdit button
           //table.setAutoCreateRowSorter(true);
           tblhdr.setBackground(Color.YELLOW);       
           tblhdr.setReorderingAllowed(false);
           tblhdr.setResizingAllowed(true);
           
           tblhdr.validate();
           table.validate();
           
           pane = new JScrollPane (table);
           //pane.setSize(new Dimension(DotingEntry.DEFAULT_WIDTH/2, DotingEntry.DEFAULT_HEIGHT/2));
           pane.setViewportView(table);

           
           pane.validate();

           tbltitle = new JLabel("Current Table : " + (SpreadSheet.chosen_table.toUpperCase()));
           Note = new JLabel ("NOTE:- After Using Add/Edit/Delete/Re-Number Press Save Button to write Changes");
           Note.setForeground(Color.RED);
           tbltitle.setForeground(Color.BLUE);
           choicesheetpanel.add(tbltitle,setConstraints (2,1,5,1));
           choicesheetpanel.add(Note, setConstraints (1,table.getY() + table.getHeight() + 1, 14, 1));
           choicesheetpanel.add(pane, setConstraints (1, 2,
                                                      table.getWidth() + 4, table.getHeight()/2));
           
           dataentryframe.add(choicesheetpanel, setConstraints(X, Y, W, H));

           dataentryframe.pack();
           
           displayButtons();
    }
/*
 * WIRING DIAGRAM :
 * Method Name : static void displayButtons ()
 * Parameters : None
 * Returns : None
 *
 * Called From : static void displaySheet ()
 * Associated Methods : ChoiceSheet::static void DeleteTakenMarkerFile (String p_file)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : When this method is called the Spreadsheet has already been instantiated. This method
 * adds Buttons at the bottom of the scrollpane within which the spreadsheet is contained and also adds some
 * ActionListener classes for each Button ssAddButton(), ssAddFileButton (), ssEditButton(), ssDeleteButton (),
 * ssSaveButton(). And finally a call to dataentryframe.pack() to draw. For the Print and Cancel Buttons
 * we use Anonymous classes.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    static void displayButtons ()
    {
          int X = table.getX() + 1, Y = table.getY() + table.getHeight() + 2, W = 1, H = 1;
          
          choicesheetpanel.add(Add = new JButton("Add Row"), setConstraints(X, Y, W, H));
          X += (Add.getWidth() + 1);
          choicesheetpanel.add(AddFile = new JButton("Add File"), setConstraints(X, Y, W, H));
          X += (AddFile.getWidth() + 1);
          choicesheetpanel.add(Edit = new JButton("Edit Row"), setConstraints(X, Y, W, H));
          X += (Edit.getWidth() + 1);
          choicesheetpanel.add(Delete = new JButton("Delete Row"), setConstraints(X, Y, W, H));
          X += (Delete.getWidth() + 1);
          choicesheetpanel.add(Save = new JButton("Save Data"), setConstraints(X, Y, W, H));
          X += (Save.getWidth() + 1);
          choicesheetpanel.add(Print = new JButton("Print Table"), setConstraints(X, Y, W, H));
          X += (Print.getWidth() + 1);
          choicesheetpanel.add(Cancel = new JButton("Cancel"), setConstraints(X, Y, W, H));          
          X += (Cancel.getWidth() + 1);
          choicesheetpanel.add(ReNumber = new JButton("ReNumber"), setConstraints(X, Y, W, H)); 
          
          Add.addActionListener(new ssAddButton());
          Add.setToolTipText("Add a New row");
          AddFile.addActionListener(new ssAddFileButton ());
          AddFile.setToolTipText("Upload a file from disk");
          Edit.addActionListener(new ssEditButton());
          Edit.setToolTipText("Edit Selected row");
          Delete.addActionListener(new ssDeleteButton ());
          Delete.setToolTipText("Delete Selected row from this table");
          Save.addActionListener(new ssSaveButton());
          Save.setToolTipText("Save Table Changes to Disk File");
          ReNumber.addActionListener(new ssReNumberButton());
          ReNumber.setToolTipText("ReNumber Table Rows Ascending/Sequentially");
          
          Print.setToolTipText("Spool this table to Printer");
          Print.addActionListener(new ActionListener ()
          {
              @Override
              public void actionPerformed (ActionEvent evnt){
                  try
                  {
                      table.print();
                  }catch (PrinterException ex_NOKIA76){
                      System.err.println(grassHopper("Printer Connectivity Problem/Others"));
                      JOptionPane.showMessageDialog(dataentryframe, "Printer Problem");
                      JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                      return;
                  }
              }
          });

          Cancel.addActionListener(new ActionListener ()
          {
              @Override
              public void actionPerformed (ActionEvent evnt)
              {
                  ChoiceSheet.DeleteTakenMarkerFile(SpreadSheet.chosen_table);
                  JOptionPane.showMessageDialog(dataentryframe, "Cancelling. Changes after last save"
                          + "\n" + "will not be Saved");
                  ChoiceSheet.choicesheetpanel.removeAll();
                  ChoiceSheet.choicesheetpanel.validate();   
                  ChoiceSheet.choicesheetpanel.repaint();
                  dummy = new ChoiceSheet();
                  return;
              }
          });
          Cancel.setToolTipText("Cancel and Go Back to ChoiceSheet");

          choicesheetpanel.setVisible(true);
          choicesheetpanel.validate();          
          choicesheetpanel.repaint();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, SpreadSheet.cells, SpreadSheet.dataentryframe, fieldseperator
 * Method Name : protected static boolean savespreadsheettofile ()
 * Parameters : None
 * Returns : boolean true -- true if no errors and spreadsheet for chosen_table SAVE() to file
 *           boolean false -- if errors of any kind
 *
 * Called From : SAVE() method of interface Data. All the table classes implement the interface DATA.
 * Associated Methods : ChoiceSheet::static void DeleteTakenMarkerFile (String p_file)
 *
 * Data File : DotingEntry.NetworkDrive + "LensViewDataEntry" + FIlESEPERATOR + chosen_table + "_de" + ".de";
 *
 * @Since Version : 1.0
 *
 * Running Commentary : When this method is called from the SAVE() method of each of the tables. The SAVE()
 * method is called when the user clicks SAVE button after editing or entering data using DataSheet.
 * It writes data in Spreadsheet.cells to Data File above.Each row is terminated by LiveDB.fieldseperator
 * followed by newline. After writing all rows it deletes the taken marker file. These marker files are
 * created to allow multi-user data entry. So if one user picks one table the other users can operate on
 * that table.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * Last Modified : 16th October 2011
 * Last Modifications : modified this patch of code in the else clause
        if (fn.canWrite())
        {
            try{
                fw = new FileWriter(fn);
                bw = new BufferedWriter(fw);
            }catch (FileNotFoundException ex_NOKIA8){
               ALRTLVL = 2;
               System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA8));
               JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                       + filetowrite + "\n" + "Cannot Save data Exiting ..." );
               return false;
            }catch (IOException ex_NOKIA1){
               ALRTLVL = 2;
               System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA1));
               JOptionPane.showMessageDialog(dataentryframe, "IOException contact SYSADM " + "\n"
                       + filetowrite + "\n" + "Cannot Save data Exiting ..." );
               return false;
            }
        }
        else
        {
               if (fn.setWritable(true, true) == false)
               {
                    ALRTLVL = 2;
                    System.err.println(grassHopper("File:" + filetowrite));
                    JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                       + filetowrite + "\n" + "Cannot Save data Exiting ..." );
               }
               else
               {
                    try{
                        fw = new FileWriter(fn);
                        bw = new BufferedWriter(fw);
                    }catch (FileNotFoundException ex_NOKIA8){
                        ALRTLVL = 2;
                        System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA8));
                        JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                                + filetowrite + "\n" + "Cannot Save data Exiting ..." );
                        return false;
                    }catch (IOException ex_NOKIA1){
                        ALRTLVL = 2;
                        System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA1));
                        JOptionPane.showMessageDialog(dataentryframe, "IOException contact SYSADM " + "\n"
                            + filetowrite + "\n" + "Cannot Save data Exiting ..." );
                        return false;
                    }
               }
        }
 *
 *
 * Last Modified : 30th May 2012
 * Last Modifications : Altered the following source line
   Row = Row + fieldseperator + '\n';
   TO
   Row = Row + '\n';
 *
 * Last Modifications Date : 23rd June 2012
 * Last Modifications : Marked as 23rd June
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean savespreadsheettofile ()
    {
        String filetowrite = DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR + chosen_table
                                                                                        + "_de" + ".de";

        // Just in case some other programmer modifies source code to a relative path
        filetowrite = new File(filetowrite).getAbsolutePath(); // Added line on 23rd June 2012
        
        File fn = new File(filetowrite);
        FileWriter fw = null;
        BufferedWriter bw = null;
        String Row = null;
        String eol = System.getProperty("line.seperator");  
        
        if (eol == null)
        {
            if (DotingEntry.OPERATINGSYSTEM.indexOf(DotingEntry.WINDOWS) != -1)
                eol = "\r\n";
            else eol = "\n";
        }
        
        
        if (fn.canWrite())
        {
            try{
                fw = new FileWriter(fn);
                bw = new BufferedWriter(fw);
            }catch (FileNotFoundException ex_NOKIA8){
               ALRTLVL = 2;
               System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA8));
               JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                       + filetowrite + "\n" + "Cannot Save data Exiting ..." );
               return false;
            }catch (IOException ex_NOKIA1){
               ALRTLVL = 2;
               System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA1));
               JOptionPane.showMessageDialog(dataentryframe, "IOException contact SYSADM " + "\n"
                       + filetowrite + "\n" + "Cannot Save data Exiting ..." );
               return false;
            }
        }
        else
        {
               if (fn.setWritable(true, true) == false)
               {
                    ALRTLVL = 2;
                    System.err.println(grassHopper("File:" + filetowrite));
                    JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                       + filetowrite + "\n" + "Cannot Save data Exiting ..." );
               }
               else
               {
                    try{
                        fw = new FileWriter(fn);
                        bw = new BufferedWriter(fw);
                    }catch (FileNotFoundException ex_NOKIA8){
                        ALRTLVL = 2;
                        System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA8));
                        JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                                + filetowrite + "\n" + "Cannot Save data Exiting ..." );
                        return false;
                    }catch (IOException ex_NOKIA1){
                        ALRTLVL = 2;
                        System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA1));
                        JOptionPane.showMessageDialog(dataentryframe, "IOException contact SYSADM " + "\n"
                            + filetowrite + "\n" + "Cannot Save data Exiting ..." );
                        return false;
                    }
               }
        }

        // now format the celldata and write to file

        for (int i = 0; i < SpreadSheet.cells.length; i++, Row = null)
        {
            for (int k = 0; k < SpreadSheet.cells[i].length; k++)
            {
                Row = Row == null ? SpreadSheet.cells[i][k] + fieldseperator: 
                                            Row + SpreadSheet.cells[i][k] + fieldseperator;
            }
            Row = Row + eol ;
            //Row = Row + fieldseperator + '\n';

            try{
                 bw.write(Row);
            }catch(IOException ex_NOKIA3){
                System.err.println(grassHopper("File:" + filetowrite, ex_NOKIA3));
                JOptionPane.showMessageDialog(dataentryframe, "IOException contact SYSADM " + "\n"
                       + filetowrite + "\n" + "Cannot write data Exiting ..." );
                return false;
            }
        }

        try{
            bw.close();
        }catch(IOException ex_NOKIA7){
            System.err.println(grassHopper(ex_NOKIA7, "File:" + filetowrite)) ;
            JOptionPane.showMessageDialog(dataentryframe, "System Error Cannot Close File:"
                    + "\n" + filetowrite + " Contact SYSADM" + "\n" + "Exiting ....");
            return false;
        }

        ChoiceSheet.DeleteTakenMarkerFile(SpreadSheet.chosen_table);
        
        return true;
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, SpreadSheet.cells, SpreadSheet.dataentryframe, fieldseperator
 * Method Name : protected static boolean loaddataintospreadsheetcells ()
 * Parameters : None
 * Returns : boolean true -- true if no errors and spreadsheet for chosen_table SAVE() to file
 *           boolean false -- if errors of any kind
 *
 * Called From : LOAD() method of interface Data. All the table classes implement the interface DATA.
 *
 * Data File : DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR + chosen_table + "_de" + ".de";
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from the LOAD() method of each of the tables. The LOAD()
 * method is called automatically when the user clicks on a table choice on ChoiceSheet. LOAD() method
 * for a specific table is also called when the user clicks on the AddFile Button under the SpreadSheet.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * Last Modification Date : June 5th 2012
 * Last Modifications : I am re-loading the indexes that i am maintaining which I have declared in
 * ChoiceSheet.java. These indexes are being used to validate during data entry for unique keys for
 * each table and so therefore they need to be re-loaded every time the tables are chosen for Data
 * Entry purposes. Look at the following patch of code starting with this
          if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
          {

              try{

              ChoiceSheet.indxfiletabledatafilemap = (HashMap)ois.readObject();
              }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  System.exit(1);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : Added some extra checks and balances to check if the index files exist on disk
 * and they can be read safely. If not it exist at most places with an error message.
 * These indexes need not necessarily exist on disk for example when the first time the data entry program
 * in invoked. Also if they exist and cant be read then there is a problem and we cant continue we have to
 * exit since these indexes are very important for data entry validations.
 *
 * Last Modification Date : June 6th 2012
 * Last Modifications : If you have already done some data entry manually and then you decide to upload
 * the rest of the data using a File. Even otherwise if you choose to upload data from a file. We have
 * to update those indexes (HashMaps) in ChoiceSheet.java because these indexes ensure validations of
 * table keys during data entry sessions. So I have added this extra method call in this patch of code
                  if (appendfile)
                  {
                    if (UpdateIndices (Fields) == false)
                    {
                      System.err.println(grassHopper("Error Updating Indices, Maybe Null value in data file"));
                      System.exit(1);
                    }
                  }
 *
 * Last Modifications Date : 23rd June 2012
 * Last Modifications : Marked with date
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean loaddataintospreadsheetcells (){


        String filetoload = DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR + chosen_table
                                                                                     + "_de" + ".de";
        filetoload = ssAddFileButton.loadthisfile != null ? ssAddFileButton.loadthisfile:filetoload;
        
        filetoload = new File(filetoload).getAbsolutePath(); // Added on 23rd June
        
        File fn = new File(filetoload);
        String Row = null;
        String Fields [] = null;
        
        FileReader fr = null;
        BufferedReader br = null;

        
        String psf = (DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                  + "indx" + SpreadSheet.chosen_table.trim()).trim() + ".ndx";
        
        File pf = new File (psf);
        
        FileInputStream fis = null;
        ObjectInputStream ois = null;

        
        boolean appendfile = false;
        
        if (SpreadSheet.chosen_action.equalsIgnoreCase("AddFile"))
            appendfile = true ;

        
        if (pf.exists())
        {
            try{
                fis = new FileInputStream (pf);
            }catch (FileNotFoundException ex_NOKIA9){
                ALRTLVL = 13;
                System.err.println(grassHopper(ex_NOKIA9));
                JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                System.exit(1);
            }

            try{
                ois = new ObjectInputStream (fis);
            }catch (IOException ex_NOKIA71){
                ALRTLVL = 13;
                System.err.println(grassHopper(ex_NOKIA71));
                JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                System.exit(1);
            }
        }

        if (pf.exists() && pf.canRead() == false)
            pf.setReadable(true, false);


          if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
          {
               
              if (pf.canRead())
              {
                try{
                    
                    ChoiceSheet.indxfiletabledatafilemap = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
              
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxdefaultadvertisingimages = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxlanguagesupport = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxlanguagetitles = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxlanguagetransalations = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxpaymenttype = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxpicturedatabase = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
          {
              if (pf.canRead())
              {
                try{

                    ChoiceSheet.indxpictureoptions = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
          {
              if (pf.canRead())
              {
                try{
                    ChoiceSheet.indxsearchdatabase = (HashMap)ois.readObject();
                }catch (ClassNotFoundException ex_NOKIA63){
                  System.err.println(grassHopper(ex_NOKIA63));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
                }

              }
              else if (pf.exists())
              {
                  System.err.println(grassHopper("Cant Read index for table" + SpreadSheet.chosen_table));
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }
          }

          
        if (SpreadSheet.chosen_action.equalsIgnoreCase("AddFile") == false)  
            SpreadSheet.cells = null; // blank this out for a fresh load
        

        if (fn.exists())
        {
            if (fn.canRead() == false)
            {
                if (fn.setReadable(true, false) == false)
                {
                    System.err.println(grassHopper("Cant setRead:" + filetoload));
                    JOptionPane.showMessageDialog(dataentryframe, "Cant setReadable on File:" + "\n"
                          + filetoload + '\n' + "Cannot Load data Exiting ..." );
                    return false;
                }
            }
            try{
                fr = new FileReader(fn);
                br = new BufferedReader(fr);
            }catch(FileNotFoundException ex_NOKIA91){
               ALRTLVL = 2;
               System.err.println(grassHopper("File:" + filetoload, ex_NOKIA91));
               JOptionPane.showMessageDialog(dataentryframe, "Prankster has altered file perms on " + "\n"
                       + filetoload + "\n" + "Cannot Load data Exiting ..." );
               return false;
            }
        }
        else
        {
               ALRTLVL = 2;
               System.err.println(grassHopper("FileNotFound:" + filetoload));
               return false;
        }

        if (fn.length() == 0)  // Added on 28th June
            return true;  // fake this

        
        int i = 0, j = -1, ii = 0, fcnt = 0;
        int si = SpreadSheet.cells == null ? 0 : SpreadSheet.cells.length;
        char [] rowarr = null;
        Object prevrows [][] = null;
        int tbl = 0;
        
        if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
               tbl = DotingEntry.ft;          
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
               tbl = DotingEntry.da;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
               tbl = DotingEntry.ls;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
               tbl = DotingEntry.lt;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
               tbl = DotingEntry.ltr;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
               tbl = DotingEntry.pt;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
               tbl = DotingEntry.pd;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
               tbl = DotingEntry.po;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
               tbl = DotingEntry.sd;
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("celebritytable"))
                tbl = DotingEntry.clt;
        
        try{

            while ((Row = br.readLine()) != null)
            {
                  j = -1; i = 0;
                
                  if (fcnt == 0)
                  {
                      rowarr = Row.toCharArray();
                      for (int c = 0; c < rowarr.length; c++)
                      {
                          if (rowarr[c] == fieldseperator.toCharArray()[0]) fcnt++;
                          if (fcnt > Integer.parseInt(
                              DotingEntry.tablenameidentifier[tbl][3]))
                          {
                             JOptionPane.showMessageDialog(SpreadSheet.dataentryframe,
                                            "FILE FORMAT FOR LOAD INCORRECT");
                              return false;
                          }
                      }
                      Fields = new String[fcnt];                      
                  }
                  
                  //if (SpreadSheet.cells != null)
                  //    prevrows = new Object[SpreadSheet.cells.length][fcnt];
                  
                  while ((j = Row.indexOf(fieldseperator, j+1)) != -1)
                  {
                            Fields [ii] = Row.substring (i, j);
                            i = j + 1;
                            ii++;
                  }

                  
                  if (appendfile)
                  {
                      
                    if (UpdateIndices (Fields) == false)
                    {
                      System.err.println(grassHopper("Error Updating Indices, Maybe Null value in data file"));
                      JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                      
                      System.exit(1);
                    }
                  }


                  for (int x = 0, y = -2; x < Fields.length; x++)
                  {                      

                      if (SpreadSheet.cells != null)
                      {                          
                          prevrows = new Object [SpreadSheet.cells.length][fcnt];
                          System.arraycopy(SpreadSheet.cells, 0, prevrows, 0, SpreadSheet.cells.length);
                      }     
                      
                      if (y != si)
                      {
                          SpreadSheet.cells = si <= 0 ? new Object [1][fcnt] : new Object [si+1][fcnt];
                          y = si;
                      }
                      
                      if (prevrows != null)
                          System.arraycopy(prevrows, 0, SpreadSheet.cells, 0, prevrows.length);
                      
                      // dont use toString here it will return a final into cells !!
                      
                      SpreadSheet.cells[si][x] = new String(Fields[x]);                      
                  } 
                  
                  si++;
                  ii = 0;
            }            
        }catch (IOException ex_NOKIA9){            
            System.err.println(grassHopper(ex_NOKIA9, "File:" + filetoload)) ;
            JOptionPane.showMessageDialog(dataentryframe, "System Error Cannot Load File:"
                    + "\n" + filetoload + " Contact SYSADM" + "\n" + "Exiting ....");
            return false;
        }

        
        try{
            br.close();
        }catch(IOException ex_NOKIA7){
            System.err.println(grassHopper(ex_NOKIA7, "File:" + filetoload)) ;
            JOptionPane.showMessageDialog(dataentryframe, "System Error Cannot Close File:"
                    + "\n" + filetoload + " Contact SYSADM" + "\n" + "Exiting ....");
            return false;
        }
        
        return true;
    }

    // JUST A NEW METHOD TO UPDATE INDICES ADDED ON 6th June 2012
    // CALLED FROM protected static boolean loaddataintospreadsheetcells ()
    private static boolean UpdateIndices (String p_Fields[]){

        boolean alreadyempty = false;

        if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
        {
            
            alreadyempty = ChoiceSheet.indxfiletabledatafilemap.isEmpty();
            if (ChoiceSheet.indxfiletabledatafilemap.put(Integer.parseInt(p_Fields[0]),
                                                            Integer.parseInt(p_Fields[0])) == null
                                                            && alreadyempty == false)
            {
             // there appears to be a bug in oos.writeObject or oos.readObject in Save
             // and up above code. Because this put is returning a null value for perfectly
             // valid key=value pairs. When I try and put in a duplicate key as below it 
             // should return the previous value associated with the key instead it is returning
             // null. Otherwise at other places where I try and do a get on the HashMap it returns
             // the correct value. So I am faking it for now and returning true instead
             // of false.   
                return true;
            } 
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
        {
            alreadyempty = ChoiceSheet.indxdefaultadvertisingimages.isEmpty();
            if (ChoiceSheet.indxdefaultadvertisingimages.put(p_Fields[0].trim(), p_Fields[0].trim())
                    == null && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
        {
            alreadyempty = ChoiceSheet.indxpicturedatabase.isEmpty();
            if (ChoiceSheet.indxpicturedatabase.put(p_Fields[0].trim(), p_Fields[0].trim()) == null
                    && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
        {
            alreadyempty = ChoiceSheet.indxpaymenttype.isEmpty();
            if (ChoiceSheet.indxpaymenttype.put(p_Fields[0] + p_Fields[1].trim(), p_Fields[0]
                                                                        + p_Fields[1].trim()) == null
                                                                        && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
        {
            alreadyempty = ChoiceSheet.indxlanguagetitles.isEmpty();
            if (ChoiceSheet.indxlanguagetitles.put(p_Fields[0].trim() + p_Fields[1],
                                                        p_Fields[0].trim() + p_Fields[1]) == null
                                                        && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
        {
            alreadyempty = ChoiceSheet.indxlanguagetransalations.isEmpty();
            if (ChoiceSheet.indxlanguagetransalations.put(p_Fields[0].trim() + p_Fields[1].trim(),
                                                        p_Fields[0].trim() + p_Fields[1].trim()) == null
                                                        && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
        {
            alreadyempty = ChoiceSheet.indxlanguagesupport.isEmpty();
            if (ChoiceSheet.indxlanguagesupport.put(p_Fields[1].trim(), p_Fields[1].trim()) == null
                    && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
        {
            alreadyempty = ChoiceSheet.indxsearchdatabase.isEmpty();
            if (ChoiceSheet.indxsearchdatabase.put(p_Fields[0] + p_Fields[1],
                                                            p_Fields[0] + p_Fields[1]) == null
                                                            && alreadyempty == false)
                return true;
        }
        else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
        {
            alreadyempty = ChoiceSheet.indxpictureoptions.isEmpty();
            if (ChoiceSheet.indxpictureoptions.put(p_Fields[0].trim() + p_Fields[1].trim()
                                                                            + p_Fields[2].trim(),
                                    p_Fields[0].trim() + p_Fields[1].trim() + p_Fields[2].trim()) == null
                                    && alreadyempty == false)
                return true;
        }

        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:DotingEntry.NetworkDrive, chosen_table, SpreadSheet.cells, SpreadSheet.dataentryframe
 * Method Name : protected static boolean doesdataentryfilexist (String... p_Action)
 * Parameters : String... p_Action -- just a dummy parameter pass anything or nothing
 *
 * Returns : boolean true -- true if no errors 
 *           boolean false -- when the data entry file *.de does not exist and p_Action is null.
 *
 * Called From : SAVE() method of interface Data. All the table classes implement the interface DATA.
 *
 * Data File : DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR + chosen_table + "_de" + ".de"
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called twice from the SAVE(). This is a dual purpose method
 * when it is called with a parameter (dummy) it does one thing and something else when parameters are
 * zero.
 *
 * If you pass a parameter and *.de data entry file does not exist in the directory LensViewDataEntry then
 * it creates a new file for chosen_table with .de extension and does setWritable on both file and directory.
 * If you dont pass a parameter and that file (*.de) does not exist then it nullifies SpreadSheet.cells.
 *
 * If you pass a parameter and *.de data entry file exists in the directory LensViewDataEntry then it sets
 * writable perms on the file *.de. If you dont pass a parameter and *.de data entry file exists in directory
 * LensViewDataEntry then it sets read perms on both the directory and the file.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 *
 * Last Modifications Date : 22nd June 2012
 * Last Modifications : Made changes to this patch of code. Take a looksy
              try{
              if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                + chosen_table + "_de" + ".de").createNewFile() == false )
              {
                    // This createNewFile will fail if either the checkwrite of SecurityManager
                    // encounters problems or this file already exists on disk. If this file
                    // already exists on disk it is a prank file that has been slipped in by
                    // some miserable ....
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de").exists())
                    {
                        System.err.println(grassHopper("PRANK FILE:" +
                                DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de"));
                        JOptionPane.showMessageDialog(dataentryframe,
                                "PRANK FILE:"
                                    + DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de" + '\n' + " contact SYSADM immediately" );
                        System.exit(1);
                    }
              }
              }catch (SecurityException ex_NOKIA88){
                  System.err.println(grassHopper(ex_NOKIA88,
                          "File:" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de"));
                  JOptionPane.showMessageDialog(dataentryframe, "SecurityException while creating File"
                          + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de");
                  System.exit(1);
              }catch (IOException ex_NOKIA7){
                  System.err.println(grassHopper("File:" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de", ex_NOKIA7));
                  JOptionPane.showMessageDialog(dataentryframe, "IOException while creating File"
                          + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de");
                  System.exit(1);
              }

              // if createNewFile does not set writable perms on the file we set it here
              if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                + chosen_table + "_de" + ".de").canWrite() == false)
              {
                  if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                        + chosen_table + "_de" + ".de").setWritable(true, false) == false)
                  {
                      System.err.println(grassHopper("File:" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de" + "  Cant setWrite"));
                      JOptionPane.showMessageDialog(dataentryframe, "File:" + DotingEntry.NetworkDrive
                              + "LensViewDataEntry" + FILESEPERATOR + chosen_table + "_de" + ".de"
                              + '\n' + "  Cant setWrite");
                      System.exit(1);
                  }
              }
          }
      }
      else
      {
          if (p_Action.length != 0)
          {
                if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").canWrite() == false)
                {
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").setWritable(true, true) == false)
                    {
                        System.err.println(grassHopper("cannot setWritable(true,true)"));
                        JOptionPane.showMessageDialog(dataentryframe,
                                              "cannot setWritable(true,true) for directory"
                                    + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                    + "\n" + " contact SYSADM immediately" );
                        System.exit(1);
                    }
                }

                if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                    + chosen_table + "_de" + ".de").canWrite() == false )
                {
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de").setWritable(true, true) == false )
                    {
                        System.err.println(grassHopper("cannot setWritable(true,true)"));
                        JOptionPane.showMessageDialog(dataentryframe, "cannot setWritable(true,true) for table"
                                    + "\n" + chosen_table + " contact SYSADM immediately" );
                        System.exit(1);
                    }
                }
          }
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean doesdataentryfilexist (String... p_Action)
    {
        
      if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                + chosen_table + "_de" + ".de").exists() == false )
      {          
          if (p_Action.length == 0)
          {
              SpreadSheet.cells = null;
              return false;
          }
          else
          {
              if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").canWrite() == false)
              {
                  if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").setWritable(true, false) == false)
                  {
                        System.err.println(grassHopper("cannot setWritable(true,true)"));
                        JOptionPane.showMessageDialog(dataentryframe, "cannot setWritable(true,true) for directory"
                                    + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                    + "\n" + " contact SYSADM immediately" );
                        JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                        System.exit(1);
                  }
              }

              try{
              if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                + chosen_table + "_de" + ".de").createNewFile() == false )
              {
                    // This createNewFile will fail if either the checkwrite of SecurityManager
                    // encounters problems or this file already exists on disk. If this file
                    // already exists on disk it is a prank file that has been slipped in by
                    // some miserable ....
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de").exists())
                    {
                        System.err.println(grassHopper("PRANK FILE:" +
                                DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de"));
                        JOptionPane.showMessageDialog(dataentryframe, 
                                "PRANK FILE:"
                                    + DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de" + '\n' + " contact SYSADM immediately" );
                        JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                        System.exit(1);
                    }                  
              }
              }catch (SecurityException ex_NOKIA88){
                  System.err.println(grassHopper(ex_NOKIA88,
                          "File:" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de"));
                  JOptionPane.showMessageDialog(dataentryframe, "SecurityException while creating File"
                          + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de");
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }catch (IOException ex_NOKIA7){
                  System.err.println(grassHopper("File:" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de", ex_NOKIA7));
                  JOptionPane.showMessageDialog(dataentryframe, "IOException while creating File"
                          + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de");
                  JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                  System.exit(1);
              }

              // if createNewFile does not set writable perms on the file we set it here
              if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                + chosen_table + "_de" + ".de").canWrite() == false)
              {
                  if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                        + chosen_table + "_de" + ".de").setWritable(true, false) == false)
                  {
                      System.err.println(grassHopper("File:" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                 + FILESEPERATOR + chosen_table + "_de" + ".de" + "  Cant setWrite"));
                      JOptionPane.showMessageDialog(dataentryframe, "File:" + DotingEntry.NetworkDrive
                              + "LensViewDataEntry" + FILESEPERATOR + chosen_table + "_de" + ".de"
                              + '\n' + "  Cant setWrite");
                      JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                      System.exit(1);
                  }
              }
          }
      }
      else
      {
          if (p_Action.length != 0)
          {
                if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").canWrite() == false)
                {
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").setWritable(true, true) == false)
                    {
                        System.err.println(grassHopper("cannot setWritable(true,true)"));
                        JOptionPane.showMessageDialog(dataentryframe,
                                              "cannot setWritable(true,true) for directory"
                                    + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                    + "\n" + " contact SYSADM immediately" );
                        JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                        System.exit(1);
                    }
                }
                
                if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                    + chosen_table + "_de" + ".de").canWrite() == false )
                {
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de").setWritable(true, true) == false )
                    {
                        System.err.println(grassHopper("cannot setWritable(true,true)"));
                        JOptionPane.showMessageDialog(dataentryframe, "cannot setWritable(true,true) for table"
                                    + "\n" + chosen_table + " contact SYSADM immediately" );
                        JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                        System.exit(1);
                    }
                }
          }
          else // check Read Perms
          {
                if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").canWrite())
                {
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").setReadable(true, true) == false)
                    {
                        System.err.println(grassHopper("cannot setReadable(true,true)"));
                        JOptionPane.showMessageDialog(dataentryframe, "cannot setReadable(true,true) for directory"
                                    + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                    + "\n" + " contact SYSADM immediately" );
                        JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                        System.exit(1);
                    }
                }

                if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                    + chosen_table + "_de" + ".de").canWrite()) // changed it to canWrite here
                {
                    if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                            + chosen_table + "_de" + ".de").setReadable(true) == false )
                    {
                        System.err.println(grassHopper("cannot setReadable(true)"));
                        JOptionPane.showMessageDialog(dataentryframe, "cannot setReadable(true) for table"
                                    + "\n" + chosen_table + " contact SYSADM immediately");
                        JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                        System.exit(1);
                    }
                }
          }
      }
      
      return true;
    }
/*
 * WIRING DIAGRAM :
 * Method Name : GridBagConstraints setConstraints (int X, int Y, int W, int H)
 * Parameters : int X -- gridX
 *              int Y -- gridY
 *              int W -- gridwidth
 *              int H -- gridheight
 *
 * Returns : GridBagConstraints  -- an instance of the constraints that you set
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method sets constraints as per your params and returns an instance of the same
 * to be used with dataentryframe.add as in method ShowUngalChoices ().
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    static GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        GridBagConstraints constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}


