/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import static DataEntryPrograms.DotingEntry.grassHopper;

import static DataEntryPrograms.DotingEntry.ErrorLogFile;
import static DataEntryPrograms.SpreadSheet.dataentryframe;
import MaintainData.LiveDB;
import java.io.File;
import javax.swing.JFileChooser;

/*
 * WIRING DIAGRAM :
 * @LOOKSY : SpreadSheet.chosen_action, SpreadSheet.chosen_table, SpreadSheet.table,
 * @LOOKSY : SpreadSheet.dataentryframe, SpreadSheet.cells
 * Listener Class Name : ssAddFileButton implements ActionListener
 * Methods : Look in Class definition
 * Data Attributes : None
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class is a registered action listener for SpreadSheet Button AddFile. It has
 * just an actionPerformed method which checks chosen_table and based on that calls LOAD() method for that
 * specific table.
 *
 * Technical References : None
 *
 * Musical Accompanyments : AMERICA The Complete greatest Hits.
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class ssAddFileButton implements ActionListener {

    static String loadthisfile ;
    @Override
    public void actionPerformed (ActionEvent evnt)
    {
         JFileChooser chooser = new JFileChooser();
         int result = 0;
               
         SpreadSheet.chosen_action = "AddFile";
         chooser.setCurrentDirectory(new File(".")); // "." indicates cwd (current working directory)
         chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
         result = chooser.showOpenDialog(dataentryframe);         
         
         if (result == JFileChooser.APPROVE_OPTION)
             loadthisfile = chooser.getSelectedFile().getPath();
         else if (result == JFileChooser.CANCEL_OPTION)
             return;
         else if (result == JFileChooser.ERROR_OPTION)
             loadthisfile = DotingEntry.NetworkDrive + "LensViewDataEntry" 
                            + DotingEntry.FILESEPERATOR + SpreadSheet.chosen_table
                            + "_de" + ".de";         
            
         if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
         {
             if (new filetabledatafilemap().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile filetabledatafilemap failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile filetabledatafilemap failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
         {
             if (new defaultadvertisingimages().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile defaultadvertisingimages failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile defaultadvertisingimages failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
         {
             if (new languagesupport().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile languagesupport failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile languagesupport failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
         {
             if (new languagetitles().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile languagetitles failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile languagetitles failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
         {
             if (new languagetransalations().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile languagetransalations failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile languagetransalations failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
         {
             if (new paymenttype().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile paymenttype failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile paymenttype failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
         {
             if (new picturedatabase().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile picturedatabase failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile picturedatabase failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
         {
             if (new pictureoptions().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile pictureoptions failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile pictureoptions failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
         {
             if (new searchdatabase().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile searchdatabase failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile searchdatabase failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }
         else if (SpreadSheet.chosen_table.equalsIgnoreCase("celebritytable"))
         {
             if (new celebritytable().LOAD() == false)
             {
                 System.err.println(grassHopper("AddFile celebritytable failed"));
                 JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, "AddFile celebritytable failed");
                 JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                 return;
             }
         }       
         loadthisfile = null;
    }
}
