/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.io.IOException;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import java.io.File;
import javax.swing.JOptionPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import static DataEntryPrograms.SpreadSheet.dataentryframe;
import static DataEntryPrograms.DotingEntry.FILESEPERATOR;
import static DataEntryPrograms.DotingEntry.grassHopper;

import static DataEntryPrograms.DotingEntry.ErrorLogFile;


/*
 * WIRING DIAGRAM :
 * @LOOKSY : SpreadSheet.chosen_action, SpreadSheet.chosen_table
 * Listener Class Name : ssAddFileButton implements ActionListener
 * Methods : Look in Class definition
 * Data Attributes : None
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class is a registered action listener for SpreadSheet Button AddFile. It has
 * just an actionPerformed method which checks chosen_table and based on that calls SAVE() method for that
 * specific table.
 *
 * Technical References : None
 *
 * Musical Accompanyments : AMERICA The Complete greatest Hits.
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 5th 2012
 * Last Modifications : I have declared some indexes (HashMaps) in ChoiceSheet.java which I am using
 * for DataSheet validations for unique key values during data entry. I am writing these indexes to
 * disk here to be re-read once again when the user re-starts the data entry application.
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class ssSaveButton implements ActionListener {

    ChoiceSheet dummy;
    @Override
    public void actionPerformed (ActionEvent evnt)
    {
          String psf = (DotingEntry.NetworkDrive + "LensViewDataEntry" + FILESEPERATOR
                  + "indx" + SpreadSheet.chosen_table.trim()).trim() + ".ndx";
          File pf = new File (psf);
          FileOutputStream fos = null;
          ObjectOutputStream oos = null;
          
          try{
              fos = new FileOutputStream (pf);
          }catch (FileNotFoundException ex_NOKIA8){
              System.err.println(grassHopper(ex_NOKIA8));
              System.exit(1);
          }

          try{
              oos = new ObjectOutputStream (fos);
          }catch (IOException ex_NOKIA88){
              System.err.println(grassHopper(ex_NOKIA88));
              System.exit(1);
          }

          SpreadSheet.chosen_action = "Save";
          if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
          {
              if ( new filetabledatafilemap().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table filetabledatafilemap"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table filetabledatafilemap");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxfiletabledatafilemap);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
          {
              if ( new defaultadvertisingimages().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table defaultadvertisingimages"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table defaultadvertisingimages");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxdefaultadvertisingimages);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
          {
              if ( new languagesupport().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table languagesupport"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table languagesupport");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxlanguagesupport);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
          {
              if ( new languagetitles().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table languagetitles"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table languagetitles");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxlanguagetitles);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
          {
              if ( new languagetransalations().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table languagetransalations"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table languagetransalations");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxlanguagetransalations);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
          {
              if ( new paymenttype().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table paymenttype"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table paymenttype");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxpaymenttype);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
          {
              if ( new picturedatabase().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table picturedatabase"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table picturedatabase");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxpicturedatabase);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
          {
              if ( new pictureoptions().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table pictureoptions"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table pictureoptions");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxpictureoptions);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("celebritytable"))
          {
              if ( new celebritytable().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table searchdatabase"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table searchdatabase");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
          }
          else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
          {
              if ( new searchdatabase().SAVE() == false)
              {
                  System.err.println(grassHopper(dataentryframe, "SAVE FAIL table searchdatabase"));
                  JOptionPane.showMessageDialog(dataentryframe, "SAVE FAILED table searchdatabase");
                  JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
              }
              try{
              oos.writeObject(ChoiceSheet.indxsearchdatabase);
              }catch (IOException ex_NOKIA76){
                  System.err.println(grassHopper(ex_NOKIA76));
                  System.exit(1);
              }
          }
          ChoiceSheet.choicesheetpanel.removeAll();
          ChoiceSheet.choicesheetpanel.validate();   
          ChoiceSheet.choicesheetpanel.repaint();
          dummy = new ChoiceSheet();
    }

}
