/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataEntryPrograms;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import javax.swing.JOptionPane;
import static DataEntryPrograms.DotingEntry.tablenameidentifier;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:DataSheet.datasheetpanel, SpreadSheet.chosen_table, SpreadSheet.table, DotingEntry.tablenameidentifier
 * Listener Class Name : public class tf3TxtFldLsnr implements ActionListener
 * Methods : Look in Class definition
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class implements a common listener interface for all DataSheets for different
 * chosen_table and it also validates input field in the DataSheet every time the data is changed by user.
 * Earlier implementation had just one Listener class called TxtFldLsnr.java for everything which
 * implemented a different interface. That source code is no longer used but still there for you
 * to take a look if you want. Now this one large source file has been split into several sources
 * namely. tf1TxtFldLsnr.java, tf1TxtFldLsnr.java, tf2TxtFldLsnr.java, tf3TxtFldLsnr.java,
 * tf4TxtFldLsnr.java, tf5TxtFldLsnr.java, tf6TxtFldLsnr.java, tf7TxtFldLsnr.java, tf8TxtFldLsnr.java,
 * tf9TxtFldLsnr.java, combo1TxtFldLsnr.java, combo2TxtFldLsnr.java, combo3TxtFldLsnr.java,
 * tf1MouseAdapter.java, tf2MouseAdapter.java, tf3MouseAdapter.java, tf4MouseAdapter.java,
 * tf5MouseAdapter.java, tf6MouseAdapter.java, tf7MouseAdapter.java, tf8MouseAdapter.java,
 * tf9MouseAdapter.java, combo1MouseAdapter.java, combo2MouseAdapter.java, combo3MouseAdapter.java
 * 
 * Technical References : None
 *
 * Musical Accompanyments : None
 *
 * Start Date: 3rd July 2012
 * End Date: 4th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class tf3TxtFldLsnr implements ActionListener {

    static String prevfont = "sw";
    
    
    @Override
    public void actionPerformed (ActionEvent event){

        Validate();

    }
    static synchronized void Validate (){
            String txtval;
            Date ad = null;
            
            DataSheet.tf3.setForeground(Color.GREEN);
            //DataSheet.datasheetpanel.validate();

            if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
            {
                txtval = DataSheet.tf3.getText();

                // Added on 17th June 2012
                if (txtval.indexOf(' ') != -1 || txtval.indexOf('.') != -1
                        || txtval.indexOf(DotingEntry.FILESEPERATOR) != -1)
                {
                    DataSheet.tf3.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Spaces, dot(.) not allowed");
                    //DataSheet.tf3.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                
                if (txtval.equals(tablenameidentifier
                        [Integer.parseInt(String.valueOf(
                    DataSheet.combo1.getSelectedItem()))][1]) == false)
                {
                    DataSheet.tf3.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Table Name Identifier should be "
                            + "\n" + 
                    tablenameidentifier[Integer.parseInt(DataSheet.combo1.getSelectedItem().toString())][1]);
                    //DataSheet.tf3.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
            {
                
                txtval = DataSheet.tf3.getText();
                if (txtval.indexOf(DotingEntry.FILESEPERATOR) != -1)
                    txtval = txtval.substring(0, txtval.lastIndexOf(DotingEntry.FILESEPERATOR));
                
                if (new File (txtval).isDirectory())
                {
                    if (new File(txtval).canRead() == false)
                    {
                        DataSheet.tf3.setForeground(Color.RED);
                        //DataSheet.datasheetpanel.validate();
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "No read perms on directory");
                    }
                }
                else
                {
                    DataSheet.tf3.setForeground(Color.RED);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "directory does not exist");
                }
                String flnm;
                // now let us check if the combination of txtval and tf1.getText make a valid file
                if (new File(flnm=DataSheet.tf3.getText().trim() 
                        + DotingEntry.FILESEPERATOR 
                        + DataSheet.tf1.getText().trim()).exists() == false)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Image Name does not exist" 
                            + '\n' + flnm);
                }                
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
            {
                txtval = DataSheet.tf3.getText();
                char txtchars [] = txtval.toCharArray();

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (!(Character.isLetter(txtchars[i])) || txtchars[i] == '_')
                    {
                        if (!Character.isSpaceChar(txtchars[i]))
                        {
                            DataSheet.tf3.setForeground(Color.RED);
                            JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                        "Invalid Characters in Language Display Name");
                        }
                        //DataSheet.tf3.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
            {                
                txtval = DataSheet.tf3.getText();
                if (DataSheet.tf3.getText().trim().length() != 2)
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Language Codes can only be two letters"                            
                            + '\n' + "Google For a valid list of language codes"
                            + '\n' + "This application only supports those"
                            + '\n' + "contained in howtoinstall.txt");
                // Finally this is the solution but it makes it go into a loop
                // because of mouselisteners and each call to getFontName takes time
                if (prevfont.equals(DataSheet.tf3.getText()) == false)
                {
                    DataSheet.usefont = 
                         DotingEntry.getFontName(DataSheet.tf3.getText().toLowerCase().trim());                   
                }
                prevfont = new String(DataSheet.tf3.getText());   
                
                                
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
            {
                txtval = DataSheet.tf3.getText();
                char txtchars [] = txtval.toCharArray();

                if (txtchars.length == 0 || txtchars.length > 1)
                {
                        DataSheet.tf3.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                                       "GUI Text Area Number must be single"
                                                       + "\n" + " digit one thru nine");
                        //DataSheet.tf3.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                }

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (!Character.isDigit(txtchars[i]))
                    {
                        DataSheet.tf3.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                                       "GUI Text Area Number must be one thru nine");
                        //DataSheet.tf3.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }

                int num = Integer.parseInt(txtval);

                if ( num <= 0 || num > 9)
                {
                     DataSheet.tf3.setForeground(Color.RED);
                     JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                                       "GUI Text Area Number must be one thru nine");
                     //DataSheet.tf3.setFocusable(true);
                     //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
            {
                txtval = DataSheet.tf3.getText();
                Date ld = null;
                String datingpattern = "EEE MMM dd HH:mm:ss zzz yyyy";
                SimpleDateFormat sd = null;
                sd = new SimpleDateFormat(datingpattern, Locale.getDefault ());

                try{
                ld = sd.parse(txtval);
                }catch (ParseException ex_NOKIA88){
                     DataSheet.tf3.setForeground(Color.RED);
                     JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                      "Invalid Last Access Date use Format" + "\n" + " EEE MMM dd HH:mm:ss zzz yyyy");
                     //DataSheet.tf3.setFocusable(true);
                     //DataSheet.datasheetpanel.validate();
                }

                try{
                    ad = sd.parse(DataSheet.tf2.getText());
                }catch (ParseException ex_NOKIA45){
                     DataSheet.tf3.setForeground(Color.RED);
                     JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                      "Invalid Add Date use Format" + "\n" + " EEE MMM dd HH:mm:ss zzz yyyy");
                     DataSheet.tf3.setFocusable(true);
                     DataSheet.datasheetpanel.validate();                    
                }
                
                if (ld.before(ad))
                {
                     DataSheet.tf3.setForeground(Color.RED);
                     JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                      "Invalid Last Access Date must be on or" + "\n" + " after Database Add Date");
                     //DataSheet.tf3.setFocusable(true);
                     //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
            {
                txtval = DataSheet.tf3.getText();
                int row = 0;
                txtval = DataSheet.tf3.getText();
                try{
                row = Integer.parseInt(txtval);
                }catch (NumberFormatException ex_NOKIA67){
                    DataSheet.tf3.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf3.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (row < 0)
                {
                    DataSheet.tf3.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be positive"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf3.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();                    
                }
                if (SpreadSheet.table.getSelectedRow() > 0)
                {
                if (row != Integer.parseInt(SpreadSheet.cells[SpreadSheet.table.getSelectedRow() - 1][2].toString()) + 1)
                {
                    DataSheet.tf3.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential");
                    //DataSheet.tf3.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                }
                else if (SpreadSheet.table.getSelectedRow() == 0)
                {
                    if (row != 0)
                    {
                        DataSheet.tf3.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Row ID must be zero");
                        //DataSheet.tf3.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }
            }        
    }
}
