/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataEntryPrograms;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

import static DataEntryPrograms.DotingEntry.tablenameidentifier;
import static DataEntryPrograms.DataSheet.tf3;
import static DataEntryPrograms.DataSheet.tf4;

import static DataEntryPrograms.DataSheet.datasheetpanel;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:DataSheet.datasheetpanel, SpreadSheet.chosen_table, 
 * @LOOKSY:ChoiceSheet.indxlanguagetitles
 * Listener Class Name : public class tf4TxtFldLsnr implements ActionListener
 * Methods : Look in Class definition
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class implements a common listener interface for all DataSheets for different
 * chosen_table and it also validates input field in the DataSheet every time the data is changed by user.
 * Earlier implementation had just one Listener class called TxtFldLsnr.java for everything which
 * implemented a different interface. That source code is no longer used but still there for you
 * to take a look if you want. Now this one large source file has been split into several sources
 * namely. tf1TxtFldLsnr.java, tf1TxtFldLsnr.java, tf2TxtFldLsnr.java, tf3TxtFldLsnr.java,
 * tf4TxtFldLsnr.java, tf5TxtFldLsnr.java, tf6TxtFldLsnr.java, tf7TxtFldLsnr.java, tf8TxtFldLsnr.java,
 * tf9TxtFldLsnr.java, combo1TxtFldLsnr.java, combo2TxtFldLsnr.java, combo3TxtFldLsnr.java,
 * tf1MouseAdapter.java, tf2MouseAdapter.java, tf3MouseAdapter.java, tf4MouseAdapter.java,
 * tf5MouseAdapter.java, tf6MouseAdapter.java, tf7MouseAdapter.java, tf8MouseAdapter.java,
 * tf9MouseAdapter.java, combo1MouseAdapter.java, combo2MouseAdapter.java, combo3MouseAdapter.java
 * 
 * Technical References : None
 *
 * Musical Accompanyments : None
 *
 * Start Date: 3rd July 2012
 * End Date: 4th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
public class tf4TxtFldLsnr implements ActionListener {
    
        
    @Override
    public void actionPerformed (ActionEvent event){

        Validate();
 
    }
    
    static synchronized void Validate ()
    {
        String txtval;
            DataSheet.tf4.setForeground(Color.GREEN);
            //DataSheet.datasheetpanel.validate();
            if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
            {
                txtval = DataSheet.tf4.getText();
                // Added on 17th June 2012

                if (txtval.indexOf(' ') != -1 || txtval.indexOf('.') != -1 
                        || txtval.indexOf(DotingEntry.FILESEPERATOR) != -1)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Spaces not allowed");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (txtval.equals(tablenameidentifier[Integer.parseInt(String.valueOf(
                    DataSheet.combo1.getSelectedItem()))][1]) == false)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Class Name for Table should be "
                            + "\n" + 
                    tablenameidentifier[Integer.parseInt(DataSheet.combo1.getSelectedItem().toString())][1]);
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
            {
                txtval = DataSheet.tf4.getText();

                if (txtval.indexOf('X') == -1 && txtval.indexOf('x') == -1 )
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for XY Coordinates Input Value as " + "\n"
                    + "20X10 meaning X = 20 Y = 10");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (txtval.length() > 5)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for XY Coordinates Input Value as " + "\n"
                    + "20X10 meaning X = 20 Y = 10");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                char lookfor = ' ';

                if (txtval.indexOf('X') != -1)
                    lookfor = 'X';
                else if (txtval.indexOf('x') != -1)
                    lookfor = 'x';

                int X = 0, Y = 0;
                String x = null, y = null;

                x = txtval.substring(0, txtval.indexOf(lookfor));
                try{
                      X = Integer.parseInt(x);
                }catch (NumberFormatException ex_NOKIA91){
                       DataSheet.tf4.setForeground(Color.RED);
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                       "Invalid Value for XY Coordinates Input Value as " + "\n"
                       + "20X10 meaning X = 20 Y = 10");
                       //DataSheet.tf4.setFocusable(true);
                       //DataSheet.datasheetpanel.validate();
                }

                if (X == 0 || X > 99)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for XY Coordinates Input Value as " + "\n"
                    + "X cant be zero or greater than 99");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                y = txtval.substring(0, txtval.indexOf(lookfor));
                try{
                        Y = Integer.parseInt(y);
                }catch (NumberFormatException ex_NOKIA91){
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for XY Coordinates Input Value as " + "\n"
                    + "Y cant be zero or greater than 99");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (Y == 0 || Y > 99)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for XY Coordinates Input Value as " + "\n"
                    + "Y cant be zero or greater than 99");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
            {
                if (ChoiceSheet.indxlanguagetitles.get(tf3.getText().trim() + tf4.getText() ) != null)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    //datasheetpanel.validate();
                    JOptionPane.showMessageDialog(datasheetpanel,
                                        "This combination of language code and"
                        + "\n" + "english label is already present Re-Enter");
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
            {
                txtval = DataSheet.tf4.getText();
                int row = 0;

                try{
                row = Integer.parseInt(txtval);
                }catch (NumberFormatException ex_NOKIA67){
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (row < 0)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be positive"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();                    
                }
                if (SpreadSheet.table.getSelectedRow() > 0)
                {
                if (row != Integer.parseInt(SpreadSheet.cells[SpreadSheet.table.getSelectedRow() - 1][3].toString()) + 1)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                }
                else if (SpreadSheet.table.getSelectedRow() == 0)
                {
                    if (row != 0)
                    {
                        DataSheet.tf4.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Row ID must be zero");
                        //DataSheet.tf4.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
            {
                txtval = DataSheet.tf4.getText();
                char txtchars[] = txtval.toCharArray();

                if (txtchars[0] != 'J')
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                "GUI Text Area Type such as JTextArea, JTextField");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (!Character.isLetter(txtchars[i]))
                    {
                        DataSheet.tf4.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                              "GUI Text Area Type such as JTextArea, JTextField"
                                              + "\n" + " JEditorPane, JLabel must be all letters");
                        //DataSheet.tf4.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
            {
                txtval = DataSheet.tf4.getText();
                char txtchars[] = txtval.toCharArray();

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (!(Character.isLetter(txtchars[i]) || txtchars [i] == ' ' || txtchars[i] == '_' ))
                    {
                        DataSheet.tf4.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                         "Picture Category contains invalid characters"
                         + "\n" + "only letters and spaces and underscores");
                        //DataSheet.tf4.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
            {
                txtval = DataSheet.tf4.getText();
                int row = 0;

                try{
                row = Integer.parseInt(txtval);
                }catch (NumberFormatException ex_NOKIA67){
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (row < 0)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be positive"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();                    
                }
                if (SpreadSheet.table.getSelectedRow() > 0)
                {
                if (row != Integer.parseInt(SpreadSheet.cells[SpreadSheet.table.getSelectedRow() - 1][4].toString()) + 1)
                {
                    DataSheet.tf4.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential");
                    //DataSheet.tf4.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                }
                else if (SpreadSheet.table.getSelectedRow() == 0)
                {
                    if (row != 0)
                    {
                        DataSheet.tf4.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Row ID must be zero");
                        //DataSheet.tf4.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }
            }        
    }
    
}
