/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.awt.event.KeyEvent;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import static MaintainData.FirstPage.footerpanel;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : FooterPanel
 *
 * @LOOKSY : FirstPage.java
 * @LOOKSY : SaleItemsPage.java
 * @LOOKSY : CataloguePage.java
 *
 * @LOOKSY : FirstPage.footerpanel, FirstPage.pageonetextpanel, FirstPage.latestprodspanel,
 *           LensView.DEFAULT_HEIGHT,
 *
 * Date File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructs the bottompane for the screen where several options
 * are listed for the user to choose from such as 'CONTACT US', RMA's, 'System Admin'.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class FooterPanel
{
    protected static JTabbedPane bottompane;

    public FooterPanel ()
    {
        int MF = 10;
        footerpanel = new JPanel();
        footerpanel.setBackground(Color.BLUE);
        footerpanel.setBorder(BorderFactory.createEtchedBorder(Color.BLUE, Color.BLACK));
        footerpanel.setBounds((int)(FirstPage.latestprodspanel.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.latestprodspanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.pageonetextpanel.RIGHT_ALIGNMENT * MF) - (int)(FirstPage.pageonetextpanel.LEFT_ALIGNMENT * MF),
                (int)(LensView.DEFAULT_HEIGHT) - (int)(FirstPage.footerpanel.TOP_ALIGNMENT * MF) -2);
        addfooterpanel();
    }
    void addfooterpanel()
    {
        int ti = 0; // tab index in bottompane

        bottompane = new JTabbedPane ();
        bottompane.addTab("Contact Us", null);
        bottompane.addTab("SALE NOTICE", null);
        bottompane.addTab("Corporate", null);
        bottompane.addTab("DEALERSHIPS", null);
        bottompane.addTab("Payment Options", null);
        bottompane.addTab("RESIDENTIAL VISITS", null);
        bottompane.addTab("SALES AGENT", null);
        bottompane.addTab("SHOWROOM", null);
        bottompane.addTab("Customer Returns", null);
        bottompane.addTab("Terms and Conditions", null);
        bottompane.addTab("System Admin", null);
        
        bottompane.addChangeListener(new BottomPaneListener());
        bottompane.setForeground(Color.WHITE);
        
        if ((ti = bottompane.indexOfTab("Contact Us")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_C);

        if ((ti = bottompane.indexOfTab("SALE NOTICE")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_N);

        if ((ti = bottompane.indexOfTab("Corporate")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_R);

        if ((ti = bottompane.indexOfTab("DEALERSHIPS")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_D);

        if ((ti = bottompane.indexOfTab("Payment Options")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_P);

        if ((ti = bottompane.indexOfTab("RESIDENTIAL VISITS")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_E);

        if ((ti = bottompane.indexOfTab("SALES AGENT")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_A);

        if ((ti = bottompane.indexOfTab("SHOWROOM")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_O);

        if ((ti = bottompane.indexOfTab("Customer Returns")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_U);

        if ((ti = bottompane.indexOfTab("Terms and Conditions")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_T);

        if ((ti = bottompane.indexOfTab("System Admin")) != -1)
            bottompane.setMnemonicAt(ti, KeyEvent.VK_Y);
        
        bottompane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
    }
}
