/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import javax.swing.JComboBox;
import javax.swing.BoxLayout;
import java.util.Random;
import javax.swing.ProgressMonitor;
import java.io.IOException;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.Date;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import static MaintainData.LanguagePanel.SelectedLanguage;
import static MaintainData.LoginPage.LoggedInCID;
import static MaintainData.FirstPage.invoicepanel;
import static MaintainData.FirstPage.cartpanel;
import static MaintainData.LiveDB.cr;
import static MaintainData.LiveDB.sc;
import static MaintainData.LiveDB.ct;
import static MaintainData.LiveDB.pd;
import static MaintainData.LiveDB.ar;
import static MaintainData.LiveDB.pt;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : InvoicePage
 *
 * @LOOKSY: CustomerRegister.java
 * @LOOKSY: ShoppingCart.java
 * @LOOKSY: ArtLeaves.java
 * @LOOKSY: PaymentType.java
 * @LOOKSY: ShoppingCart.java
 * @LOOKSY: ViewBasketPanel.java
 *
 * @LOOKSY:FirstPage.pageonetextpanel, LiveDB.grassHopper, LiveDB.ALRTLVL, LiveDB.serializedfilespath,
 * @LOOKSY:FirstPage.featuredpanel, FirstPage.cartpanel, LiveDB.FILESEPERATOR, LiveDB.indxcustomerRegister,
 * @LOOKSY:LiveDB.appframe, LiveDB.indxpaymentType, LiveDB.indx1shoppingCart, LiveDB.indxlanguageTitles,
 * @LOOKSY:LiveDB.indx2pictureOptions, LiveDB.indx2shoppingCart, LiveDB.indxpictureOptions,
 * @LOOKSY:LiveDB.STOREHOLIDAYS, LiveDB.STORETIMINGS, LiveDB.LiveSharedDB, LiveDB.SendNotificationEmail,
 * @LOOKSY:LiveDB.indx2shoppingCart, LaunchGUI.MAX_WIDTH, LanguagePanel.SelectedLanguage
 *
 * Data File : None
 *
 * Associated Methods : public ViewBasketPanel () constructor from ViewBasketPanel.java
 *
 * Class Dedicated to : All our Heroines the world over
 *                      The Song Michael Franks the Art of Tea/Song NIGHTMOVES.
 *
 * @Since Version : 1.0
 *
 * Running Commentary : The invoice page will display the Qty, Product, Price, Line Price details
 * and also draw stamp size images. It also generates an invoice and emails it as attachment to
 * customer & company email. Invoice is always printed in American Dollar (USD).
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 11th October 2011
 * 
 * Last Modification Date : 11th August 2012
 * Last Modifications : Marked as 11th August 2012
 * 
 * Last Modification Date : 14th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar( Technical
 * reference read The Last Caucasian).
 * 
 * Last Modification Date : 16th August 2012
 * Last Modifications : Marked as 16th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : Marked as 17th August 2012
 * Also search for LiveDB.USEFONT
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class InvoicePage {

    GridBagConstraints constraints = null;
    // removed declaration and its usage 11thAugust 2012
    //String langstring [] = null;
    JLabel viewbasket = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket")
            == null ? "View Basket" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket"));
    JLabel addmore = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Want to add more items")
            == null ? "Want to add more items ?" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Want to add more items") + " ?");
    JLabel enterprodcode = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Enter the Product Code")
            == null ? "Enter the Product Code:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Enter the Product Code") + ":");
    JTextField addprod = new JTextField ("PIC01", 7);
    JButton addprodcode = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Add")
            == null ? "Add" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Add"));
    JPanel titlebar = new JPanel (new GridBagLayout());

    // Dont transalate these into languages let it remain in English
    JLabel Qty = new JLabel ("Qty");
    JLabel Product = new JLabel ("Product");
    JLabel Code = new JLabel ("Code");
    JLabel Stock = new JLabel ("Stock");
    JLabel Price = new JLabel ("Price");
    JLabel LinePrice = new JLabel ("Line Price");
        
    long picqty [] = null;
    String ponumbers [] = null;
    String piccode [] = null;
    String picimg [] = null;
    String pictitle [] = null;
    String picsubopts [] = null;
    float picprice [] = null;
    float picdiscount [] = null;
    JPanel stampsize [] = null;
    String globalsubopts [][] = null;
    JButton delete [] = null;
    JTextField QtyTxtFlds [] = null;
    JScrollPane basketpane = null;
    JLabel BasketTotal = null;
    JButton cont = null;
    JButton emptybasket = null;
    float baskettotals = 0.0F;
    float refunds [] = null;
    long paymentmodes [] = null;

    JLabel InvAddr = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Invoice Address")
            == null ? "Invoice Address" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Invoice Address"));
    JLabel InvFName = null;

    JLabel InvAddrLine1 = null;
    JLabel InvAddrLine2 = null;
    JLabel InvAddrLine3 = null;    
    JLabel InvTown = null;
    
    JLabel InvPost = null;
    JLabel InvCountry = null;
    JButton EditInvAddr =  new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Edit Invoice Address")
            == null ? "Update Invoice Address" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Edit Invoice Address"));
    String paymodes [] = null;
    JPanel editaddrpanel = new JPanel ();

    JTextField EditFName;
    JTextField EditAddr1;
    JTextField EditAddr2;
    JTextField EditAddr3;
    JTextField EditTown;
    JTextField EditPost;
    JComboBox EditCountry;
    Integer I[] = null;
    
    Object retval =  null; // 17th August 2012

    public InvoicePage ()
    {        
        int MF = 10;
        int pX = 0, pY = 0, pW = 0, pH = 0;
        long rid = LiveDB.indxcustomerRegister.get(LoggedInCID);
        final long RID = rid;
        long logno = 0L;
        
        int Y = 5, y = 0;
        String reppath = LiveDB.serializedfilespath + "etc";

        I = null; // Added 11th August 2012
        // check some perms quickly
        if (new File(reppath).canWrite() == false)
        {
            if (new File(reppath).exists() == false)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("directory destroyed:" + reppath));
                System.exit(1);
            }
            else
            {
                if (new File(reppath).setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("can set write perms:" + reppath));
                    System.exit(1);
                }
            }
        }
        
        FirstPage.invoicepanel = new JPanel (new GridBagLayout());

        editaddrpanel.setLayout(new BoxLayout(editaddrpanel, BoxLayout.Y_AXIS));
        
        LiveDB.appframe.remove(FirstPage.pageonetextpanel);
        LiveDB.appframe.remove(FirstPage.maillistpanel);
        LiveDB.appframe.remove(FirstPage.infopanel);
        LiveDB.appframe.remove(FirstPage.languagepanel);
        LiveDB.appframe.remove(FirstPage.currencypanel);
        LiveDB.appframe.remove(FirstPage.popularpanel);
        LiveDB.appframe.remove(FirstPage.featuredpanel);
        LiveDB.appframe.remove(FirstPage.salepanel);

        // first get all the paymodes from the table
        for (long id = 1; id <= LiveDB.indxpaymentType.size(); id++)
        {
             // grow the array 11th August 2012
             paymodes = paymodes == null ? new String[1] : Arrays.copyOf(paymodes, paymodes.length + 1);
             paymodes[paymodes.length -1] = ((PaymentType)LiveDB.LiveSharedDB[pt]
                     [(int)(long)LiveDB.indxpaymentType.get(String.valueOf(id))]).getPmt_type();
        }
/* old logic 
        for (int rw = 1, i = 0;
        (globalsubopts[globalsubopts.length][i] =
                LiveDB.indx2pictureOptions.get(rw + SelectedLanguage)) != null; rw++, i++);
                * */
                
        int rW = 1; int iii = 0;
        do // new logic 11th August 2012
        {
            // grow the array 11th August 2012
            globalsubopts = Arrays.copyOf(globalsubopts, globalsubopts.length + 1);
            globalsubopts[globalsubopts.length -1] = Arrays.copyOf(globalsubopts[globalsubopts.length -1],
                    iii + 1); 
            globalsubopts[globalsubopts.length -1][iii] = 
                    LiveDB.indx2pictureOptions.get(rW + SelectedLanguage);
            rW++; iii++;
        }while (LiveDB.indx2pictureOptions.get((rW - 1) + SelectedLanguage) != null);
        
        invoicepanel.setBounds(pX = 0, pY = (int)(cartpanel.TOP_ALIGNMENT * MF), pW = LaunchGUI.MAX_WIDTH - 6,
               pH = (int) (FirstPage.footerpanel.TOP_ALIGNMENT * MF) - 2);

        LiveDB.appframe.remove(FirstPage.cartpanel);

        basketpane = new JScrollPane(invoicepanel);

        invoicepanel.setBorder(BorderFactory.createLineBorder(Color.GRAY));

        InvFName = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustname());
        InvAddrLine1 = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustaddr1());
        InvAddrLine2 = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustaddr2());
        InvAddrLine3 = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustaddr3());
        InvTown = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustcity());
        InvPost = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustzip());
        InvCountry = new JLabel(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustnation());

        //invoicepanel.add(viewbasket, setConstraints(0,0,2,1)); // 17th August 2012
        invoicepanel.add(viewbasket, setConstraints(0,0,2,1));
        invoicepanel.add(addmore, setConstraints(16, 2, 4, 1));
        invoicepanel.add(enterprodcode, setConstraints(21, 2, 4, 1));
        invoicepanel.add(addprod, setConstraints(26, 2, 1, 1));

        addprod.addInputMethodListener(new InputMethodListener (){

            @Override
            public void inputMethodTextChanged(InputMethodEvent event)
            {
               if (LiveDB.indxpictureDatabase.get(addprod.getText()) == null)
               {
                   addprod.setText("Enter Valid Picture Code");
                   addprod.setFocusable(true);
                   addprod.validate();
               }
            }

            @Override
            public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
            }
        });

        invoicepanel.add(addprodcode, setConstraints(28, 2, 1, 1));
        addprodcode.addMouseListener(new MouseClickHandler (addprod.getText()));

        titlebar.setBackground(Color.GRAY);
        titlebar.setForeground(Color.WHITE);
        Qty.setForeground(Color.WHITE);
        Qty.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        Product.setForeground(Color.WHITE);
        Product.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
        Code.setForeground(Color.WHITE);
        Code.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
        Stock.setForeground(Color.WHITE);
        Stock.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
        Price.setForeground(Color.WHITE);
        Price.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
        LinePrice.setForeground(Color.WHITE);
        LinePrice.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));

        titlebar.add(Qty, setConstraints(1,0,1,1));
        titlebar.add(Product, setConstraints(6,0,2,1));
        titlebar.add(Code, setConstraints(14,0,1,1));
        titlebar.add(Stock, setConstraints(17,0,1,1));
        titlebar.add(Price, setConstraints(21,0,1,1));
        titlebar.add(LinePrice, setConstraints(23,0,1,1));

        InvAddr.setForeground(Color.GRAY);
        InvAddr.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        invoicepanel.add(InvAddr, setConstraints (0, 3, 3, 1));

        invoicepanel.add(InvFName, setConstraints (0, 4, 4, 1));

        invoicepanel.add(InvAddrLine1, setConstraints (0, 5, 4, 1));
        invoicepanel.add(InvAddrLine2, setConstraints (0, 6, 4, 1));
        invoicepanel.add(InvAddrLine3, setConstraints (0, 7, 4, 1));

        invoicepanel.add(InvTown, setConstraints (0, 8, 4, 1));
        invoicepanel.add(InvPost, setConstraints (0, 9, 4, 1));
        invoicepanel.add(InvCountry, setConstraints (0, 10, 4, 1));

        EditFName = new JTextField(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustname(),25);
        EditAddr1 = new JTextField(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustaddr1(),25);
        EditAddr2 = new JTextField(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustaddr2(),25);
        EditAddr3 = new JTextField(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustaddr3(),25);
        EditTown = new JTextField(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustcity(),20);
        EditPost = new JTextField(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rid]).getCustzip(),10);
        EditCountry = new JComboBox(RegistrationPage.nations);

        editaddrpanel.setBounds((int)(InvFName.RIGHT_ALIGNMENT * MF) + 10, 3, 8, 11);

        editaddrpanel.add(EditFName);
        editaddrpanel.add(EditAddr1);
        editaddrpanel.add(EditAddr2);
        editaddrpanel.add(EditAddr3);
        editaddrpanel.add(EditTown);
        editaddrpanel.add(EditPost);
        editaddrpanel.add(EditCountry);

        invoicepanel.add(editaddrpanel,
                setConstraints((int)(InvFName.RIGHT_ALIGNMENT * MF) + 10, 3, 8, 11));
        
        EditInvAddr.setBackground(Color.ORANGE);
        EditInvAddr.setForeground(Color.WHITE);
        invoicepanel.setBounds(pX = 0, pY = (int)(cartpanel.TOP_ALIGNMENT * MF), pW = LaunchGUI.MAX_WIDTH - 6,
               pH = (int) (FirstPage.footerpanel.TOP_ALIGNMENT * MF) - 2);
        invoicepanel.add(EditInvAddr, setConstraints (0, 12, 4, 1));
        EditInvAddr.addMouseListener(new MouseListener ()
        {
                     @Override
                     public void mousePressed (MouseEvent evnt){
                        EditInvAddr.setBackground(Color.MAGENTA);
                        EditInvAddr.validate();
                     }
                     @Override
                     public void mouseClicked (MouseEvent evnt){
                        String changeofaddress = null;

                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustname(EditFName.getText().trim());
                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustaddr1(EditAddr1.getText().trim());
                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustaddr1(EditAddr2.getText().trim());
                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustaddr1(EditAddr3.getText().trim());
                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustcity(EditTown.getText().trim());
                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustzip(EditPost.getText().trim());
                        ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                                .setCustnation(((String)EditCountry.getSelectedItem()).trim());
                        
                        LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                        new ChangeTracker ((long)cr,RID, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[cr][(int)(long)RID],
                        (long)LiveDB.LiveSharedDB[ct].length -1);

                        changeofaddress = "First Name:" + EditFName.getText().trim() + '\n' +
                                "Address 1:" + EditAddr1.getText().trim() + '\n' +
                                "Address 2:" + EditAddr2.getText().trim() + '\n' +
                                "Address 3:" + EditAddr3.getText().trim() + '\n' +
                                "Town:" + EditTown.getText().trim() + '\n' +
                                "Zip:" + EditPost.getText().trim() + '\n' +
                                "Nation:" + ((String)EditCountry.getSelectedItem()).trim();

                        if (LiveDB.PrepareAndSendMailMesg(null, null,
                            ((CustomerRegister)LiveDB
                            .LiveSharedDB[cr][(int)(long)RID]).getCustemail(),
                            ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                            "YOU HAVE CHANGED ADDRESS DETAILS ON "
                            + LiveDB.versionControl.getApplicationName(),
                            changeofaddress, null) == false)
                        {
                           LiveDB.SendNotificationEmail("Email Send to "
                               + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)(long)RID])
                               .getCustemail() + " Failed");
                        }

                        LiveDB.ALRTLVL = 5;
                        System.err.println(LiveDB.grassHopper("CID:"
                                + LoggedInCID + " has changed name,address details."));
                        System.gc();
                     }
                     @Override
                     public void mouseEntered (MouseEvent evnt){
                        EditInvAddr.setBackground(Color.MAGENTA);
                        EditInvAddr.validate();
                     }
                     @Override
                     public void mouseReleased (MouseEvent evnt){
                        EditInvAddr.setBackground(Color.ORANGE);
                        EditInvAddr.validate();
                     }
                     @Override
                     public void mouseExited (MouseEvent evnt){
                        EditInvAddr.setBackground(Color.ORANGE);
                        EditInvAddr.validate();
                     }
        });

        invoicepanel.add(titlebar, setConstraints(0,14,(int)(viewbasket.RIGHT_ALIGNMENT * MF)
                - (int)(viewbasket.LEFT_ALIGNMENT * MF),1));

        rid = LiveDB.indx2shoppingCart.get(LoginPage.LoggedInCID);

            // now search backwards
            for (int rw = (int)rid; rw >= 0; rw--)
            {
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getShopdate().after(LiveDB.today))
                {
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getBilled() == 1) // 17th August
                    {
                        // grow array 11thAugust 2012
                       piccode = piccode == null ? new String [1] : Arrays.copyOf(piccode, piccode.length + 1); 
                       piccode[piccode.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getPic();
                       // grow array 11th August 2012
                       picqty = picqty == null ? new long[1] : Arrays.copyOf(picqty, picqty.length + 1);
                       picqty[picqty.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getPic_qty();
                       // grow Array 11th August 2012
                       picsubopts = picsubopts == null ? new String [1] : Arrays.copyOf(picsubopts, picsubopts.length + 1);
                       picsubopts[picsubopts.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getSub_opt_id();
                       if (LiveDB.indxpictureDatabase.get(piccode[piccode.length -1]) != null )
                       {
                           // grow the array 11th August 2012
                           picimg = picimg == null ? new String [1] : Arrays.copyOf(picimg, picimg.length + 1);
                           picimg[picimg.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_img_location();
                           // grow Array 11th August 2012
                           picprice = picprice == null ? new float[1] : Arrays.copyOf(picprice, picprice.length + 1);
                           picprice[picprice.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_price();
                           // grow the Array 11th August 2012
                           pictitle = pictitle == null ? new String [1] : Arrays.copyOf(pictitle, pictitle.length + 1);
                           pictitle [pictitle.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_title();
                           // grow the array 11th August 2012
                           picdiscount = picdiscount == null ? new float[1] : Arrays.copyOf(picdiscount, picdiscount.length + 1);
                           picdiscount[picdiscount.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_discount();
                           if (LiveDB.indx2shoppingCart.get(LoggedInCID) != null)
                           {
                              for (int row = (int)(long)LiveDB.indx2shoppingCart.get(LoggedInCID);
                                           row >= 0; row--)
                              {
                                  if (((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getCid()
                                          .equals(LoggedInCID) &&
                                      ((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getPic()
                                      .equals(piccode[piccode.length -1]) &&
                                      ((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getShopdate()
                                      .after(LiveDB.today))
                                  { // BUG HERE CHEK DURING TESTING
                                       // grow Array 11th August 2012
                                       //picsubopts = picsubopts == null ? new String [1]:Arrays.copyOf(picsubopts, picsubopts.length + 1);                                      
                                       picsubopts[picsubopts.length -1] =
                                               ((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getSub_opt_id();
                                  }
                              }
                           }
                           else
                           {
                               LiveDB.ALRTLVL = 15;
                               System.err.println(LiveDB.grassHopper("indx2shoppingCart corruption"));
                               System.exit(1);
                           }
                       }
                       else
                       {
                           LiveDB.ALRTLVL = 15;
                           System.err.println(LiveDB.grassHopper("Master/Detail Corruption PictureDatabase/ShoppingCart"));
                           logno = LiveDB.logerrorno;
                           System.err.println ("LINE:" + logno + " " + "Missing pic code in indxpictureDatabase " + piccode[piccode.length -1]);
                           System.exit(1);
                       }
                    }
                }
            } // for (int rw = (int)rid; rw >= 0; rw--)

            for (int i = 0; i < piccode.length; i++)
            {
                 // grow array 11th August 2012
                 I = I == null ? new Integer[1] : Arrays.copyOf(I, I.length + 1);
                 I[I.length] = i;
                 invoicepanel.add(new JLabel (pictitle[i]), setConstraints(6,Y,3,1));
                 invoicepanel.add(new JLabel(LiveDB.indxpictureOptions.get(1 + SelectedLanguage)
                 + ":" + globalsubopts[0][Integer.parseInt(picsubopts[0].substring(1, 2))]), setConstraints(6, ++Y, 3, 1));
                 // grow the Array 11th August 2012
                 stampsize = stampsize == null ? new JPanel [1] : Arrays.copyOf(stampsize, i + 1);
                 stampsize [i] = new JPanel (new GridBagLayout());
                 FirstPage.DrawImage(null, picimg[i], stampsize[i],
                         picimg[i].substring(picimg[i].lastIndexOf('.'), picimg[i].length()));

                 invoicepanel.add(stampsize[i], setConstraints(4, Y, 6, 6));
                 invoicepanel.add(new JLabel(LiveDB.indxpictureOptions.get(2 + SelectedLanguage)
                 + ":" + globalsubopts[1][Integer.parseInt(picsubopts[1].substring(3, 4))]),
                         setConstraints(6, ++Y, 3, 1));

                 // grow Array 11th August 2012
                 delete = delete == null ? new JButton [1] : Arrays.copyOf(delete, delete.length + 1);
                 delete[delete.length -1] = new JButton ("X");
                 delete[delete.length -1].setBackground(Color.RED);
                 delete[delete.length -1].setForeground(Color.WHITE);
                 delete[delete.length -1].createToolTip().setToolTipText("Delete");

                 delete[delete.length -1].addMouseListener(new MouseListener (){
                     @Override
                     public void mousePressed (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.YELLOW);
                         delete[delete.length -1].validate();
                     }
                     @Override
                     public void mouseClicked (MouseEvent evnt){

                         // we have to delete this row from the table
                         // but our database engine only allows mark for deletion
                         // so we will do some hera pheri
                         // maybe we should include an extra method called isDeleted ()
                         // in every table

                         long rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[I[I.length -1]] + picsubopts[I[I.length -1]]);
                         
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(2L);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setPic_qty(0L);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setShopdate(null);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setTotal(0.0f);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setOrderdiscount(0.0f);
                         // Now mark this record for Deletion
                         LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                               new ChangeTracker (sc, rid, 'D', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[sc][(int)rid],
                                   (long)LiveDB.LiveSharedDB[ct].length -1);

                         retval = new ViewBasketPanel (); // 17th August 2012
                     }
                     @Override
                     public void mouseEntered (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.YELLOW);
                         delete[delete.length -1].validate();
                     }
                     @Override
                     public void mouseReleased (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.RED);
                         delete[delete.length -1].validate();
                     }
                     @Override
                     public void mouseExited (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.RED);
                         delete[delete.length -1].validate();
                     }
                 });

                 invoicepanel.add(delete[delete.length -1], setConstraints(1,8,1,1));
                 // grow array 11th August 2012
                 QtyTxtFlds = QtyTxtFlds == null ? new JTextField [1] : Arrays.copyOf(QtyTxtFlds, QtyTxtFlds.length + 1);
                 QtyTxtFlds [QtyTxtFlds.length -1] = new JTextField (picqty[i] + "", 3);
                 QtyTxtFlds [QtyTxtFlds.length -1].createToolTip().setToolTipText("Enter Non Decimal Integer Number");
                 QtyTxtFlds [QtyTxtFlds.length -1].addInputMethodListener(new InputMethodListener (){
                    @Override
                    public void inputMethodTextChanged(InputMethodEvent event)
                    {
                        float disco = 0.0f;
                        long rid = 0L;
                        try{                           
                          picqty[I[I.length -1]] =
                                Integer.parseInt(QtyTxtFlds [QtyTxtFlds.length -1].getText());
                        }catch (NumberFormatException ex_YESKIA23){
                            QtyTxtFlds [QtyTxtFlds.length -1].setText(picqty[I[I.length -1]] + "");
                            QtyTxtFlds [QtyTxtFlds.length -1].setFocusable(true);
                        }

                        // Update Basket here
                        ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                        [(int)(long) (rid = LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[I[I.length-1]]
                         + picsubopts[I[I.length -1]]))])
                         .setPic_qty(Long.parseLong(QtyTxtFlds [QtyTxtFlds.length -1].getText()));

                        ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                        [(int)(long)LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[I[I.length-1]]
                         + picsubopts[I[I.length -1]])])
                         .setOrderdiscount(disco = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                         [(int)(long)LiveDB.indxpictureDatabase.get(piccode[I[I.length-1]])]).getPic_discount()
                         * picqty[I[I.length-1]]);

                        ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                        [(int)(long)LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[I[I.length-1]]
                         + picsubopts[I[I.length -1]])])
                         .setTotal((Long.parseLong(QtyTxtFlds [QtyTxtFlds.length -1].getText())
                                                                    * picqty[I[I.length-1]]) - disco);

                        // Now one single delete entry for the entire row in ChangeTracker table
                        LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                               new ChangeTracker (sc, rid, 'U', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[sc][(int)rid],
                                   (long)LiveDB.LiveSharedDB[ct].length -1);
                    }

                    @Override
                    public void caretPositionChanged(InputMethodEvent event){
                              ; // dont bother
                    }

                 });

                 invoicepanel.add(QtyTxtFlds[QtyTxtFlds.length -1], setConstraints(3,++Y,1,1));
                 y = Y;
                 for (int opt = 3, X = 6; opt <= LiveDB.indxpictureOptions.size(); opt++, Y++)
                 {
                    invoicepanel.add(new JLabel(LiveDB.indxpictureOptions.get(opt + SelectedLanguage)
                    + ":" + globalsubopts[opt -1][Integer.parseInt(picsubopts[opt -1].substring(opt + 2, opt + 3))]),
                         setConstraints(X, Y, 3, 1));        // *1*2*3*4*5
                    opt++; // dont knock this out
                 }

                 invoicepanel.add(new JLabel(piccode[i]),
                    setConstraints((int)Code.LEFT_ALIGNMENT * MF, y, 2, 1));
                 invoicepanel.add(new JLabel ("IN-STOCK"),
                        setConstraints((int)Stock.LEFT_ALIGNMENT * MF, y, 2, 1));
                 invoicepanel.add(new JLabel ("" + picprice[i]),
                        setConstraints((int)Price.LEFT_ALIGNMENT * MF, y, 2, 1));
                 invoicepanel.add(new JLabel ("" + (picprice[i] * picqty[i])),
                        setConstraints((int)LinePrice.LEFT_ALIGNMENT * MF, y, 2, 1));
                 baskettotals += (picprice[i] * picqty[i]);
            }
        
        invoicepanel.add(new JLabel ("Subtotal:"), setConstraints((int)(Price.LEFT_ALIGNMENT * MF) - 4,
                Y++, 2, 1));
        invoicepanel.add(new JLabel ("Tax:"), setConstraints((int)(Price.LEFT_ALIGNMENT * MF) + 2,
                Y, 2, 1));
        invoicepanel.add(new JLabel ("n/a"), setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF) + 2,
                Y, 2, 1));
        Y++;
        invoicepanel.add(new JLabel ("Shipping:"), setConstraints((int)(Price.LEFT_ALIGNMENT * MF) - 4,
                Y, 2, 1));
        invoicepanel.add(new JLabel ("n/a"), setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF) - 4,
                Y, 2, 1)); Y++;
        BasketTotal = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Basket Total")
            == null ? "Basket Total:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Basket Total") + ":");
        BasketTotal.setForeground(Color.BLACK);
        BasketTotal.setFont(new Font ("Dialog", Font.BOLD, 10));
        invoicepanel.add(BasketTotal, setConstraints((int)(Price.LEFT_ALIGNMENT * MF) - 8,
                Y, 2, 1));
        invoicepanel.add(new JLabel ("" + baskettotals), setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF),
                Y, 2, 1));
        cont = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Continue")
            == null ? "Continue" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Continue"));

        cont.setBackground(Color.GREEN);
        cont.setForeground(Color.WHITE);
        invoicepanel.add(cont, setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF),
                ++Y, 2, 1));

        cont.addMouseListener(new MouseListener (){
            @Override
            public void mouseClicked (MouseEvent evnt){

                // FILL THIS UP WITH new PaymentProcessor ()
                // in next release for now send an email to notification mail box
                Date shopdate = new Date();
                String billfile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                  + LiveDB.USRNAME.trim() + LiveDB.NODENAME.trim()
                                  + new Date().getTime() + ".inv";
                String custdetailfile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                  + LiveDB.USRNAME.trim() + LiveDB.NODENAME.trim()
                                  + new Date().getTime() + ".cdet";
                File fl = null;
                FileWriter fw = null;
                BufferedWriter bw = null;
                long rw = LiveDB.indxcustomerRegister.get(LoggedInCID);
                int linesperpage = 0;
                long rid = 0L;
                String custemail = ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustemail();
                ProgressMonitor progressmonitor;
                
                char ch = 'A' ;
                int iii = 0;

                String filetext [] = {
                    "Customer Name:"
                    + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustname() + '\n',
                    "Billing/Delivery Address:"
                    + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr1() + '\n',
                    ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr2() + '\n',
                    ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr3() + '\n',
                    ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr4() + '\n',
                    "NEAR:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getLandmark() + '\n',
                    ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustcity() + '\n',
                    "ZIP CODE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustzip() + '\n',
                    ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustnation() + '\n',
                    "TELEPHONE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustphone() + '\n',
                    "  FAX:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustfax() + '\n',
                    "EMAIL ADDRESS:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustemail() + '\n',
                    "PERSONAL PARTICULARS FOLLOW" + '\n',
                    "CUSTOMER ID:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCid() + '\n',
                    "MARITAL STATUS:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustmaritalstatus() + '\n',
                    "BIRTH DATE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustbirthdate() + '\n',
                    "BIRTH CITY:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustbirthcity() + '\n',
                    "BIRTH STATE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustbirthstate() + '\n',
                    "BIRTH NATION:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustnation() + '\n',
                    "GENDER:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustsex() + '\n',
                    "LOGIN PARTICULARS FOLLOW" + '\n',
                    "USERNAME:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getUsername() + '\n',
                    "REGISTRATION DATE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustregisterdate() + '\n',
                    "LAST LOGIN:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustlogintime() + '\n',
                    "LAST LOGOUT:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustlogouttime() + '\n'
                } ;

              if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustflag() == 'O')
                  filetext[filetext.length] = "CUSTOMER STATUS:" + "ALIVE" + '\n';
              else if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustflag() == 'B')
                  filetext[filetext.length] = "CUSTOMER STATUS:" + "BAD" + '\n';
              else if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustflag() == 'C')
                  filetext[filetext.length] = "CUSTOMER STATUS:" + "CELEBRITY" + '\n';
              else if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustflag() == 'T')
                  filetext[filetext.length] = "CUSTOMER STATUS:" + "TOP GUN" + '\n';
              else if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustflag() == 'S')
                  filetext[filetext.length] = "CUSTOMER STATUS:" + "STAYIN ALIVE" + '\n';
              else if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustflag() == 'D')
                  filetext[filetext.length] = "CUSTOMER STATUS:" + "DEAD" + '\n';

              String invoiceheader [] = {
                  " " + '\n',
                  " " + '\n',
                  " " + '\n',
                  " " + '\n',
                  " " + '\n',
                  " " + '\n',
                  "                                                 INVOICE" + '\n',
                  "                ======================================================================================" +'\n',
                  "                FROM:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCompname() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getAddr1() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getAddr2() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getAddr3() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getAddr4() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCity() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getState() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getZipcode() + '\n',
                  "               " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCountry() + '\n',
                  "                EMAIL:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail2() + '\n',
                  "                PHONE:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getPhone1() + '\n',
                  "                ALTERNATE PHONE:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getPhone2() + '\n',
                  "                MOBILE:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getMobile1() + '\n',
                  "                ALTERNATE MOBILE:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getMobile2() + '\n',
                  "                FAX:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getFax1() + '\n',
                  "                ALTERNATE FAX:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getFax2() + '\n',
                  "                ======================================================================================" +'\n',
                  "                TO:"
                  + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustname() + '\n',
                  "                BILLING ADDRESS" + '\n',
                  "               " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr1() + '\n',
                  "               " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr2() + '\n',
                  "               " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr3() + '\n',
                  "               " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustaddr4() + '\n',
                  "                NEAREST LANDMARK:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getLandmark() + '\n',
                  "               " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustcity() + '\n',
                  "                ZIP CODE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustzip() + '\n',
                  "               " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustnation() + '\n',
                  "                YOUR EMAIL:" + custemail + '\n',
                  "                CUSTOMER CONTACT PHONE:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustphone() + '\n',
                  "                CUSTOMER FAX:" + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)rw]).getCustfax() + '\n',
                  "                ======================================================================================" +'\n'
              };

              String invoicebody [] = null;

              String invoicefooter [] =
              {
                  "                STORE RETURNS POLICY APPLYING TO INVOICE" + '\n',
                  "                Goods Once Sold Can be Returned for Refund after deduction  of Re-Stocking Fees" + '\n',
                  "                You will need to obtain a Return Material Authorization Number for the same and" + '\n',
                  "                return purchased goods at your expense in damage free condition  to  our  Store" + '\n',
                  "                address within specified time periods failing which the RMA will  automatically" + '\n',
                  "                stand cancelled and you will not be eligible for further refunds. All  Consumer" + '\n',
                  "                Disputes to be subject to jurisdiction of " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCity()
                                   + "," + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCountry() + " Consumer Courts" + '\n',
                  "                Our Store Restock Percentage is " + LiveDB.RESTOCKPERCENT + "%" + " Goods Return Period of" + '\n',
                  "                14 calendar days for customers within " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCountry() +
                  " & 21 calendar days for customers" + '\n',
                  "                outside " + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCountry() + " from payment receipt date. Goods Return Material Authorizations can" + '\n',
                  "                only be obtained for a maximum purchase of five photographs on any day. If your" + '\n',
                  "                order quantity exceeds five on a day you will not be eligible for RMA ( Return " + '\n',
                  "                Material Authorization ) and Refunds although you may still Exchange the Goods " + '\n',
                  "                within specified timelines as above at your expense(both costs of returning and" + '\n',
                  "                cost of re-shipping exchanged goods to you will be borne by you).All refund will" + '\n',
                  "                will be reduced or increased based on exchange rate of USD visa-vis currency you" + '\n',
                  "                paid Invoiced amount in at Invoice Date and Time to ensure refund of your moneys" + '\n',
                  "                actual worth at the date and time Invoice was generated by computer system." + '\n',
                  "                STORE HOLIDAYS:" + LiveDB.STOREHOLIDAYS.substring(0, 79) + '\n',
                  "                REGIONAL HOLIDAYS:" + LiveDB.OTHERHOLIDAYS.substring(0, 79) + '\n',
                  "                STORE TIMING:" + LiveDB.STORETIMINGS.substring(0, 79) + '\n',
                  "                RETAIN THIS KEYCODE TO OBTAIN AN RMA FROM THE SYSTEM WITHIN TIME FRAMES AS ABOVE." + '\n',
                  "                IF YOU LOOSE KEYCODE BELOW STORE CUSTOMER SERVICES CAN NOT RETRIEVE IT FOR YOU." + '\n'
              };

              progressmonitor = new ProgressMonitor(LiveDB.appframe, "Generating Invoice for Order",
                  "Checks In Progress", 0, 100);


              progressmonitor.setProgress(5);

              // first write the .cdet file and email that so that you can raise the invoice
              fl = new File (custdetailfile);
              
              try{
              fw = new FileWriter (fl);
              }catch (IOException ex_NOKIA21){
                  System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + custdetailfile));
                  LiveDB.system_exit = 1;
                  //LiveDB.SmoothExitCondition.signalAll();
              }

              bw = new BufferedWriter (fw);
              progressmonitor.setNote("Generating Customer Detail File");
              for (int i = 0; i < filetext.length; i++)
              {
                  try{
                  bw.write(filetext[i]);
                  }catch (IOException ex_NOKIA21){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + custdetailfile));
                    LiveDB.system_exit = 1;
                    //LiveDB.SmoothExitCondition.signalAll();
                  }
              }

              try{
              bw.close();
              }catch (IOException ex_NOKIA21){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + custdetailfile));
                    LiveDB.system_exit = 1;
                    //LiveDB.SmoothExitCondition.signalAll();
              }
              progressmonitor.setNote("Mail Customer Detail File");
              progressmonitor.setProgress(10);
              // MAIL the cdet file here as an attachment
              if (LiveDB.MailCustomerDetailFile(custdetailfile) == false)
              {
                      LiveDB.SendNotificationEmail("EMAIL FAILURE OF Customer Detail File Generated on Disk at File:" + custdetailfile);
                      LiveDB.ALRTLVL = 3;
                      System.err.println(LiveDB.grassHopper("Failure Email:" + " File:" + custdetailfile));
              }
              else fl.deleteOnExit();

              progressmonitor.setNote("Generating Invoice File");
              // set some fields and also get some
              for (int ii = 0, row = 0, pm = 10; ii < piccode.length; ii++, billfile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                  + LiveDB.USRNAME.trim() + LiveDB.NODENAME.trim()
                                  + new Date().getTime() + ".inv", linesperpage = 0,  pm += 90/piccode.length)
              {
                  if (pm != 10) progressmonitor.setProgress(pm);
                  
                  if (progressmonitor.isCanceled())
                  {
                     // Empty Basket Code                     
                     for (int k = 0; k < piccode.length; k++ )
                     {
                            // we have to delete this row from the table
                           // but our database engine only allows mark for deletion
                          // so we will do some hera pheri
                         // maybe we should include an extra method called isDeleted ()
                        // in every table

                         rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[k] + picsubopts[k]);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setPic_qty(0L);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setShopdate(null);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setTotal(0.0f);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setOrderdiscount(0.0f);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(6);
                         // Now mark this record for Deletion
                         LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                            new ChangeTracker (sc, rid, 'D', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[sc][(int)rid],
                                (long)LiveDB.LiveSharedDB[ct].length -1);
                     } // for (int k = 0; k < piccode.length; k++ )
                  } // if (progressmonitor.isCanceled())
                  // the index indx1shoppingCart should not fail here
                  ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                          [row = (int)(long)LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[ii] + picsubopts[ii])]).setShopdate(shopdate);
                  ((ShoppingCart)LiveDB.LiveSharedDB[sc][row])
                          .setOrdernumber(((ShoppingCart)LiveDB.LiveSharedDB[sc]
                          [row]).getOrdernumber() + 1);
                  // Now  U entry for the entire row in ChangeTracker table
                  LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                       new ChangeTracker (sc, row, 'U', LiveDB.pid, new Date (),
                                  LiveDB.LiveSharedDB[sc][(int)row],
                                  (long)LiveDB.LiveSharedDB[ct].length -1);

                  iii = new Random().nextInt(22);
                  ch += iii;

                  ponumbers = ponumbers == null ? new String [1] : Arrays.copyOf(ponumbers, ponumbers.length + 1);
                  ponumbers[ponumbers.length -1] = String.valueOf(ch).trim() + new Random().nextLong();
  
                  // grow array 11th August 2012
                  refunds = refunds == null ? new float[1] : Arrays.copyOf(refunds, refunds.length + 1);
                  refunds [refunds.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                          [row]).getRefund();
                  // grow Array 11th August 2012
                  paymentmodes = paymentmodes == null ? new long[1] : Arrays.copyOf(paymentmodes, paymentmodes.length + 1);
                  paymentmodes [paymentmodes.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                          [row]).getPmtid();
                  // now start writing the bill file

                  fl = new File (billfile);
                  progressmonitor.setNote("Generating Invoice File " + billfile );
                  try{
                     fw = new FileWriter (fl);
                  }catch (IOException ex_NOKIA21){
                     System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                     LiveDB.system_exit = 1;
                     //LiveDB.SmoothExitCondition.signalAll();
                  }

                  bw = new BufferedWriter (fw);

                  for (int i = 0; i < invoiceheader.length; i++)
                  {
                     try{
                         bw.write(invoiceheader[i]);
                     }catch (IOException ex_NOKIA21){
                          System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                          LiveDB.system_exit = 1;
                          //LiveDB.SmoothExitCondition.signalAll();
                     }
                  }
                  linesperpage += invoiceheader.length;
                  // grow the array 11th August 2012
                  invoicebody = invoicebody == null ? new String [1] : Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                PURCHASE ORDER:" + ponumbers[ponumbers.length -1] + "   INVOICE NUMBER:" + ponumbers[ponumbers.length -1] + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                ORDER DATE:" + shopdate.toString() + "    INVOICE DATE:" + new Date().toString() + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                PAYMENT VIA:"
                  + ((PaymentType)LiveDB.LiveSharedDB[pt]
                    [(int)(long)LiveDB.indxpaymentType.get(String.valueOf(paymentmodes[paymentmodes.length -1]))])
                    .getPmt_type() + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                For Credit Card payments you will be billed using PayPal/PayAmerica" + '\n' ;
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                All Prices and Discounts and Totals in USD(United States of America Dollar ($)" + '\n' ;
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] =
                  "                 -----------------------------------------------------------------------------------------" + '\n' ;
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                PIC CODE  PICTURE TITLE     PIC PRICE  LESS  QTY  TOTAL" + '\n' ;
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] =
                  "                 -----------------------------------------------------------------------------------------" + '\n' ;
                  // At all other places in the application we will use a currency converter
                  // but on the bill we will print the prices in USD (Super Power Currency)
                  baskettotals = 0.0f;
                  baskettotals = (picprice[ii] * picqty[ii]) - (picdiscount[ii] * picqty[ii]);
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                " + piccode[ii] + "     "
                          + pictitle[ii] + " " + "USD $" + picprice[ii] + "    " + "$" + picdiscount[ii] + "  " + picqty[ii] + "  "
                          + "$" + ((picprice[ii] * picqty[ii]) - (picdiscount[ii] * picqty[ii])) + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = " " + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);                  
                  invoicebody [invoicebody.length -1] = " " + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);                  
                  invoicebody [invoicebody.length -1] = "                 YOUR FRAMING CHOICES AS BELOW" + '\n';
                  for (int opt = 1, bi = 0; opt <= LiveDB.indxpictureOptions.size(); opt++)
                  {
                      // *1*4*5*3*2
                      // grow the array 11th August 2012
                      invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);                      
                      invoicebody[invoicebody.length -1] = "                 " +
                              LiveDB.indxpictureOptions.get(opt + SelectedLanguage)
                      + ":" + globalsubopts[opt -1][Integer.parseInt(picsubopts[ii].substring(bi = (opt * 2 -1), bi+1))];
                  }
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);                  
                  invoicebody [invoicebody.length -1] =
                  "                                                                                                       =========" + '\n' ;
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = " " + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] =
                  "                                                                                         GRAND TOTAL   " + baskettotals + '\n';         
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] =
                  "                                                                                          ========="  + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = " " + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                WE THANK YOU FOR YOUR ORDER" + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                YOU ARE ELIGIBLE FOR REFUND AS PER RETURN POLICY OF USD $:" + refunds [refunds.length-1] + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                TAX NOT APPLICABLE WE PAY YOUR TAXES" + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                FREE STANDARD SHIPPING CHARGES NOT APPLICABLE" + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = "                IF YOU REQUEST FASTER SHIPPING THAN STANDARD YOU WILL BE INVOICED ADDITIONALLY" + '\n';
                  // grow the array 11th August 2012
                  invoicebody = Arrays.copyOf(invoicebody, invoicebody.length + 1);
                  invoicebody [invoicebody.length -1] = " " + '\n';

                  for (int i = 0; i < invoicebody.length; i++, linesperpage++)
                  {
                     if (linesperpage >= 47)
                     {
                         try{
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                         }catch (IOException ex_NOKIA21){
                            System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                            LiveDB.system_exit = 1;
                            //LiveDB.SmoothExitCondition.signalAll();
                         }
                         linesperpage = 7;
                     }
                     try{
                         bw.write(invoicebody[i]);
                     }catch (IOException ex_NOKIA21){
                          System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                          LiveDB.system_exit = 1;
                          //LiveDB.SmoothExitCondition.signalAll();
                     }
                  }

                  // grow the array 11th August 2012
                  invoicefooter = invoicefooter == null ? new String [1] : Arrays.copyOf(invoicefooter, invoicefooter.length + 1);
                  invoicefooter[invoicefooter.length -1]= 
                  "                KEYCODE:<" + LoggedInCID + piccode[ii] + picsubopts[ii] + ">" + '\n';
                  // grow the array 11th August 2012
                  invoicefooter = Arrays.copyOf(invoicefooter, invoicefooter.length + 1);
                  invoicefooter[invoicefooter.length -1] =
                  "                KEYCODE IS WITHIN < & > SO DONT TYPE < & > ON THE SYSTEM." + '\n';
                  // grow the array 11th August 2012
                  invoicefooter = Arrays.copyOf(invoicefooter, invoicefooter.length + 1);
                  invoicefooter[invoicefooter.length -1] =
                  "                FUTURE TERMS & CONDITIONS OF SALE, RETURN POLICY ARE SUBJECT TO CHANGES" + '\n';
                  // grow the array 11th August 2012
                  invoicefooter = Arrays.copyOf(invoicefooter, invoicefooter.length + 1);
                  invoicefooter[invoicefooter.length -1] =
                  "                WITHOUT NOTICE IN WRITTEN OR VERBALLY OR ANY OTHER FORM OF COMMUNICATION" + '\n';
                  
                  for (int i = 0; i < invoicefooter.length; i++, linesperpage++)
                  {
                     if (linesperpage >= 47)
                     {
                         try{
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                            bw.write(" " + '\n');
                         }catch (IOException ex_NOKIA21){
                            System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                            LiveDB.system_exit = 1;
                            //LiveDB.SmoothExitCondition.signalAll();
                         }
                         linesperpage = 7;
                     }
                     try{
                         bw.write(invoicefooter[i]);
                     }catch (IOException ex_NOKIA21){
                          System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                          LiveDB.system_exit = 1;
                          //LiveDB.SmoothExitCondition.signalAll();
                     }
                  }

                  try{
                     bw.close();
                  }catch (IOException ex_NOKIA21){
                       System.err.println(LiveDB.grassHopper(ex_NOKIA21, "File:" + billfile));
                       LiveDB.system_exit = 1;
                       //LiveDB.SmoothExitCondition.signalAll();
                  }

                  rid = LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[ii] + picsubopts[ii]);
                  ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(4L);
                  ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setPonumber(ponumbers[ponumbers.length-1]);
                  // Now one single U entry for the entire row in ChangeTracker table
                  LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                       new ChangeTracker (sc, rid, 'U', LiveDB.pid, new Date (),
                                  LiveDB.LiveSharedDB[sc][(int)rid],
                                  (long)LiveDB.LiveSharedDB[ct].length -1);
                  // Within the loop email the .inv file as an attachment
                  // also send a notification email with billfile name just in case the
                  // attachment email does not reach the store owner for some reason at least
                  // the notification email will reach and he can pick the .inv from disk to print
                  LiveDB.SendNotificationEmail("Invoice Generated on Disk at File:" + billfile);
                  if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                        null, null, "EMAIL FROM " +
                        LiveDB.versionControl.getApplicationName() + " INVOICE DESK ",
                        "PLEASE FIND ATTACHED YOUR INVOICE FILE:" + billfile, billfile) == false)
                  {
                      LiveDB.SendNotificationEmail("EMAIL FAILURE OF Invoice Generated on Disk at File:" + billfile);
                      LiveDB.ALRTLVL = 3;
                      System.err.println(LiveDB.grassHopper("Failure Email:" + custemail + " File:" + billfile));
                  }
                  else
                  {
                      rid = LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[ii] + picsubopts[ii]);
                      ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(5L);
                      // Now one single U entry for the entire row in ChangeTracker table
                      LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                       new ChangeTracker (sc, rid, 'U', LiveDB.pid, new Date (),
                                  LiveDB.LiveSharedDB[sc][(int)rid],
                                  (long)LiveDB.LiveSharedDB[ct].length -1);
                  }
                  
                  if (LiveDB.PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                        null, null, "KEYCODE MAIL FROM " +
                        LiveDB.versionControl.getApplicationName() + " INVOICE DESK ",
                        "KEYCODE FOR CANCELLING/ALTERING INVOICE STATUS IS <"
                        + LoggedInCID + piccode[ii] + picsubopts[ii] + "> FOR INVOICEFILE:" + billfile, null) == false)
                  {
                      LiveDB.SendNotificationEmail("KEYCODE:<"
                              + LoggedInCID + piccode[ii] + picsubopts[ii] + ">" + "FILE:" + billfile);
                      LiveDB.ALRTLVL = 3;
                      System.err.println(LiveDB.grassHopper("Fail Email:" +
                              ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4() + " File:" + billfile));
                  }                  

                  progressmonitor.setNote("Emailing Invoice File:" + billfile);
                  if (LiveDB.EmailInvoice(billfile) == false)
                  {
                      LiveDB.SendNotificationEmail("EMAIL FAILURE OF Invoice Generated on Disk at File:" + billfile);
                      LiveDB.ALRTLVL = 3;
                      System.err.println(LiveDB.grassHopper("Invoice Email Failure:" + " File:" + billfile));
                  }
                  // even if the email fails invoice has still been generated so setCustlastdate
                  // 16th August 2012
                  ((CustomerRegister)LiveDB.LiveSharedDB[cr][LoginPage.LoggedInCustRow]).setCustlastdate(new Date());
                  LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                  new ChangeTracker ((long)cr,LoginPage.LoggedInCustRow, 'U', LiveDB.pid, new Date (),
                  LiveDB.LiveSharedDB[cr][LoginPage.LoggedInCustRow],
                          (long)LiveDB.LiveSharedDB[LiveDB.ct].length -1);
              } // for (int ii = 0, row = 0; ii < piccode.length; ii++)
              progressmonitor.close();
            }

            @Override
            public void mousePressed (MouseEvent evnt){
                 cont.setBackground(Color.ORANGE);
                 cont.validate();
            }
            @Override
            public void mouseReleased (MouseEvent evnt){
                 cont.setBackground(Color.GREEN);
                 cont.validate();
            }
            @Override
            public void mouseExited (MouseEvent evnt){
                 cont.setBackground(Color.GREEN);
                 cont.validate();
            }
            @Override
            public void mouseEntered (MouseEvent evnt){
                 cont.setBackground(Color.ORANGE);
                 cont.validate();
            }
        });

        emptybasket = new JButton ("Empty Basket");
        emptybasket.setBackground(Color.YELLOW);
        emptybasket.setForeground(Color.WHITE);
        emptybasket.createToolTip().setToolTipText("Danger Drag your mouse away !!");

        emptybasket.addMouseListener(new MouseListener (){

            @Override
            public void mousePressed (MouseEvent evnt){
                emptybasket.setBackground(Color.RED);
                emptybasket.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt) {
                // Booo hooo miserable son .......
                long rid = 0L;
                for (int k = 0; k < piccode.length; k++ )
                {
                     // we have to delete this row from the table
                     // but our database engine only allows mark for deletion
                     // so we will do some hera pheri
                     // maybe we should include an extra method called isDeleted ()
                     // in every table

                     rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[k] + picsubopts[k]);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setPic_qty(0L);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setShopdate(null);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setTotal(0.0f);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setOrderdiscount(0.0f);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(7);
                     // Now mark this record for Deletion
                     LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                            new ChangeTracker (sc, rid, 'D', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[sc][(int)rid],
                                (long)LiveDB.LiveSharedDB[ct].length -1);
                }
            }

            @Override
            public void mouseEntered (MouseEvent evnt) {
                emptybasket.setBackground(Color.RED);
                emptybasket.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt) {
                emptybasket.setBackground(Color.YELLOW);
                emptybasket.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt) {
                emptybasket.setBackground(Color.YELLOW);
                emptybasket.validate();
            }
        });

        invoicepanel.add(emptybasket, setConstraints(0, Y++, 2, 1));
        LiveDB.appframe.add(invoicepanel, setConstraints (pX, pY, pW, pH));        
        invoicepanel.validate();
        System.gc();
        
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
