/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.awt.GridBagConstraints;
import java.awt.Font;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import java.awt.Image;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.logopanel;
import static MaintainData.LiveDB.ar;
import static MaintainData.LanguagePanel.SelectedLanguage;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : LogoPanel
 *
 * @LOOKSY : LensView.DEFAULT_HEIGHT, LiveDB.appframe, LiveDB.serializedfilespath, LiveDB.FILESEPERATOR
 * @LOOKSY : LiveDB.ALRTLVL, LiveDB.grassHopper
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Logo Panel at north west corner
 * of screen. It also draws the logo image.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 * 
 * Last Modification Date : 11th August 2012
 * Last Modifications : Marked as 11th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : search for LiveDB.USEFONT
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class LogoPanel
{
    GridBagConstraints constraints = null;
    // removed declaration and its usage
    //String langstring [] = null;
    JLabel comp = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCompname())
            == null ? ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCompname() : LiveDB.indxlanguageTitles.get(SelectedLanguage + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCompname()));
    JLabel mesg = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + " Powered By Your Commerce !")
            == null ? " Powered By Your Commerce !" : LiveDB.indxlanguageTitles.get(SelectedLanguage + " Powered By Your Commerce !"));

    public LogoPanel ()
    {
        logopanel = new JPanel (new GridBagLayout());
        logopanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        logopanel.setBackground(Color.WHITE);
        addlogopanel();
    }

    void addlogopanel()
    {
        boolean readperms = true;        
        File file = null;
        String path = LiveDB.serializedfilespath + "images" + LiveDB.FILESEPERATOR + "companylogo.jpg";
        Image image = null;
        int infoflags = 0;
        int MF = 0 ;

        logopanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                     (int)(LiveDB.appframe.TOP_ALIGNMENT * MF),
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/16,
                (int)LensView.DEFAULT_HEIGHT/7);
        
        file = new File (path);

        if (file.canRead() == false)
        {
            if (file.exists())
            {
                try{
                if (file.setReadable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("cant set read perms File:" + path ));
                    readperms = false;
                }
                }catch (SecurityException ex_YESKIA67){
                    System.err.println(LiveDB.grassHopper("JSM denies set read perms on File:" + path ));
                    readperms = false;
                }
            }
        }

        if (file.exists() == false || readperms == false)
        {
             logopanel.setBackground(Color.BLUE);
             comp.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
             comp.setForeground(Color.ORANGE);
             mesg.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
             mesg.setForeground(Color.YELLOW);

             logopanel.add(comp, setConstraints ((int)(logopanel.LEFT_ALIGNMENT * MF) + 3,
                (int)(logopanel.BOTTOM_ALIGNMENT * MF) - 3, 3, 1));
             logopanel.add(mesg, setConstraints ((int)(logopanel.LEFT_ALIGNMENT * MF) + 4,
                (int)(logopanel.BOTTOM_ALIGNMENT * MF) - 2, 3, 1));
             return;
        }

        try{
            image = ImageIO.read(new File(path));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" + path));
            return ;
        }

        if (logopanel.getGraphics().drawImage(image, (int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(LiveDB.appframe.TOP_ALIGNMENT * MF),
                (int)(logopanel.RIGHT_ALIGNMENT * MF) - (int)(logopanel.LEFT_ALIGNMENT * MF), // width
                (int)(logopanel.BOTTOM_ALIGNMENT * MF) - (int)(LiveDB.appframe.TOP_ALIGNMENT * MF), // height
                null) == false)
        {
            logopanel.imageUpdate(image, infoflags,
                    (int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                    (int)(LiveDB.appframe.TOP_ALIGNMENT * MF),
                    (int)(logopanel.RIGHT_ALIGNMENT * MF) - (int)(logopanel.LEFT_ALIGNMENT * MF),
                    (int)(logopanel.BOTTOM_ALIGNMENT * MF) - (int)(LiveDB.appframe.TOP_ALIGNMENT * MF));

            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" + path));
            return;
        }

        comp.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        comp.setForeground(Color.ORANGE);
        mesg.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        mesg.setForeground(Color.YELLOW);

        logopanel.add(comp, setConstraints ((int)(logopanel.LEFT_ALIGNMENT * MF) + 3, 
                (int)(logopanel.BOTTOM_ALIGNMENT * MF) - 3, 3, 1));
        logopanel.add(mesg, setConstraints ((int)(logopanel.LEFT_ALIGNMENT * MF) + 4,
                (int)(logopanel.BOTTOM_ALIGNMENT * MF) - 2, 3, 1));
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
