/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

/*
 * WIRING DIAGRAM :
 * LISTENER CLASS NAME : MouseClickHandler extends MouseAdapter
 *
 * @LOOKSY : PicturePage.java
 *
 * Date File : None
 *
 * Called From : public ViewBasketPanel ()
 *
 * Associated Methods : public PicturePage(final String p_piccode)
 *
 * Constructor Parameters : final String p_piccode
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a registered action listener in class ViewBasketPanel for the Add Button.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 *
 * Last Modification Date : 17th August 2012
 * Last Modification : 17th August 2012
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class MouseClickHandler extends MouseAdapter
{
    String piccode = null;
    Object retval = null;  // 17th August 2012
    public MouseClickHandler (String p_piccode){
        piccode = p_piccode.toString();
    }

    @Override
    public void mouseClicked (MouseEvent evnt)
    {
         retval = new PicturePage (piccode); // 17th August 2012
         // if you dont trap the new Object into retval jvm may gargbage collect it
    }
}
