/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.Font;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import static MaintainData.FirstPage.popularpanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.LanguagePanel.SelectedLanguage;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : PopularPanel
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Popular Products Panel at east
 * corner of screen.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 * 
 * Last Modification Date : 11th August 2012
 * Last Modifications : Marked as 11th August 2012
 * 
 * Last Modifications Date : 17th August 2012
 * Last Modification : Marked as 17th August 2012
 * Also search for LiveDB.USEFONT
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class PopularPanel
{
    // removed declaration and its usage 11th August 2012
    //String langstring [] = null;
    JLabel tit = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Popular Products")
            == null ? "Popular Products" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Popular Products"));
    String pics [] = (String []) LiveDB.indx2shoppingCart.keySet().toArray();
    String pic [] = null;
    JLabel disp [] = null;
    Object retval = null ; // 17th August 2012
    
    public PopularPanel ()
    {
        int MF = 10;
        popularpanel = new JPanel ();
        popularpanel.setLayout(new BoxLayout(popularpanel, BoxLayout.Y_AXIS));
        popularpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        popularpanel.setBackground(Color.WHITE);
        popularpanel.setBounds((int)(FirstPage.featuredpanel.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.featuredpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.featuredpanel.RIGHT_ALIGNMENT * MF) - (int)(FirstPage.featuredpanel.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.infopanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.infopanel.TOP_ALIGNMENT * MF)
                + ((int)(FirstPage.currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.currencypanel.TOP_ALIGNMENT))
                + ((int)(FirstPage.currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.currencypanel.TOP_ALIGNMENT))/2);
        addpopularpanel(); // Oh shut up about these warnings
    }

    void addpopularpanel ()
    {
        int sno = 1;
       
        for ( int i = 0; i < (pics.length < 13 ? pics.length: 13) ; i++)
        {
            // grow array 11th August 2012
            pic = pic == null ? new String[1]:Arrays.copyOf(pic, i + 1);
            pic[pic.length -1] = pics[i].toString();
        }
        
        for (int i = 0 ; i < (pics.length < 13 ? pics.length: 13); i++)
        {
            pics[i] = 
            ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)LiveDB.indxpictureDatabase.get(pics[i])])
                    .getPic_title();
            pics[i] = sno + ". " + pics[i];
            sno++;
            disp = disp == null ? new JLabel[1] : Arrays.copyOf(disp, disp.length + 1);
            disp[disp.length -1] = new JLabel(pics[i]);
            disp[disp.length -1].setForeground(Color.BLUE);
        }

        tit.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 8));
        tit.setForeground(Color.BLACK);
        popularpanel.add(tit);

        for (int i = 0; i < disp.length; i++)
        {
            popularpanel.add(disp[i]);
        }

        // hope this works too i think i got away by a whisker
        // maybe i should rename the class as UNPopularPanel
        
        for (int i = 0; i < disp.length; i++)
        {
            disp[i].addMouseListener(new MouseListener()
            {                
                @Override
                public void mousePressed (MouseEvent evnt) {
                    disp[disp.length -1].setForeground(Color.MAGENTA);
                    disp[disp.length -1].setFont(new Font (LiveDB.USEFONT, Font.ITALIC, 10));
                    disp[disp.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt) {
                    disp[disp.length -1].setForeground(Color.BLUE);
                    disp[disp.length -1].setFont(new Font (LiveDB.USEFONT, Font.PLAIN, 8));
                    disp[disp.length -1].validate();
                }
                @Override
                public void mouseEntered (MouseEvent evnt) {
                    disp[disp.length -1].setForeground(Color.MAGENTA);
                    disp[disp.length -1].setFont(new Font (LiveDB.USEFONT, Font.ITALIC, 10));
                    disp[disp.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt) {
                    disp[disp.length -1].setForeground(Color.BLUE);
                    disp[disp.length -1].setFont(new Font (LiveDB.USEFONT, Font.PLAIN, 8));
                    disp[disp.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt)
                {
                    retval = new PicturePage(pic[disp.length -1]); // 17th August 2012
                }
            });
        }
    }
}
