/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.io.IOException;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.File;
import java.util.Random;
import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.util.Date;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import static MaintainData.LiveDB.cr;
import static MaintainData.LiveDB.sc;
import static MaintainData.LiveDB.ar;
import static MaintainData.LiveDB.ct;
import static MaintainData.LiveDB.pd;
import static MaintainData.LoginPage.LoggedInCID;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : RMAPage
 *
 * @LOOKSY : LiveDB.indx1shoppingCart, LoginPage.LoggedInCID, LiveDB.PrepareAndSendMailMesg
 * @LOOKSY : LiveDB.appframe, LiveDB.EasyMail, LiveDB.system_exit, LiveDB.SmoothExitCondition
 * @LOOKSY : LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.indxcustomerRegister
 * @LOOKSY : LiveDB.SendNotificationEmail, LiveDB.ErrorLogFile, LiveDB.indxpictureDatabase
 * @LOOKSY : LiveDB.indxcustomerRegister, LiveDB.logerrorno, LiveDB.grassHopper
 *
 * @LOOKSY : PageOneTextPanel.java
 *           ChangeTracker.java
 *           ShoppingCart.java
 *           ArtLeaves.java
 *           CustomerRegister.java
 *           BottomPaneListener
 *
 * Date File : None
 *
 * Called From : public void stateChanged (ChangeEvent evnt) of BottomPaneListener.java
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct Return Material Authorization Page
 * when the user click on RMA's on the FooterPanel. It Generates an RMA number based on the KEYCODE
 * that was printed on your INVOICE. The KEYCODE entered by you is verified before generating the RMA.
 * Once the RMA number is generated it is emailed to proprietor of company and customer along with a
 * RMA report. It also generates a caught a thief report where there is no reason to generate an RMA
 * and a possible hacker is suspected on the system called chorreport. This chorreport is emailed only
 * to the company and not to the customer.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 * 
 * Last Modification Date : 15th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar.
 * 
 * Last Modification Date : 15th August 2012
 * Last Modifications : Changed the following patch of code
                              // Pick this entire shopping cart row details and email to company
                               // notification email box as an attachment
                               emailbody[0] =  // Changed this patch of code 15th August 2012
                               "CID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid() + '\n';
                               emailbody[1] =
                               "PIC CODE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic() + '\n';
                               emailbody[2] =
                               "PO NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPonumber() + '\n';
                               emailbody[3] =
                               "SUBOPT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getSub_opt_id() + '\n'; 
 *
 * Last Modification Date : 15th August 2012
 * Last Modifications : Changed this patch of code
                                 chorreport[0] = "PRE-ARREST WARRANT, Where are we going today ?" + '\n';
                                 chorreport[1] =
                                 "CID = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCid() + '\n';
                                 chorreport[2] =
                                 "Customer Name = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustname() + '\n';
                                 chorreport[3] =
                                 "Customer Birth Date = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustbirthdate().toString() + '\n';
                                 chorreport[4] =
                                 "Customer Birth City = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustbirthcity() + '\n';
 * 
 * Last Modification Date : 17th August 2012
 * Last Modificaitons : Marked as 17th August 2012
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class RMAPage {

    GridBagConstraints constraints = null;
    JLabel mesg1 = new JLabel ("Enter the KEYCODE printed in your INVOICE");
    JLabel mesg2 = new JLabel ("Store Customer Services cant help retrieve KEYCODE if LOST.");
    JLabel mesg3 = new JLabel ("KEYCODE:");
    JTextField keycode = new JTextField ("enter keycode here", 30);
    JLabel mesg4 = new JLabel ("The System will generate an RMA Number and email it to you");
    JLabel mesg5 = new JLabel ("Provided you are within specified time frame for RETURNS");
    JLabel mesg6 = new JLabel ("if you have exceeded time frame we cannot help you further");

    static JPanel rmapanel = new JPanel (new BorderLayout());
    
    Object retval = null; // 17th August 2012
    
    public RMAPage (){

        int pX = 0, pY = 0, pW = 0, pH = 0;
        int MF = 10;
        String reppath = LiveDB.serializedfilespath + "etc";

        // check some perms quickly
        if (new File(reppath).canWrite() == false)
        {
            if (new File(reppath).exists() == false)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("directory destroyed:" + reppath));
                System.exit(1);
            }
            else
            {
                if (new File(reppath).setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("can set write perms:" + reppath));
                    System.exit(1);
                }
            }
        }
        rmapanel.setBounds(pX = (int)FirstPage.pageonetextpanel.LEFT_ALIGNMENT * MF,
                           pY = (int)FirstPage.pageonetextpanel.TOP_ALIGNMENT * MF,
                           pW = (int)FirstPage.pageonetextpanel.RIGHT_ALIGNMENT * MF
                           - (int)FirstPage.pageonetextpanel.LEFT_ALIGNMENT * MF,
                           pH = (int)FirstPage.pageonetextpanel.BOTTOM_ALIGNMENT * MF
                           - (int)FirstPage.pageonetextpanel.TOP_ALIGNMENT * MF);

        rmapanel.add( mesg1, BorderLayout.CENTER);
        rmapanel.add( mesg2, BorderLayout.CENTER);
        rmapanel.add( mesg3, BorderLayout.CENTER);
        rmapanel.add( keycode, BorderLayout.CENTER);
        keycode.addInputMethodListener(new InputMethodListener (){

            @Override
            public void inputMethodTextChanged(InputMethodEvent event)
            {
                     // 1. Check Time Frames for returns
                     // 2. Generate RMA
                     // 3. Mail Out RMA Request to customer and store
                     // 4. Show Dialog with RMA to customer
                     // 5. Say thank you (Gudda Balsindi)
                     long logno = 0L;
                     long rid = 0L, row = 0L;
                     long oneday = 1000 * 60 * 60 * 24;
                     int period = 14;
                     String custemail = null;
                     String chorreport [] = new String[48]; // Changed 15th August 2012
                     String emailbody [] = new String [13]; // Changed 15th August 2012
                     String emailbodytxt = null;
                     String rmafile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                          + "generated.rma";
                     File fl = new File (rmafile);
                     FileWriter fw = null;
                     BufferedWriter bw = null;
                     String reason = null;

                     if (LiveDB.indx1shoppingCart.get(keycode.getText().trim()) == null)
                     {
                         JOptionPane.showMessageDialog(LiveDB.appframe, "INVALID KEYCODE SPECIFIED"
                                 + '\n' + "RE-ENTER KEYCODE FROM INVOICE");
                         keycode.setFocusable(true);
                     }
                     else
                     {
                         rid = LiveDB.indx1shoppingCart.get(keycode.getText().trim());

                         // Has he already generated a RMA ? Wants to steal money eh ??
                         if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma() == 0)
                         {
                            if (LiveDB.indxcustomerRegister
                                .get(((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid()) == null)
                            {
                                JOptionPane.showMessageDialog(LiveDB.appframe, "Possible Index Corruption"
                                        + '\n' + "indxcustomerRegister" + "  Exiting ..." );
                                JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                     + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                     + LiveDB.ErrorLogFile);
                                
                                System.err.println(LiveDB.grassHopper("Possible indxcustomerRegister corruption"));
                                logno = LiveDB.logerrorno;
                                System.err.println("LINE:" + logno + " " + "KEYCODE:" + keycode.getText().trim());
                                LiveDB.system_exit = 1;
                                //LiveDB.SmoothExitCondition.signalAll();
                            }
                            else
                            {
                                row = LiveDB.indxcustomerRegister
                                .get(((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid());
                                if (((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustnation()
                                        .equalsIgnoreCase(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getCountry()))
                                    period = 14; // customer from same nation as where you installed software
                                else period = 21; // customer from outside nation where you installed software
                                custemail = ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustemail();
                            }

                            if ((((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid])
                                    .getShopdate().getTime() + (oneday * period))
                                    <= new Date().getTime())
                                // knock of the equal to here if you want to
                                // one nanosecond is not sufficient to serve a customer !!
                            {
                               // okay he just made it so issue the poor .... a RMA
                               ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid])
                                       .setRma(new Random().nextLong());
                               ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(3);
                               // ChangeTracker entry here
                               LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                               new ChangeTracker (sc, rid, 'U', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[sc][(int)rid],
                                   (long)LiveDB.LiveSharedDB[ct].length -1);
                               
                               JOptionPane.showMessageDialog(LiveDB.appframe,
                                   "Your RMA is "
                                   + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma()
                                   + '\n'
                                   + "Write this down in a safe place"
                                   + '\n'
                                   + "We will also be sending you an email"
                                   + '\n'
                                   + "Email may not reach you if your email id"
                                   + '\n'
                                   + "no longer works/exists/mail carrier problem" );

                               // Send customer an email
                               if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                                          null, null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " RETURN MATERIAL AUTHORIZATION DESK ",
                                          "YOUR RMA IS:"
                                          + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma(),
                                          null) == false)
                               {
                                    JOptionPane.showMessageDialog(LiveDB.appframe,
                                           "RMA emailed to your Email ID Failed:" + custemail);
                                    LiveDB.SendNotificationEmail("EMAIL FAILURE OF RMA TO CUSTOMER");
                                    LiveDB.ALRTLVL = 3;
                                    System.err.println(LiveDB.grassHopper("Failure Email:" + custemail));
                               }
                               else
                                   JOptionPane.showMessageDialog(LiveDB.appframe,
                                           "RMA emailed to your Email ID:" + custemail);

                               // Pick this entire shopping cart row details and email to company
                               // notification email box as an attachment
                               emailbody[0] =  // Changed this patch of code 15th August 2012
                               "CID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid() + '\n';
                               emailbody[1] =
                               "PIC CODE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic() + '\n';
                               emailbody[2] =
                               "PO NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPonumber() + '\n';
                               emailbody[3] =
                               "SUBOPT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getSub_opt_id() + '\n';
                               emailbody[4] =
                               "PMT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPmtid() + '\n';
                               emailbody[5] =
                               "PIC QTY = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic_qty() + '\n';
                               emailbody[6] =
                               "TOTAL = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getTotal() + '\n';
                               emailbody[7] =
                               "BILLED = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() + '\n';
                               emailbody[8] =
                               "SHOPDATE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getShopdate().toString() + '\n';
                               emailbody[9] =
                               "ORDER NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getOrdernumber() + '\n';
                               emailbody[10] =
                               "ORDER DISCOUNT = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getOrderdiscount() + '\n';
                               emailbody[11] =
                               "RMA = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma() + '\n';
                               emailbody[12] =
                               "REFUND = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRefund() + '\n';

                               emailbodytxt = null;
                               for (int ln = 0; ln < emailbody.length; ln++)
                                      emailbodytxt += emailbody[ln];
                               try{
                                  fw = new FileWriter (fl);
                               }catch (IOException ex_NOKIA92){
                                  // send out an email here to customer with emailbody
                                  // maybe the file does not write its okay we will still send
                                  // an email to both customer and self and then exit.
                                  // Send customer an email
                                  
                                  if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                                          ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " RETURN MATERIAL AUTHORIZATION DESK ",
                                          emailbodytxt,
                                          null) == false)
                                  {
                                      JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "RMA could not be emailed to " + custemail);
                                  }
                                  else
                                      JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "RMA DETAILS EMAILED TO" + custemail);
                                  System.err.println(LiveDB.grassHopper(ex_NOKIA92, "File:"
                                                                     + rmafile));
                                  JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                + LiveDB.ErrorLogFile);
                                  LiveDB.system_exit = 1;
                                  //LiveDB.SmoothExitCondition.signalAll();                                    
                               }
                               
                               bw = new BufferedWriter (fw);

                               for (int i = 0; i < emailbody.length; i++)
                               {
                                   try{
                                   bw.write(emailbody[i]);
                                   }catch (IOException ex_NOKIA76){
                                     // send out an email here to customer with emailbody
                                     // maybe the file does not write its okay we will still send
                                     // an email to both customer and self and then exit.
           
                                     if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                                          ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " RETURN MATERIAL AUTHORIZATION DESK ",
                                          emailbodytxt,
                                          null) == false)
                                     {
                                        JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "RMA could not be emailed to " + custemail);
                                     }
                                     else
                                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "RMA DETAILS EMAILED TO" + custemail);
                                     System.err.println(LiveDB.grassHopper(ex_NOKIA76, "File:" + rmafile));
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                   + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                   + LiveDB.ErrorLogFile);
                                     LiveDB.system_exit = 1;
                                   //  LiveDB.SmoothExitCondition.signalAll();
                                   }
                               } // for (int i = 0; i < emailbody.length; i++)

                               try{
                                 bw.close();
                               }catch (IOException ex_NOKIA44){
                                     if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                                          ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " RETURN MATERIAL AUTHORIZATION DESK ",
                                          emailbodytxt,
                                          null) == false)
                                     {
                                        JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "RMA could not be emailed to " + custemail);
                                     }
                                     else
                                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "RMA DETAILS EMAILED TO" + custemail);

                                     System.err.println(LiveDB.grassHopper(ex_NOKIA44, "File:" + rmafile));
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                   + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                   + LiveDB.ErrorLogFile);
                                     LiveDB.system_exit = 1;
                                    // LiveDB.SmoothExitCondition.signalAll();
                               }
                               
                               if (LiveDB.EasyMail(custemail, emailbodytxt, rmafile) == false)
                               {
                                   JOptionPane.showMessageDialog(LiveDB.appframe,
                                           "Generated RMA File on Disk " + rmafile
                                           + '\n'
                                           + "Could not be emailed to recipients"
                                           + '\n' 
                                           + "Even after several retries");
                               }
                               else
                               {
                                   if (fl.delete() == false)
                                   {
                                       System.err.println(LiveDB.grassHopper("CANT DELETE RMA FILE:"
                                               + rmafile));
                                   }
                                   JOptionPane.showMessageDialog(LiveDB.appframe,
                                           "RMA FILE:" + rmafile + '\n'
                                           + "Emailed as an attachment to"
                                           + '\n'
                                           + custemail + " RETAIN FILE SAFELY"
                                           + '\n' + "UNTIL COMPLETE REFUND RECEIVED");
                               }
                            }
                         } // if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma() == 0)
                         else
                         {
                             if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 3)
                             {
                                 JOptionPane.showMessageDialog(LiveDB.appframe,
                                     "You have already been issued an RMA" + '\n'
                                     + "RMA = "
                                     + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma()
                                     + '\n'
                                     + "Contact Store with this RMA"
                                     + '\n'
                                     + "GoodBye and Have a Nice Day");
                             }
                             else if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 8)
                             {
                                 JOptionPane.showMessageDialog(LiveDB.appframe,
                                         "YOUR INVOICE HAS ALREADY BEEN CANCELLED"
                                         + '\n'
                                         + "SO YOU CANNOT BE ISSUED AN RMA"
                                         + '\n'
                                         + "AN INVOICE CANCELLATION EMAIL WOULD"
                                         + '\n'
                                         + "HAVE BEEN SENT TO YOUR EMAIL ID"
                                         + '\n'
                                         + custemail);
                             }
                             else
                             {
                                 String pc = null;
                                 long pdr = 0L;
                                 String chorfile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                          + "caughtathief.chor";

                                 if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 1)
                                     reason = "just requested billing";
                                 else if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 2)
                                     reason = "reset shopping cart";
                                 else if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 4)
                                     reason = "system just Printed Invoice";
                                 else if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 6)
                                     reason = "you Clicked Cancelled";
                                 else if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() == 7)
                                     reason = "you emptied basket";

                                 // CHOR (THIEF) AUTO WALK IN FEATURE IN LENSVIEW
                                 // EVEN BILL GATES DOES NOT PROVIDE THIS IN O/S
                                 
                                 JOptionPane.showMessageDialog(LiveDB.appframe,
                                         "RMA DENIAL REASONS BELOW"
                                         + '\n'
                                         + reason
                                         + '\n'
                                         + "YOU APPEAR A COMPUTER HACKER"
                                         + '\n'
                                         + "EMAIl WITH YOUR PARTICULARS HAS"
                                         + '\n'
                                         + "BEEN SENT TO LAW ENFORCEMENT"
                                         + '\n'
                                         + "PLEASE CALL NEAREST STATE PATROL CAR"
                                         + '\n'
                                         + "PLEASE WAIT GENERATING ARREST WARRANT");

                                 row = LiveDB.indxcustomerRegister
                                 .get(((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid());

                                 // Mark him as a Felon in your database                                 
                                 ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).setCustflag('F');
                                 LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                                    new ChangeTracker (cr, row, 'U', LiveDB.pid, new Date (),
                                          LiveDB.LiveSharedDB[cr][(int)row],
                                          (long)LiveDB.LiveSharedDB[ct].length -1);
                                 // Changed this patch of code 15th August 2012
                                 chorreport[0] = "PRE-ARREST WARRANT, Where are we going today ?" + '\n';
                                 chorreport[1] =
                                 "CID = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCid() + '\n';
                                 chorreport[2] =
                                 "Customer Name = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustname() + '\n';
                                 chorreport[3] =
                                 "Customer Birth Date = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustbirthdate().toString() + '\n';
                                 chorreport[4] =
                                 "Customer Birth City = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustbirthcity() + '\n';
                                 chorreport[5] =
                                 "Customer Birth State = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustbirthstate() + '\n';
                                 chorreport[6] =
                                 "Customer Birth Nation = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustbirthnation() + '\n';
                                 chorreport[7] =
                                 "Customer Sex = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustsex() + '\n';
                                 chorreport[8] =
                                 "Customer Marital Status = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustmaritalstatus() + '\n';
                                 chorreport[9] =
                                 "Marital Status Flags = M - Married, S - Single, D - Divorced, L - Living In, E - Engaged, W - Widow, V - Widower" + '\n';
                                 chorreport[10] =
                                 "Customer Login Time = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustlogintime().toString() + '\n';
                                 chorreport[11] =
                                 "Customer Logout Time = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustlogouttime().toString() + '\n';
                                 chorreport[12] =
                                 "Customer Register Date = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustregisterdate().toString() + '\n';
                                 chorreport[13] =
                                 "Customer Address 1 = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustaddr1() + '\n';
                                 chorreport[14] =
                                 "Customer Address 2 = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustaddr2() + '\n';
                                 chorreport[15] =
                                 "Customer Address 3 = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustaddr3() + '\n';
                                 chorreport[16] =
                                 "Customer Address 4 = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustname() + '\n';
                                 chorreport[17] =
                                 "Customer Landmark = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getLandmark() + '\n';
                                 chorreport[18] =
                                 "Customer City = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustcity() + '\n';
                                 chorreport[19] =
                                 "Customer Nation = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustnation() + '\n';
                                 chorreport[20] =
                                 "Customer Zip = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustzip() + '\n';
                                 chorreport[21] =
                                 "Customer Email = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustemail() + '\n';
                                 chorreport[22] =
                                 "Customer Phone = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustphone() + '\n';
                                 chorreport[23] =
                                 "Customer Fax = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustfax() + '\n';
                                 chorreport[24] =
                                 "Customer Flag = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustflag() + '\n';
                                 chorreport[25] =
                                 "Customer Flags = " + " O - Alive, B - Bad, C - Celebrity, T - Top Gun, S - Stayin Alive, D - Dead Customers, F - Possible Felon" + '\n';
                                 chorreport[26] =
                                 "Customer Last Date = " + ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustlastdate().toString() + '\n';

                                 // Now lets get details of what the bugar tried to get a RMA for
                                 chorreport[27] = "SHOP CART DETAILS" + '\n';
                                 chorreport[28] =
                                 "PIC CODE = " + (pc = ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic()) + '\n';
                                 chorreport[29] =
                                 "PO NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPonumber() + '\n';
                                 chorreport[30] =
                                 "SUBOPT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getSub_opt_id() + '\n';
                                 chorreport[31] =
                                 "PMT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPmtid() + '\n';
                                 chorreport[32] =
                                 "PIC QTY = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic_qty() + '\n';
                                 chorreport[33] =
                                 "TOTAL = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getTotal() + '\n';
                                 chorreport[34] =
                                 "BILLED = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() + '\n';
                                 chorreport[35] =
                                 "SHOPDATE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getShopdate().toString() + '\n';
                                 chorreport[36] =
                                 "ORDER NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getOrdernumber() + '\n';
                                 chorreport[37] =
                                 "ORDER DISCOUNT = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getOrderdiscount() + '\n';
                                 chorreport[38] =
                                 "RMA = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma() + '\n';
                                 chorreport[39] =
                                 "REFUND = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRefund() + '\n';
                                 chorreport[40] = "ADDITIONAL PICTURE DETAILS" + '\n';
                                 chorreport[41] =
                                 "PICTURE TITLE:" + ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)pdr]).getPic_title() + '\n';
                                 chorreport[42] =
                                 "PICTURE CATEGORY:" + ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)pdr]).getPic_category() + '\n';
                                 chorreport[43] =
                                 "PICTURE IMAGE LOCATION ON DISK:" + ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)pdr]).getPic_img_location() + '\n';
                                 chorreport[44] =
                                 "PICTURE ADDED TO DATABASE ON:" + ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)pdr]).getAdd_date().toString() + '\n';
                                 chorreport[45] =
                                 "PICTURE LAST ACESS DATE ON DATABASE:" + ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)pdr]).getLast_access().toString() + '\n';
                                 chorreport[46] =
                                 "REASON FOR RMA DENIAL:" + reason + '\n';
                                 chorreport[47] = "Hacker used KEYCODE:" + keycode.getText().trim() + '\n';
                                 
                                 if (LiveDB.indxpictureDatabase.get(pc) == null)
                                 {
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting Index Corrupt" + '\n'
                                         + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                         + LiveDB.ErrorLogFile);
                                     System.err.println(LiveDB.grassHopper("indxpictureDatabase corrupt Pic:" + pc + " no find"));
                                     LiveDB.system_exit = 1;
                                    // LiveDB.SmoothExitCondition.signalAll();
                                 }
                                 else pdr = LiveDB.indxpictureDatabase.get(pc);                                 

                                 emailbodytxt = null;
                                 for (int j = 0; j < chorreport.length; j++)
                                     emailbodytxt += chorreport[j];

                                 fl = new File(chorfile);

                                 try{
                                    fw = new FileWriter (fl);
                                 }catch (IOException ex_NOKIA92){
                                   // send out an email here to customer with emailbody
                                   // maybe the file does not write its okay we will still send
                                   // an email to both customer and self and then exit.
                                   // Send customer an email
                                   for (int ln = 0; ln < emailbody.length; ln++)
                                        emailbodytxt += emailbody[ln];

                                   if (LiveDB.PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null,
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " CORPORATE POLICE DESK ",
                                          emailbodytxt,
                                          null) == false)
                                   {
                                       JOptionPane.showMessageDialog(LiveDB.appframe,
                                       "Caught A Thief Report could not be emailed to" + '\n'
                                       + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                   }
                                   else
                                      JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "Caught A Thief Report emailed to" + '\n' + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                   System.err.println(LiveDB.grassHopper(ex_NOKIA92, "File:"
                                                                     + chorfile));
                                   JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                + LiveDB.ErrorLogFile);
                                   LiveDB.system_exit = 1;
                                  // LiveDB.SmoothExitCondition.signalAll();
                                }

                                bw = new BufferedWriter (fw);

                                for (int i = 0; i < chorreport.length; i++)
                                {
                                   try{
                                      bw.write(chorreport[i]);
                                   }catch (IOException ex_NOKIA76){
                                     // send out an email here to customer with emailbody
                                     // maybe the file does not write its okay we will still send
                                     // an email to both customer and self and then exit.
                                     if (emailbodytxt == null)
                                     {
                                         for (int ln = 0; ln < emailbody.length; ln++)
                                              emailbodytxt += chorreport[ln];
                                     }

                                     if (LiveDB.PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null,
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " CORPORATE POLICE DESK ",
                                          emailbodytxt,
                                          null) == false)
                                     {
                                        JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "Caught A Thief Report could not be emailed to"
                                              + '\n' + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                     }
                                     else
                                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "Caught A Thief Report emailed to"
                                                 + '\n' + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                     System.err.println(LiveDB.grassHopper(ex_NOKIA76, "File:" + chorfile));
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                   + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                   + LiveDB.ErrorLogFile);
                                     LiveDB.system_exit = 1;
                                  //   LiveDB.SmoothExitCondition.signalAll();
                                   }
                                 } // for (int i = 0; i < emailbody.length; i++)

                                 try{
                                    bw.close();
                                 }catch (IOException ex_NOKIA44){
                                     if (LiveDB.PrepareAndSendMailMesg(null, null,((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                           null,
                                           null, "EMAIL FROM " +
                                           LiveDB.versionControl.getApplicationName() +
                                           " CORPORATE POLICE STATION ",
                                           emailbodytxt,
                                           null) == false)
                                     {
                                           JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "Stolen Report could not be emailed"
                                              + '\n'
                                              + "from Corporate Police Station to company"
                                              + '\n'
                                              + "You got away this time congratulations");
                                     }
                                     else
                                     {
                                           JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "STOLEN REPORT DETAILS EMAILED TO" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                          // send a notification email instead
                                          LiveDB.SendNotificationEmail("Thief Report " + " Emailed to:"
                                             + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                     }
                                     System.err.println(LiveDB.grassHopper(ex_NOKIA44, "File:" + chorfile));
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                   + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                   + LiveDB.ErrorLogFile);
                                     LiveDB.system_exit = 1;
                                  //   LiveDB.SmoothExitCondition.signalAll();
                                 }

                                 // send both even if the attachment is corrupted etc etc
                                 if (LiveDB.PrepareAndSendMailMesg(null, null,((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                      null,
                                      null, "EMAIL FROM " +
                                      LiveDB.versionControl.getApplicationName() +
                                      " CORPORATE POLICE STATION ",
                                          emailbodytxt,
                                          chorfile) == false)
                                 {
                                     JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "Stolen Report could not be emailed"
                                              + '\n'
                                              + "from Corporate Police Station to company"
                                              + '\n'
                                              + "You got away this time congratulations");
                                 }
                                 else
                                 {
                                     JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "STOLEN REPORT DETAILS EMAILED TO" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                     // fl.delete(); dont delete this file never know if the email reached
                                     // send a notification email instead
                                     LiveDB.SendNotificationEmail("Thief Report:" + chorfile + " Emailed to:" 
                                             + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4());
                                 }

                                 LiveDB.ALRTLVL = 2;                                 
                                 System.err.println(LiveDB.grassHopper("Possible Hacker CID:" + LoggedInCID));
                                 logno =  LiveDB.logerrorno;
                                 System.err.println("LINE:" + logno + " " + "Hacker used KEYCODE:" + keycode.getText().trim());
                             }
                         }

                         LiveDB.appframe.remove(rmapanel);
                         retval = new PageOneTextPanel (); // 17th August 2012
                     }
            }

            @Override
            public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
            }
        });

        rmapanel.add( mesg4, BorderLayout.CENTER);
        rmapanel.add( mesg5, BorderLayout.CENTER);
        rmapanel.add( mesg6, BorderLayout.CENTER);

        LiveDB.appframe.add(rmapanel, setConstraints(pX, pY, pW, pH));
        rmapanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
