/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;
import java.util.Random;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.awt.Component;
import javax.media.CannotRealizeException;
import javax.media.NoPlayerException;
import javax.media.MediaLocator;
import java.net.MalformedURLException;
import java.net.URL;
import javax.media.Player;
import javax.media.Manager;
import java.awt.BorderLayout;
import javax.swing.JScrollPane;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.Iterator;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import java.io.File;
import javax.swing.JEditorPane;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import javax.swing.JPanel;
import static DatabaseEngine.LiveDB.appframe;
import static DatabaseEngine.LiveDB.da;
import static DatabaseEngine.LaunchGUI.MAX_HEIGHT;
import static DatabaseEngine.LaunchGUI.MAX_WIDTH;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : FirstPage
 * @LOOKSY: InfoPanel.java -- Wall Street Journal
 * @LOOKSY: PopularPanel.java  --- Take a good look very popular
 * @LOOKSY: MailListPanel.java  --- Take a very quick look
 * @LOOKSY: SalePanel.java  --- Take a very quick look
 * @LOOKSY: LogoPanel.java  --- Take a very quick look
 * @LOOKSY: RegisterPanel.java  --- Take a very quick look
 * @LOOKSY: CartPanel.java  --- Take a very quick look
 * @LOOKSY: CataloguePanel.java  --- Take a good look
 * @LOOKSY: FooterPanel.java  --- Take a very quick look (RMA's involved)
 * @LOOKSY: CurrencyPanel.java  --- Take a very quick look
 * @LOOKSY: LanguagePanel.java  --- Take a very quick look (you cant get masters in all languages)
 * @LOOKSY: FeaturedPanel.java  --- Single Topping Pizza
 * @LOOKSY: DefaultAdvertisingImages.java -- Take a very quick look
 * @LOOKSY: NorthAdvertPanel.java -- Free Ads
 * @LOOKSY: SouthAdvertPanel.java -- Free Ads
 * @LOOKSY: NorthWestAdvertPanel.java -- Free Ads
 * @LOOKSY: SouthAdvertPanel.java -- Free Ads
 * @LOOKSY: NorthEastAdvertPanel.java -- Free Ads
 * @LOOKSY: EastAdvertPanel.java -- Free Ads
 * @LOOKSY: WestAdvertPanel.java -- Free Ads
 * @LOOKSY: SouthEastAdvertPanel.java -- Free Ads
 * @LOOKSY: SouthWestAdvertPanel.java -- Free Ads
 *
 * @LOOKSY:CurrencyPanel.currency, LiveDB.appframe, Madagascar.DEFAULT_HEIGHT,
 * @LOOKSY:LaunchGUI.MAX_HEIGHT, LaunchGUI.MAX_WIDTH, LiveDB.INR, LiveDB.EURO, LiveDB.POUNDSTERLING,
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.OPERATINGSYSTEM,
 * @LOOKSY:LiveDB.WINDOWS, LiveDB.serializedfilespath, LiveDB.FILESEPERATOR, LiveDB.AUDIOADVERT,
 * @LOOKSY:LiveDB.ANIMATIONADVERT, LiveDB.MAXADVERTS, LiveDB.north, LiveDB.south, LiveDB.northeast,
 * @LOOKSY:LiveDB.northwest, LiveDB.east, LiveDB.west, LiveDB.southeast, LiveDB.southwest,
 * @LOOKSY:LiveDB.VIDEOPLAYERERROR, LiveDB.IMAGEADVERT, LiveDB.VIDEOADVERT
 *
 * Chained Methods : protected static void PlayAllAdverts ()
 *
 * Date File : Image files for advertisement contained in DefaultAdvertisingImages
 *             The image location file path is provided in this table
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the first page and it also plays
 * all adverts that have been registered in table DefaultAdvertisingImages.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class FirstPage {

    protected static String chosenlang = null; // will now contain lid for LanguagePanel.SelectedLanguage
                                               // as a String
    protected static String loginname = null;
    protected static ImageReader reader = null;
    
    static JPanel registerpanel, cartpanel, cataloguepanel, footerpanel, currencypanel,
                  languagepanel, logopanel, pageonetextpanel, featuredpanel, popularpanel,
                  picturepagetextpanel, infopanel, maillistpanel, salepanel, latestprodspanel,
                  viewbasketpanel, invoicepanel;

    static JScrollPane appscrollpane = null;

    JButton badcontent ;

    static Player [] mediaPlayer = null;
    static Component [] video, controls = null;
    static URL [] URLpath = null;

    // look in class BottomPaneListener.java and DisplayHyperLinkListener.java
    static JEditorPane win ;
    static javax.swing.JEditorPane [] videowin = null;

    static JPanel [] videoJPanels = null;

    GridBagConstraints constraints = null;

    int DPI = (int)Toolkit.getDefaultToolkit().getScreenResolution();

    public FirstPage()
    {
        appframe.removeAll();
        appframe.setSize(MAX_WIDTH, MAX_HEIGHT + 30); // + 30 for advert space
        appscrollpane = new JScrollPane (appframe);
        addpanels();
        appframe.pack();
        appscrollpane.setVisible(true);
    }

    // you idiot read below it is in plain english
    void addpanels()
    {
        Object unnecessary;
        int MF = 10;

        // FirstPage can be called at several different places in the program code
        // such as LanguagePanel.java and badcontent button below
        
        if (infopanel != null)
            LiveDB.appframe.remove(infopanel);

        unnecessary = new InfoPanel();

        if (maillistpanel != null)
            LiveDB.appframe.remove(maillistpanel);
        
        unnecessary = new MailListPanel ();

        if (salepanel != null)
            LiveDB.appframe.remove(salepanel);

        unnecessary = new SalePanel();

        if (logopanel != null)
            LiveDB.appframe.remove(logopanel);

        unnecessary = new LogoPanel ();

        if (registerpanel != null)
            LiveDB.appframe.remove(registerpanel);

        unnecessary = new RegisterPanel ();

        if (cartpanel != null)
            LiveDB.appframe.remove(cartpanel);

        unnecessary = new CartPanel ();

        if (cataloguepanel != null)
            LiveDB.appframe.remove(cataloguepanel);

        unnecessary = new CataloguePanel ();

        if (footerpanel != null)
            LiveDB.appframe.remove(footerpanel);

        unnecessary = new FooterPanel ();

        if (currencypanel != null)
            LiveDB.appframe.remove(currencypanel);

        unnecessary = new CurrencyPanel ();

        if (languagepanel != null)
            LiveDB.appframe.remove(languagepanel);

        unnecessary = new LanguagePanel ();

        if (featuredpanel != null)
            LiveDB.appframe.remove(featuredpanel);

        unnecessary = new FeaturedPanel ();

        if (popularpanel != null)
            LiveDB.appframe.remove(popularpanel);

        unnecessary = new PopularPanel ();        

        appframe.pack();
        
        appframe.add(logopanel, setConstraints((int)LiveDB.appframe.LEFT_ALIGNMENT * MF,
                (int)(LiveDB.appframe.TOP_ALIGNMENT * MF),
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/16,
                (int)(Madagascar.DEFAULT_HEIGHT)/7));
        appframe.pack();
        // pack very frequently since i am using delicate relative possitioning for accuracy


        appframe.add(registerpanel, setConstraints((int)LiveDB.appframe.RIGHT_ALIGNMENT * MF -
        (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/16 * 14,
                (int)(LiveDB.appframe.TOP_ALIGNMENT * MF),
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/16 * 2,
                (int)(Madagascar.DEFAULT_HEIGHT)/7));
        appframe.pack();


        appframe.add(cataloguepanel, setConstraints((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(registerpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF),
                (int)(Madagascar.DEFAULT_HEIGHT)/25));
        appframe.pack();

        appframe.add(cartpanel,setConstraints((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(cataloguepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/MF,
                (int)(Madagascar.DEFAULT_HEIGHT)/6));
        appframe.pack();

        appframe.add(featuredpanel, setConstraints((int)(pageonetextpanel.RIGHT_ALIGNMENT * MF) +1,
                (int)(pageonetextpanel.TOP_ALIGNMENT * MF),
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF),
                (int)(cartpanel.BOTTOM_ALIGNMENT * MF) - (int) (cartpanel.TOP_ALIGNMENT * MF)));

        if (pageonetextpanel != null)
            LiveDB.appframe.remove(pageonetextpanel);
        unnecessary = new PageOneTextPanel ();
        appframe.add(pageonetextpanel, setConstraints((int)(cartpanel.RIGHT_ALIGNMENT * MF),
                (int)(cataloguepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(featuredpanel.LEFT_ALIGNMENT * MF) - (int)(cartpanel.RIGHT_ALIGNMENT * MF) + 1,
                (int)(Madagascar.DEFAULT_HEIGHT)/3));
        appframe.pack();


        appframe.pack();

        appframe.add(infopanel, setConstraints((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(cartpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(cartpanel.RIGHT_ALIGNMENT * MF),
                (int)(cartpanel.BOTTOM_ALIGNMENT * MF) - (int)(cartpanel.TOP_ALIGNMENT * MF) -1));
        appframe.pack();
        
        appframe.add(popularpanel, setConstraints((int)(featuredpanel.LEFT_ALIGNMENT * MF),
                (int)(featuredpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(featuredpanel.RIGHT_ALIGNMENT * MF) - (int)(featuredpanel.LEFT_ALIGNMENT * MF),
                (int)(infopanel.BOTTOM_ALIGNMENT * MF) - (int)(infopanel.TOP_ALIGNMENT * MF)
                + ((int)(currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(currencypanel.TOP_ALIGNMENT))
                + ((int)(currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(currencypanel.TOP_ALIGNMENT))/2));
        appframe.pack();

        
        appframe.add(currencypanel, setConstraints((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(infopanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(currencypanel.RIGHT_ALIGNMENT * MF),
                (int)(currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(currencypanel.TOP_ALIGNMENT * MF)));
        appframe.pack();

        appframe.add(languagepanel,setConstraints((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(currencypanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(currencypanel.RIGHT_ALIGNMENT * MF),
                (int)(currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(currencypanel.TOP_ALIGNMENT * MF)));
        appframe.pack();

        appframe.add(salepanel, setConstraints((int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)
                - (int)(pageonetextpanel.RIGHT_ALIGNMENT * MF) + 1,
                (int)(popularpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(popularpanel.RIGHT_ALIGNMENT * MF),
                (int)(popularpanel.BOTTOM_ALIGNMENT * MF) - (int)(popularpanel.TOP_ALIGNMENT * MF) + 1));
        appframe.pack();

        appframe.add(maillistpanel, setConstraints((int)(pageonetextpanel.RIGHT_ALIGNMENT * MF) + 1,
                (int)(salepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(salepanel.RIGHT_ALIGNMENT * MF) - (int)(salepanel.LEFT_ALIGNMENT * MF),
                ((int)(popularpanel.BOTTOM_ALIGNMENT * MF) - (int)(popularpanel.TOP_ALIGNMENT * MF))/2));
        appframe.pack();

        appframe.add(latestprodspanel, setConstraints((int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
                (int)(pageonetextpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(pageonetextpanel.RIGHT_ALIGNMENT * MF) - (int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
                (int)(MAX_HEIGHT + 30) - (int)(pageonetextpanel.BOTTOM_ALIGNMENT * MF) + 1));
        appframe.pack();

        appframe.add(footerpanel,setConstraints((int)(latestprodspanel.LEFT_ALIGNMENT * MF),
                (int)(latestprodspanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(pageonetextpanel.RIGHT_ALIGNMENT * MF) - (int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
                (int)(Madagascar.DEFAULT_HEIGHT) - (int)(footerpanel.TOP_ALIGNMENT * MF) -2));
        appframe.pack();

        //appframe.add(northwestadvertpanel, setConstraints(2,2,2,2));

        //appframe.add(northeastadvertpanel,setConstraints(2,2,2,2));
        badcontent = new JButton("Bad Content");
        badcontent.createToolTip().setTipText("Click this Button if you find adverts XRated");
        
        appframe.add(badcontent, setConstraints((int)(footerpanel.RIGHT_ALIGNMENT * MF)/2,
                (int)(footerpanel.BOTTOM_ALIGNMENT * MF) + 1, 2, 1));

        badcontent.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed (ActionEvent evnt)
            {
                for (int rw = 0; rw < LiveDB.LiveSharedDB[da].length; rw++)
                    ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).setChildsafe(0);
                new FirstPage(); // refresh the first page totally
            }
        });
        appframe.pack();

        PlayAllAdverts (); // by hook or by crook we will play even in a JEditorPane with html !!
        appframe.pack();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.EURO, LiveDB.POUNDSTERLING, LiveDB.INR, CurrencyPanel.currency.
 *
 * Method Name : protected static float convertCurrency(float p_amt)
 * Parameters : float p_amt -- the amount in usd -- now i cant verify this IMPOSSIBLE
 * Returns : float -- the converted amount from usd to the selected currency
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : There are currency ratios which are read from the LENSVIEWPROPERTIESFILE in
 * LiveDB.USRDIR which is auto copied to conf subdirectory. These currency ratios are LiveDB.INR,
 * LiveDB.POUNDSTERLING, LiveDB.EURO. These ratios are multiplied by the incomming p_amt which is
 * assumed to be a USD amount and the result returned. I cannot verify which is the currency you
 * intended in that p_amt. This is a major challenge for Robotic Intelligence to be mentioned in
 * the white papers of the future.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static float convertCurrency(float p_amt)
    {
        float newamt = 0.0f;

        if (CurrencyPanel.currency.equalsIgnoreCase("Indian Rupee"))
            newamt = p_amt * LiveDB.INR;
        else if (CurrencyPanel.currency.equalsIgnoreCase("Euro"))
                 newamt = p_amt * LiveDB.EURO;
        if (CurrencyPanel.currency.equalsIgnoreCase("British Pound"))
            newamt = p_amt * LiveDB.POUNDSTERLING;
        
        return newamt;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.EURO, LiveDB.POUNDSTERLING, LiveDB.INR, CurrencyPanel.currency.
 *
 * Method Name : protected static boolean DrawImage (String p_path, JPanel p_panel, int p_X, int p_Y,
 *                                                                int p_W, int p_H, boolean p_potrait)
 * Parameters : String p_path -- the pathname for the image file
 *              JPanel p_panel - Use this panel to draw image to do a remove of this component later
 *              int p_X -- X Coordinate for image
 *              int p_Y -- Y Coordinate for image
 *              int p_W -- Width the image should be scaled to and drawn, can be zero, look below
 *              int p_H -- Height the image should be scaled to and drawn, can be zero, look below.
 *              boolean p_potrait -- if true potrait else landscape
 *
 * Returns : boolean true if image drawn
 *           boolean false if any error in drawing image
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to draw an image and not an animation on the JPanel that
 * you passed as parameter. This JPanel must be added to LiveDB.appframe or any other component by
 * you with setConstraints(). The image is specified by p_path which will be scaled to size using
 * p_X, p_Y, p_W, p_H params passed. If either p_W or P_H is zero it will be scaled to stamp size
 * depending on the orientation specified.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean DrawImage (String p_path, JPanel p_panel, int p_X, int p_Y, int p_W,
                                                                       int p_H, boolean p_potrait)
    {
        Image image = null;
        int infoflags = 0;
        int MF = 10;
        
        int W = p_W, H = p_H;

        if (p_W == 0 || p_H == 0)
        {
            if (p_potrait == false)
            {
                W = 6; H = 4; // stamp size it why flag error auto correct
            }
            else
            {
                H = 6; W = 4; // stamp size it why flag error auto correct
            }
        }

        if (p_X < (int)p_panel.LEFT_ALIGNMENT * MF || p_X > (p_panel.RIGHT_ALIGNMENT * MF) - 2)
            p_X = (int)p_panel.LEFT_ALIGNMENT * MF;

        if (p_Y < (int)p_panel.TOP_ALIGNMENT * MF || p_Y > (p_panel.BOTTOM_ALIGNMENT * MF) - 2)
            p_Y = (int)p_panel.TOP_ALIGNMENT * MF;


        try{
            image = ImageIO.read(new File(p_path));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" + p_path));
            return false;
        }

        image = image.getScaledInstance(W, H, Image.SCALE_SMOOTH);

        if (p_panel.getGraphics().drawImage(image, p_X, p_Y, W, H, null) == false)
        {
            p_panel.imageUpdate(image, infoflags, p_X, p_Y, W, H);
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" + p_path));
            return false;
        }

        p_panel.validate();
        
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.grassHopper
 *
 * Method Name : protected static boolean DrawImage DrawImage (String p_path, JPanel p_panel,
 *                                                                            String... p_suffix)
 *
 * Parameters : String p_path - the pathname for the image file
 *              JPanel p_panel - Use this panel to draw image to do a remove of this component later
 *              String... p_suffix - the suffix of the image name to get the decoders idiot ??
 *
 * Returns : boolean true if image drawn
 *           boolean false if image not drawn or any other error
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to draw an image and not an animation on the JPanel that
 * you passed as parameter. This JPanel must be added to LiveDB.appframe or any other component by
 * you with setConstraints(). The image is specified by p_path. The only difference between this
 * overload method and others is that this wont check the orientation of the image as potrait or
 * landscape and neither will it scale the image to size as in previous overloaded method. So it
 * will draw the image in whatever size the image has on disk.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean DrawImage (String p_path, JPanel p_panel, String... p_suffix)
    {
        Iterator<ImageReader> iter = null;
        ImageInputStream ImageIn = null;
        Image image = null;
        int infoflags = 0;
        File file = null;
        int W = 0, H = 0;

        try{
            image = ImageIO.read(new File(p_path));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" + p_path));
            return false;
        }

        file = new File (p_path);
        try{
              ImageIn = ImageIO.createImageInputStream(file);
            }catch (IOException ex_YESKIA98){
                System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + p_path));
                return false;
            }

        iter = ImageIO.getImageReadersBySuffix(p_suffix.length != 0 ? p_suffix[0]:"jpg");
        reader = iter.next();
        reader.setInput(ImageIn);

        try{
             W = reader.getWidth(0);
             H = reader.getHeight(0);
        }catch (IndexOutOfBoundsException ex_NOKIA8){
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper(ex_NOKIA8));
            return false;
        }catch (IOException ex_NOKIA66){
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper(ex_NOKIA66));
            return false;
        }

        if (p_panel.getGraphics().drawImage(image, (int)p_panel.LEFT_ALIGNMENT,
                (int)p_panel.TOP_ALIGNMENT, W, H, null) == false)
        {
            p_panel.imageUpdate(image, infoflags,
                    (int)p_panel.LEFT_ALIGNMENT,
                    (int)p_panel.TOP_ALIGNMENT,
                    W, H);

            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" + p_path));
            return false;
        }

        p_panel.validate();
        
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.grassHopper
 *
 * Method Name : protected static boolean DrawImage (String p_size, String p_path, JPanel p_panel,
 *                                                                                 String... p_suffix)
 *
 * Parameters : String p_size - un-used for now see note below
 *              String p_path - the pathname for the image file
 *              JPanel p_panel - Use this panel to draw image to do a remove of this component later
 *              String... p_suffix - the suffix of the image name to get the decoders idiot ??
 *
 * Returns : boolean true if image drawn
 *           boolean false if image not drawn or any other error
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to draw an image and not an animation on the JPanel that
 * you passed as parameter. This JPanel must be added to LiveDB.appframe or any other component by
 * you with setConstraints(). The image is specified by p_path. The only difference between this
 * overload method and others is that the image will be scaled to the dimensions of the p_panel and
 * then drawn but the image will be SCALED FAST and so qualty of the image wont be up to the mark.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean DrawImage (String p_size, String p_path, JPanel p_panel, String... p_suffix)
    {
        // This p_size param is un-used for now you can use it if you want. It is in pixels.
        // we need to convert it to width and height There is an instance variable called DPI
        // right at the top but I dont know if it means Dots Per Inch as in a line or Dots per
        // square inch ?
        
        File file = null;
        Image image = null;
        ImageInputStream ImageIn = null;
        Iterator<ImageReader> iter = null;
        int infoflags = 0;
        int W, H = 0;
        int MF = 10;

        try{
            image = ImageIO.read(new File(p_path));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" + p_path));
            return false;
        }

        file = new File (p_path);
        if (file.exists() == false)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Missing File:" + p_path));
            return false;
        }

        try{
              ImageIn = ImageIO.createImageInputStream(file);
        }catch (IOException ex_YESKIA98){
               System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + p_path));
               return false;
        }

        iter = ImageIO.getImageReadersBySuffix(p_suffix.length != 0 ? p_suffix[0]:"jpg");
        reader = iter.next();
        reader.setInput(ImageIn);

        try{
             W = reader.getWidth(0);
             H = reader.getHeight(0);
        }catch (IndexOutOfBoundsException ex_NOKIA8){
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper(ex_NOKIA8));
            return false;
        }catch (IOException ex_NOKIA66){
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper(ex_NOKIA66));
            return false;
        }

        if (p_size == null)
        {
            if (H > (int)(p_panel.BOTTOM_ALIGNMENT * MF) - (int)(p_panel.TOP_ALIGNMENT * MF))
                H = (int)(p_panel.BOTTOM_ALIGNMENT * MF) - (int)(p_panel.TOP_ALIGNMENT * MF);

            if (W > (int)(p_panel.RIGHT_ALIGNMENT) - (int)(p_panel.LEFT_ALIGNMENT))
                W = (int)(p_panel.RIGHT_ALIGNMENT) - (int)(p_panel.LEFT_ALIGNMENT);
        }
        // if p_size is not null convert the pixels into height maybe we could use
        // constraints.weightx or constraints.weighty
        
        image = image.getScaledInstance(W, H, Image.SCALE_FAST);

        if (p_panel.getGraphics().drawImage(image, (int)p_panel.LEFT_ALIGNMENT,
                (int)p_panel.TOP_ALIGNMENT, W, H, null) == false)
        {
            p_panel.imageUpdate(image, infoflags,(int)p_panel.LEFT_ALIGNMENT,
                    (int)p_panel.TOP_ALIGNMENT, W, H);
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" + p_path));
            return false;
        }

        p_panel.validate();

        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.grassHopper
 *
 * Method Name : protected static boolean PlayAnimation (String p_size, String p_path, JPanel p_panel)
 *
 * Parameters : String p_size - imagewidthXimageheight
 *              String p_path - the pathname for the animation file
 *              JPanel p_panel - Use this panel to draw image to do a remove of this component later
 *
 * Returns : boolean true if image drawn
 *           boolean false if image not drawn or any other error
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to draw an animation and not an image on the JPanel that you
 * passed as parameter. This JPanel must be added to LiveDB.appframe or any other component by you with
 * setConstraints(). All that this method does is to create a new Instance of class Animation.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean PlayAnimation (String p_size, String p_path, JPanel p_panel)
    {
        // ignore the return value dont assign to a variable in local scope 
        
        new Animation (p_size, p_path, p_panel);
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.grassHopper, LiveDB.system_exit, LiveDB.SmoothExitCondition
 *
 * Method Name : protected static boolean PlayVideo (String p_size, String p_path, JPanel p_panel)
 *
 * Parameters : String p_size - HeightXWidth (see NOTE below)
 *              String p_path - the pathname for the animation file
 *              JPanel p_panel - Use this panel to draw image to do a remove of this component later
 *
 * Returns : boolean true if video plays
 *           boolean false if video does not play or some other error
 *
 * Chained Methods : private static boolean writeandPlayHtml (JPanel p_panel, String p_path,
 *                                                                            String p_size)
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to play any video (preferably short) on the JPanel that you
 * passed as parameter. This JPanel must be added to LiveDB.appframe or any other component by you with
 * setConstraints(). All that this method does is to play the video on that JPanel.
 *
 * NOTE :- If createRealizedPlayer throws an exception such as NoPlayerException, CannotRealizeException
 * then it calls a chained method writeandPlayHtml (JPanel p_panel, String p_path, String p_size) wherein
 * it writes to a html files and then tries to play your video as a last ditch effort.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean PlayVideo (String p_size, String p_path, JPanel p_panel)
    {
        
        MediaLocator pathlocator = null;

        try{
            URLpath[URLpath.length] = new URL (p_path);
        }catch (MalformedURLException ex_YESKIA72){
            try{
                 URLpath[URLpath.length] = new File (p_path).toURI().toURL();
            }catch (IllegalArgumentException ex_NOKIA81){
               LiveDB.ALRTLVL = 15;
               System.err.println(LiveDB.grassHopper(ex_NOKIA81, "URL not Absolute:" + p_path));
               LiveDB.system_exit = 1;
               LiveDB.SmoothExitCondition.signalAll();
               return false;
            }catch(MalformedURLException ex_YESKIA81){
              // yes this needs a media locator constructor it is just a file name path
              pathlocator = new MediaLocator (p_path);
            }
        }
        
        p_panel.setLayout(new BorderLayout());

        // use light weight components for swing compatibility
        Manager.setHint( Manager.LIGHTWEIGHT_RENDERER, true );

        if (pathlocator == null && URLpath[URLpath.length -1] != null)
        {
                try{
                    mediaPlayer[mediaPlayer.length -1] = Manager.createRealizedPlayer(URLpath[URLpath.length -1]);
                }catch (MalformedURLException ex_NOKIA81){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA81, "Invalid URL:" + p_path));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }catch (NoPlayerException ex_NOKIA31){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA31, "Cannot Find Player to play media clip"));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }catch (CannotRealizeException ex_NOKIA11){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA11, "Missing extra resources to play media clip"));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }catch (IOException ex_NOKIA76){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA76, "Error reading media clip " + p_path));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }
                video[video.length] = mediaPlayer[mediaPlayer.length -1].getVisualComponent();
                controls[controls.length] = mediaPlayer[mediaPlayer.length -1].getControlPanelComponent();

                if (video[video.length -1] != null)
                    p_panel.add(video[video.length -1], BorderLayout.CENTER);

                if (controls[controls.length -1] != null)
                    p_panel.add(controls[controls.length -1], BorderLayout.SOUTH);

                mediaPlayer[mediaPlayer.length -1].start();
        }
        else if (pathlocator != null)
        {
             try{
                    mediaPlayer[mediaPlayer.length -1] = Manager.createRealizedPlayer(pathlocator);
             }catch (MalformedURLException ex_NOKIA81){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA81, "Invalid Video:" + p_path));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
             }catch (NoPlayerException ex_NOKIA31){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA31, "Cannot Find Player to play media clip"));
                    if (writeandPlayHtml (p_panel, p_path, p_size) == false)
                    {
                        LiveDB.system_exit = 1;
                        LiveDB.SmoothExitCondition.signalAll();
                    }else return true;
             }catch (CannotRealizeException ex_NOKIA11){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA11, "Missing extra resources to play media clip"));
                    if (writeandPlayHtml (p_panel, p_path, p_size) == false)
                    {
                        LiveDB.system_exit = 1;
                        LiveDB.SmoothExitCondition.signalAll();
                    }else return true;
             }catch (IOException ex_NOKIA76){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA76, "Error reading media clip " + p_path));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
             }
             video[video.length] = mediaPlayer[mediaPlayer.length -1].getVisualComponent();
             controls[controls.length] = mediaPlayer[mediaPlayer.length -1].getControlPanelComponent();

             if (video[video.length -1] != null)
                 p_panel.add(video[video.length -1], BorderLayout.CENTER);

             if (controls[controls.length -1] != null)
                 p_panel.add(controls[controls.length -1], BorderLayout.SOUTH);

             mediaPlayer[mediaPlayer.length -1].start();
        }

        p_panel.validate();
        
        return true;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.grassHopper, LiveDB.system_exit, LiveDB.SmoothExitCondition
 * @LOOKSY:LiveDB.OPERATINGSYSTEM, LiveDB.WINDOWS
 *
 * Method Name : private static boolean writeandPlayHtml (JPanel p_panel, String p_path, String p_size)
 *
 * Parameters : JPanel p_panel - Use this panel to draw image to do a remove of this component later
 *              String p_size - HeightXWidth (see NOTE below)
 *              String p_path - the pathname for the animation file
 *              
 * Returns : boolean true if video plays
 *           boolean false if video does not play or some other error
 *
 * Chained Methods : None
 *
 * Called From : protected static boolean PlayVideo (String p_size, String p_path, JPanel p_panel)
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is an auxilliary method that is called from PlayVideo when that
 * method encounters an exception while creating a realized player. To be more specific
 * If createRealizedPlayer throws an exception such as NoPlayerException, CannotRealizeException
 * then it calls a chained method writeandPlayHtml (JPanel p_panel, String p_path, String p_size) wherein
 * it writes to a html files and then tries to play your video as a last ditch effort.
 * In this last ditch effort it tries to download the codebase for the file format from a remote server.
 * Obviously there is a problem with the player on your macchina. This is jst another resource intensive
 * attempt to make it fail safe. Hope it works.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    private static boolean writeandPlayHtml (JPanel p_panel, String p_path, String p_size)
    {
        if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) == -1)
            return false;

        String htmlfile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR +
                          "videoplay" + new Random().nextInt() + ".html";
        File file = null;
        FileWriter fw = null;
        BufferedWriter bw = null;
        String videoformat = p_path.substring(p_path.lastIndexOf('.'), p_path.length());
        String H = p_size.substring(0,p_size.toLowerCase().indexOf('x'));
        String W = p_size.substring(p_size.toLowerCase().indexOf('x') + 1, p_size.length());

        String [] linestowrite = {
            "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">" + '\n', // 0
            "<html><head><title></title>" + '\n', // 1
            "<meta content=\"text/html; charset=unicode\" http-equiv=\"Content-Type\">" + '\n', // 2
            "<meta name=\"GENERATOR\" content=\"MSHTML 8.00.6001.19120\"></head>" + '\n', // 3
            "<body>"                       
        };
        
        if (videoformat.equalsIgnoreCase("webm"))
        {
            linestowrite[linestowrite.length] = "<video width=\"" + W + "\" height=\"" + H + "\" controls >" + "\n".toString();
            linestowrite[linestowrite.length] = "<source src=\"" + p_path + "\" type='video/webm; codecs=\"vp8, vorbis\"'>" + "\n".toString();
            linestowrite[linestowrite.length] = "<object id=\"MediaPlayer1\" width=\"" + W + "\" height=\"" + H + "\"" + "\n".toString();
            linestowrite[linestowrite.length] = "classid=\"CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95\"" + "\n".toString();
            linestowrite[linestowrite.length] = "codebase=\"http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,02,902\"" + "\n".toString();
            linestowrite[linestowrite.length] = "standby=\"Loading Microsoft Windows Media Player components...\"" + "\n".toString();
            linestowrite[linestowrite.length] = "type=\"application/x-oleobject\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"FileName\" value=\"" + p_path + "\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"animationatStart\" value=\"false\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"transparentatStart\" value=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"autoStart\" value=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"showControls\" value=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<EMBED style=\"Z-INDEX: 106; LEFT: 1px; POSITION: absolute; TOP: 1px; WIDTH: " + W + "px; HEIGHT: " + H + "px;" + "\n".toString();
            linestowrite[linestowrite.length] = " type=\"application/x-mplayer2\"" + "\n".toString();
            linestowrite[linestowrite.length] = "pluginspage=\"http://www.microsoft.com/Windows/MediaPlayer/\"" + "\n".toString();
            linestowrite[linestowrite.length] = "Name=\"MediaPlayer\" src=\"" + p_path + "\" AutoStart=\"true\"" + "\n".toString();
            linestowrite[linestowrite.length] = "ShowStatusBar=\"0\" volume=\"-1\" HEIGHT=\"" + H + "\"" + "\n".toString();
            linestowrite[linestowrite.length] = "WIDTH=\"" + W + "\"></embed></object>" + "\n".toString();
            linestowrite[linestowrite.length] = "</video>" + "\n".toString();
        }
        else if (videoformat.equalsIgnoreCase("swf"))
        { // boob tube inclusive
                                               
            linestowrite[linestowrite.length] = "<OBJECT style=\"Z-INDEX: 106; LEFT: 1px; POSITION: absolute; TOP: 1px; WIDTH: " + W + "px; HEIGHT: " + H + "px;" + "\n".toString();
            linestowrite[linestowrite.length] = " classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\"" + "\n".toString();
            linestowrite[linestowrite.length] = " codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0\"" + "\n".toString();
            linestowrite[linestowrite.length] = " WIDTH=\"" + W + "\" HEIGHT=\"" + H + "\" id=\"" + p_path + "\" ALIGN=\"\">" + "\n".toString();
            linestowrite[linestowrite.length] = " <PARAM NAME=movie VALUE=\"" + p_path + "\">" + "\n".toString();
            linestowrite[linestowrite.length] = " <PARAM NAME=quality VALUE=high>" + "\n".toString();
            linestowrite[linestowrite.length] = " <PARAM NAME=bgcolor VALUE=#333399>" + "\n".toString();
            linestowrite[linestowrite.length] = "<EMBED style=\"Z-INDEX: 106; LEFT: 1px; POSITION: absolute; TOP: 1px; WIDTH: " + W + "px; HEIGHT: " + H + "px;" + "\n".toString();
            linestowrite[linestowrite.length] = " src=\"" + p_path + "\" quality=high bgcolor=#333399 WIDTH=\"" + W + "\" HEIGHT=\"" + H + "\"" + "\n".toString();
            linestowrite[linestowrite.length] = " NAME=\"" + p_path + "\" ALIGN=\"\"" + "\n".toString();
            linestowrite[linestowrite.length] = " TYPE=\"application/x-shockwave-flash\"" + "\n".toString();
            linestowrite[linestowrite.length] = " PLUGINSPAGE=\"http://www.macromedia.com/go/getflashplayer\">" + "\n".toString();
            linestowrite[linestowrite.length] = " </EMBED> </OBJECT>" + "\n".toString();            
        }
        else if (videoformat.equalsIgnoreCase("mov") || videoformat.equalsIgnoreCase("mp4"))
        {
            linestowrite[linestowrite.length] = "<OBJECT CLASSID=\"clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B\" WIDTH=\"" + W + "\" HEIGHT=\"" + H + "\"" + "\n".toString();
            linestowrite[linestowrite.length] = "CODEBASE=\"http://www.apple.com/qtactivex/qtplugin.cab\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<PARAM NAME=\"src\" VALUE=\"" + p_path + "\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<PARAM NAME=\"autoplay\" VALUE=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<PARAM NAME=\"controller\" VALUE=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<PARAM NAME=\"loop\" VALUE=\"false\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<EMBED style=\"Z-INDEX: 106; LEFT: 1px; POSITION: absolute; TOP: 1px; WIDTH: " + W + "px; HEIGHT: " + H + "px;" + "\n".toString();
            linestowrite[linestowrite.length] = " SRC=\"" + p_path + "\" WIDTH=\"" + W + "\" HEIGHT=\"" + H + "\" AUTOPLAY=\"true\" CONTROLLER=\"true\" LOOP=\"false\"" + "\n".toString();
            linestowrite[linestowrite.length] = "PLUGINSPAGE=\"http://www.apple.com/quicktime/\">" + "\n".toString();
            linestowrite[linestowrite.length] = "</EMBED></OBJECT>" + "\n".toString();
        }
        else if (videoformat.equalsIgnoreCase("mpg") || videoformat.equalsIgnoreCase("mpeg")
                || videoformat.equalsIgnoreCase("wmv") || videoformat.equalsIgnoreCase("avi"))
        {
            linestowrite[linestowrite.length] = "<object id=\"MediaPlayer1\" width=\"" + W + "\" height=\"" + H + "\"" + "\n".toString();
            linestowrite[linestowrite.length] = "classid=\"CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95\"" + "\n".toString();
            linestowrite[linestowrite.length] = "codebase=\"http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,02,902\"" + "\n".toString();
            linestowrite[linestowrite.length] = "standby=\"Loading Microsoft Windows Media Player components...\"" + "\n".toString();
            linestowrite[linestowrite.length] = "type=\"application/x-oleobject\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"FileName\" value=\"" + p_path + "\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"animationatStart\" value=\"false\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"transparentatStart\" value=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"autoStart\" value=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<param name=\"showControls\" value=\"true\">" + "\n".toString();
            linestowrite[linestowrite.length] = "<EMBED style=\"Z-INDEX: 106; LEFT: 1px; POSITION: absolute; TOP: 1px; WIDTH: " + W + "px; HEIGHT: " + H + "px;" + "\n".toString();
            linestowrite[linestowrite.length] = " type=\"application/x-mplayer2\"" + "\n".toString();
            linestowrite[linestowrite.length] = "pluginspage=\"http://www.microsoft.com/Windows/MediaPlayer/\"" + "\n".toString();
            linestowrite[linestowrite.length] = "Name=\"MediaPlayer\" src=\"" + p_path + "\" AutoStart=\"true\"" + "\n".toString();
            linestowrite[linestowrite.length] = "ShowStatusBar=\"0\" volume=\"-1\" HEIGHT=\"" + H + "\"" + "\n".toString();
            linestowrite[linestowrite.length] = "WIDTH=\"" + W + "\"></embed></object>" + "\n".toString();
        }

        // add one last line
        linestowrite[linestowrite.length] = "</body></html>" + "\n".toString();
        
        file = new File (htmlfile);

        try{
                while (file.createNewFile() == false)
                {
                    htmlfile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR +
                          "videoplay" + new Random().nextInt() + ".html";
                    file = new File(htmlfile);
                }
        }catch (IOException ex_NOKIA7){
               System.err.println(LiveDB.grassHopper(ex_NOKIA7, "File:" + htmlfile));
               LiveDB.system_exit = 1;
               LiveDB.SmoothExitCondition.signalAll();
               return false;
        }catch (SecurityException ex_NOKIA6){
               System.err.println(LiveDB.grassHopper(ex_NOKIA6, "JSM deny perms File:" + htmlfile));
               LiveDB.system_exit = 1;
               LiveDB.SmoothExitCondition.signalAll();
               return false;
        }

        file.deleteOnExit();

        if (file.canWrite() == false)
        {
                try{
                  file.setWritable(true, false);
                }catch (SecurityException ex_NOKIA81){
                   System.err.println(LiveDB.grassHopper(ex_NOKIA81, "JSM deny perms File:" + htmlfile));
                   LiveDB.system_exit = 1;
                   LiveDB.SmoothExitCondition.signalAll();
                   return false;
                }
        }

        try{
               fw = new FileWriter (file);
        }catch (IOException ex_NOKIA9){
               System.err.println(LiveDB.grassHopper(ex_NOKIA9, "File:" + htmlfile));
               LiveDB.system_exit = 1;
               LiveDB.SmoothExitCondition.signalAll();
               try{
                  fw.close();
               }catch (IOException ex_NOKIA1){
                  System.err.println(LiveDB.grassHopper(ex_NOKIA1, "File:" + htmlfile));
                  LiveDB.system_exit = 1;
                  LiveDB.SmoothExitCondition.signalAll();
               }
               return false;
        }

        bw = new BufferedWriter(fw);
        for (int i = 0; i < linestowrite.length; i++)
        {
                try{
                  bw.write(linestowrite[i]);
                }catch (IOException ex_NOKIA4){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA4, "File:" + htmlfile));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                    try{
                     bw.flush();
                    }catch (IOException ex_NOKIA2){
                        System.err.println(LiveDB.grassHopper(ex_NOKIA2, "File:" + htmlfile));
                        LiveDB.system_exit = 1;
                        LiveDB.SmoothExitCondition.signalAll();
                    }
                    try{
                      bw.close();
                    }catch (IOException ex_NOKIA5){
                        System.err.println(LiveDB.grassHopper(ex_NOKIA5, "File:" + htmlfile));
                        LiveDB.system_exit = 1;
                        LiveDB.SmoothExitCondition.signalAll();
                    }
                    return false;
                }
        } // for (int i = 0; i < linestowrite.length; i++)

        try{
                 bw.close();
        }catch (IOException ex_NOKIA5){
                System.err.println(LiveDB.grassHopper(ex_NOKIA5, "File:" + htmlfile));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
                return false;
        }

        videowin[videowin.length] = new JEditorPane ();
        try{
            videowin[videowin.length -1].setPage(new File(htmlfile).toURI().toURL());
        }catch (MalformedURLException ex_NOKIA11){
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper(ex_NOKIA11, "Malformed URL:" + htmlfile));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
                return false;
        }catch (IOException ex_NOKIA49){
                System.err.println(LiveDB.grassHopper(ex_NOKIA49, "File:" + htmlfile));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
                return false;
        }

        videowin[videowin.length -1].setEditable(false);

        videowin[videowin.length -1].addHyperlinkListener(new HyperlinkListener (){
            @Override
            public void hyperlinkUpdate (HyperlinkEvent evnt)
            {
                if (evnt.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
                {
                    try
                    {
                          videowin[videowin.length -1].setPage(evnt.getURL());
                    }catch (IOException ex_YESKIA98){
                          videowin[videowin.length -1].setText(ex_YESKIA98.toString());
                    }
                }
            }
        });

        // possible bug here check during testing
        videoJPanels[videoJPanels.length] = p_panel;
        videoJPanels[videoJPanels.length -1].add(videowin[videowin.length -1], 1);

        p_panel.validate();
        
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:JukeBox.java
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.grassHopper, LiveDB.system_exit, LiveDB.SmoothExitCondition
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.FILESEPERATOR
 * @LOOKSY:NorthAdvertPanel.java
 * @LOOKSY:NorthEastAdvertPanel.java
 * @LOOKSY:NorthWestAdvertPanel.java
 * @LOOKSY:SouthAdvertPanel.java
 * @LOOKSY:SouthEastAdvertPanel.java
 * @LOOKSY:SouthWestAdvertPanel.java
 * @LOOKSY:EastAdvertPanel.java
 * @LOOKSY:WestAdvertPanel.java
 * 
 * Method Name : protected static boolean PlayAudio (String p_path, JPanel p_panel, String p_size)
 *
 * Parameters : String p_path - the pathname for the audio file
 *              JPanel p_panel - Use this panel to play audio, to do a remove of this component later
 *              String p_size - HeightXWidth (see NOTE below)
 *
 * Returns : boolean true only for now
 *
 * Chained Methods : protected static boolean PlayAnimation (String p_size, String p_path,
 *                                                                                 JPanel p_panel)
 *                   public JukeBox (String p_musicfile) -- Constructor call
 * 
 * Called From : Each of the advert panels listed above.
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to play any audio on the JPanel that you passed as parameter.
 * This JPanel must be added to LiveDB.appframe or any other component by you with setConstraints().
 * All that this method does is to play the audio on that JPanel.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean PlayAudio (String p_path, JPanel p_panel, String p_size)
    {
        String size = "200x100";
        String path = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR + "BigBand.gif";

        PlayAnimation (p_size == null ? size: p_size, path, p_panel);

        new JukeBox (p_path);

        p_panel.validate();
        
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:NorthAdvertPanel.java
 * @LOOKSY:NorthEastAdvertPanel.java
 * @LOOKSY:NorthWestAdvertPanel.java
 * @LOOKSY:SouthAdvertPanel.java
 * @LOOKSY:SouthEastAdvertPanel.java
 * @LOOKSY:SouthWestAdvertPanel.java
 * @LOOKSY:EastAdvertPanel.java
 * @LOOKSY:WestAdvertPanel.java
 *
 * @LOOKSY:LiveDB.AUDIOADVERT
 *
 * Method Name : protected static void PlayAudio (long p_direction, String p_path, String p_size)
 *
 * Parameters : long p_direction - Any Of LiveDB.north, LiveDB.northeast, LiveDB.northwest, LiveDB.south,
 *                                 LiveDB.southeast,  LiveDB.southwest, LiveDB.west, LiveDB.east
 *              String p_path - the pathname for the audio file
 *              String p_size - HeightXWidth (see NOTE below)
 *
 * Returns : None
 *
 * Chained Methods : 
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a bit confusing. The sequence of calls is like this. This method checks
 * the direction where you want that music audio to play and then calls appropriate panel constructor
 * with params (one of those indicates LiveDB.AUDIOADVERT). Then that panel constructor calls overloaded
 * PlayAudio method above.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static void PlayAudio (long p_direction, String p_path, String p_size)
    {
        Object unnecessary;

        if (p_direction == LiveDB.north)
        {
            unnecessary = new NorthAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northeast)
        {
             unnecessary = new NorthEastAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northwest)
        {
             unnecessary = new NorthWestAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.south)
        {
             unnecessary = new SouthAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southeast)
        {
             unnecessary = new SouthEastAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southwest)
        {
             unnecessary = new SouthWestAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.east)
        {
             unnecessary = new EastAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.west)
        {
             unnecessary = new WestAdvertPanel (LiveDB.AUDIOADVERT, p_size, p_path);
        }        
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:DefaultAdvertisingImages.java
 *
 * @LOOKSY:LiveDB.FILESEPERATOR, LiveDB.MAXADVERTS, LiveDB.LiveSharedDB
 *
 * Method Name : protected static void PlayAllAdverts ()
 *
 * Parameters : None
 *
 * Returns : None
 *
 * Chained Methods : protected static void PlayAudio (long p_direction, String p_path, String p_size)
 *                   protected static boolean PlayVideo (long p_direction, String p_path, String p_size)
 *                   protected static boolean PlayAnimationAdvert (long p_direction, String p_path,
 *                                                                                        String p_size)
 *                   protected static boolean DrawImageAdvert (long p_direction, String p_path,
 *                                                                                        String p_size)
 *
 * Called From : FirstPage constructor
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is only called from the FirstPage constructor. This is the master
 * method that calls all other methods like PlayVideo, PlayAudio, PlayAnimationAdvert, DrawImageAdvert.
 * All that it does is to run thru the table DefaultAdvertisingImages and checks flags to check if it
 * is a audio or video. If flag is neither of these then it has to be an animation or plain image.
 * So it checks the number of frames and/or a .gif extension to ensure that it is a animation.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static void PlayAllAdverts ()
    {
        File file = null;
        ImageInputStream ImageIn = null;
        
        Iterator<ImageReader> iter = null;
        int numimages = 0;
        int ii = 0;
        BufferedImage bi = null;


        for (int rw = 0; rw <= LiveDB.MAXADVERTS && rw < LiveDB.LiveSharedDB[da].length; rw++)
        {
            // remove this line if you want to load and watch naughty movies at office time
            if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getChildsafe() == 0)
                continue;
            
            if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getVideo() == 1)
            {
                if (PlayVideo (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                    ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                    + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                    .getImagename(),
                    ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize())
                        == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant Play Video"));
                    continue;
                }
            }
            else if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getAudio() == 1)
            {
                PlayAudio(((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                        + LiveDB.FILESEPERATOR +
                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize());
            }
            else
            {
                // first check if animation then play animation otherwise draw image as is
                if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename()
                        .indexOf(".gif") != -1)
                {
                    // maybe a true animation
                    file = new File (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename());
                    try{
                    ImageIn = ImageIO.createImageInputStream(file);
                    }catch (IOException ex_YESKIA98){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" +
                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                        .getImagename()));
                        continue;
                    }
                    
                    iter = ImageIO.getImageReadersBySuffix("gif");
                    reader = iter.next();
                    reader.setInput(ImageIn);

                    try{
                         numimages = reader.getNumImages(true);
                    }catch (IllegalStateException ex_NOKIA1){
                       try{
                            if ((numimages = reader.getNumImages(false)) == -1)
                            {
                                // still fails miserable ....
                                do
                                {
                                    try{
                                    bi = reader.read(ii);
                                    }catch(IndexOutOfBoundsException ex_YESKIA1){                                        
                                        break;
                                    }
                                    ii++;
                                }while (bi != null);

                                if (ii == 1)
                                {
                                    // then this is not a true animation
                                    // but it could be an animation still since thumbnail images have not been counted
                                    try{
                                    if (reader.getNumThumbnails(ii-1) == 0)
                                    {
                                    if (DrawImageAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                                    {
                                        System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                        .getImagename()));
                                        continue;
                                    }
                                    }
                                    else
                                    {
                                        // this is an animation
                                        if (PlayAnimationAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                                        {
                                            System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                                            ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                            + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                            .getImagename()));
                                            continue;
                                        }else continue;
                                    }
                                    }catch (IndexOutOfBoundsException ex_NOKIA3){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA3));
                                        System.exit(1);
                                    }catch (IOException ex_YESKIA2){
                                        System.err.println(LiveDB.grassHopper(ex_YESKIA2));
                                        continue;
                                    }
                                }
                                else if (ii == 0)
                                {
                                    // there is an error in ImageIn
                                    System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                                    ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                    + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                    .getImagename()));
                                    continue;
                                }
                                else
                                {
                                    // this is an animation
                                    if (PlayAnimationAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                                    {
                                        System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                        .getImagename()));
                                        return;
                                    }else continue;
                                }

                            }
                       }catch (IOException ex_YESKIA9){
                            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "File:" +
                            ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                            + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                            .getImagename()));
                            continue;
                        }
                    }catch (IOException ex_YESKIA9){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA9, "File:" +
                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                        .getImagename()));
                        continue;
                    }

                    if (numimages == 1)
                    {
                       // then this is not a true animation
                       // but it could be an animation still since thumbnail images have not been counted
                       try{
                       if (reader.getNumThumbnails(numimages -1) == 0)
                       {
                            if (DrawImageAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                                ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                                ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                            {
                                System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                                ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                .getImagename()));
                                continue;
                            }
                       }
                       else
                       {
                            // this is an animation
                            if (PlayAnimationAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                                ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                                ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                            {
                                System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                                ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                                + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                .getImagename()));
                                continue;
                            }else continue;
                       }
                       }catch (IndexOutOfBoundsException ex_NOKIA3){
                           System.err.println(LiveDB.grassHopper(ex_NOKIA3));
                           System.exit(1);
                       }catch (IOException ex_YESKIA2){
                           System.err.println(LiveDB.grassHopper(ex_YESKIA2));
                           continue;
                       }
                   }
                   else if (numimages <= 0)
                   {
                                    // there is an error in ImageIn
                        System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                        ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                        + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                        .getImagename()));
                        continue;
                   }
                   else
                   {
                       
                       if (DrawImageAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                           ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                           + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                           ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                       {
                           System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                           ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                           + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                           .getImagename()));
                           continue;
                       }
                   }
                }
                else // if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename()
                {
                   if (DrawImageAdvert (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirections(),
                       ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                       + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagename(),
                       ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getImagesize()) == false)
                   {
                       System.err.println(LiveDB.grassHopper( "Cant Draw Image:" +
                       ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw]).getDirectoryname()
                       + LiveDB.FILESEPERATOR + ((DefaultAdvertisingImages)LiveDB.LiveSharedDB[da][rw])
                                        .getImagename()));
                       continue;
                   }
                }
            } 
        } // for (int rw = 0; rw < LiveDB.MAXADVERTS; rw++)
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:NorthAdvertPanel.java
 * @LOOKSY:NorthEastAdvertPanel.java
 * @LOOKSY:NorthWestAdvertPanel.java
 * @LOOKSY:SouthAdvertPanel.java
 * @LOOKSY:SouthEastAdvertPanel.java
 * @LOOKSY:SouthWestAdvertPanel.java
 * @LOOKSY:EastAdvertPanel.java
 * @LOOKSY:WestAdvertPanel.java
 *
 * @LOOKSY:LiveDB.ANIMATIONADVERT
 *
 * Method Name : protected static boolean PlayAnimationAdvert (long p_direction, String p_path,
 *                                                                               String p_size)
 * Parameters : long p_direction - Any Of LiveDB.north, LiveDB.northeast, LiveDB.northwest, LiveDB.south,
 *                                 LiveDB.southeast,  LiveDB.southwest, LiveDB.west, LiveDB.east
 *              String p_path - the pathname for the animation file
 *              String p_size - imagewidthXimageheight
 *
 * Returns : boolean true for now 
 *
 * Associated Constructors : Constructors for each of the panels as listed above.
 *
 * Called From : protected static void PlayAllAdverts ()
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Call this method to play animation. This is a bit confusing. The sequence of
 * calls is like this. This method checks the direction where you want that animation to play and
 * then calls appropriate panel constructor with params (one of those indicates LiveDB.ANIMATIONADVERT)
 * Then that panel constructor calls overloaded protected static boolean PlayAnimation (String p_size,
 * String p_path, JPanel p_panel) method above.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 8th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean PlayAnimationAdvert (long p_direction, String p_path, String p_size)
    {
        Object unnecessary;

        if (p_direction == LiveDB.north)
        {
            unnecessary = new NorthAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northeast)
        {
             unnecessary = new NorthEastAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northwest)
        {
             unnecessary = new NorthWestAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.south)
        {
             unnecessary = new SouthAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southeast)
        {
             unnecessary = new SouthEastAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southwest)
        {
             unnecessary = new SouthWestAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.east)
        {
             unnecessary = new EastAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.west)
        {
             unnecessary = new WestAdvertPanel (LiveDB.ANIMATIONADVERT, p_size, p_path);
        }

        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:NorthAdvertPanel.java
 * @LOOKSY:NorthEastAdvertPanel.java
 * @LOOKSY:NorthWestAdvertPanel.java
 * @LOOKSY:SouthAdvertPanel.java
 * @LOOKSY:SouthEastAdvertPanel.java
 * @LOOKSY:SouthWestAdvertPanel.java
 * @LOOKSY:EastAdvertPanel.java
 * @LOOKSY:WestAdvertPanel.java
 *
 * @LOOKSY:LiveDB.VIDEOADVERT, LiveDB.VIDEOPLAYERERROR
 *
 * Method Name : protected static boolean PlayVideo (long p_direction, String p_path, String p_size)
 *
 * Parameters : long p_direction - Any Of LiveDB.north, LiveDB.northeast, LiveDB.northwest, LiveDB.south,
 *                                 LiveDB.southeast,  LiveDB.southwest, LiveDB.west, LiveDB.east
 *              String p_path - the pathname for the video file
 *              String p_size - HeightXWidth (see NOTE below)
 *
 * Returns : LiveDB.VIDEOPLAYERERROR the value for which is set in the constructors of each of the
 *           panels such as NorthAdvertPanel ..... WestAdvertPanel as above.
 *
 * Called From : protected static void PlayAllAdverts ()
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from PlayAllAdverts which checks DefaultAdvertisingImages
 * for the image type and then calls this method PlayVideo. This is a bit confusing. The sequence
 * of calls is like this. This method checks the direction where you want that video to play and then
 * calls the appropriate panel constructor with params (one of those indicates LiveDB.VIDEOADVERT)
 * Then that panel constructor calls overloaded PlayVideo method above.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean PlayVideo (long p_direction, String p_path, String p_size)
    {
        Object unnecessary;

        if (p_direction == LiveDB.north)
        {
            unnecessary = new NorthAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northeast)
        {
             unnecessary = new NorthEastAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northwest)
        {
             unnecessary = new NorthWestAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.south)
        {
             unnecessary = new SouthAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southeast)
        {
             unnecessary = new SouthEastAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southwest)
        {
             unnecessary = new SouthWestAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.east)
        {
             unnecessary = new EastAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.west)
        {
             unnecessary = new WestAdvertPanel (LiveDB.VIDEOADVERT, p_size, p_path);
        }

        return LiveDB.VIDEOPLAYERERROR;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:NorthAdvertPanel.java
 * @LOOKSY:NorthEastAdvertPanel.java
 * @LOOKSY:NorthWestAdvertPanel.java
 * @LOOKSY:SouthAdvertPanel.java
 * @LOOKSY:SouthEastAdvertPanel.java
 * @LOOKSY:SouthWestAdvertPanel.java
 * @LOOKSY:EastAdvertPanel.java
 * @LOOKSY:WestAdvertPanel.java
 *
 * @LOOKSY:LiveDB.VIDEOADVERT
 *
 * Method Name : protected static boolean DrawImageAdvert (long p_direction, String p_path,
 *                                                                                        String p_size)
 *
 * Parameters : long p_direction - Any Of LiveDB.north, LiveDB.northeast, LiveDB.northwest, LiveDB.south,
 *                                 LiveDB.southeast,  LiveDB.southwest, LiveDB.west, LiveDB.east
 *              String p_path - the pathname for the image file
 *              String p_size - HeightXWidth (see NOTE below)
 *
 * Returns : None
 *
 * Called From : protected static void PlayAllAdverts ()
 *
 * Data File : String p_path
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from PlayAllAdverts which checks DefaultAdvertisingImages
 * for the image type and then calls this method DrawImageAdvert. This is a bit confusing. The sequence
 * of calls is like this. This method checks the direction where you want that video to play and then
 * calls the appropriate panel constructor with params (one of those indicates LiveDB.IMAGEADVERT)
 * Then that panel constructor calls overloaded DrawImage (String p_size, String p_path, JPanel p_panel,
 *                                                                                 String... p_suffix)
 *
 * Technical Reference : [Buy] and Read Tin Tin and Seven Crystal Balls
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean DrawImageAdvert (long p_direction, String p_path, String p_size)
    {
        Object unnecessary;

        if (p_size == null)
        {
            // guess the darned size
            Iterator<ImageReader> iter = null;
            ImageInputStream ImageIn = null;
            Image image = null;
            int infoflags = 0;
            File file = null;
            int W = 0, H = 0;

            try{
                image = ImageIO.read(new File(p_path));
            }catch (IOException ex_YESKIA9){
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" + p_path));
                return false;
            }

            file = new File (p_path);
            try{
              ImageIn = ImageIO.createImageInputStream(file);
            }catch (IOException ex_YESKIA98){
                System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + p_path));
                return false;
            }

            iter = ImageIO.getImageReadersBySuffix(p_path.lastIndexOf('.') == -1 ? "jpg" :
                           (p_path.lastIndexOf('.') == p_path.length() ?
                           "jpeg" : p_path.substring(p_path.lastIndexOf('.') + 1, p_path.length())));

            reader = iter.next();
            reader.setInput(ImageIn);
            try{
                p_size = reader.getHeight(0) + "X" + reader.getWidth(0);
            }catch (IndexOutOfBoundsException ex_NOKIA5){
                System.err.println(LiveDB.grassHopper(ex_NOKIA5));
                System.exit(1);
            }catch (IOException ex_NOKIA0){
                System.err.println(LiveDB.grassHopper(ex_NOKIA0));
                return false;
            }
        }

        if (p_direction == LiveDB.north)
        {
            unnecessary = new NorthAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northeast)
        {
             unnecessary = new NorthEastAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.northwest)
        {
             unnecessary = new NorthWestAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.south)
        {
             unnecessary = new SouthAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southeast)
        {
             unnecessary = new SouthEastAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.southwest)
        {
             unnecessary = new SouthWestAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.east)
        {
             unnecessary = new EastAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }
        else if (p_direction == LiveDB.west)
        {
             unnecessary = new WestAdvertPanel (LiveDB.IMAGEADVERT, p_size, p_path);
        }

        return true;
    }

    // easy method to set constraints. Every call constraints = new GridBagConstraints ();
    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
