/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;
import javax.swing.event.HyperlinkListener;
import javax.swing.event.HyperlinkEvent;
import java.io.IOException;
import java.io.File;
import javax.swing.JEditorPane;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import static DatabaseEngine.FirstPage.pageonetextpanel;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : PageOneTextPanel
 *
 * @LOOKSY:FirstPage.pageonetextpanel, LiveDB.grassHopper, LiveDB.ALRTLVL, LiveDB.serializedfilespath,
 * @LOOKSY:FirstPage.featuredpanel, FirstPage.cartpanel, LiveDB.FILESEPERATOR
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor will construct the pageonetextpanel and attach it to
 * front page. The addpageonetextpanel() method that the constructor calls will set/display html page
 * and also add a HyperlinkListener to it for URL's.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 11th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class PageOneTextPanel
{

    JEditorPane dispwindow = new JEditorPane ();

    public PageOneTextPanel ()
    {
        int MF = 10;
        pageonetextpanel = new JPanel();
        pageonetextpanel.setLayout(new BoxLayout(pageonetextpanel, BoxLayout.PAGE_AXIS));
        pageonetextpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));

        pageonetextpanel.setBounds((int)(FirstPage.cartpanel.RIGHT_ALIGNMENT * MF),
                (int)(FirstPage.cataloguepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.featuredpanel.LEFT_ALIGNMENT * MF) - 
                (int)(FirstPage.cartpanel.RIGHT_ALIGNMENT * MF) + 1,
                (int)Madagascar.DEFAULT_HEIGHT/3);
        
        pageonetextpanel.setBackground(Color.WHITE);
        addpageonetextpanel();
    }

    void addpageonetextpanel()
    {
         String textfromfile = LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "etc"
         + "LENSVIEWFIRSTPAGE" + LanguagePanel.SelectedLanguage + ".html";

         if (new File(textfromfile).exists() == false)
         {
             textfromfile = LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "etc"
                            + "LENSVIEWFIRSTPAGE" + "en" + ".html";
         }
         
         if (new File(textfromfile).canRead() == false)
         {
             new File(textfromfile).setReadOnly();
         }

         if (new File(textfromfile).canWrite())
         {
             new File(textfromfile).setReadOnly();
         }

         dispwindow.addHyperlinkListener(new HyperlinkListener()
         {
               @Override
               public void hyperlinkUpdate (HyperlinkEvent evnt)
               {
                  if (evnt.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
                  {
                      try
                      {
                          dispwindow.setPage(evnt.getURL());
                      }catch (IOException ex_YESKIA98){
                          dispwindow.setText(ex_YESKIA98.toString());
                      }
                  }
               }         
         });
         
         try{
            dispwindow.setPage(textfromfile);
         }catch (IOException ex_NOKIA8){
            dispwindow.setText(ex_NOKIA8.toString());
            System.err.println(LiveDB.grassHopper(ex_NOKIA8, "URL:" + textfromfile));
            System.exit(1);
         }
        
         dispwindow.setEditable(false);
         
         pageonetextpanel.add(dispwindow,1);
         pageonetextpanel.validate();
    }
}
