/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import javax.swing.JOptionPane;
import java.awt.Font;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JTextField;
import static DatabaseEngine.LanguagePanel.SelectedLanguage;
import static DatabaseEngine.FirstPage.registerpanel;
import static DatabaseEngine.LiveDB.cr;
import static DatabaseEngine.LiveDB.ct;
import static DatabaseEngine.LiveDB.ar;
import static DatabaseEngine.LoginPage.LoggedInCID;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : RegistrationPage
 *
 * @LOOKSY: CustomerRegister.java
 * @LOOKSY: ViewBasketPanel.java
 * @LOOKSY: ChangeTracker.java
 * 
 * @LOOKSY:LiveDB.indxlanguageTitles, LoginPage.LoggedInCID, LiveDB.indxcustomerRegister
 * @LOOKSY:FirstPage.pageonetextpanel, FirstPage.maillistpanel, FirstPage.infopanel, LoginPage.LoggedInCID
 * @LOOKSY:FirstPage.popularpanel, FirstPage.featuredpanel, FirstPage.salepanel, LiveDB.appframe
 * @LOOKSY:FirstPage.cartpanel, LiveDB.grassHopper, LiveDB.ALRTLVL, LiveDB.USRNAME, LiveDB.NODENAME
 * @LOOKSY:LiveDB.PrepareAndSendMailMesg, LaunchGUI.MAX_WIDTH, LiveDB.indxcustomerRegister
 *
 * Associated Methods : public ViewBasketPanel () constructor from ViewBasketPanel.java
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor will construct the registerpanel. This panel presents
 * the user with a registration form and after submission of the form the registered users details
 * are emailed to the user for confirmation and also a copy to the company. Immediately after submit
 * and acceptance of new user details the guest user is also logged in immediately by setting
 * LoginPage.LoggedInCID
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 *
 * Last Modified : 14th October 2011
 * Last Modifications : added this input method listener to make address line 1 mandatory
        addr1.addInputMethodListener(new InputMethodListener ()
        {
           @Override
           public void inputMethodTextChanged(InputMethodEvent event){
                if (addr1.getText().trim().length() == 0)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Address Line 1 Mandatory");
                    addr1.setText(" ");
                    addr1.setFocusable(true);
                    formsubmit = false;
                    addr1.validate();
                }
           }

           @Override
           public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
           }
        });
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class RegistrationPage {

    GridBagConstraints constraints = null;
    String langstring [] = null;
    JLabel expregis = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Express Registration")
            == null ? "Express Registration" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel asterisk = new JLabel ("Please note that all fields that have an asterisk (*) are required to process your registration.");
    JLabel pers = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Personal Details")
            == null ? "Personal Details" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel addr = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Address")
            == null ? "Address" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel address = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Address")
            == null ? "Address(*):" : new String(langstring[langstring.length -1].toCharArray()) + "(*):");
    JTextField addr1 = null;
    JTextField addr2 = null;
    JTextField addr3 = null;
    JLabel Landmark = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Landmark")
            == null ? "Landmark:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JTextField landmark = null;
    JLabel securitydet = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Security Details")
            == null ? "Security Details" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel title = new JLabel ("Title (Mr/Mrs/Miss/Majesty/Earl/Sir/Lord:");
    JTextField titles = null;
    JLabel firstname = new JLabel ("First Name(*):");
    JTextField fname = null;
    JLabel lastname = new JLabel ("Last Name(*):");
    JTextField lname = null;
    JLabel emailaddr = new JLabel ("Email Address(*):");
    JTextField email = null;
    JLabel telephone = new JLabel ("Telephone(*):");
    JTextField tel = null;
    JLabel fax = new JLabel ("Fax:");
    JTextField faxnumber = null;
    JLabel choosepasswd = new JLabel ("Choose Password(*):");
    JLabel town = new JLabel ("Town(*):");
    JTextField towns = null;
    JLabel countystate = new JLabel ("County/State(*):");
    JTextField state = null;
    JLabel country = new JLabel ("Country(*):");
    JLabel postcode = new JLabel ("Post Code(*):");
    JTextField post = null;
    JLabel confirmpass = new JLabel ("Confirm Password(*):");
    JButton submitcont = new JButton (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Submit and Continue")
            == null ? "Submit and Continue" : new String(langstring[langstring.length -1].toCharArray()));
    JComboBox countries = null;
    JLabel custbirthdate = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Birth Date")
            == null ? "Birth Date:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JTextField birthdate = null;
    Date BirthDay = null;
    
    JLabel custsex = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Customer Sex")
            == null ? "Customer Sex:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JComboBox sex = null;
    JLabel marital = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Marital Status")
            == null ? "Marital Status:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JLabel birthcity = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Birth City")
            == null ? "Birth City:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JLabel birthstate = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Birth State")
            == null ? "Birth State:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JLabel birthnation = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Birth Nation")
            == null ? "Birth Nation:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JComboBox custbirthnation = null;
    JTextField custbirthcity = null;
    JTextField custbirthstate = null;
    JComboBox MaritalStatus = null;
    String sexes [] = {"M", "F"};
    String maritalstatus [] = { "Married", "Single", "Divorced", "LivingIn", "Widow", "Widower", "Engaged" };
    
    static String nations [] = { "Afghanistan", "Albania", "Algeria", "American Samoa", "Andorra", "Angola",
    "Anguilla", "Antartica", "Antigua and Barbuda", "Argentina", "Armenia", "Aruba", "Australia",
    "Austria", "Azerbaijan", "Bahamas", "Bahrain", "Bangladesh", "Barbados", "Belarus", "Belgium", 
    "Belize", "Benin", "Bermuda", "Bhutan", "Bolivia", "Boznia and Herzegovina", "Botswana",
    "Bouvet Island", "Brazil", "British Indian Ocean", "Brunei Darussalam", "Bulgaria",
    "Burkina Faso", "Burundi", "Cambodia", "Cameroon", "Canada", "Cape Verde", "Cayman Islands",
    "Central African Republic", "Chad", "Chile", "China", "Christmas Island", "Cocos (Keeling Island)",
    "Colombia", "Comoros", "Congo", "Congo Democratic Republic", "Cook Islands", "Costa Rica",
    "Cote D'Ivoire", "Croatia", "Cuba", "Cyprus", "Czech Republic", "Denmark", "Djibouti",
    "Dominica", "Dominican Republic", "Ecuador", "Egypt", "El Salvador", "Equatorial Guinea", 
    "Eritrea", "East Timor", "Estonia", "Ethiopia", "Falkland Islands", "Faroe Islands", "Fiji",
    "Finland", "France", "French Guiyana", "French Polynesia", "French Southern Territory",
    "Gabon", "Gambia", "Georgia", "Germany", "Ghana", "Gibraltar", "Greece", "Greenland",
    "Grenada", "Guadeloupe", "Guam", "Guatemala", "Guinea", "Guinea-Bissau", "Guyana", "Haiti",
    "Heard Island", "Holy See (Vatican Village)", "Honduras", "Hong Kong", "Hungary", "Iceland",
    "India", "Indonesia", "Iran Islamic Republic", "Iraq", "Ireland", "Israel", "Italy", "Jamaica",
    "Japan", "Jordan", "Kazakhstan", "Kenya", "Kiribati", "Korea North", "Korea South", "Kuwait",
    "Kyrgyzstan", "Lao", "Latvia", "Lebanon", "Lesotho", "Libya", "Liberia", "Liechtenstein",
    "Lithuania", "Luxembourg", "Macao", "Macedonia", "Madagascar", "Malawi", "Malaysia", "Maldives",
    "Mali", "Malta", "Marshall Islands", "Martinique", "Mauritania", "Mauritius", "Mayotte", "Mexico",
    "Micronesia", "Moldova", "Monaco", "Mongolia", "Montserrat", "Morocco", "Mozambique", "Myanmar",
    "Namibia", "Nauru", "Nepal", "Netherlands", "Netherlands Antilles", "New Caledonia", "New Zealand",
    "Nicaragua", "Niger", "Nigeria", "Nieu", "Norfolk Island", "Northern Mariana Island", "Norway",
    "Oman", "Pakistan", "Palau", "Palestinian Territory", "Panama", "Papua New Guinea", "Paraguay",
    "Peru", "Philippines", "Pitcairn", "Poland", "Portugal", "Puerto Rico", "Quatar", "Re-Union",
    "Romania", "Russian Federation", "Rwanda", "Saint Helena", "Saint Kitts", "Saint Lucia",
    "Saint Pierre", "Saint Vincent", "Samoa", "San Marino", "Sao Tome", "Saudi Arabia", "Senegal",
    "Serbia and Montenegro", "Seychelles", "Sierra Leone", "Singapore", "Slovakia", "Slovenia",
    "Solomon Islands", "South Africa", "South Georgia", "Spain", "Sri Lanka", "Sudan", "Surinam",
    "Svalbard", "Swaziland", "Sweden", "Switzerland", "Syria", "Taiwan", "Tajikistan", "Tanzania",
    "Thailand", "Togo", "Tokelau", "Tonga", "Trinidad and Tobago", "Tunisia", "Turkey", "Turkmenistan",
    "Turks and Caicos Islands", "Tuvalu", "Uganda", "Ukraine", "United Arab Emirates", "United Kingdom",
    "United States", "United States Minor", "Uruguay", "Uzbekistan", "Vanuatu", "Venezuela", "Vietnam",
    "Virgin Islands British", "Virgin Islands U.S", "Wallis and Futuna", "Western Sahara", "Yemen",
    "Zambia", "Zimbabwe"
    };

    String emailbody = null;
    
    boolean formsubmit = true;

    public RegistrationPage ()
    {
        int MF = 10;
        
        
        registerpanel = new JPanel (new GridBagLayout ());

        LiveDB.appframe.remove(FirstPage.pageonetextpanel);
        LiveDB.appframe.remove(FirstPage.maillistpanel);
        LiveDB.appframe.remove(FirstPage.infopanel);
        LiveDB.appframe.remove(FirstPage.languagepanel);
        LiveDB.appframe.remove(FirstPage.currencypanel);
        LiveDB.appframe.remove(FirstPage.popularpanel);
        LiveDB.appframe.remove(FirstPage.featuredpanel);
        LiveDB.appframe.remove(FirstPage.salepanel);        

        registerpanel.setBounds(0, (int)(FirstPage.cartpanel.TOP_ALIGNMENT * MF),
        LaunchGUI.MAX_WIDTH - 6, (int) (FirstPage.footerpanel.TOP_ALIGNMENT * MF) - 2);

        LiveDB.appframe.remove(FirstPage.cartpanel);

        expregis.setForeground(Color.BLUE);
        expregis.setFont(new Font("Dialog", Font.BOLD, 12));
        registerpanel.add(expregis, setConstraints(0,1,4,1));

        registerpanel.add(asterisk, setConstraints (0, 3, 25, 1));

        pers.setForeground(Color.GRAY);
        pers.setFont(new Font ("Dialog", Font.BOLD, 14));        
        registerpanel.add(pers, setConstraints (0, 5, 4, 1));

        registerpanel.add(title, setConstraints (0, 7, 4, 1));

        titles = new JTextField ("Mr", 6);
        registerpanel.add(titles, setConstraints ((int)(title.RIGHT_ALIGNMENT * MF) + 1,
                7, 2, 1));

        addr.setForeground(Color.GRAY);
        addr.setFont(new Font ("Dialog", Font.BOLD, 14));
        registerpanel.add(addr, setConstraints ((int)(titles.RIGHT_ALIGNMENT * MF) + 15, 5, 2, 1));

        registerpanel.add(address, setConstraints ((int)(addr.LEFT_ALIGNMENT * MF), 7, 4, 1));

        addr1 = new JTextField ("Address1", 20);
        registerpanel.add(addr1, setConstraints((int)(address.RIGHT_ALIGNMENT * MF) + 1,
                7, 4, 1));
        addr1.addInputMethodListener(new InputMethodListener ()
        {
           @Override
           public void inputMethodTextChanged(InputMethodEvent event){
                if (addr1.getText().trim().length() == 0)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Address Line 1 Mandatory");
                    addr1.setText(" ");
                    addr1.setFocusable(true);
                    formsubmit = false;
                    addr1.validate();
                }
           }

           @Override
           public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
           }
        });
        
        registerpanel.add(firstname, setConstraints (0, 8, 3, 1));
        fname = new JTextField ("Pachino", 20);
        registerpanel.add(fname, setConstraints((int)(firstname.RIGHT_ALIGNMENT * MF) + 1,8,4,1));


        addr2 = new JTextField ("Address2", 20);
        registerpanel.add(addr2, setConstraints ((int)(addr1.LEFT_ALIGNMENT) * MF, 8, 4, 1));

        registerpanel.add(lastname, setConstraints (0,9,3,1));
        lname = new JTextField ("Al", 20);
        registerpanel.add(lname, setConstraints ((int)(lastname.RIGHT_ALIGNMENT * MF) + 1,
                9, 4, 1));
                
        addr3 = new JTextField ("Address3", 20);
        registerpanel.add(addr3, setConstraints((int)(addr3.LEFT_ALIGNMENT * MF), 9, 4, 1));

        registerpanel.add(emailaddr, setConstraints (0, 10, 3, 1));
        email = new JTextField ("pskris@sify.com", 15);
        registerpanel.add(email, setConstraints ((int)(emailaddr.RIGHT_ALIGNMENT * MF) + 1,
                10, 4, 1));

        email.addInputMethodListener(new InputMethodListener ()
        {
           @Override
           public void inputMethodTextChanged(InputMethodEvent event){
                if (LiveDB.PrepareAndSendMailMesg(null, null, email.getText(),
                    null, null, "EMAIL FROM " + LiveDB.USRNAME, null, null) == false)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Invalid Email ID Re-Enter");
                    email.setText("pskris@gmail.com");
                    email.setFocusable(true);
                    formsubmit = false;
                    email.validate();
                }
           }
           
           @Override
           public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
           }
        });

        registerpanel.add(Landmark, setConstraints((int)(email.RIGHT_ALIGNMENT * MF) + 15, 10, 4, 1));
        landmark = new JTextField ("Near", 20);
        registerpanel.add(landmark, setConstraints ((int)(Landmark.RIGHT_ALIGNMENT * MF) + 1,
                10, 4, 1));

        registerpanel.add(telephone, setConstraints (0, 11, 3, 1));
        tel = new JTextField ("+91-", 20);
        registerpanel.add(tel, setConstraints ((int)(Landmark.RIGHT_ALIGNMENT * MF) + 1,
                11, 4, 1));

        registerpanel.add(town, setConstraints((int)(tel.RIGHT_ALIGNMENT * MF) + 15, 11, 2, 1));
        towns = new JTextField ("Scotts Valley", 20);
        registerpanel.add(towns, setConstraints ((int)(town.RIGHT_ALIGNMENT * MF) + 1,
                11, 4, 1));

        registerpanel.add(fax, setConstraints (0, 12, 3, 1));
        registerpanel.add(faxnumber, setConstraints ((int)(fax.RIGHT_ALIGNMENT * MF) + 1,
                12, 3, 1));

        registerpanel.add(countystate, setConstraints((int)(faxnumber.RIGHT_ALIGNMENT * MF) + 15, 12, 3, 1));
        state = new JTextField ("California", 20);
        registerpanel.add(state, setConstraints ((int)(countystate.RIGHT_ALIGNMENT * MF) + 1,
                12, 4, 1));

        registerpanel.add(custbirthdate, setConstraints (0, 13, 3, 1));
        birthdate = new JTextField (new Date().toString(), 20);
        birthdate.createToolTip().setToolTipText("Write a date in any other format also");
        registerpanel.add(birthdate, setConstraints ((int)(custbirthdate.RIGHT_ALIGNMENT * MF) + 1,
                13, 4, 1));
        
        birthdate.addInputMethodListener(new InputMethodListener ()
        {
           @Override
           public void inputMethodTextChanged(InputMethodEvent event)
           {
              SimpleDateFormat sdf = null;
              try{
                  BirthDay = sdf.parse(birthdate.getText());
              }catch (ParseException ex_NOKIA81){
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe,
                            "Invalid Date Format");
                    birthdate.setFocusable(true);
                    birthdate.validate();
              }

              JOptionPane.showMessageDialog(LiveDB.appframe,
                        "The Date you have entered is " + "\n"
                        + BirthDay.toString());
           }

           @Override
           public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
           }
        });

        registerpanel.add(country, setConstraints((int)countystate.LEFT_ALIGNMENT * MF, 13, 3, 1));
        countries = new JComboBox (nations);
        registerpanel.add(countries, setConstraints ((int)(countystate.RIGHT_ALIGNMENT * MF) + 1,
                13, 4, 1));

        registerpanel.add(custsex, setConstraints (0, 14, 3, 1));
        sex = new JComboBox (sexes);
        registerpanel.add(sex, setConstraints ((int)(custsex.RIGHT_ALIGNMENT * MF) + 1,
                14, 1, 1));

        registerpanel.add(postcode, setConstraints((int)countystate.LEFT_ALIGNMENT * MF, 14, 3, 1));
        post = new JTextField ("500594", 10);
        registerpanel.add(post, setConstraints ((int)(postcode.RIGHT_ALIGNMENT * MF) + 1,
                14, 3, 1));

        registerpanel.add(marital, setConstraints (0, 15, 3, 1));
        MaritalStatus = new JComboBox (maritalstatus);
        registerpanel.add(MaritalStatus, setConstraints ((int)(marital.RIGHT_ALIGNMENT * MF) + 1,
                15, 3, 1));

        registerpanel.add(birthcity, setConstraints ((int)(MaritalStatus.RIGHT_ALIGNMENT * MF) + 10, 15, 3, 1));
        custbirthcity = new JTextField ("Palo Alto", 20);
        registerpanel.add(custbirthcity, setConstraints ((int)(birthcity.RIGHT_ALIGNMENT * MF) + 1,
                15, 4, 1));

        registerpanel.add(birthstate, setConstraints (0, 16, 3, 1));
        custbirthstate = new JTextField ("California Dreaming", 20);        
        registerpanel.add(custbirthstate, setConstraints ((int)(birthstate.RIGHT_ALIGNMENT * MF) + 1,
                16, 4, 1));

        registerpanel.add(birthnation, setConstraints ((int)(custbirthstate.RIGHT_ALIGNMENT * MF) + 10, 16, 4, 1));
        custbirthnation = new JComboBox (nations);
        registerpanel.add(custbirthnation, setConstraints ((int)(birthnation.RIGHT_ALIGNMENT * MF) + 1, 16, 4, 1));

        submitcont.setBackground(Color.GREEN);
        submitcont.setForeground(Color.WHITE);
        submitcont.addMouseListener(new MouseListener (){

            @Override
            public void mousePressed (MouseEvent evnt){
                submitcont.setBackground(Color.CYAN);
                submitcont.validate();
            }
            @Override
            public void mouseClicked (MouseEvent evnt){

                if (fname.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill First Name");
                    fname.setFocusable(true);
                    fname.validate();
                }

                if (lname.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Last Name");
                    lname.setFocusable(true);
                    lname.validate();
                }

                if (email.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Email");
                    email.setFocusable(true);
                    email.validate();
                }

                if (tel.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Telephone");
                    tel.setFocusable(true);
                    tel.validate();
                }

                if (addr1.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Address Line 1");
                    addr1.setFocusable(true);
                    addr1.validate();
                }

                if (addr2.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Address Line 2");
                    addr2.setFocusable(true);
                    addr2.validate();
                }

                if (towns.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Town");
                    towns.setFocusable(true);
                    towns.validate();
                }

                if (state.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill State");
                    state.setFocusable(true);
                    state.validate();
                }

                if (post.getText().trim().length() == 0)
                {
                    formsubmit = false;
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Incomplete Form Fill Post Code");
                    post.setFocusable(true);
                    post.validate();
                }

                if (formsubmit)
                {
                    // check if this cid already exists in the database
                    if (LiveDB.indxcustomerRegister.get(LiveDB.USRNAME + '@' + LiveDB.NODENAME + email.getText().trim()) != null)
                    {
                        JOptionPane.showMessageDialog(LiveDB.appframe, "This CID already exists in database"
                                + '\n' + "CID=" + LiveDB.USRNAME + '@' + LiveDB.NODENAME + email.getText().trim() + '\n'
                                + " Try changing you email id and try again");
                        email.setFocusable(true);
                    }
                    
                    LoggedInCID = LiveDB.USRNAME + '@' + LiveDB.NODENAME + email.getText().trim();

       // new CustomerRegister
       // public CustomerRegister (String p_Cid, String p_Custname,
       // Date p_Custbirthdate, String p_Custbirthcity, String p_Custbirthstate,
       // String p_Custbirthnation, char p_Custsex, String p_Custmaritalstatus,
       // Date p_Custlogintime, Date p_Custlogouttime,Date p_Custregisterdate, String p_Custaddr1,
       // String p_Custaddr2, String p_Custaddr3, String p_Custaddr4, String p_Landmark, String p_Custcity,
       // String p_Custnation, String p_Custzip, String p_Custemail, String p_Custphone, String p_Custfax,
       // char p_Custflag, Date p_Custlastdate, long p_Rowid)

                    LiveDB.LiveSharedDB[cr][LiveDB.LiveSharedDB[cr].length]
                      = new CustomerRegister (LiveDB.USRNAME + '@' + LiveDB.NODENAME + email.getText().trim(),
                            '<' + LiveDB.USRNAME + '>' + titles.getText().trim() + ' '
                            + fname.getText().trim() + ' ' + lname.getText().trim(),
                            BirthDay, custbirthcity.getText().trim(), 
                            custbirthstate.getText().trim(),
                            (String)custbirthnation.getSelectedItem().toString(),
                            (Character)sex.getSelectedItem(),
                            (String)MaritalStatus.getSelectedItem().toString(),
                            null, null, new Date(), addr1.getText().trim(), addr2.getText().trim(),
                            addr3.getText().trim(), null, landmark.getText().trim(),
                            towns.getText().trim(), (String)countries.getSelectedItem().toString(),
                            post.getText().trim(), email.getText().trim(),
                            tel.getText().trim(), faxnumber.getText().trim(),
                            'O', new Date (), LiveDB.LiveSharedDB[cr].length);

                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker ((long)cr,LiveDB.LiveSharedDB[cr].length -1, 'I',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[cr][LiveDB.LiveSharedDB[cr].length -1],
                        (long)LiveDB.LiveSharedDB[ct].length);

                    emailbody = "Name:" + titles.getText().trim() + fname.getText().trim()
                            + '\n' + lname.getText().trim() + " Birth Date:" + BirthDay.toString()
                            + '\n' + " Birth City:" + custbirthcity.getText().trim() +
                            " Birth State:" + custbirthstate.getText().trim() + '\n' +
                            " Birth Nation:" + (String)custbirthnation.getSelectedItem().toString()
                            + " Sex :" + (Character)sex.getSelectedItem() + " Marital Status:"
                            + (String)MaritalStatus.getSelectedItem().toString() + '\n' +
                            " Registration Date :" + new Date().toString() 
                            + '\n' + " Address 1:"
                            + addr1.getText().trim() 
                            + '\n' + " Address 2:" + addr2.getText().trim() + '\n'
                            + " Address 3:" + addr3.getText().trim() + '\n' +  " LandMark:" +
                            landmark.getText().trim() + '\n' + " Cust City:" + towns.getText().trim()
                            + '\n' + " Cust Nation:" + (String)countries.getSelectedItem().toString()
                            + '\n' + " Post Code:" + post.getText().trim() + " Email:" + email.getText().trim()
                            + '\n' + " Telephone :" + tel.getText().trim() + " Fax Number:" + faxnumber.getText().trim()
                            + '\n' + " Cust Status Alive " + " Your Password:"
                            + '<' + LiveDB.USRNAME + '>' + titles.getText().trim() + ' '
                            + fname.getText().trim() +  ' ' + lname.getText().trim() 
                            + '\n'
                            + "YOUR SECRET PASSWORD:" + LoggedInCID 
                            + '\n'
                            +  "  IF ERROR IN DETAILS NOTIFY AT EMAIL: "
                            + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();              

                    if (LiveDB.PrepareAndSendMailMesg(null, null, email.getText().trim(),
                        null, null, "EMAIL FROM " +
                        LiveDB.versionControl.getApplicationName() + " REGISTRATION DESK ",
                        emailbody, null) == false)
                    {
                        JOptionPane.showMessageDialog(LiveDB.appframe, "Invalid Email ID Re-Enter");
                        email.setFocusable(true);
                    }
                    else
                    {
                        JOptionPane.showMessageDialog(LiveDB.appframe,
                            "Form Submitted Successfully "
                            + "\n" + " Your submitted details and password"
                            + " have been emailed to you" );
                    }
                    
                    System.gc();
                    // new ViewBasketPanel ();
                }
            }

            @Override
            public void mouseReleased (MouseEvent evnt){
                submitcont.setBackground(Color.GREEN);
                submitcont.validate();
            }
            @Override
            public void mouseEntered (MouseEvent evnt){
                submitcont.setBackground(Color.CYAN);
                submitcont.validate();
            }
            @Override
            public void mouseExited (MouseEvent evnt){
                submitcont.setBackground(Color.GREEN);
                submitcont.validate();
            }
        });

        registerpanel.add(submitcont, setConstraints (0, 18, 3, 1));
        
        LiveDB.appframe.add(registerpanel, setConstraints(0, (int)(FirstPage.cartpanel.TOP_ALIGNMENT * MF),
        LaunchGUI.MAX_WIDTH - 6, (int) (FirstPage.footerpanel.TOP_ALIGNMENT * MF) - 2));
        registerpanel.validate();        
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
