/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.TreeSet;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadroyal
 * CLASS NAME : RoyaltyTracker
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.Action, LiveDB.STATIONMASTERSREPORT
 * @LOOKSY:RoyaltyTracker.java run () method
 *
 * Method Name : public void run ()
 *
 * Parameters : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a light duty thread that generates some reports of a Royal kind and/or
 * processing Royal Kinds. Since the workload on other threads is very large I have chosen to tuck in all
 * the Custom Reports in this Royal thread since anyways these reports deserve a Royal treatment. Other
 * Custom Reports will follow in next release.
 * Please Note : This thread also prints a station masters report of train running information just as in
 * the adverts princess waiting to board her train at her private railway station.
 *
 * Technical Reference : Watch the Princesses Diaries along with her.
 * Musical Accompanyments : IN THE COURT OF THE CRIMSON KING "An Observation by King Crimson"
 *
 * Thread Dedicated to : ALAN PARSONS ON AIR
 *
 * Start Date: 18th October 2010
 * End Date: 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

class RoyaltyTracker extends LiveDB implements Runnable, Royal {
    @Override
    public void run () {
        
        ThreadController.TakeOffTimes[6] = new Date ();

        if (new File(LiveDB.serializedfilespath + "daemon").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "daemon"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }

        try
        {
            new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadroyal"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).createNewFile();
        }catch (IOException ex_YESKIA41){
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadroyal"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        } // to hell with this error it wont happen continue processing

        boolean ex = false;
        LiveDB.threadroyalid = Thread.currentThread().getId();
        
        
        if (HerMajestyService () == false)
        {
            /* just write the log and sysexit */
            System.err.println(LiveDB.grassHopper("HerMajestyService Report Failed"));
            ex = true;
        }
        
        if (prettyWoman() == false)
            /* write the log but dont sysexit */
            System.err.println(LiveDB.grassHopper("prettyWoman Celebrity Tracker Failed"));

        if (CustomShoppingCart () == false)
        {
            /* just write the log and dont sysexit */
            System.err.println(LiveDB.grassHopper("CustomShoppingCart () Report Failed"));
        }

        LiveDB.LogFileSabotageCheck ();

        if (CustomCustomerRegister () == false)
                        /* just write the log and dont sysexit */
            System.err.println(LiveDB.grassHopper("CustomCustomerRegister () Report Failed"));

        if (LiveDB.system_exit == 0)
        {
        /* Now print this report */
        LiveDB.STATIONMASTERSREPORT = true;
        LiveDB.Action PrintLatestStationMastersReport;  /* this is what you call object oriented reporting just
                                                         * instantiate and it does everything for you. You can
                                                         * instantiate it anywhere and everywhere but is it
                                                         * really worth it in terms of system time hogged is
                                                         * the question. So dont go about pulling this trigger
                                                         * anywhere.
                                                         */

        LiveDB.STATIONMASTERSREPORT = false;  /* re-false it sorry tinglish very ticklish. */

        }

        if (ex)
        {
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }


        if (new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadroyal"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete() == false)
        {
            System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadroyal"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        }

        if (new File (LiveDB.serializedfilespath + "daemon").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }
        
        ThreadController.LandingTimes[6] = new Date ();
        
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.java (just the top half)
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.CrownPrincessCatherine (Catherine I of England)
 * @LOOKSY:run() method of RoyaltyTracker.java
 *
 * Method Name: protected boolean CustomShoppingCart ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print CustomShoppingCart report
 * Report Data : Make a single call to CrownPrincessCatherine.ReportWriter() with/without parameters
 * and if you choose to pass parameters you can dump everything as in the example below in the method
 * protected boolean CustomCustomerRegister (). The ReportWriter will handle yeverything.
 *
 * Use CrownPrincessCatherine Instance for thread RoyaltyTracker only dont mixup.
 * The report writer is not thread safe.
 *
 * Start Date : 18th October 2010
 * End Date : 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected boolean CustomShoppingCart ()
    {
       if (LiveDB.CustomShoppingCartReport.length == 0)
           return true; // zero rows just fake it to true or else there will be an error log
       return CrownPrincessCatherine.ReportWriter(); // pass zero or more arguments
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.java (just the top half)
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.CrownPrincessCatherine (Catherine I of England)
 * @LOOKSY:run() method of RoyaltyTracker.java
 *
 * Method Name: protected boolean CustomCustomerRegister ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print CustomCustomerRegister report
 * Report Data : Make a single call to CrownPrincessCatherine.ReportWriter() with/without parameters
 * and if you choose to pass parameters you can dump everything as in the example below. The ReportWriter
 * will handle everything.
 *
 * Use CrownPrincessCatherine Instance for thread RoyaltyTracker only dont mixup.
 * The report writer is not thread safe.
 *
 * Start Date : 18th October 2010
 * End Date : 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected boolean CustomCustomerRegister ()
    {
       // if you pass zero arguments it will assume you have generated required rowids
       // and pinned them on the wall at LiveDB otherwise it takes all the data that
       // you passed
       Object YourObject [] = null; // fill this up with data for the report
       // fill it up with data
       ArrayList<CustomerRegister> REGISTER = new ArrayList<CustomerRegister>();
       TreeSet<CustomerRegister> CUSTOMERTREE = new TreeSet<CustomerRegister>();
       // fill this up like i have done below
       Long RowsforThisReport [] = null;

       if (LiveDB.LiveSharedDB[cr].length != 0)
       {
           for (int row = LiveDB.LiveSharedDB[cr].length -1, i = 0; row >= LiveDB.CRSR; row--, i++)
               LiveDB.CustomCustomerRegisterReport[i] = ((CustomerRegister)LiveDB.LiveSharedDB[cr][row]).getRowid();
       } // this is the way numbers will generated for your custom report most of the times

       if (LiveDB.CustomCustomerRegisterReport.length == 0)
           return true; // zero rows just fake it to true or else there will be an error log
       return CrownPrincessCatherine.ReportWriter(); // pass zero or more arguments
       // write anything in there that makes some reporting sense for example
       // return CrownPrincessCatherine.ReportWriter("NAME          CITY        NATION      BIRTHDATE    REGISTRATION ON",
       //         RowsforThisReport, YourObject, REGISTER, CUSTOMERTREE);
       // similarly for the CustomShoppingCart () report
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.CrownPrincessCatherine (Catherine I of England)
 * @LOOKSY:run() method of RoyaltyTracker.java
 *
 * Method Name: protected boolean CustomPlotter ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print CustomPlotter report
 * Report Data : Make several calls to ReportWriter as in the example below to plot. The ReportWriter will
 * handle yeverthing for you.
 *
 * Use CrownPrincessCatherine Instance for thread RoyaltyTracker only dont mixup.
 * The report writer is not thread safe.
 *
 * Start Date : 18th October 2010
 * End Date : 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected boolean CustomPlotter ()
    {
        // dont leave empty you must pass arguments
        // use CrownPrincessCatherine for Royalty Tracker thread only dont mixup for heaven sake that report writer
        // is just not thread safe it will screw up all method pointers
        CrownPrincessCatherine.ReportWriter("\\n");
        CrownPrincessCatherine.ReportWriter("\\n");
        CrownPrincessCatherine.ReportWriter("\\n");
        CrownPrincessCatherine.ReportWriter("BOYS DEATH CHARTS GIRLS BIRTH CHARTS IN ENGLISH");
        CrownPrincessCatherine.ReportWriter("\\n");
        CrownPrincessCatherine.ReportWriter("\\n");
        CrownPrincessCatherine.ReportWriter("\\n");
        CrownPrincessCatherine.ReportWriter("=======================================================================================", 18, 20);
        CrownPrincessCatherine.ReportWriter("|    Rahu              Ketu           Guruji           Kunya      Vivaah      Anishtih |", 19, 20);
        CrownPrincessCatherine.ReportWriter("|    Ludki             Ko             Pipal            Kay        Jaadh     MayLatkana |", 20, 20);
        CrownPrincessCatherine.ReportWriter("|    Kudi              meaning        drunkard         or give    Kunya     Rashi      |", 21, 20);
        CrownPrincessCatherine.ReportWriter("|    Wakt              abhi           Shubh            hai        Matara    Ponnu      |", 22, 20);
        CrownPrincessCatherine.ReportWriter("|    Mathara   ponnu matu ponnu  mattu ponnu  manglik (saat khoon ponnu  champaastanu  |", 23, 20);
        CrownPrincessCatherine.ReportWriter("|    Please fill up the rest of the boys death charts he will never re-incarnate after |", 24, 20);
        CrownPrincessCatherine.ReportWriter("|    weeeding this girl   NAKSHATRA VENUS  GIRL WONT NEED CLOTHES OTHER THAN JEWELLERY |", 25, 20);
        CrownPrincessCatherine.ReportWriter("|    ludki go garam masala kay saath pakaa kay khana                                   |", 26, 20);
        CrownPrincessCatherine.ReportWriter("|    Ludki ko khoob ferari lekay firnaa   SHE WILL SING HAPPY BIRTHDAY MR PRESIDENT    |", 27, 20);
        CrownPrincessCatherine.ReportWriter("|    Ludki ko theatre may popcorn khilanaa muth lay janaa                              |", 28, 20);
        CrownPrincessCatherine.ReportWriter("|    NO NO NO U NEVER HAD ANY ......... ITS TOTALLY LIKE                               |", 29, 20);
        CrownPrincessCatherine.ReportWriter("|    LUDKI MEMSAAB BANEGI YEH USKA CHAIRMAN (OUTSIDE GATE KURSI)                       |", 30, 20);
        CrownPrincessCatherine.ReportWriter("|    SHANIANA   SHANIAN  SHANIA   TWANG  BADMAASH COMPANY SAAB AAPSEY MOHABBUT .....   |", 31, 20);
        CrownPrincessCatherine.ReportWriter("|    ludki frequntly switzerland kay chakkar kaategi                                   |", 32, 20);
        CrownPrincessCatherine.ReportWriter("|    LUDKI JHADOO POCHA BARTAN KUPDA SUB KARKAA DEGI                                   |", 33, 20);
        CrownPrincessCatherine.ReportWriter("|    LUDKI KHOOB HING LAGAKAA LISS KI TARAH HASEGI TYPICAL INDIAN BROHU                |", 34, 20);
        CrownPrincessCatherine.ReportWriter("|    ludki bahut kamanaaa waali hogi                                                   |", 35, 20);
        CrownPrincessCatherine.ReportWriter("|    THERE WILL BE PLENTY TO CHAIN SNATCH ON THE GIRLS NECK AND WAIST BAND AND HEADS   |", 36, 20);
        CrownPrincessCatherine.ReportWriter("|    uskaaa diwanon ki list budhtey hi jayegi                                          |", 37, 20);
        CrownPrincessCatherine.ReportWriter("|    ludki bilkul soni dikhegi    GOOD SINGER TU HI HAI MERA PYAAR ...                 |", 38, 20);
        CrownPrincessCatherine.ReportWriter("|    Ludki ki jindagi mey saath diwanaa pheray lagayengay                              |", 39, 20);
        CrownPrincessCatherine.ReportWriter("|    Ludki bilkul size zero hogi   COFFEE PHIKI HOGI BAHU MIIITI HOGI !!               |", 40, 20);
        return CrownPrincessCatherine.ReportWriter("======================================================================================", 41, 20);
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java (just the top half)
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.CrownPrincessCatherine (Catherine I of England)
 * @LOOKSY:run() method of RoyaltyTracker.java
 *
 * Method Name: public boolean HerMajestyService ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print HerMajestyService report
 * Report Data : Get all customers from CustomerRegister who have custflag = 'R' or 'C'
 * Basically Tracks Royals in the Database and marks them with "R", Royal Reports. Print Royal Report even if
 * they dont buy. For now I am not marking as 'R' will do later.
 * 
 * Use CrownPrincessCatherine Instance for thread RoyaltyTracker only dont mixup.
 * The report writer is not thread safe.
 *
 * Start Date : 18th October 2010
 * End Date : 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    @Override
    public boolean HerMajestyService (){return CrownPrincessCatherine.ReportWriter();}
/*
 * WIRING DIAGRAM :
 * @LOOKSY:
 * @LOOKSY:
 * @LOOKSY:
 * @LOOKSY:
 *
 * Parameters :
 *
 *
 * Running Commentary :
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    /* Tracks celebrities in the database
     * and marks them with "C".
     */
    @Override
    public boolean prettyWoman ()  // ??
    {
        if (LiveDB.system_exit == 1)
            return true;
    
        return true;
    }
}
