/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;


import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.nio.channels.FileChannel;
import java.nio.channels.FileLock;
import java.util.Arrays;
import java.util.Date;
import java.util.Random;
import javax.swing.JOptionPane;


/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadspy
 * CLASS NAME : Spy
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck()
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : public void run ()
 *
 * Parameters : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a heavy duty thread that generates some reports and also calls several
 * application integrity methods to ensure data integrity and consistency. It calls for a dump() of data
 * files when needed and also calls LiveDB.DECLARE_EMERGENCY() when needed.
 *
 * In simple terms this thread does the job of a watchman on a constant beat keeping an eye on mischief.
 * This is the State Patrol.
 *
 * Technical Reference : Watch Police Academy .... with your mouth gagged with a handkerchief at home
 * with some beer to go around and of course a couple of pizza's. Hey take permission of Pentecostal
 * church before you sip beer !!
 *
 * Also Buy and Read Asterix and the Roman Agent
 * Thread Dedicated to : Fleming Bond Ka Baap
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class Spy extends LiveDB implements Runnable, SpyMaker {

    static long logline = 0L;
    
    @Override
    public void run () {
        
        ThreadController.TakeOffTimes[8] = new Date ();

        if (new File(LiveDB.serializedfilespath + "daemon").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "daemon"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }
        
        boolean ex = false;
        LiveDB.threadspyid = Thread.currentThread().getId();
        
        try
        {
            new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadspy"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).createNewFile();
        }catch (IOException ex_YESKIA41){
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadspy"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        } // to hell with this error it wont happen continue processing

        LiveDB.LogFileSabotageCheck();
        if (LostSouls () == false) // call this method prior to calling licenceToKill ()
        {
            System.err.println(LiveDB.grassHopper("Fat Database Skinning Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }
        if (licenceToKill () == false) // call this method only after calling LostSouls ()
        {
            LiveDB.ALRTLVL = 8;
            System.err.println(LiveDB.grassHopper("Gun Backfired Point Barrel at your face take aim,pull trigger again"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            LiveDB.DECLARE_EMERGENCY();
            dump();
            ex = true;
        }
        if (moneyMoneyMoney() == false) // must be called before casinoRoyale()
        {            
            System.err.println(LiveDB.grassHopper("moneyMoneyMoney Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        if (diamondsAreForever() == false)
        {            
           System.err.println(LiveDB.grassHopper("diamondsAreForever Report Failed"));
           logline = LiveDB.logerrorno;
           System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
           // ex = true;
        }
        
        if (theLivingDaylights() == false)
        {            
            System.err.println(LiveDB.grassHopper("theLivingDaylights Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        if (neverSayNeverAgain() == false)
        {            
            System.err.println(LiveDB.grassHopper("neverSayNeverAgain Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        LiveDB.LogFileSabotageCheck();

        if (youOnlyLiveTwice() == false)
        {            
            System.err.println(LiveDB.grassHopper("youOnlyLiveTwice Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        if (quantumOfSolace() == false)
        {            
            System.err.println(LiveDB.grassHopper("quantumOfSolace Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }
        
        if (RunAwayBride() == false)
        {            
            System.err.println(LiveDB.grassHopper("RunAwayBride Report Failure"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        

        if (DrNo() == false) // must be called before goldenFingers()
        {            
            System.err.println(LiveDB.grassHopper("DrNo Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        if (Octopussy() == false)
        {
            System.err.println(LiveDB.grassHopper("Octopussy Report Failed"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            // ex = true;
        }

        if (thunderBall() == false)
        {
            System.err.println(LiveDB.grassHopper("System Tuning Failed Change Spark Plug"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
        }


        
        if (goldenFinger() == false)
        {
            LiveDB.ALRTLVL = 1;
            System.err.println(LiveDB.grassHopper("Data Corruption/Hacker/Virus/Report Sabotage Check dump files"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            ex = true;
        }

        LiveDB.LogFileSabotageCheck(); // dont overdo this it will be an overkill
        
        if (casinoRoyale() == false)
        {
            LiveDB.ALRTLVL = 8;
            System.err.println(LiveDB.grassHopper("Data Corruption/Hacker/Virus/Report Sabotage Check dump files"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            LiveDB.DECLARE_EMERGENCY();
            dump();
            ex = true;
        }

        

        if (fromRussiaWithLove() == false)
        {
            LiveDB.ALRTLVL = 1;
            System.err.println(LiveDB.grassHopper("Data Corruption/Hacker/Virus Check"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            ex = true;
        }

        if (ForYourEyesOnly() == false)
        {
            LiveDB.ALRTLVL = 8;
            System.err.println(LiveDB.grassHopper("Data Corruption/Hacker/Virus Check"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            dump();
            LiveDB.DECLARE_EMERGENCY();
            ex = true;
        }
        
        if (manWithGoldenGun () == false)
        {
            LiveDB.ALRTLVL = 8;
            System.err.println(LiveDB.grassHopper("Data Corruption/Hacker/Virus Check"));
            logline = LiveDB.logerrorno;
            System.err.println("LINE " +  ": " + String.valueOf(logline) + " "
            + "Class Vars:" + "ThreadController.TakeOffTimes[8]=" + String.valueOf(ThreadController.TakeOffTimes[8]));
            dump();
            LiveDB.DECLARE_EMERGENCY();
            ex = true;
        }

        if (ex)
        {
            LiveDB.ALRTLVL = 6;
            System.err.println(LiveDB.grassHopper("Failure in Spy Thread Smooth Exiting"));
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }
        
        
        if (new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadspy"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete() == false)
        {
            System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadspy"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        }

        if (new File (LiveDB.serializedfilespath + "daemon").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }

        ThreadController.LandingTimes[8] = new Date ();        
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:InstallDB.java
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java -- Search for "FiXdAtAcOrRuPtIoN"
 * @LOOKSY:ReportsTable.java
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.LiveSharedDB
 * @LOOKSY:LiveDB.MEMDUMP, LiveDB.DISKDUMP, LiveDB.BKUPDUMP, LiveDB.wanted_rows, LiveDB.wanted_rows_permit,
 *         LiveDB.TrainsInWaiting
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : protected static void dump()
 * Chained Methods : private static boolean dump_cr(FileWriter fw, String fn)
 *                   private static boolean dump_sc(FileWriter fw, String fn)
 *                   private static boolean dump_ct(FileWriter fw, String fn)
 *                   private static boolean dump_it(FileWriter fw, String fn)
 *                   private static boolean dump_rt(FileWriter fw, String fn)
 * 
 * Parameters : None
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If there is some data corruption detected or failure of a specific critical
 * method then this static method dump() is called. What it does is to write out character readable
 * files using the Chained Methods for each of the important tables cr,sc,ct,it,rt. The SYSADM needs
 * to correct each of these table dumps and reload the data using command line at operating system
 * $InstallDB FiXdAtAcOrRuPtIoN. The dump() method checks some global flags that the user has set
 * and dumps files accordingly to character readable files at LiveDB.serializedfilespath. The flags
 * it checks are LiveDB.MEMDUMP, LiveDB.DISKDUMP, LiveDB.BKUPDUMP.
 *
 * In simple terms it dumps character readable data to files which need to be corrected by Application
 * administrator and then reloaded to get the database in a consistent state after Harry Hackers visit.
 *
 * Technical Reference : Watch Uma's the next time you dump your girlfriend inside a secure compound !!
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static void dump(){
            if (LiveDB.system_exit == 1)
                return;

            if (new File(LiveDB.serializedfilespath + "dump").canWrite())
            {
                System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "dump"));
            }
            else
            {
                if (new File(LiveDB.serializedfilespath + "dump").setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("Cant setWritable File:" + LiveDB.serializedfilespath
                                                                                           + "dump"));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }
            }

            String fn = null;
            File df = null;
            FileWriter fw = null;
            boolean ok = true;
            int tableno = 2;        
            
            // if any of these flags is true dump the data in Tables in Readable/Reload Format
            // seperated by chosen fieldseperator.
            if (LiveDB.MEMDUMP)
            {
                for (tableno = 1; tableno <= LiveDB.REALTABLES ; tableno++)
                {
                LiveDB.wanted_rows_permit.acquireUninterruptibly();

                if (tableno == ct)
                {
                    // clone yever thing although it is slower than copying references (which is risky)
                    for (int rw = 0; rw < LiveDB.LiveSharedDB[tableno].length; rw++)
                         LiveDB.wanted_rows[rw] =
                                 ((ChangeTracker)LiveDB.LiveSharedDB[tableno][rw]).clone();
                }
                else if (tableno == cr)
                {
                    // clone yever thing although it is slower than copying references (which is risky)
                    for (int rw = 0; rw < LiveDB.LiveSharedDB[tableno].length; rw++)
                         LiveDB.wanted_rows[rw] =
                                 ((CustomerRegister)LiveDB.LiveSharedDB[tableno][rw]).clone();
                }
                else if (tableno == it)
                {
                    // clone yever thing although it is slower than copying references (which is risky)
                    for (int rw = 0; rw < LiveDB.LiveSharedDB[tableno].length; rw++)
                         LiveDB.wanted_rows[rw] =
                                 ((InstalledTables)LiveDB.LiveSharedDB[tableno][rw]).clone();
                }
                else if (tableno == rt)
                {
                    // clone yever thing although it is slower than copying references (which is risky)
                    for (int rw = 0; rw < LiveDB.LiveSharedDB[tableno].length; rw++)
                         LiveDB.wanted_rows[rw] =
                                 ((ReportsTable)LiveDB.LiveSharedDB[tableno][rw]).clone();
                }

                df = new File (fn = LiveDB.serializedfilespath + "dump" +
                        ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + LiveDB.pid
                        + ".mem" + ".dmp");
                if (LiveDB.DUMPSECURITY)
                    df.deleteOnExit();
                try{
                   fw = new FileWriter(df);
                }catch(IOException ex_YESKIA97){
                    System.err.println(LiveDB.grassHopper(ex_YESKIA97, "Write Memory Dump Failed File:" + fn));
                    return;
                }
 
                if (tableno == ct)
                {
                    if (dump_ct(fw, fn) == false)
                    {
                       LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                       return;
                    }
                }

                if (tableno == cr)
                {
                   if (dump_cr(fw, fn) == false)
                   {
                       LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                       return;
                   }
                }

                if (tableno == it)
                {
                    if (dump_it(fw, fn) == false)
                    {
                        LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                        return;
                    }
                }

                if (tableno == rt)
                {
                    if (dump_rt(fw, fn) == false)
                    {
                        LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                        return;
                    }
                }
                                    
                LiveDB.wanted_rows_permit.release();
                tableno = tableno == id ? 13: tableno == it ? it: 18;
                
                } /* for */
            }

            if (LiveDB.DISKDUMP)
            {
                File inf = null;
                Object adhoclock = new Object();
                FileInputStream fi = null;
                ObjectInputStream oi = null;

                int requestno = (new Random ()).nextInt();
                TrainRunningInformation myrunninginfo = null;
                PlatformClearance mytrain = null;
                boolean eof = false;

                for (tableno = 1; tableno <= LiveDB.REALTABLES ; tableno++)
                {
                inf = new File (LiveDB.serializedfilespath + 
                        ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser");
                requestno = (new Random ()).nextInt();
                myrunninginfo = new TrainRunningInformation (tableno,
                    Thread.currentThread().getId(), Thread.currentThread().getName(),
                    Thread.currentThread().getThreadGroup().getName(), null, null, null, 0L);

                LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] = new PlatformClearance ( requestno,
                    LiveDB.pid, Action.READOBJECT, new Date (), myrunninginfo,LiveDB.LiveSharedDB[pc].length);

                mytrain = (PlatformClearance) LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1];

                
                df = new File (fn = LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                        ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + LiveDB.pid
                        + ".dsk" + ".dmp" );
                if (LiveDB.DUMPSECURITY)
                    df.deleteOnExit();
                try{
                   fw = new FileWriter(df);
                }catch(IOException ex_YESKIA97){
                    System.err.println(LiveDB.grassHopper(ex_YESKIA97,"Disk Dump Failed File:" + fn));
                    return;
                }

                LiveDB.wanted_rows_permit.acquireUninterruptibly();

                try
                {
                    fi = new FileInputStream (inf);
                    oi = new ObjectInputStream (fi);
                }catch (IOException ex_NOKIA9){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA9));
                    logline = LiveDB.logerrorno;
                    System.err.println ("LINE " +  ": " + String.valueOf(logline) + " "
                         + "Persistent Storage File InputStream not opening "
                         + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + "  "
                         + String.valueOf(ex_NOKIA9));
			JOptionPane.showMessageDialog(appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
                }
                FileChannel ch = fi.getChannel(); /* return a Channel for locking */
                FileLock fl = null;
                LiveDB.QueueTrainsInWaiting(mytrain, ch, fl, requestno);

                /* since this is just an advisory lock on some operating systems
                 * set the lock_flag to "L" in fileTableDataFileMap
                 */

                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("L");

                // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (ft,tableno, 'U',
                LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ft][tableno],
                (long)LiveDB.LiveSharedDB[ct].length);
                LiveDB.LASTLOCKMETHOD = "run"; /* set this only where you are applying lock even stack trace will give you this */
                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
                // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (ft,tableno, 'U',
                LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ft][tableno],
                (long)LiveDB.LiveSharedDB[ct].length);

                try{
                     if (tableno == ct)
                     {
                        for (int rw = 0; eof == false ;rw++)
                        {
                            try{
                             ((ChangeTracker)LiveDB.wanted_rows[rw]).readExternal(oi);
                            }catch (EOFException ex_YESKIA33){
                                  eof = true;
                            }
                        }
                     }
                     else if (tableno == it)
                          LiveDB.wanted_rows = (InstalledTables[]) oi.readObject();
                     else if (tableno == rt)
                     {
                        for (int rw = 0; eof == false ;rw++)
                        {
                            try{
                             ((ReportsTable)LiveDB.wanted_rows[rw]).readExternal(oi);
                            }catch (EOFException ex_YESKIA33){
                                  eof = true;
                            }
                        }
                     }
                     else if (tableno == cr)
                     {
                        for (int rw = 0; eof == false ;rw++)
                        {
                            try{
                             ((CustomerRegister)LiveDB.wanted_rows[rw]).readExternal(oi);
                            }catch (EOFException ex_YESKIA33){
                                  eof = true;
                            }
                        }
                     }
                     LiveDB.wanted_rows_permit.release();
                }catch (ClassNotFoundException ex_NOKIA8){
                        LiveDB.wanted_rows_permit.release();
                        LiveDB.DeQueueTrainsInWaiting();
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA8,"Serialized File:" +
                            LiveDB.serializedfilespath +
                            ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser"));
			JOptionPane.showMessageDialog( appframe,"Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
                        try{
                            oi.close();
                        }catch(IOException ex_NOKIA72){
                            LiveDB.wanted_rows_permit.release();

                            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                            // insert an entry in ChangeTracker table for this table
                            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                            new ChangeTracker (ft,tableno, 'U', LiveDB.pid, new Date (),
                            LiveDB.LiveSharedDB[ft][tableno],
                            (long)LiveDB.LiveSharedDB[ct].length);

                            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
                            // insert an entry in ChangeTracker table for this table
                            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                            new ChangeTracker (ft,tableno, 'U', LiveDB.pid, new Date (),
                            LiveDB.LiveSharedDB[ft][tableno],
                            (long)LiveDB.LiveSharedDB[ct].length);
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper(ex_NOKIA72, "InputStream not closing File:" +
                            LiveDB.serializedfilespath + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno])
                                    .getFilename() + ".ser"));
                            return;
                        } // catch IOException
                        return;
                }catch (IOException ex_NOKIA9){
                    LiveDB.wanted_rows_permit.release();
                    LiveDB.DeQueueTrainsInWaiting();
                    ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                    // insert an entry in ChangeTracker table for this table
                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (ft,tableno, 'U',
                    LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][tableno],
                    (long)LiveDB.LiveSharedDB[ct].length);

                    ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
                    // insert an entry in ChangeTracker table for this table
                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (ft,tableno, 'U',
                    LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][tableno],
                    (long)LiveDB.LiveSharedDB[ct].length);
                    System.err.println(LiveDB.grassHopper(ex_NOKIA9,"Not Deserializing File:" +
                                ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser"));
			JOptionPane.showMessageDialog( appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
                    try{
                        oi.close();
                    }catch(IOException ex_NOKIA72){
                        LiveDB.wanted_rows_permit.release();

                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA72, "InputStream not closing File:" +
                        LiveDB.serializedfilespath + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno])
                                .getFilename() + ".ser"));

                        return;
                    } // catch IOException
                    return;
                }

                // There is some superfluous code above. This is to avoid using a finally clause
                // The finally clause must be used with caution while closing resources because it
                // can leave some bugs. In this case I wont know how it got to the finally clause.
                // Did it get there after executing code in a catch clause or did it get there when
                // an uncaught exception was thrown or did it get there after successfull execution
                // of code in a try block. So because of this grey area I wont know if I should call
                // LiveDB.DeQueueTrainsInWaiting(); OR LiveDB.DeQueueTrainsInWaitingArrivals();
                // So if i do use a finally clause and call LiveDB.DeQueueTrainsInWaitingArrivals();
                // it could leave a BUG which is difficult to trace. The only other way to use a
                // finally clause is to check the stack trace to ascertain route by which it got
                // there but if someone changes the source code later it will be a problem.
                
                    try{
                        oi.close();
                    }catch(IOException ex_NOKIA72){
                        LiveDB.wanted_rows_permit.release();
                        LiveDB.DeQueueTrainsInWaiting();
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                        new ChangeTracker (ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        (long)LiveDB.LiveSharedDB[ct].length);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                        new ChangeTracker (ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        (long)LiveDB.LiveSharedDB[ct].length);
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA72, "InputStream not closing File:" +
                                ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename()));
                        return;
                    } // catch IOException
                    LiveDB.wanted_rows_permit.release();
                    if (LiveDB.DeQueueTrainsInWaitingArrivals() == false)
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("LiveDB.DeQueueTrainsInWaitingArrivals() failed"));
                    }
                    ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                    // insert an entry in ChangeTracker table for this table
                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (ft,tableno, 'U',
                    LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][tableno],
                    (long)LiveDB.LiveSharedDB[ct].length);

                    ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
                    // insert an entry in ChangeTracker table for this table
                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (ft,tableno, 'U',
                    LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][tableno],
                    (long)LiveDB.LiveSharedDB[ct].length);
                

                // check here the stack trace and call appropriate functions

                if (tableno == ct)
                {
                    if (dump_ct(fw, fn) == false)
                    {
                        LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                        return;
                    }
                }

                if (tableno == cr)
                {
                   if (dump_cr(fw, fn) == false)
                   {
                       LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                       return;
                   }
                }

                if (tableno == it)
                {
                    if (dump_it(fw, fn) == false)
                    {
                         LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                         return;
                    }
                }

                if (tableno == rt)
                {
                    if (dump_rt(fw, fn) == false)
                    {
                        LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                        return;
                    }
                }

               
                LiveDB.wanted_rows_permit.release();
                tableno = tableno == id ? 13: tableno == it ? it: 18;

                } /* for */                
            }

            if (LiveDB.BKUPDUMP)
            {
                File inf = null;
                FileInputStream fi = null;
                ObjectInputStream oi = null;

                int requestno = (new Random ()).nextInt();
                boolean eof = false;

                for (tableno = 1; tableno <= LiveDB.REALTABLES ; tableno++)
                {
                inf = new File (LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                        ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename()
                        + ".ser" + ".dsk" + ".bkp");
                df = new File (fn = LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                        ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + LiveDB.pid
                        + ".bkp" + ".dmp");
                if (LiveDB.DUMPSECURITY)
                    df.deleteOnExit();

                if (inf.exists() == false )
                {
                   System.err.println(LiveDB.grassHopper("File " + LiveDB.serializedfilespath + "dump"
                   + LiveDB.FILESEPERATOR + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename()
                   + ".ser" +  ".dsk" + ".bkp" + "dont exist"));
                   continue;
                }
                
                try{
                   fw = new FileWriter(df);
                }catch(IOException ex_YESKIA97){
                    System.err.println(LiveDB.grassHopper(ex_YESKIA97,"Write Fail Dump File:" + fn));
                    return;
                }

                LiveDB.wanted_rows_permit.acquireUninterruptibly();

                try
                {
                    fi = new FileInputStream (inf);
                    oi = new ObjectInputStream (fi);
                }catch (IOException ex_NOKIA9){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA9,
                     "InputStream not open Serialized File:" + LiveDB.serializedfilespath + "dump" +
                     LiveDB.FILESEPERATOR
                     + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() 
                     + ".ser" + ".dsk" +  ".bkp"));
			JOptionPane.showMessageDialog( appframe,"Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
                    return;
                }

                try{
                     if (tableno == ct)
                     {
                        for (int rw = 0; eof == false ;rw++)
                        {
                            try{
                             ((ChangeTracker)LiveDB.wanted_rows[rw]).readExternal(oi);
                            }catch (EOFException ex_YESKIA33){
                                  eof = true;
                            }
                        }
                     }
                     else if (tableno == it)
                          LiveDB.wanted_rows = (InstalledTables[]) oi.readObject();
                     else if (tableno == rt)
                     {
                        for (int rw = 0; eof == false ;rw++)
                        {
                            try{
                             ((ReportsTable)LiveDB.wanted_rows[rw]).readExternal(oi);
                            }catch (EOFException ex_YESKIA33){
                                  eof = true;
                            }
                        }
                     }
                     else if (tableno == cr)
                     {
                        for (int rw = 0; eof == false ;rw++)
                        {
                            try{
                             ((CustomerRegister)LiveDB.wanted_rows[rw]).readExternal(oi);
                            }catch (EOFException ex_YESKIA33){
                                  eof = true;
                            }
                        }
                     }
                }catch (ClassNotFoundException ex_NOKIA8){
                   LiveDB.wanted_rows_permit.release();
                   System.err.println(LiveDB.grassHopper(ex_NOKIA8,"File:" + LiveDB.serializedfilespath
                   + "dump" + LiveDB.FILESEPERATOR + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno])
                           .getFilename() + ".ser" + ".dsk" + ".bkp"));
                   return;
                }catch (IOException ex_NOKIA9){
                   LiveDB.wanted_rows_permit.release();
                   System.err.println(LiveDB.grassHopper(ex_NOKIA9, "InputStream not deserializing " +
                   LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR
                   + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser"
                                                                                     + ".dsk" + ".bkp"));
                   return;
                }finally{
                    try{
                        oi.close();
                    }catch(IOException ex_NOKIA72){
                        LiveDB.wanted_rows_permit.release();
                        System.err.println(LiveDB.grassHopper(ex_NOKIA72, "InputStream not closing " +
                         LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                         ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser"
                         + ".dsk" + ".bkp"));
                        return;
                    }
                }               

               if (tableno == ct)
               {
                   if (dump_ct(fw, fn) == false)
                   {
                       LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                       return;
                   }
               }

               if (tableno == cr)
               {
                  if (dump_cr(fw, fn) == false)
                  {
                      LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                      return;
                  }
               }

               if (tableno == it)
               {
                  if (dump_it(fw, fn) == false)
                  {
                      LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                      return;
                  }
               }

               if (tableno == rt)
               {
                   if (dump_rt(fw, fn) == false)
                   {
                       LiveDB.wanted_rows_permit.release();
			JOptionPane.showMessageDialog( appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                       return;
                   }
                }
                
                LiveDB.wanted_rows_permit.release();
                tableno = tableno == id ? 13: tableno == it ? it: 18;
                } /* for */
            } // if (LiveDB.BKUPDUMP)
        if (new File (LiveDB.serializedfilespath + "dump").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "dump"));
        }
        // Now email the Dumpfiles to proprietor of company
        if (LiveDB.SendDumpFileMessages() == false)
            System.err.println(LiveDB.grassHopper("Error Emailing  Dump Files Collect from Disk"));
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : private static boolean dump_cr(FileWriter fw, String fn)
 * First Cousin Methods : private static boolean dump_rt(FileWriter fw, String fn)
 *                        private static boolean dump_sc(FileWriter fw, String fn)
 *                        private static boolean dump_ct(FileWriter fw, String fn)
 *                        private static boolean dump_it(FileWriter fw, String fn)
 *
 * Parameters : FileWriter fw, String fn (filename corresponding to FileWriter)
 * Returns : boolean true if a dump of CustomerRegister file has been written to character readable file
 *           boolean false if any streams error during the dump of CustomerRegister
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If there is some data corruption detected or failure of a specific critical
 * method then this static method dump_cr() is called. What it does is to write out character readable
 * files. The SYSADM needs to correct each of these table dumps and reload the data using command line
 * at operating system $InstallDB FiXdAtAcOrRuPtIoN.
 *
 * In simple terms it dumps character readable data to files which need to be corrected by Application
 * administrator and then reloaded to get the database in a consistent state after Harry Hackers visit.
 * This method dumps just the CustomerRegister table to a character readable file.
 *
 * Technical Reference : Watch Uma's the next time you dump your girlfriend inside a secure compound !!
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static boolean dump_cr(FileWriter fw, String fn){
        
                if (LiveDB.system_exit == 1)
                    return true;

                for (int rw = 0; rw < LiveDB.wanted_rows.length; rw++)
                {
                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCid().trim(),0,
                            ((CustomerRegister)LiveDB.wanted_rows[rw]).getCid().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustname().trim(),0,
                            ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustname().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false;
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    // try date format here to simple date format
                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustbirthdate().toString().trim(),0,
                       ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustbirthdate().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false;
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustbirthcity().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustbirthcity().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustbirthnation()).trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustbirthnation().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustsex()).trim(),0,
                    String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustsex()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustmaritalstatus().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustmaritalstatus().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    
                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustlogintime().toString().trim(),0,
                     ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustlogintime().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    
                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustlogouttime().toString().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustlogouttime().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustregisterdate().toString().trim(),0,
                     ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustregisterdate().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr1().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr1().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr2().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr2().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr3().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr3().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false;
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr4().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustaddr4().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getLandmark().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getLandmark().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustcity().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustcity().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustnation().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustnation().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustzip().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustzip().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }


                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustemail().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustemail().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }


                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustphone().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustphone().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustfax().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustfax().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }


                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustflag()).trim(),0,
                    String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustflag()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }


                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }
                    
                    try{
                    fw.write(((CustomerRegister)LiveDB.wanted_rows[rw]).getCustlastdate().toString().trim(),0,
                    ((CustomerRegister)LiveDB.wanted_rows[rw]).getCustlastdate().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getRowid()).trim(),0,
                    String.valueOf(((CustomerRegister)LiveDB.wanted_rows[rw]).getRowid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.append('\n');
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.flush();
                    }catch(IOException ex_YESKIA87){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                        "Toilet not flushing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }
                } /* for (int rw = 0, sc = 3; rw < LiveDB.wanted_rows.length; rw++) */

                try{
                fw.close();
                }catch(IOException ex_YESKIA87){
                   System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                   "Toilet Lid not Closing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                   return false; // do a rapid fire exit
                }
 
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Dump File Successfully written to:" + fn));
                
         return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : private static boolean dump_ct(FileWriter fw, String fn)
 * First Cousin Methods : private static boolean dump_rt(FileWriter fw, String fn)
 *                        private static boolean dump_cr(FileWriter fw, String fn)
 *                        private static boolean dump_sc(FileWriter fw, String fn)
 *                        private static boolean dump_it(FileWriter fw, String fn)
 *
 * Parameters : FileWriter fw, String fn (filename corresponding to FileWriter)
 * Returns : boolean true if a dump of ChangeTracker file has been written to character readable file
 *           boolean false if any streams error during the dump of ChangeTracker
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If there is some data corruption detected or failure of a specific critical
 * method then this static method dump_ct() is called. What it does is to write out character readable
 * files. The SYSADM needs to correct each of these table dumps and reload the data using command line
 * at operating system $InstallDB FiXdAtAcOrRuPtIoN.
 *
 * In simple terms it dumps character readable data to files which need to be corrected by Application
 * administrator and then reloaded to get the database in a consistent state after Harry Hackers visit.
 * This method dumps just the ChangeTracker table to a character readable file.
 *
 * Technical Reference : Watch Uma's the next time you dump your girlfriend inside a secure compound !!
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static boolean dump_ct(FileWriter fw, String fn)
    {
                if (LiveDB.system_exit == 1)
                    return true;

                for (int rw = 0; rw < LiveDB.wanted_rows.length; rw++)
                {
                    try{
                    fw.write(String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getTableno()).trim(),0,
                       String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getTableno()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getRowid()).trim(),0,
                       String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getRowid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ChangeTracker)LiveDB.wanted_rows[rw]).getChange_flag());                            
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getPid()).trim(),0,
                    String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getPid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ChangeTracker)LiveDB.wanted_rows[rw]).getDmldate().toString().trim(),0,
                            ((ChangeTracker)LiveDB.wanted_rows[rw]).getDmldate().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ChangeTracker)LiveDB.wanted_rows[rw]).getEntirerow().toString().trim(),0,
                    ((ChangeTracker)LiveDB.wanted_rows[rw]).getEntirerow().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getCtrowid()).trim(),0,
                    String.valueOf(((ChangeTracker)LiveDB.wanted_rows[rw]).getCtrowid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.append('\n');
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.flush();
                    }catch(IOException ex_YESKIA87){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                        "Toilet not flushing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                } /* for (int rw = 0, sc = 3; rw < LiveDB.wanted_rows.length; rw++) */

                try{
                  fw.close();
                }catch(IOException ex_YESKIA87){
                   System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                   "Toilet Lid not Closing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                   return false; // do a rapid fire exit
                }
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Dump File Successfully written to:" + fn));
         return true;
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : private static boolean dump_it(FileWriter fw, String fn)
 * First Cousin Methods : private static boolean dump_rt(FileWriter fw, String fn)
 *                        private static boolean dump_cr(FileWriter fw, String fn)
 *                        private static boolean dump_sc(FileWriter fw, String fn)
 *                        private static boolean dump_ct(FileWriter fw, String fn)
 *
 * Parameters :  FileWriter fw, String fn (filename corresponding to FileWriter)
 * Returns : boolean true if a dump of InstalledTables file has been written to character readable file
 *           boolean false if any streams error during the dump of InstalledTables
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If there is some data corruption detected or failure of a specific critical
 * method then this static method dump_it() is called. What it does is to write out character readable
 * files. The SYSADM needs to correct each of these table dumps and reload the data using command line
 * at operating system $InstallDB FiXdAtAcOrRuPtIoN.
 *
 * In simple terms it dumps character readable data to files which need to be corrected by Application
 * administrator and then reloaded to get the database in a consistent state after Harry Hackers visit.
 * This method dumps just the InstalledTables table to a character readable file.
 *
 * Technical Reference : Watch Uma's the next time you dump your girlfriend inside a secure compound !!
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static boolean dump_it(FileWriter fw, String fn)
    {
                if (LiveDB.system_exit == 1)
                    return true;

                for (int rw = 0; rw < LiveDB.wanted_rows.length; rw++)
                {
                    try{
                    fw.write(String.valueOf(((InstalledTables)LiveDB.wanted_rows[rw]).getTableno()).trim(),0,
                       String.valueOf(((InstalledTables)LiveDB.wanted_rows[rw]).getTableno()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((InstalledTables)LiveDB.wanted_rows[rw]).getAccesstime().toString().trim(),0,
                       ((InstalledTables)LiveDB.wanted_rows[rw]).getAccesstime().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((InstalledTables)LiveDB.wanted_rows[rw]).getModifiedtime().toString().trim(),0,
                       ((InstalledTables)LiveDB.wanted_rows[rw]).getModifiedtime().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((InstalledTables)LiveDB.wanted_rows[rw]).getInstalltime().toString().trim(),0,
                      ((InstalledTables)LiveDB.wanted_rows[rw]).getInstalltime().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((InstalledTables)LiveDB.wanted_rows[rw]).getWhichlocale().trim(),0,
                       ((InstalledTables)LiveDB.wanted_rows[rw]).getWhichlocale().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((InstalledTables)LiveDB.wanted_rows[rw]).getIsocharset().trim(),0,
                             ((InstalledTables)LiveDB.wanted_rows[rw]).getIsocharset().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((InstalledTables)LiveDB.wanted_rows[rw]).getInitialsize()).trim(),0,
                    String.valueOf(((InstalledTables)LiveDB.wanted_rows[rw]).getInitialsize()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                  try{
                    fw.write(String.valueOf(((InstalledTables)LiveDB.wanted_rows[rw]).getRowid()).trim(),0,
                    String.valueOf(((InstalledTables)LiveDB.wanted_rows[rw]).getRowid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.append('\n');
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.flush();
                    }catch(IOException ex_YESKIA87){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                        "Toilet not flushing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }
                } /* for (int rw = 0, sc = 3; rw < LiveDB.wanted_rows.length; rw++) */
                
                try{
                  fw.close();
                }catch(IOException ex_YESKIA87){
                   System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                   "Toilet Lid not Closing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                   return false; // do a rapid fire exit
                }
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Dump File Successfully written to:" + fn));
         return true;
     }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:ReportsTable.java
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : private static boolean dump_rt(FileWriter fw, String fn)
 * First Cousin Methods : private static boolean dump_it(FileWriter fw, String fn)
 *                        private static boolean dump_cr(FileWriter fw, String fn)
 *                        private static boolean dump_sc(FileWriter fw, String fn)
 *                        private static boolean dump_ct(FileWriter fw, String fn)
 *
 * Parameters :  FileWriter fw, String fn (filename corresponding to FileWriter)
 * Returns : boolean true if a dump of ReportsTable file has been written to character readable file
 *           boolean false if any streams error during the dump of ReportsTable
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If there is some data corruption detected or failure of a specific critical
 * method then this static method dump_rt() is called. What it does is to write out character readable
 * files. The SYSADM needs to correct each of these table dumps and reload the data using command line
 * at operating system $InstallDB FiXdAtAcOrRuPtIoN.
 *
 * In simple terms it dumps character readable data to files which need to be corrected by Application
 * administrator and then reloaded to get the database in a consistent state after Harry Hackers visit.
 * This method dumps just the ReportsTable table to a character readable file.
 *
 * Technical Reference : Watch Uma's the next time you dump your girlfriend inside a secure compound !!
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static boolean dump_rt(FileWriter fw, String fn)
    {
                if (LiveDB.system_exit == 1)
                    return true;
                
                for (int rw = 0; rw < LiveDB.wanted_rows.length; rw++)
                {
                    try{
                    fw.write(String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getDocumentno()).trim(),0,
                       String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getDocumentno()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getId()).trim(),0,
                       String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getId()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ReportsTable)LiveDB.wanted_rows[rw]).getDoctype().trim(),0,
                       ((ReportsTable)LiveDB.wanted_rows[rw]).getDoctype().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ReportsTable)LiveDB.wanted_rows[rw]).getPathname().trim(),0,
                    ((ReportsTable)LiveDB.wanted_rows[rw]).getPathname().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getSize()).trim(),0,
                       String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getSize()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ReportsTable)LiveDB.wanted_rows[rw]).getReportdate().toString().trim(),0,
                       ((ReportsTable)LiveDB.wanted_rows[rw]).getReportdate().toString().trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(((ReportsTable)LiveDB.wanted_rows[rw]).getStatus());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                  try{
                    fw.write(String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getByteswritten()).trim(),0,
                    String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getByteswritten()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }


                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getPid()).trim(),0,
                    String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getPid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                        fw.write(LiveDB.fieldseperator,0,1);
                    }catch (IOException ex_YESKIA89){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA89,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.write(String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getRowid()).trim(),0,
                    String.valueOf(((ReportsTable)LiveDB.wanted_rows[rw]).getRowid()).trim().length());
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.append('\n');
                    }catch(IOException ex_YESKIA91){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA91,
                        "Write Fail File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }

                    try{
                    fw.flush();
                    }catch(IOException ex_YESKIA87){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                        "Toilet not flushing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                        return false; // do a rapid fire exit
                    }
                } /* for (int rw = 0, sc = 3; rw < LiveDB.wanted_rows.length; rw++) */

                try{
                  fw.close();
                }catch(IOException ex_YESKIA87){
                   System.err.println(LiveDB.grassHopper(ex_YESKIA87,
                   "Toilet Lid not Closing File:" + fn + " try O/S:" + LiveDB.OSVENDORNAME));
                   return false; // do a rapid fire exit
                }
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Dump File Successfully written to:" + fn));
         return true;
     }



    @Override
    public boolean goldenFinger (){
                if (LiveDB.system_exit == 1)
                    return true;

        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:LiveDB.java (quick look at top half)
 * @LOOKSY:LiveDB.indxinstalledTables
 * @LOOKSY:LiveDB.tablenameidentifier, LiveDB.REALTABLES
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : public boolean fromRussiaWithLove()
 * Parameters : None
 * Returns : boolean true if there is no change to static tables
 *           boolean false if these tables have been modified from their initialsize at install time
 *
 * @Since Version : 1.0
 *
 * Running Commentary : tables 0,7,8,9,10,11,12 contain static data so it there is some change in modified
 * time or size of these tables on disk is different from the initial installed size in InstalledTables.
 * The Celebrity table has been excluded from the checks because Celebrities can change and wither away
 * asin Bond movies.
 *
 * In simple terms it is periodically verifying the authenticity tables that are most often serialized
 * just once and even if they are serialized repeatedly the size cannot change as in FileTableDataFileMap
 * Technical Reference: Watch movie in large multiplex with popcorn !!
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean fromRussiaWithLove(){
                if (LiveDB.system_exit == 1)
                    return true;
        long gr;
        String tn = null;
        File fln = null;
        boolean ex = false;
                
        for (int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++)
        {
            // these tables there is a long way to check accuracy of file size next release
            if (tbl != ct && tbl != cr && tbl != id && tbl != cp && tbl != crr && tbl != it && tbl != rt && tbl != pc)
            {
                switch (tbl)
                {   // these are static tables whoose size does not change
                    case ft:
                    case pt:
                    case ni:
                    case po:
                    case sd:
                    case da:
                    case ar:
                        gr = LiveDB.indxinstalledTables.get(Integer.toString(tbl));
                        fln = new File (((FileTableDataFileMap) LiveDB.LiveSharedDB[ft][(int)gr]).getFilename());
                        if (((InstalledTables) LiveDB.LiveSharedDB[it][(int)gr]).getModifiedtime() != null ||
                            fln.length() != ((InstalledTables) LiveDB.LiveSharedDB[it][(int)gr]).getInitialsize())
                        {
                            for (int i = 0 ; i < LiveDB.tablenameidentifier.length; i++)
                            {
                                if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) == tbl)
                                {
                                    tn = LiveDB.tablenameidentifier[i][1];
                                    break;
                                }                                
                            }
                            LiveDB.ALRTLVL = 4;
                            System.err.println(LiveDB.grassHopper("Table Number " + Integer.toString(tbl) + " Table Name : " + tn));
                            ex = true;
                        }
                        break;
                    default:
                        break;
                }   // switch
            } // if (tbl != ct && tbl != cr && tbl != sc && tbl != crr && tbl != it && tbl != rt && tbl != pc && tbl != clt)
        } // for (int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++)
        
        if (ex == true) return false; else return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:LiveDB.java (quick look at top half)
 * @LOOKSY:LiveDB.indxinstalledTables, LiveDB.indxchangeTracker
 * @LOOKSY:LiveDB.tablenameidentifier, LiveDB.REALTABLES
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : public boolean ForYourEyesOnly ()
 * Parameters : None
 * Returns : boolean true if Purchase Order report has not been tampered with just critical numbers
 *           boolean false if streams error or Purchase Order report is corrupt or has been tampered with.
 *
 * @Since Version : 1.0
 *
 * Running Commentary : some files and tables are readonly there are no updates involved then
 * why have they been altered in memory or on disk
 *
 * In simple terms it is periodically verifying the authenticity of the ChangeTracker table which is a very
 * critical table for database reconstruct. Even if you loose everything but have this table alone miracles
 * are possible.
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean ForYourEyesOnly (){
                if (LiveDB.system_exit == 1)
                    return true;
        String tn = null;
        boolean ret = true;
        Date instdt = null;
        long rid = -1L;
        
        for ( int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++ )
        {
            // get the table name
            for (int i = 0 ; i < LiveDB.tablenameidentifier.length; i++)
            {
                 if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) == tbl)
                 {
                     tn = LiveDB.tablenameidentifier[i][1];
                     break;
                 }
            }

            // Is there an entry in change tracker for this tbl ? remember this is a dual purpose index
            if (LiveDB.indxchangeTracker.get(Integer.toString(tbl)) != null)
            {
                // these tables other than ft,ct,cr,sc,pd,it,rt,pc cannot be present in ChangeTracker
                // after install date most probably
                if ( tbl != ft && tbl != ct && tbl != cr && tbl != id && tbl != cp && tbl != crr
                     && tbl != it && tbl != rt  && tbl != pc )
                {
                    // these other tables can be present in ChangeTracker before install date
                    // so get the install date for this tbl from InstalledTables and then check
                    // ChangeTracker for a row start with LiveDB.CTSR to make it quick
                    rid = LiveDB.indxinstalledTables.get(String.valueOf(tbl));
                    if (rid < 0)
                    {
                        LiveDB.ALRTLVL = 2;
                        System.err.println(LiveDB.grassHopper("Table Number " + Integer.toString(tbl) +
                        " Table Name : " + tn + " dont exist in InstalledTables"));
                        ret = false;
                    }
                    else
                    {
                        instdt = ((InstalledTables)LiveDB.LiveSharedDB[it][(int)rid]).getInstalltime();
                        // for now dont send out alarming messages because these can be present
                        // in ChangeTracker after install date provided certain conditions are
                        // met as in ChangeTracker constructor
                        // check if a database reconstruct happened on this table 'T' || 'K'
                        // Okay these are basically SerializeJustOnce tables here in this switch
                        // This means that the application will only use these tables for lookups
                        // there may have been certain admin commands issued on these tables as a
                        // result of which ChangeTracker will show some entries in it. These admin
                        // commands other than 'FileTableDataFileMap' for Install are
                        // 'Delete' for physically deleting records marked for deletion from database
                        // 'Archive' to Archive excess records to an archive file
                        // 'QuickRepairChangeTracker' to repair a corrupt ChangeTracker table
                        // None of the above admin commands will show a trace in the ChangeTracker
                        // and so we dont worry about it either
                        // This admin 'FixDataCorruption' command will have oldChangeflag = 'I' || ChangeFlag = 'I'
                        // records in the ChangeTracker after a dump() is corrected and reloaded but based on this
                        // flag alone i cant say that a FixDataCorruption admin command happened.
                        // So again there is no trace for this either. So I will have to maintain some special
                        // admin commands file on disk which will list the table number, admin command, date/time
                        // Since I am running out of time on the wrist watch I will do it next time. For now
                        // I will only check what is below this line
                        // The other ChangeFlag 'T' is for database reconstruct admin command which will show
                        // in the ChangeTracker and this admin command impacts all these tables here
                        // Similarly a database rollback could have happened on this table which will show as
                        // ChangeFlag = 'K'
                        // A table rollback could have happened where ChangeFlag will show as 'R' for some time
                        // until COMMIT() erases that with a 'C'.
                        // A table Rollforward could also have happened where ChangeFlag will always show as 'J'                                   

                        // for now i take the idiots approach
                        for (int ctr = LiveDB.LiveSharedDB[ct].length -1; ctr >= 0; ctr--)
                        {
                             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getTableno() == tbl
                                && ( ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'R'
                                     || ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getOldchangeflag() == 'R'
                                     || ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'K'
                                     || ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'T'
                                     || ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'J'))
                                if (((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getDmldate().compareTo(instdt) <= 0)
                                {
                                     LiveDB.ALRTLVL = 3;
                                     System.err.println(LiveDB.grassHopper("Table Number " + Integer.toString(tbl) +
                                            " Table Name: " + tn + " Invalid in ChangeTracker" + " at row" + ctr));
                                     ret = false; 
                                     break;
                                }
                        } // for (int ctr = LiveDB.LiveSharedDB[ct].length -1; ctr >= 0; ctr--)
                    } // else for if (rid < 0)
                } // if ( tbl != ft && tbl != ct && tbl != cr && tbl != sc && tbl != pd && tbl != crr
            } // if (LiveDB.indxchangeTracker.get(Integer.toString(tbl)) != null)
        } // for ( int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++ )
        if (ret == false) return false; else return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean moneyMoneyMoney ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print moneyMoneyMoney (Purchase Order) report
 * Report Data : purchase order generation
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
    @Override
    public boolean moneyMoneyMoney () {return Generic.ReportWriter();}


    @Override
    public boolean casinoRoyale (){

        if (LiveDB.system_exit == 1)
            return true;
                
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ThreadController.java
 * @LOOKSY:LiveDB.java
 * @LOOKSY:LiveDB.PilotLessTrigger
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : public boolean thunderBall ()
 * Parameters : None
 * Returns : boolean true always !
 * (You may choose to modify the source to return false under certain conditions)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Originally i thought a lot many weird creative designs to alter
 * process priorities. I have given up on all that. What it does now is to simply monitor
 * the bulk of work on this Application database which are Reports allocated to each user
 * who logs in. Remember once you login as a user feel free to log out but you have started
 * daemon processes on your system which will only exit after completing work alloted to you.
 * So it checks the reports that are completed and not completed and based on those numbers
 * it alters the process priorities. This application distributes the report workload evenly
 * between users logged into system. So more the users on the system the less the work load
 *
 * In simple terms The program is being used very heavily so monitor for such conditions using
 * thunderBall()
 * Technical Reference : Watch James Bond movie in a large multiplex !! Oh no this Ian here
 * Musical Accompanyments : THE ABBREVIATED KING CRIMSON "heartbeat"
 *
 * Start Date: 18th October 2010
 * End Date: 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean thunderBall (){

                if (LiveDB.system_exit == 1)
                    return true;
        short dn = 0; // reports completed
        short ndn = 0; // reports not done

        // post advised speed limits based on users logged in at LiveDB.RevvoMeter

        /* Get users logged in Now from CustomerRegister table */
        
        for (int i = 0; i < LiveDB.LiveSharedDB[cr].length ; i++)
        {
            if (((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustlogintime().after(LiveDB.midnight)
                && ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustlogouttime() != null)
            {
                LiveDB.usersloggedin++;
            }
        }

        // now check the reports table for completed workload only
        // if most workload is completed dont bother or else alter process priority
        // and also thread priorities for other threads place them on cruise control
        // a thread is a light-weight process consuming system cpu resources.
        // to alter process priorities we need to Alter LiveDb.Revvometer


        for (int rw = 0; rw < LiveDB.LiveSharedDB[rt].length; rw++)
        {
            if (((ReportsTable) LiveDB.LiveSharedDB[rt][rw]).getReportdate().after(LiveDB.midnight))
            {
                if (((ReportsTable) LiveDB.LiveSharedDB[rt][rw]).getStatus() == 'C')
                    dn++; // reports completed
                else ndn++; // reports not done
            }
        }

        // I am checking just the reports table because this is the only heavy duty task on board

        // We are now altering process priorities so therefore use the console button to turn off
        // cruise control

        if (ThreadController.getCruiseControl())
            ThreadController.setCruiseControl(false);

        if (dn == 0)
        {
            // all pids have reports not completed yet
            if (LiveDB.usersloggedin <= LiveDB.ALLOWUSERS/2)
            {
                // we can increase the process priority
                // because we have allocated more reports to each user
                if (ThreadController.getTorqueInduction() == true)
                {
                    // do a GearDn to increase priority
                    ThreadController.GearDn (ThreadController.DashBoardGPS.THREADSPY.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADSPY.ordinal()] -2L));
                    ThreadController.GearDn (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADLOVEALL.ordinal()] -2L));
                }
                else
                {
                    // do a GearUp to increase priority
                    ThreadController.GearUp (ThreadController.DashBoardGPS.THREADSPY.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADSPY.ordinal()] +2L));
                    ThreadController.GearUp (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADLOVEALL.ordinal()] +2L));
                }
            }
            else
            {
                // we can put all processes on cruise control
                // because usersloggedin are more and so the report load is very less
                // and if the dn count is zero then then the system is very slow so help it.
                ThreadController.CruiseControl(null, ThreadController.DashBoardGPS.THREADLEASH.ordinal(),
                ThreadController.DashBoardGPS.THREADSRTINDX.ordinal(), ThreadController.DashBoardGPS.THREADREFRESHDB.ordinal(),
                ThreadController.DashBoardGPS.THREADSYSEXIT.ordinal(), ThreadController.DashBoardGPS.THREADWRITETABLES.ordinal(),
                ThreadController.DashBoardGPS.THREADROYAL.ordinal(), ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),
                ThreadController.DashBoardGPS.THREADSPY.ordinal(),ThreadController.DashBoardGPS.THREADAUTOBACKKUP.ordinal());
                
            }
        }
        else if (ndn == 0)
        {
            // all pids have completed all reports allocated to them
            // so everything is hunky dory so reduce process priority for report thread to 1 !!!
            if (ThreadController.getTorqueInduction() == true)
            {
                // do a GearUp to reduce priority
                ThreadController.GearUp (ThreadController.DashBoardGPS.THREADSPY.ordinal(),10);

                ThreadController.GearUp (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),10);
            }
            else
            {
                // do a GearDn to reduce priority
                ThreadController.GearDn (ThreadController.DashBoardGPS.THREADSPY.ordinal(),1);

                ThreadController.GearDn (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),1);
            }
        }
        else if (ndn < dn)
        {
            // reports not done are less than done reports very little work left to do
            if (LiveDB.usersloggedin >= LiveDB.ALLOWUSERS/2)
            {
                // we can reduce the process priority for report thread
                // because we have allocated very few reports to each user
                // and ndn count is less then dn count
                if (ThreadController.getTorqueInduction() == true)
                {
                    // do a GearUp to reduce priority
                    ThreadController.GearUp (ThreadController.DashBoardGPS.THREADSPY.ordinal(),10);

                    ThreadController.GearUp (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),10);
                }
                else
                {
                    // do a GearDn to reduce priority
                    ThreadController.GearDn (ThreadController.DashBoardGPS.THREADSPY.ordinal(),1);

                    ThreadController.GearDn (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),1);
                }
            }

        }
        else if (dn < ndn)
        {
            LiveDB.SLEEPTIME = 500; // we are setting this in a loop so reduce to very little sleep
            // reports that are done are less than not done reports so still a lot of work to do
            if (LiveDB.usersloggedin <= LiveDB.ALLOWUSERS/2)
            {
                // we can increase the process priority of report thread
                // because we have allocated more reports to each user
                if (ThreadController.getTorqueInduction() == true)
                {
                    // do a GearDn to increase priority
                    ThreadController.GearDn (ThreadController.DashBoardGPS.THREADSPY.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADSPY.ordinal()] -2L));

                    ThreadController.GearDn (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADLOVEALL.ordinal()] -2L));
                }
                else
                {
                    // do a GearUp to increase priority
                    ThreadController.GearUp (ThreadController.DashBoardGPS.THREADSPY.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADSPY.ordinal()] +2L));

                    ThreadController.GearUp (ThreadController.DashBoardGPS.THREADLOVEALL.ordinal(),
                    (int) (ThreadController.getCurrentGear()[ThreadController.DashBoardGPS.THREADLOVEALL.ordinal()] +2L));
                }
            }
        }
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean diamondsAreForever ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print diamondsAreForever report
 * Report Data : HIGH QUANTUM PURCHASE REPORT. Get all customers from CustomerRegister who have highest 
 * purchase "order" quantity or billed amountBasically there is an un-usually high purchase order quantity
 * valuation of a RichieRich from diamond district antwerp, Bulgium. Just a quick crosscheck with customer
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean diamondsAreForever () {return Generic.ReportWriter();}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean theLivingDaylights ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print theLivingDaylights report
 * Report Data : Some users using the program and shopping at weird times such as middle of the night
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean theLivingDaylights (){return Generic.ReportWriter();}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean neverSayNeverAgain ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print neverSayNeverAgain report
 * Report Data : some users of the program have been playing mischief by emptying there shopping carts
 * repeatedly after shopping. FastTrack. We need to cross check with such fellers. Maybe some kid called
 * Dennis logging into office intranets from where-ever. Mark such customers as 'S' in customer register.
 * 'S' means staying alive.
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
 
    @Override
    public boolean neverSayNeverAgain (){return Generic.ReportWriter();}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean youOnlyLiveTwice ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print youOnlyLiveTwice report
 * Report Data : These customers have been emptying shopping carts in Lifts .... A report to rag them ?
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    @Override
    public boolean youOnlyLiveTwice (){return Generic.ReportWriter();}


/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:CrashRecovery.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:InstallDB.java method private static boolean PowerOutageSensor ()
 * @LOOKSY:LiveDB.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean quantumOfSolace ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print quantumOfSolace report. Any DML done on the database is also offered to the
 * CrashRecovery table and so if a clean crash happens then data recovery is handled by PowerOutageSensor.
 * Report Data : Some power outage has happened on the intranet which usually does not happen due to which
 * some data has not committed. This is a report of such data which may or may not have been committed.
 * 
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   @Override
   public boolean quantumOfSolace (){return Generic.ReportWriter();}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean RunAwayBride ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print RunAwayBride report
 * Report Data : Users who have been logged in for a very long time and there is total inactivity
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   @Override
   public boolean RunAwayBride (){return Generic.ReportWriter();}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:LiveDB.indxcustomerRegister
 * @LOOKSY:LiveDB.DrNoReport[]
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name : public boolean DrNo ()
 * Parameters : None
 * Returns : boolean
 *           true if call to Generic.ReportWriter(); successfully generates report on disk
 *           false if call to Generic.ReportWriter(); fails to complete report
 *
 * @Since Version : 1.0
 *
 * Running Commentary : These are baddest customers so Mark in database table CustomerRegister with flag
 *                      'B' - Bad. Also print the RMA report.
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean DrNo (){
                if (LiveDB.system_exit == 1)
                    return true;


       return Generic.ReportWriter();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY: PlatformClearance.java
 * @LOOKSY: ReportsTable.java
 * @LOOKSY: ChangeTracker.java
 * @LOOKSY: run () method Spy.java
 *
 * Method Name : public boolean LostSouls ()
 * Parameters : None
 * Returns : boolean true always !
 * (You may choose to modify the source to return false under certain conditions)
 *
 * @Since Version : 1.0
 *
 * Method Dedicated t0 : Mini Memon, Shereen Blam, Mimansa Maalik
 *                       The Song Michael Franks Album The Art of Tea Song Popsicle Toes
 *
 * Running Commentary : This is a automatic purge mechanism for tables 15 (rt), 17(pc)
 * which may have unwanted rows to purge. If you dont then Satan will occupy Soul of
 * your database and chew up your hard disk it will be  a "Horror" "Wits" episode.
 * These are Satanic verses in the Database that have to be removed. You can even alter
 * this source to do a fine purge. The call to method licenceToKill () will physically
 * delete these rows from Database. So this method must be called in run() method Spy.java
 * prior to calling method licenceToKill()
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean LostSouls (){

                if (LiveDB.system_exit == 1)
                    return true;

        int hrs48 = 1000 * 60 * 60 * 48;
        int days31 = 1000 * 60 * 60 * 24 * 31;
        Date retain = new Date (new Date().getTime() - hrs48);

        for (int rw = 0; rw < LiveDB.LiveSharedDB[pc].length; rw++)
        {
            if (((PlatformClearance)LiveDB.LiveSharedDB[pc][rw]).getRequest_time().before(retain))
            {
                // CHECK DuRING BETA TESTING
                // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (pc,((PlatformClearance)LiveDB.LiveSharedDB[pc][rw]).getRowid(), 'D',
                LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[pc][(int)((PlatformClearance)LiveDB.LiveSharedDB[pc][rw]).getRowid()],
                (long)LiveDB.LiveSharedDB[ct].length);
            }
        }

        // for Reports Table we will retain 31 days worth of rows only
        // Two reports the DoorsReports (366 days) and Sleepless in Seattle (9 months)
        // have a report frequency of more than 31 days. Pah dont bother to retain so many rows
        // even for an audit trail report if you wish to generate one. We dont have disk space
        // to install this Application on some Corporate Intranet at best they will give us 4GB
        // which will run for approx three years and collapse !! If there is a disk space shortage
        // give the sysadm a 32 GB pen drive to stick at the USB port at the rear of the server.
        // It will run for 24 years and collapse or else make it a 64 GB usb pen drive it will work
        // for 48 years and you wont live longer than that.


        // YOU CAN DO A FINE PURGE HERE AFTER CHECKING REPORT ID, REPORT FREQUENCY
        // IT WILL MAKE IT ULTRA LIGHT WEIGHT.
        
        retain = new Date (new Date().getTime() - days31);

        for (int rw = 0; rw < LiveDB.LiveSharedDB[rt].length; rw++)
        {
            if (((ReportsTable)LiveDB.LiveSharedDB[rt][rw]).getReportdate().before(retain))
            {
                // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (rt,((ReportsTable)LiveDB.LiveSharedDB[rt][rw]).getRowid(), 'D',
                LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[rt][(int)((ReportsTable)LiveDB.LiveSharedDB[rt][rw]).getRowid()],
                (long)LiveDB.LiveSharedDB[ct].length);
            }
        }

        // okay now the next method licenceToKill () will physically delete these rows from Database
        return true;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:ReportsTable.java
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name : public boolean licenceToKill ()
 * Parameters : None
 * Returns : boolean true if all goes well
 *           boolean false if there is a streams problem or data corruption
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method has three purposes Purpose 1: to invoke the System.gc() garbage collector
 * Purpose 2: to Purge the database of deleted records. Purpose 3: to archive database based on rowsets which
 * is incomplete in this release. Both Actions can only be performed in zero user mode with just database service
 * running.To purge unwanted rows in database issue command "$InstallDB DeLeTe" from command line of operating
 * system.To Archive issue command "$InstallDB ArChIvE from command line of operating system.The Archival will
 * only be done if table length for any table other than table zero exceeds LiveDB.maxrows. Table zero
 * FileTableDataFileMap can never exceed LiveDB.maxrows. To check zero user mode the method uses file ULI.inf
 * for number of users logged in. The GUI must constantly update this file. There is another character file
 * called ULI.chr which is a readable file for the SysAdm to do a quick lookup of users logged into Application.
 * In next release this file will provide a lot more frivolous information for the Application administrator.
 * So both files ULI.inf and ULI.chr must exist for method to process command line otherwise false returned.
 * Only four tables can be purged namely CustomerRegister, ShoppingCart, PlatformClearance, ReportsTable.
 *
 * In simplified terms This is actually a garbage collection and/or archival mechanism
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean licenceToKill (){

                if (LiveDB.system_exit == 1)
                    return true;

       long itr = -1; // installed table row
       long gt = 0;
 
       String searchkey = null;       
       long itbl = 0L; // index table
       int ex = -1;
       boolean retval = true;


       // first call garbage collector then select wanted rows and re-assign to LiveSharedDB
       System.gc();
       
       if (LiveDB.AllUsersKickedOut() == false)
       {
           System.err.println(LiveDB.grassHopper("Retried 126 times. All Users have not logged out. Try Shooting !"));
           return false;
       }

       // now get wanted rows one table at a time
       if (LiveDB.command_line.equals("DeLeTe") == true )
       {
            for (int tbl = 2; tbl <= LiveDB.REALTABLES; tbl++)
            {
                if (tbl != cr && tbl != rt && tbl != pc)
                      continue;
           
                for (int rw = 0; rw < LiveDB.LiveSharedDB[tbl].length; rw++)
                {
                    searchkey = Integer.toString(tbl) + Long.toString((long)rw);
                    if (LiveDB.indxchangeTracker.get(searchkey) != null)
                    {
                        gt = LiveDB.indxchangeTracker.get(searchkey);
                        if (((ChangeTracker) LiveDB.LiveSharedDB[ct][(int)gt]).getOldchangeflag() != 'D')
                        {
                            // now renumber the wanted_rows rowid for each of these tables since we have chucked out
                            // rows with flag 'D' as unwanted
                            // now renumber the rowids in wanted rows very important
                            switch (tbl){
                                // only tables 2,3, 8, 15, 17 will see row deletes
                                // tables 2,3 will have row deletes because of user actions
                                // tables 15, 17 will have row deleted because of frequent row purges
                                case cr:
                                    LiveDB.wanted_rows[LiveDB.wanted_rows.length] =
                                        ((CustomerRegister)LiveDB.LiveSharedDB[tbl][rw]).clone();
                                    ((CustomerRegister)wanted_rows[LiveDB.wanted_rows.length -1]).
                                        setRowid((long)LiveDB.wanted_rows.length -1L);
                                    break;
                                case rt:
                                    LiveDB.wanted_rows[LiveDB.wanted_rows.length] =
                                        ((ReportsTable)LiveDB.LiveSharedDB[tbl][rw]).clone();
                                    ((ReportsTable)wanted_rows[LiveDB.wanted_rows.length -1]).
                                        setRowid((long)LiveDB.wanted_rows.length -1L);
                                    break;
                                case pc:
                                    LiveDB.wanted_rows[LiveDB.wanted_rows.length] =
                                        ((PlatformClearance)LiveDB.LiveSharedDB[tbl][rw]).clone();
                                    ((PlatformClearance)wanted_rows[LiveDB.wanted_rows.length -1]).
                                        setRowid((long)LiveDB.wanted_rows.length -1L);
                                    break;
                                default:
                                    break;
                            }
                            // the corresponding row in ChangeTracker must also be set
                            // to reflect this renumbering of rowids in other tables
                            ((ChangeTracker)LiveDB.LiveSharedDB[ct][(int)gt]).
                                setRowid((long)LiveDB.wanted_rows.length -1L);
                        } // if (((ChangeTracker) LiveDB.LiveSharedDB[ct][(int)gt]).getOldchangeflag() != 'D')
                    } // if (LiveDB.indxchangeTracker.get(searchkey) != null)
                    else
                    {
                        LiveDB.ALRTLVL = 4;
                        System.err.println(LiveDB.grassHopper("Change Tracker corrupted"));
			JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                        return false;
                    }
                } // for (int rw = 0; rw < LiveDB.LiveSharedDB[tbl].length; rw++)
                LiveDB.LiveSharedDB[tbl] = Arrays.copyOf(LiveDB.wanted_rows, 0);
                LiveDB.wanted_rows = null;
                // now switch tbl once again and slow commit all tables
                ex = -1;
                switch(tbl){
                    case cr:
                       if ((LiveDB.LiveSharedDB[tbl].length != 0)
                               && ((CustomerRegister)LiveDB.LiveSharedDB[tbl][0]).COMMIT() == false)
                       {
                           System.err.println(LiveDB.grassHopper("CustomerRegister COMMIT() failed"));
                           ex = cr;
                       }
                       break;

                    case rt:
                       if ((LiveDB.LiveSharedDB[tbl].length != 0)
                               && ((ReportsTable)LiveDB.LiveSharedDB[tbl][0]).COMMIT() == false)
                       {
                           System.err.println(LiveDB.grassHopper("ReportsTable COMMIT() failed"));
                           ex = rt;
                       }
                       break;
                    case pc:
                       if ((LiveDB.LiveSharedDB[tbl].length != 0)
                               && ((PlatformClearance)LiveDB.LiveSharedDB[tbl][0]).COMMIT() == false)
                       {
                           System.err.println(LiveDB.grassHopper("PlatformClearance COMMIT() failed"));
                           ex = pc;
                       }
                       break;
                    default:
                       break;    
                }

                for (int line = 0;line < LiveDB.LiveSharedDB[it].length;line++)
                {
                    if (((InstalledTables)LiveDB.LiveSharedDB[it][line]).getTableno() == tbl)
                        itr = ((InstalledTables)LiveDB.LiveSharedDB[it][line]).getRowid();
                }

                if (tbl != ex)
                {
                    ((InstalledTables)LiveDB.LiveSharedDB[it][(int)itr]).
                    setInitialsize((LiveDB.serializedfilespath + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl])
                    .getFilename()).length());
                }
                if (ex != -1)
                    retval = false;
            } // for (int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++)
       }
       else if (LiveDB.command_line.equals("ArChIvE") == true)
       {
            // DONT USE THIS COMMAND FOR NOW NOT YET READY
           
            // this is a command that Archives all excess records to a rowset.
            // so you will have rs1, rs2, rs3, rs4 etc etc but I have to scratch my bottoms for
            // a smart and fast algorithm to load these rowsets into memory when they are
            // requested by a transaction !!! Whoops pain in the ...... and so wait next release
            // just change LiveDB.maxrows to a smaller number and write 'n' row sets to disk
            // LiveDB.MAXROWSETS can be set to round(LiveDB.maxrows/32766 (or any other number)
            // if there are memory HOG issues but hi hi hi you die with it for now PAISA mungta hai !!!
            // you dont write it it will generate an error message JA BAAAAAAA .........
            // I have worked out a ContextSwitch to support rowsets and reduce the memory footprint
            // to just 32MB perhaps. But that stuff can only be released in the next release due to
            // some more programming work involved with that.
           
            // start with program for each table check if maxrows limit has been reached
            for (int tbl = 1; tbl <= LiveDB.REALTABLES; tbl ++)
            {
                if (LiveDB.LiveSharedDB[tbl].length > LiveDB.maxrows)
                {
                    // Archive this to disk with row set number
                    if (LiveDB.commit_database(tbl) == false)
                        System.err.println(LiveDB.grassHopper("Error Archiving Database Table No :"
                            + String.valueOf(tbl)));
                }
            }
       }
       
       // Take a good look at protected static boolean AllUsersKickedOut ()
       // for an explanation of the lines of code below
       try{
           LiveDB.Xclusive.release();
           LiveDB.FOS.close();
       }catch (IOException ex_NOKIA71){
           System.err.println(LiveDB.grassHopper(ex_NOKIA71, "Suggested O/S Vendor:" + LiveDB.OSVENDORNAME));
       }
       
       System.gc(); // no harm done call it again

       if (retval)
       {
           LiveDB.ALRTLVL = 5;
           System.err.println(LiveDB.grassHopper("ADMIN COMMAND " + LiveDB.command_line + " COMPLETED SUCCESSFULLY"));
			JOptionPane.showMessageDialog(appframe, "ADMIN COMMAND COMPLETED SUCCESSFULLY USERS MAY LOGIN NOW");
           if (new File (LiveDB.TMPDIR + "admincommands.dbs").delete() == false)
           {
               System.err.println(LiveDB.grassHopper(LiveDB.TMPDIR + "admincommands.dbs" + " delete failed"));
			JOptionPane.showMessageDialog( appframe,"admincommands.dbs" + " delete failed");
           }
       }
       else
       {
           if (new File (LiveDB.TMPDIR + "admincommands.dbs").delete() == false)
           {
               System.err.println(LiveDB.grassHopper(LiveDB.TMPDIR + "admincommands.dbs" + " delete failed"));
			JOptionPane.showMessageDialog( appframe,"admincommands.dbs" + " delete failed");
           }
           
           LiveDB.ALRTLVL = 6;
           System.err.println(LiveDB.grassHopper("ADMIN COMMAND " + LiveDB.command_line + " HAS ERRORS"));
           System.exit(1);
       }
       
       return retval;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:SortandIndex.java Search for this report name idiot
 * @LOOKSY:LiveDB.java
 * @LOOKSY:GenericReportWriter.java
 * @LOOKSY:LiveDB.Generic
 * @LOOKSY:run() method of Spy.java
 *
 * Method Name: public boolean Octopussy ()
 * Parameters : None
 * Returns : boolean true if ReportWriter successfully wrote the report
 *           boolean false if ReportWriter fails
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Print Octopussy report
 * Report Data : When there are eight new female customers registered every day Lady Luck has Smiled.
 * One is called Freedom the other Enterprise
 * Technical Reference : Watch James Bond Movie
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean Octopussy (){return Generic.ReportWriter();}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:LanguageSupport.java
 * @LOOKSY:LanguageTitles.java
 * @LOOKSY:LanguageTransalations.java
 * @LOOKSY:PaymentType.java
 * @LOOKSY:PictureDatabase.java
 * @LOOKSY:PictureOptions.java
 * @LOOKSY:SearchDatabase.java
 * @LOOKSY:DefaultAdvertisingImages.java
 * @LOOKSY:ArtLeaves.java
 * @LOOKSY:CrashRecovery.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:ReportsTable.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.java
 * @LOOKSY:LiveDB.tablenameidentifier
 * @LOOKSY:run() method of Spy.java
 * 
 * Method Name : public boolean manWithGoldenGun()
 * Parameters : None
 * Returns : boolean true if all rowid checks are successfull
 *           boolean false if there is an error in the rowids and/or error in LiveDB.tablenameidentifier
 *
 * @Since Version : 1.0 (Release 1 version 0)
 *
 * Running Commentary : Currently this method only checks rowids for each and every LiveDB.REALTABLES
 * In the next release we may or may not call a native method. Native methods break all access specifiers
 * and so must be avoided from a application security view point. In the next release we will check for
 * suspicious processes in your user space with your userid other than jvm. We will kill such processes.
 * But we need extreme caution here we might accidentally delete a valid running service of some kind.
 *
 * In simplified terms this method shoots down suspicious activiy with malevolent intentions.
 *
 * Start Date : 18th October 2010
 * End Date : 10th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    @Override
    public boolean manWithGoldenGun (){
                if (LiveDB.system_exit == 1)
                    return true;
        // Part of Anti-Corruption-Bureau
        // Checking Rowids for now
        boolean fnd = false;

        String tbn = null; // tablename
        
        for (int tb = 0; tb <= LiveDB.REALTABLES; tb++)
        {
            for (int i = 0; i < LiveDB.tablenameidentifier.length; i++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) == tb)
                {
                    tbn = LiveDB.tablenameidentifier[i][1];
                    fnd = true;
                    break;
                }
            }

            if (fnd == false)
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("tablenameidentifier has incorrect values cant find table :"
                + String.valueOf(tb)));
                return false;
            }

            for (int rw = 0; rw < LiveDB.LiveSharedDB[tb].length; rw++)
            {
                switch (tb){
                    case 0:
                        if (((FileTableDataFileMap)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 1:
                        if (((ChangeTracker)LiveDB.LiveSharedDB[tb][rw]).getCtrowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 2:
                        if (((CustomerRegister)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;

                    case 4:
                        if (((LanguageSupport)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 5:
                        if (((LanguageTitles)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;

                    case 7:
                        if (((PaymentType)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;

                    case 10:
                        if (((SearchDatabase)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 11:
                        if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 12:
                        if (((ArtLeaves)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 13:
                        if (((CrashRecovery)LiveDB.LiveSharedDB[tb][rw]).getCrrowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 14:
                        if (((InstalledTables)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 15:
                        if (((ReportsTable)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    case 17:
                        if (((PlatformClearance)LiveDB.LiveSharedDB[tb][rw]).getRowid() != rw)
                        {
                            LiveDB.ALRTLVL = 2;
                            System.err.println(LiveDB.grassHopper("Internal Rowid mismatch with array subscript Tablename:" + tbn));
                            return false;
                        }
                        break;
                    default:
                        break;
                } // switch
            }
        }
        return true;
    }
}

