/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataEntryPrograms;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import static DataEntryPrograms.DataSheet.combo1;
import static DataEntryPrograms.DataSheet.datasheetpanel;
import static DataEntryPrograms.DotingEntry.REALTABLES;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:DataSheet.datasheetpanel, SpreadSheet.chosen_table, DotingEntry.REALTABLES
 * @LOOKSY:ChoiceSheet.indxfiletabledatafilemap
 * Listener Class Name : public class combo1TxtFldLsnr implements ActionListener
 * Methods : Look in Class definition
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class implements a common listener interface for all DataSheets for different
 * chosen_table and it also validates input field in the DataSheet every time the data is changed by user.
 * Earlier implementation had just one Listener class called TxtFldLsnr.java for everything which
 * implemented a different interface. That source code is no longer used but still there for you
 * to take a look if you want. Now this one large source file has been split into several sources
 * namely. tf1TxtFldLsnr.java, tf1TxtFldLsnr.java, tf2TxtFldLsnr.java, tf3TxtFldLsnr.java,
 * tf4TxtFldLsnr.java, tf5TxtFldLsnr.java, tf6TxtFldLsnr.java, tf7TxtFldLsnr.java, tf8TxtFldLsnr.java,
 * tf9TxtFldLsnr.java, combo1TxtFldLsnr.java, combo2TxtFldLsnr.java, combo3TxtFldLsnr.java,
 * tf1MouseAdapter.java, tf2MouseAdapter.java, tf3MouseAdapter.java, tf4MouseAdapter.java,
 * tf5MouseAdapter.java, tf6MouseAdapter.java, tf7MouseAdapter.java, tf8MouseAdapter.java,
 * tf9MouseAdapter.java, combo1MouseAdapter.java, combo2MouseAdapter.java, combo3MouseAdapter.java
 * 
 * Technical References : None
 *
 * Musical Accompanyments : None
 *
 * Start Date: 3rd July 2012
 * End Date: 4th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
public class combo1TxtFldLsnr implements ActionListener {
    
    @Override
    public void actionPerformed (ActionEvent event){

        Validate();
        
    }
    
    static synchronized void Validate()
    {
            if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
            {
                if (Integer.parseInt(combo1.getSelectedItem().toString()) < 0 
                        || Integer.parseInt(combo1.getSelectedItem().toString()) > REALTABLES)
                {
                    combo1.setForeground(Color.RED);
                    //combo1.setFocusable(true);
                    //datasheetpanel.validate();
                    JOptionPane.showMessageDialog(datasheetpanel,
                                "Incorrect Values for Tableno " + '\n'
                                + "Correct values zero thru seventeen" + '\n' + "correct immediately");
                }


                if (ChoiceSheet.indxfiletabledatafilemap.get(Integer.parseInt(combo1.getSelectedItem().toString()))
                                                != null )
                {
                    combo1.setForeground(Color.RED);
                    // datasheetpanel.validate();
                    JOptionPane.showMessageDialog(datasheetpanel,
                                "This table number has a previous record " + '\n'
                                    + "duplicates not allowed" + '\n' + "correct immediately");
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
            {
                 if (Integer.parseInt(combo1.getSelectedItem().toString()) < 0 
                     || Integer.parseInt(combo1.getSelectedItem().toString()) > 8)
                 {
                    combo1.setForeground(Color.RED);
                    //combo1.setFocusable(true);
                    //datasheetpanel.validate();
                    JOptionPane.showMessageDialog(datasheetpanel,
                                            "Invalid Direction Valid Directions are" + '\n'
                                                + "zero thru eight" + '\n' + "correct immediately");
                 }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
            {
                if (Integer.parseInt(combo1.getSelectedItem().toString()) <= 0)
                {
                    combo1.setForeground(Color.RED);
                    //combo1.setFocusable(true);
                    //datasheetpanel.validate();
                    JOptionPane.showMessageDialog(datasheetpanel,
                                            "Payment ID must be 1 or higher"
                                                            + "\n" + "from one thru 10");
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
            {
                if (Integer.parseInt(combo1.getSelectedItem().toString()) <= 0)
                {
                    combo1.setForeground(Color.RED);
                    //combo1.setFocusable(true);
                    //datasheetpanel.validate();
                    JOptionPane.showMessageDialog(datasheetpanel,
                                                "Option ID must be 1 or higher"
                                                            + "\n" + "cant be zero or lower");
                }
            }        
    }
    
}
