/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import static DataEntryPrograms.SpreadSheet.dataentryframe;
import static DataEntryPrograms.DotingEntry.grassHopper;

import static DataEntryPrograms.DotingEntry.ErrorLogFile;

/*
 * WIRING DIAGRAM :
 * @LOOKSY : SpreadSheet.chosen_table.
 * Listener Class Name : lsButton implements ActionListener
 * Methods : Look in Class definition
 * Data Attributes : None
 *
 * Data File : None
 * Associated Methods : static void CreateTakenMarkerFile (String p_file)
 *                      public boolean LOAD () method of interface Data implemented by all table classes.
 * @Since Version 1.0
 *
 * Running Commentary : This class is a registered action listener for ChoiceSheet Button languagesupport.
 * It has just an actionPerformed method which calls CreateTakenMarkerFile (String p_file) method to create a
 * *.taken marker file. This marker file is created to prevent other users from picking the same table for data
 * entry. And then it sets SpreadSheet.chosen_table and calls the LOAD() method of interface Data to load data
 * into the SpreadSheet if any.
 *
 * Technical References : None
 *
 * Musical Accompanyments : AMERICA The Complete greatest Hits.
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class lsButton implements ActionListener {

    @Override
    public void actionPerformed (ActionEvent evnt)
    {
        if (ChoiceSheet.CreateTakenMarkerFile("languagesupport") == false)         
            return;
        
        JOptionPane.showMessageDialog(dataentryframe,
                "Taking you to SpreadSheet for table languagesupport");
        
        SpreadSheet.chosen_table = "languagesupport";
        if ( new languagesupport().LOAD() == false)
        {
            System.err.println(grassHopper(dataentryframe, "LOAD FAIL table languagesupport"));
            JOptionPane.showMessageDialog(dataentryframe, "LOAD FAILED table languagesupport");
            JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
        }
    }
}
