/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * @LOOKSY : SpreadSheet.chosen_action, SpreadSheet.table, SpreadSheet.dataentryframe, SpreadSheet.cells
 * Listener Class Name : ssDeleteButton implements ActionListener
 * Methods : Look in Class definition
 * Data Attributes : None
 *
 * Data File : None
 * Chained Methods : private void fillupcells(int index)
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class is a registered action listener for SpreadSheet Button Delete.
 * It has just an actionPerformed method which removes the user selected row of the SpreadSheet
 * from the SpreadSheet view contained in pane and it also removes the same row from underlying
 * data model by calling method fillupcells(int index).
 *
 * Technical References : None
 *
 * Musical Accompanyments : AMERICA The Complete greatest Hits.
 *
 * Start Date: 1st August 2011
 * End Date: 14th August 2011
 *
 * Last Modification Date : June 5th 2012
 * Last Modifications : I have created some HashMaps to be used as indexes in ChoiceSheet.java. These
 * are used to validate for unique key value entries for tables during data entry. But if the user
 * chooses to delete a certain row then that key value for the row has to be deleted from the indexes
 * in ChoiceSheet.java to keep them up to date and accurate. Look up the code patch below starting
 * with the code below.
               if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
               {
                   ChoiceSheet.indxfiletabledatafilemap.remove((Integer)SpreadSheet.table.getValueAt
                           (SpreadSheet.table.getSelectedRow(), 1));
               }
 *
 * 
 * Last Modifications Date : 4th July 2012
 * Last Modifications : Made quite a few changes to this entire source file. Just some re-arrangement
 * of calls. 
 * 
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class ssDeleteButton implements ActionListener {

    Object Cells [][] = null;
    
    @Override
    public void actionPerformed (ActionEvent evnt)
    {
           int index = SpreadSheet.table.getSelectedRow();
           String valuetodelete;     
           Integer valtodelete;

           SpreadSheet.chosen_action = "Delete";
           
           if (SpreadSheet.table.getSelectedRow() != -1)
           {
               SpreadSheet.SelectedRow = SpreadSheet.cells[SpreadSheet.table.getSelectedRow()];
               
               if (SpreadSheet.table.getValueAt(SpreadSheet.table.getSelectedRow(), 0) == null)
                   return;              

               if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
               {                   
                   valtodelete = Integer.parseInt(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0).toString());                   
                   ChoiceSheet.indxfiletabledatafilemap.remove(SpreadSheet.SelectedRow == null ? -1 :
                        valtodelete);                   
               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                                     SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 1).toString();
                     ChoiceSheet.indxlanguagesupport.remove(valuetodelete);
               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                             String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0)).trim()
                          +  String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 1));
                     ChoiceSheet.indxlanguagetitles.remove(valuetodelete);
               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                             String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0)).trim()
                          +  String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 1)).trim();
                     ChoiceSheet.indxlanguagetransalations.remove(valuetodelete);
               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                             String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0))
                          +  String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 1)).trim();
                     ChoiceSheet.indxpaymenttype.remove(valuetodelete);

               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                             String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0)).trim();
                     ChoiceSheet.indxpicturedatabase.remove(valuetodelete);

               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                             String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0)).trim()
                          +  String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 1))
                          + String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 2));
                     ChoiceSheet.indxpictureoptions.remove(valuetodelete);
               }
               else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
               {
                     valuetodelete = SpreadSheet.SelectedRow == null ? "":
                             String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 0))
                          +  String.valueOf(SpreadSheet.table.getValueAt
                             (SpreadSheet.table.getSelectedRow(), 1));
                     ChoiceSheet.indxsearchdatabase.remove(valuetodelete);
               }
               
               SpreadSheet.dataentryframe.remove(ChoiceSheet.choicesheetpanel);        
               ChoiceSheet.choicesheetpanel = null;
               SpreadSheet.dataentryframe.validate();
                              
               fillupcells(index);
               
               SpreadSheet.getColumns(SpreadSheet.chosen_table);               
           }        
           else
           {
               JOptionPane.showMessageDialog(SpreadSheet.dataentryframe, 
                       "Please Select a Row and then Delete");
               return;
           }
    }

    private void fillupcells(int index)
    {          
          int i = 0;     
          
          Cells = new Object[SpreadSheet.cells.length -1][];
          
          for ( ; i < SpreadSheet.cells.length -1; i++)
          {
               Cells[i] = new Object[SpreadSheet.cells[i].length];
               if (i < index)
               {                   
                   for (int k = 0; k < SpreadSheet.cells[i].length; k++)
                   {                                       
                       Cells [i][k] = new String (SpreadSheet.cells[i][k].toString());                      
                   }                  
               }
               else if (i >= index)
               {
                   for (int k = 0; k < SpreadSheet.cells[i+1].length; k++)
                   {                       
                        Cells [i][k] = new String (SpreadSheet.cells[i+1][k].toString());                      
                   }
               }
          }
          

          
          SpreadSheet.cells = new Object[Cells.length][];

          for (int ii = 0; ii < Cells.length; ii++)
          {
               SpreadSheet.cells[ii] = new Object [Cells[ii].length];
               for (int k = 0; k < Cells[ii].length; k++)
               {                   
                   // this toString returns a final so I dont want a final in cells[i][k]
                   // therefore i will call the String constructor again.
                   
                   SpreadSheet.cells [ii][k] = new String(Cells[ii][k].toString());
               }
          }

          System.gc();
    }
}
