/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataEntryPrograms;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:DataSheet.datasheetpanel, SpreadSheet.chosen_table, 
 * @LOOKSY:ChoiceSheet.indxdefaultadvertisingimages, ChoiceSheet.indxpaymenttype,
 * @LOOKSY:ChoiceSheet.indxpicturedatabase
 * Listener Class Name : public class tf1TxtFldLsnr implements ActionListener
 * Methods : Look in Class definition
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class implements a common listener interface for all DataSheets for different
 * chosen_table and it also validates input field in the DataSheet every time the data is changed by user.
 * Earlier implementation had just one Listener class called TxtFldLsnr.java for everything which
 * implemented a different interface. That source code is no longer used but still there for you
 * to take a look if you want. Now this one large source file has been split into several sources
 * namely. tf1TxtFldLsnr.java, tf1TxtFldLsnr.java, tf2TxtFldLsnr.java, tf3TxtFldLsnr.java,
 * tf4TxtFldLsnr.java, tf5TxtFldLsnr.java, tf6TxtFldLsnr.java, tf7TxtFldLsnr.java, tf8TxtFldLsnr.java,
 * tf9TxtFldLsnr.java, combo1TxtFldLsnr.java, combo2TxtFldLsnr.java, combo3TxtFldLsnr.java,
 * tf1MouseAdapter.java, tf2MouseAdapter.java, tf3MouseAdapter.java, tf4MouseAdapter.java,
 * tf5MouseAdapter.java, tf6MouseAdapter.java, tf7MouseAdapter.java, tf8MouseAdapter.java,
 * tf9MouseAdapter.java, combo1MouseAdapter.java, combo2MouseAdapter.java, combo3MouseAdapter.java
 * 
 * Technical References : None
 *
 * Musical Accompanyments : None
 *
 * Start Date: 3rd July 2012
 * End Date: 4th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
public class tf1TxtFldLsnr implements ActionListener {
        
    @Override
    public void actionPerformed (ActionEvent event){
        Validate();
    }
    
    static synchronized void Validate(){
        String txtval;
            DataSheet.tf1.setForeground(Color.GREEN);
            //DataSheet.datasheetpanel.validate();

            if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
            {
                txtval = DataSheet.tf1.getText();

                if (txtval.indexOf(' ') != -1)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Invalid Data File Name"
                            + "\n" + "Remove Spaces");
                    //DataSheet.datasheetpanel.validate();
                }

                if (new File(txtval).canRead() == false)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Invalid Data File Name"
                            + "\n" + "File does not exist" + '\n' + " or Read perms missing");
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
            {
                txtval = DataSheet.tf1.getText();

                char txtchars [] = txtval.toCharArray();

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (!(Character.isLetter(txtchars[i]) || txtchars[i] == '_' 
                            || txtchars[i] == '.' || Character.isDigit(txtchars[i])))
                    {
                        DataSheet.tf1.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                          "Invalid Characters in Image File Name Suggested ADVERT*.*");
                        //DataSheet.tf1.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }

                if (ChoiceSheet.indxdefaultadvertisingimages.get(txtval.trim()) != null)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Duplicate Image Name"
                            + "\n" + " Correct Immediately");
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
            {
                txtval = DataSheet.tf1.getText();
                int num = 0;
                try{
                    num = Integer.parseInt(txtval);
                }catch (NumberFormatException ex_NOKIA76){
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Language ID must be non decimal number"
                            + "\n" + " from one thru 36");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (num <= 0 || num > 50)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Language ID must be non decimal number"
                            + "\n" + " from one thru 50");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }                
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
            {
                txtval = DataSheet.tf1.getText();
                int num = 0;
                try{
                    num = Integer.parseInt(txtval);
                }catch (NumberFormatException ex_NOKIA76){
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Language ID must be non decimal number"
                            + "\n" + " from one thru 36");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (num <= 0 || num > 36)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Language ID must be non decimal number"
                            + "\n" + " from one thru 36");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
            {
                txtval = DataSheet.tf1.getText();
                char txtchars [] = txtval.toCharArray();

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (Character.isDigit(txtchars[i]))
                    {
                        DataSheet.tf1.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                                     "Description of Payment Type contains digits");
                        //DataSheet.tf1.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }

                    if (!(Character.isLetter(txtchars[i]) || Character.isSpaceChar(txtchars[i])))
                    {
                             DataSheet.tf1.setForeground(Color.RED);
                             JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                             "Description of Payment Type contains" + "\n" + "invalid special characters");
                             //DataSheet.tf1.setFocusable(true);
                             //DataSheet.datasheetpanel.validate();
                        
                    }
                }

                if (ChoiceSheet.indxpaymenttype.get(String.valueOf(DataSheet.combo1.getSelectedItem())
                        + txtval.trim()) != null)
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "This combination of Payment ID and Payment Type"
                            + "\n" + "has been entered previously Enter Unique"
                            + '\n' + "Combination. Correct Immediately");
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
            {
                txtval = DataSheet.tf1.getText();

                if (Character.isDigit(txtval.toCharArray()[0])
                        || Character.isDigit(txtval.toCharArray()[1]))
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes cant start with"
                            + "\n" + "digits in the first two places");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (!(txtval.startsWith("PIC") || txtval.startsWith("ST")))
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes must start with"
                            + "\n" + "PIC or ST followed by two digits");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (!(Character.isDigit(txtval.toCharArray()[txtval.length() -1])
                    && Character.isDigit(txtval.toCharArray()[txtval.length() -2])))
                {
                    DataSheet.tf1.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes must start with"
                            + "\n" + "PIC or ST followed by two digits");
                    //DataSheet.tf1.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (ChoiceSheet.indxpicturedatabase.get(txtval.trim()) != null)
                {
                       DataSheet.tf1.setForeground(Color.RED);
                       //DataSheet.datasheetpanel.validate();
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                       "This picture code has been entered before"
                                       + '\n' + "Enter Unique picture code");
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("pictureoptions"))
            {
                txtval = DataSheet.tf1.getText();
                if (txtval.trim().length() != 2)
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Language Codes can only be two lowercase letters"
                            + '\n' +  "Lookup http:// "
                            + '\n' + "For a valid list of language codes"
                            + '\n' + "This application only supports those"
                            + '\n' + "contained in howtoinstall.txt");
                DataSheet.tf1.setText(txtval.trim().toLowerCase()); // Added 26th June 2012
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("celebritytable"))
            {
                txtval = DataSheet.tf1.getText();
                char txtchars [] = txtval.toCharArray();
                for (int i = 0; i < txtchars.length; i++)
                {
                    if (Character.isLetter(txtchars[i]) == false)
                    {
                        if (txtchars[i] != '.' && txtchars[i] != ' ')
                        {
                            DataSheet.tf1.setForeground(Color.RED);
                            JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Invalid Celebrity Name");
                            //DataSheet.tf1.setFocusable(true);
                            //DataSheet.datasheetpanel.validate();
                        }
                    }
                }
            }        
    }
}
