/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataEntryPrograms;


import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Locale;
import javax.swing.JOptionPane;
import java.util.Date;
import static DataEntryPrograms.DotingEntry.FILESEPERATOR;


/*
 * WIRING DIAGRAM :
 * @LOOKSY:DataSheet.datasheetpanel, SpreadSheet.chosen_table, 
 * @LOOKSY:ChoiceSheet.indxsearchdatabase, ChoiceSheet.indxlanguagesupport,
 * @LOOKSY:ChoiceSheet.indxlanguagetransalations
 * Listener Class Name : public class tf2TxtFldLsnr implements ActionListener
 * Methods : Look in Class definition
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class implements a common listener interface for all DataSheets for different
 * chosen_table and it also validates input field in the DataSheet every time the data is changed by user.
 * Earlier implementation had just one Listener class called TxtFldLsnr.java for everything which
 * implemented a different interface. That source code is no longer used but still there for you
 * to take a look if you want. Now this one large source file has been split into several sources
 * namely. tf1TxtFldLsnr.java, tf1TxtFldLsnr.java, tf2TxtFldLsnr.java, tf3TxtFldLsnr.java,
 * tf4TxtFldLsnr.java, tf5TxtFldLsnr.java, tf6TxtFldLsnr.java, tf7TxtFldLsnr.java, tf8TxtFldLsnr.java,
 * tf9TxtFldLsnr.java, combo1TxtFldLsnr.java, combo2TxtFldLsnr.java, combo3TxtFldLsnr.java,
 * tf1MouseAdapter.java, tf2MouseAdapter.java, tf3MouseAdapter.java, tf4MouseAdapter.java,
 * tf5MouseAdapter.java, tf6MouseAdapter.java, tf7MouseAdapter.java, tf8MouseAdapter.java,
 * tf9MouseAdapter.java, combo1MouseAdapter.java, combo2MouseAdapter.java, combo3MouseAdapter.java
 * 
 * Technical References : None
 *
 * Musical Accompanyments : None
 *
 * Start Date: 3rd July 2012
 * End Date: 4th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
public class tf2TxtFldLsnr implements ActionListener {
    

    
    @Override
    public void actionPerformed (ActionEvent event){

        Validate();

    }
    
    static synchronized void Validate(){
            String txtval;
            Date ad;
            DataSheet.tf2.setForeground(Color.GREEN);
            //DataSheet.datasheetpanel.validate();
            if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
            {
                txtval = DataSheet.tf2.getText();
                if (txtval.indexOf('.') != -1 || txtval.indexOf(FILESEPERATOR) != -1 
                        || txtval.indexOf(' ') != -1) // Changed on 17th June 2012
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Invalid Persistent Storage File Name");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
            {
                txtval = DataSheet.tf2.getText();                

                if (txtval.indexOf('X') == -1 && txtval.indexOf('x') == -1 )
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for Image Size Input Value as " + "\n"
                    + "200X100 meaning 200 pixels height 100 pixels width");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (txtval.length() > 7)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for Image Size Input Value as " + "\n"
                    + "200X100 meaning 200 pixels height 100 pixels width");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                char lookfor = ' ';

                if (txtval.indexOf('X') != -1)
                    lookfor = 'X';
                else if (txtval.indexOf('x') != -1)
                    lookfor = 'x';

                int H = 0, W = 0;
                String h = null, w = null;

                h = txtval.substring(0, txtval.indexOf(lookfor));
                try{
                      H = Integer.parseInt(h);
                }catch (NumberFormatException ex_NOKIA91){
                       DataSheet.tf2.setForeground(Color.RED);
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                       "Invalid Value for Image Size Input Value as " + "\n"
                       + "200X100 meaning 200 pixels height 100 pixels width");
                       //DataSheet.tf2.setFocusable(true);
                       //DataSheet.datasheetpanel.validate();
                }

                if (H == 0 || H > 650)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for Image Size Input Value as " + "\n"
                    + "200X100 meaning 200 pixels height 100 pixels width" + "\n"
                    + "Height cant be zero or greater than 650");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                w = txtval.substring(0, txtval.indexOf(lookfor));
                try{
                        W = Integer.parseInt(w);
                }catch (NumberFormatException ex_NOKIA91){
                       DataSheet.tf2.setForeground(Color.RED);
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                       "Invalid Value for Image Size Input Value as " + "\n"
                       + "200X100 meaning 200 pixels height 100 pixels width");
                       //DataSheet.tf2.setFocusable(true);
                       //DataSheet.datasheetpanel.validate();
                }

                if (W == 0 || W > 650)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "Invalid Value for Image Size Input Value as " + "\n"
                    + "200X100 meaning 200 pixels height 100 pixels width" + "\n"
                    + "Width cant be zero or greater than 650");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagesupport"))
            {
                txtval = DataSheet.tf2.getText();


                char txtchars [] = txtval.toCharArray();

                for (int i = 0; i < txtchars.length; i++)
                {
                    if (!Character.isLetter(txtchars[i]))
                    {
                        DataSheet.tf2.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                     "Language Code must be two lowercase letters");
                        //DataSheet.tf2.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }

                for (int i = 0; i < txtchars.length; i++)
                {
                   if (Character.isUpperCase(txtchars[i]))
                   {
                       DataSheet.tf2.setForeground(Color.RED);
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                     "Language Code must be two lowercase letters");
                       //DataSheet.tf2.setFocusable(true);
                       //DataSheet.datasheetpanel.validate();
                   }
                }

                if (txtchars.length == 2)
                {
                    if (new Locale(txtval.trim()) == null)
                    {
                       DataSheet.tf2.setForeground(Color.RED);
                       //DataSheet.tf2.setFocusable(true);
                       //DataSheet.datasheetpanel.validate();
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                     "Invalid two letter ISO language code");
                    }
                }
                else  // Added on 25th June 2012
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                     "Invalid two letter ISO language code");
                }

                if (ChoiceSheet.indxlanguagesupport.get(txtval.trim()) != null)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                    "This ISO language code has a previous entry " + "\n"
                    + "You are entering a duplicate value" + "\n"
                    + "Correct Immediately");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
            {
                txtval = DataSheet.tf2.getText();


                if (Character.isDigit(txtval.toCharArray()[0])
                        || Character.isDigit(txtval.toCharArray()[1]))
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes cant start with"
                            + "\n" + "digits in the first two places");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                else if (!(txtval.startsWith("PIC") || txtval.startsWith("ST")))
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes must start with"
                            + "\n" + "PIC or ST followed by two digits");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                else if (!(Character.isDigit(txtval.toCharArray()[txtval.length() -1])
                    && Character.isDigit(txtval.toCharArray()[txtval.length() -2])))
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes must start with"
                            + "\n" + "PIC or ST followed by two digits");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (ChoiceSheet.indxlanguagetransalations.get(DataSheet.tf1.getText().trim() +
                        txtval.trim()) != null)
                {
                       DataSheet.tf2.setForeground(Color.RED);
                       //DataSheet.datasheetpanel.validate();
                       JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                     "This combination of Language ID and Picture Code" + '\n'
                                     + "has been entered previously Enter a unique combination");
                }

            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("paymenttype"))
            {
                int row = 0;
                txtval = DataSheet.tf2.getText();


                try{
                row = Integer.parseInt(txtval);
                }catch (NumberFormatException ex_NOKIA67){
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (row < 0)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be positive"
                            + "\n" + "and non decimal number");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();                    
                }
                if (SpreadSheet.table.getSelectedRow() > 0)
                {
                if (row != Integer.parseInt(SpreadSheet.cells[SpreadSheet.table.getSelectedRow() - 1][2].toString()) + 1)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Rowid must be Sequential");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                }
                else if (SpreadSheet.table.getSelectedRow() == 0)
                {
                    if (row != 0)
                    {
                        DataSheet.tf2.setForeground(Color.RED);
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Row ID must be zero");
                        //DataSheet.tf2.setFocusable(true);
                        //DataSheet.datasheetpanel.validate();
                    }
                }


            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
            {
                txtval = DataSheet.tf2.getText();
                
                String datingpattern = "EEE MMM dd HH:mm:ss zzz yyyy";
                SimpleDateFormat sd = null;
                sd = new SimpleDateFormat(datingpattern, Locale.getDefault ());

                try{
                ad = sd.parse(txtval);
                }catch (ParseException ex_NOKIA88){
                     DataSheet.tf2.setForeground(Color.RED);
                     JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                      "Invalid Database Add Date use Format" + "\n" + " EEE MMM dd HH:mm:ss zzz yyyy");
                     //DataSheet.tf2.setFocusable(true);
                     //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("searchdatabase"))
            {
                txtval = DataSheet.tf2.getText();
                if (Character.isDigit(txtval.toCharArray()[0])
                        || Character.isDigit(txtval.toCharArray()[1]))
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes cant start with"
                            + "\n" + "digits in the first two places");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (!(txtval.startsWith("PIC") || txtval.startsWith("ST")))
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes must start with"
                            + "\n" + "PIC or ST followed by two digits");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
                if (!(Character.isDigit(txtval.toCharArray()[txtval.length() -1])
                    && Character.isDigit(txtval.toCharArray()[txtval.length() -2])))
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Picture Codes must start with"
                            + "\n" + "PIC or ST followed by two digits");
                    //DataSheet.tf2.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (ChoiceSheet.indxsearchdatabase.get(DataSheet.tf1.getText() + txtval) != null)
                {
                    DataSheet.tf2.setForeground(Color.RED);
                    //DataSheet.datasheetpanel.validate();
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "This combination of Keyword and Picture Code"
                            + "\n" + "has been used previously Re-Enter");
                }

            }
    }
}
