/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package DataEntryPrograms;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.lang.Character.UnicodeBlock;
import java.nio.charset.Charset;
import javax.swing.JFormattedTextField;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:DataSheet.datasheetpanel, SpreadSheet.chosen_table, 
 * Listener Class Name : public class tf5TxtFldLsnr implements ActionListener
 * Methods : Look in Class definition
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class implements a common listener interface for all DataSheets for different
 * chosen_table and it also validates input field in the DataSheet every time the data is changed by user.
 * Earlier implementation had just one Listener class called TxtFldLsnr.java for everything which
 * implemented a different interface. That source code is no longer used but still there for you
 * to take a look if you want. Now this one large source file has been split into several sources
 * namely. tf1TxtFldLsnr.java, tf1TxtFldLsnr.java, tf2TxtFldLsnr.java, tf3TxtFldLsnr.java,
 * tf4TxtFldLsnr.java, tf5TxtFldLsnr.java, tf6TxtFldLsnr.java, tf7TxtFldLsnr.java, tf8TxtFldLsnr.java,
 * tf9TxtFldLsnr.java, combo1TxtFldLsnr.java, combo2TxtFldLsnr.java, combo3TxtFldLsnr.java,
 * tf1MouseAdapter.java, tf2MouseAdapter.java, tf3MouseAdapter.java, tf4MouseAdapter.java,
 * tf5MouseAdapter.java, tf6MouseAdapter.java, tf7MouseAdapter.java, tf8MouseAdapter.java,
 * tf9MouseAdapter.java, combo1MouseAdapter.java, combo2MouseAdapter.java, combo3MouseAdapter.java
 * 
 * Technical References : None
 *
 * Musical Accompanyments : None
 *
 * Start Date: 3rd July 2012
 * End Date: 4th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
public class tf5TxtFldLsnr implements ActionListener {
    static String prevfont = "sw";
    
    @Override
    public void actionPerformed (ActionEvent event){

        Validate();

    }
    
    static synchronized void Validate()
    {
            
            String txtval;
            DataSheet.tf5.setForeground(Color.GREEN);
            //DataSheet.datasheetpanel.validate();

            if (SpreadSheet.chosen_table.equalsIgnoreCase("filetabledatafilemap"))
            {
                txtval = DataSheet.tf5.getText();
                if (txtval.equals("U") == false && txtval.equals("L") == false)
                {
                    DataSheet.tf5.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel, "Lock Status should be U or L");
                    //DataSheet.tf5.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("defaultadvertisingimages"))
            {
                txtval = DataSheet.tf5.getText();

                if (txtval.length() == 0 || txtval.length() > 1)
                {
                    DataSheet.tf5.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                     "Invalid Value for Image Type" + "\n" + " Valid Values U (User Loaded Advert)"
                     + "\n" + " or D (Default Advert)");
                    //DataSheet.tf5.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (txtval.toCharArray()[0] != 'U' && txtval.toCharArray()[0] != 'D'
                        && txtval.toCharArray()[0] != 'P')
                {
                    DataSheet.tf5.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                     "Invalid Value for Image Type" + "\n" + " Valid Values U (User Loaded Advert)"
                     + "\n" + " or D (Default Advert)");
                    //DataSheet.tf5.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetransalations"))
            {
                txtval = DataSheet.tf5.getText();

                if (txtval.trim().length() == 0)
                {
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "ERROR:Empty File Name Specified");
                    //DataSheet.tf5.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                // Added on 17th June 2012
                if (txtval.indexOf(' ') != -1)
                {
                    DataSheet.tf5.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Spaces not allowed");
                    //DataSheet.tf5.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();
                }

                if (new File(DataSheet.tf5.getText()).exists())
                {
                    if (new File(DataSheet.tf5.getText()).canRead() == false)
                    {
                        DataSheet.tf5.setForeground(Color.RED);
                        //DataSheet.datasheetpanel.validate();
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                       "Read Perms missing on Filename" + '\n'
                                       + txtval);
                    }
                }
                else
                {
                        DataSheet.tf5.setForeground(Color.RED);
                        //DataSheet.datasheetpanel.validate();
                        JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                                       "Filename does not exist on disk :" + '\n'
                                       + "OR it could be a invalid Filename"
                                       + '\n' + "Correct Immediately" + '\n'
                                       + txtval);
                }
            }
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("picturedatabase"))
            {
                txtval = DataSheet.tf5.getText();
                char txtchars [] = txtval.toCharArray();
                int c = 0;
                for (int i = 0; i < txtchars.length; i++)
                {
                    if (txtchars[i] == ' ')
                        c++;
                }

                if (c > 3)
                {
                    DataSheet.tf5.setForeground(Color.RED);
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "One or Two or Three or Four Word Picture Title");
                    //DataSheet.tf5.setFocusable(true);
                    //DataSheet.datasheetpanel.validate();     
                }
            }  
            else if (SpreadSheet.chosen_table.equalsIgnoreCase("languagetitles"))
            { // Hope this works. Nope it recognises as Tamil and EditValid but cant display
               boolean done = false;
              /*                  
                if (DataSheet.tf3.getText().equals("ta"))
                if (isTamil(DataSheet.tf5.getText()))
                    System.out.println("Eureka I have discovered buoyancy");
                JFormattedTextField ftf = new JFormattedTextField (DataSheet.tf5.getText());
                if (ftf.isEditValid()) System.out.println(ftf.getValue().toString()); */
                if (DataSheet.tf3.getText().equals("ta"))
                {                
                /* This stunt dont work so lets try the above stunt 
                Charset cset = Charset.forName("ISCII91");
                txtval = DataSheet.tf5.getText();
                ByteBuffer buffer = cset.encode(txtval);
                byte [] bytes = buffer.array();
                ByteBuffer bbuf = ByteBuffer.wrap(bytes, 0, bytes.length);
                CharBuffer cbuf = cset.decode(bbuf);
                DataSheet.tf5.setText(cbuf.toString());
                */
                }

            }
    }
    
    
    static boolean isTamil(String text){   
        boolean result = true;   
        UnicodeBlock tamilBlock = UnicodeBlock.forName("TAMIL");   
        for(int i=0, k = 0; i<text.length(); i++){   
           k = text.charAt(i); 
           UnicodeBlock charBlock = UnicodeBlock.of(k);   
           if(!tamilBlock.equals(charBlock)){   
              result = false;   
           }   
        }   
        return result;
   }    
}
