/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.io.IOException;
import java.awt.Image;
import java.io.File;
import javax.imageio.ImageIO;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.GridBagConstraints;
import java.awt.Font;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.Color;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.cartpanel;
import static MaintainData.FirstPage.convertCurrency;
import static MaintainData.LiveDB.sc;
import static MaintainData.LanguagePanel.SelectedLanguage;
/**
 *
 * @author pskris
 */
public class CartPanel {

    GridBagConstraints constraints = null;
    // remove this declaration and its usage everywhere 9th August 2012
    // String langstring [] = null;
    JLabel img = null;
    JLabel sb = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Shopping Basket")
            == null ? "Shopping Basket" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Shopping Basket"));
    JLabel empty = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your basket is empty")
            == null ? "Your basket is empty" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your basket is empty"));
    JLabel full = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "You have shopped")
            == null ? "You have shopped" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "You have shopped"));
    JLabel items = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Items in cart")
            == null ? "Items in cart:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Items in cart") + ":");
    JLabel total = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Total")
            == null ? "Total:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Total") + ":");
    JLabel totitems = null;
    JLabel totamt = null;
    //final JButton basket = new JButton(langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket")
    //        == null ? "View Basket" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket"));
    final JButton basket = new JButton(LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket")
            == null ? "View Basket" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket"));
    ViewBasketPanel thisbasket ; // 17th August 2012
    
    public CartPanel ()
    {
        int MF = 10;

        cartpanel = new JPanel(new GridBagLayout());
        cartpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        cartpanel.setBackground(Color.WHITE);
        
        cartpanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.cataloguepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/MF,
                (int)(LensView.DEFAULT_HEIGHT)/6);

        addcartpanel();
    }
    
    void addcartpanel()
    {

        long totalitems = 0L;
        Float totalamt = 0.0F;
        Image image = null;
        int infoflags = 0;
        
        try{
            image = ImageIO.read(new File(LiveDB.serializedfilespath + LiveDB.FILESEPERATOR
                + "etc" + LiveDB.FILESEPERATOR + "cart.jpg"));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" +
            LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "etc" + LiveDB.FILESEPERATOR + "cart.jpg"));
        }

        sb.setForeground(Color.BLACK);
        sb.setFont (new Font(LiveDB.USEFONT, Font.BOLD, 9)); // 17th August 2012

        empty.setForeground(Color.BLUE);
        full.setForeground(Color.GREEN);
        items.setForeground(Color.BLUE);
        total.setForeground(Color.BLUE);

        basket.setBackground(Color.ORANGE);

        for (int rw = LiveDB.LiveSharedDB[sc].length -1; rw >= 0; rw--)
        {
              if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getShopdate().after(LiveDB.today))
              {
                  if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getBilled() <= 1)
                  {
                      if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getCid().
                              indexOf(FirstPage.loginname) != -1)
                      {
                         totalitems = totalitems + ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getPic_qty();
                         totalamt = totalamt + ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getTotal();
                      }
                  }
              }
        }

        totitems = new JLabel (" " + totalitems);
        totamt = new JLabel (" " + convertCurrency(totalamt));        
        if (totalitems == 0)
        {
            totitems.setForeground(Color.RED);
            totamt.setForeground(Color.RED);
        }
        else
        {
            totitems.setForeground(Color.GREEN);
            totamt.setForeground(Color.GREEN);
        }

        
        cartpanel.add(sb,setConstraints(0,0,1,1));
        cartpanel.add(totalitems == 0 ? empty : full, setConstraints (0,1,1,1));

        // get this components graphics context and then draw dont do what that idiot wrote in the book.
        if (cartpanel.getGraphics().drawImage(image, 3, 1, 1, 1, null) == false)
        {
            cartpanel.imageUpdate(image, infoflags, 3, 1, 1, 1);
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" +
            LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "etc" + LiveDB.FILESEPERATOR + "cart.jpg"));
        }
        
        // cartpanel.imageUpdate(image, 3, 3, 1, 1, 1);
        cartpanel.add(items, setConstraints(0,2,1,1));
        cartpanel.add(totitems, setConstraints(3,2,1,1));
        cartpanel.add(total,setConstraints(0,3,1,1));
        cartpanel.add(totamt, setConstraints(3,3,1,1));
        cartpanel.add(basket, setConstraints(2,4,1,1));

        basket.addMouseListener(new MouseListener(){
            @Override
            public void mousePressed (MouseEvent evnt){
                basket.setBackground(Color.GREEN);
                basket.validate();
            }
            @Override
            public void mouseEntered (MouseEvent evnt){
                basket.setBackground(Color.GREEN);
                basket.validate();
            }
            @Override
            public void mouseClicked (MouseEvent evnt){
                thisbasket = new ViewBasketPanel (); // 17th August 2012
            }
            @Override
            public void mouseReleased (MouseEvent evnt){
                basket.setBackground(Color.ORANGE);
                basket.validate();
            }
            @Override
            public void mouseExited (MouseEvent evnt){
                basket.setBackground(Color.ORANGE);
                basket.validate();
            }
        });
        cartpanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
