/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.applet.Applet;
import java.io.File;
import java.net.MalformedURLException;
import java.net.URL;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : JukeBox
 *
 * Date File : String p_path passed to constructor
 *
 * Called From : protected static boolean PlayAudio (String p_path, JPanel p_panel, String p_size)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct and then the music file passed to
 * it as a parameter. Even if the music file is invalid log the error but dont do a System.exit(1).
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class JukeBox extends Applet implements Runnable {

    Thread audioplay = null;
    URL music = null;

    public JukeBox (String p_musicfile)
    {
        try{
             music = new URL (p_musicfile);
        }catch (MalformedURLException ex_YESKIA74){
            try{
                music = new File (p_musicfile).toURI().toURL();
            }catch (MalformedURLException ex_YESKIA77){
                LiveDB.ALRTLVL = 3;
                music = null;
                System.err.println(LiveDB.grassHopper(ex_YESKIA77, "Invalid Music File:" + p_musicfile));
            }
        }
        audioplay = new Thread(this);
        audioplay.start();
    }

    @Override
    public void run (){
        this.play(music);
    }
}
