/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import javax.swing.JOptionPane;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Font;
import javax.swing.JButton;
import java.awt.GridBagConstraints;
import javax.swing.JTextField;
import javax.swing.JLabel;
import java.awt.Color;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.maillistpanel;
import static MaintainData.LanguagePanel.SelectedLanguage;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : MailListPanel
 *
 * @LOOKSY : LiveDB.SendNotificationEmail
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Mail List Panel at east corner
 * of screen. It collects email ids from Guests who wish to subscribe in addition to customers whoose
 * email ids are already registered in the database.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * Last Modified : 14th October 2011
 * Last Modifications : changed this patch of code to validate the Email Id supplied by user
            public void actionPerformed (ActionEvent evnt)
            {
                String webstarturl = " ";
                // later on plug in your web start URL here for Option 1 along with this friendly message
                // so he downloads the software immediately and starts using it
                String invite = "KUTHTAAA KAMINAAA LEKIN HAR EK FRIEND ZAROORI HOTHA HAI" + '\n'
                                + "TRA LA LA LALA LALA LAAA" + '\n' + webstarturl;

                if (LiveDB.PrepareAndSendMailMesg(null, null, tb.getText().trim(), null, null,
                    "EMAIL FROM " + LiveDB.NODENAME, invite, null))
                    LiveDB.SendNotificationEmail("LEKIN HAR EK FRIEND ZAROORI HOTHA HAI :" + tb.getText().trim());
                else
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "The Email Id you typed :" + tb.getText().trim()
                            + '\n' + "Is not functional Re-Type new Email");
                    tb.setText(" ");
                    tb.setFocusable(true);
                    tb.validate();
                }
            }
 *
 * 
 * Last Modification DAte : 11th August 2012
 * Last Modifications : MArkd as 11th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : search for LiveDB.USEFONT
 * 
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class MailListPanel {

    GridBagConstraints constraints = null;
    // removed declaration and its usage  11th August 2012
    //String langstring [] = null;
    JLabel ml = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Mailing List")
            == null ? "Mailing List" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Mailing List"));
    JLabel msg = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Subscribe to mail list below")
            == null ? "Subscribe to mail list below:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Subscribe to mail list below") + ":");
    JLabel eml = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Email")
            == null ? "Email" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Email"));
    JTextField tb = new JTextField ();
    final JButton jn = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Join Now")
            == null ? "Join Now" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Join Now"));

    public MailListPanel ()
    {
        int MF = 10;
        maillistpanel = new JPanel (new GridBagLayout());
        maillistpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        maillistpanel.setBackground(Color.WHITE);
        maillistpanel.setBounds((int)(FirstPage.pageonetextpanel.RIGHT_ALIGNMENT * MF) + 1,
                (int)(FirstPage.salepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.salepanel.RIGHT_ALIGNMENT * MF) - (int)(FirstPage.salepanel.LEFT_ALIGNMENT * MF),
                ((int)(FirstPage.popularpanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.popularpanel.TOP_ALIGNMENT * MF))/2);
        addmaillistpanel();
    }

    void addmaillistpanel ()
    {
        ml.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 10));
        maillistpanel.add(ml, setConstraints(0,0,1,1));
        maillistpanel.add(msg,setConstraints(0,2,1,1));
        maillistpanel.add(eml,setConstraints(0,3,1,1));
        maillistpanel.add(tb, setConstraints(2,3,1,1));
        jn.setBackground(Color.ORANGE);
        jn.setForeground(Color.WHITE);
        jn.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 10));
        maillistpanel.add(jn, setConstraints(2,4,1,1));
        
        jn.addActionListener(new ActionListener()
        {
            @Override
            public void actionPerformed (ActionEvent evnt)
            {
                String webstarturl = " ";
                // later on plug in your web start URL here for Option 1 along with this friendly message
                // so he downloads the software immediately and starts using it
                String invite = "KUTHTAAA KAMINAAA LEKIN HAR EK FRIEND ZAROORI HOTHA HAI" + '\n'
                                + "TRA LA LA LALA LALA LAAA" + '\n' + webstarturl;

                if (LiveDB.PrepareAndSendMailMesg(null, null, tb.getText().trim(), null, null,
                    "EMAIL FROM " + LiveDB.NODENAME, invite, null))
                    LiveDB.SendNotificationEmail("LEKIN HAR EK FRIEND ZAROORI HOTHA HAI :" + tb.getText().trim());
                else
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "The Email Id you typed :" + tb.getText().trim()
                            + '\n' + "Is not functional Re-Type new Email");
                    tb.setText(" ");
                    tb.setFocusable(true);
                    tb.validate();
                }
            }
        });
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
