/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import javax.swing.JOptionPane;
import javax.swing.border.BevelBorder;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JButton;
import javax.swing.JTextField;
import java.awt.Font;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JPasswordField;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.registerpanel;
import static MaintainData.LanguagePanel.SelectedLanguage;
import static MaintainData.LiveDB.sd;
import java.util.Arrays;
import java.util.Date;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : RegisterPanel
 *
 * @LOOKSY : LensView.DEFAULT_HEIGHT, LiveDB.appframe
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Registration Panel at the
 * nort east corner of the screen which contain your local weather readings and Search For text field
 * and options such as login logout register etc.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 * 
 * Last Modification Date : 11th August 2012
 * Last Modifications : MArked as 11th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * I have declared a new variable returnval []. This is needed to collect the newly constructed
 * objects in the code. If this is not used a new Object will be created but the JVM may view 
 * these objects as Orphans and garbage collect them.
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : search for LiveDB.USEFONT
 * 
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class RegisterPanel
{
    GridBagConstraints constraints = null;
    static JPasswordField passwordfld;
    protected static String custname = LoginPage.LoggedInCID == null ? "Guest": LoginPage.LoggedInUserName;

    // keep these as final because if the user presses the back button on the browser
    // the mouseclicks should still work because the mouselistener is added to a final
    // reference. So the final will be usefull as an anchor.
    // removed declaration and its usage 11th August 2012
    //String langstring [] = null;
    final JLabel login = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Login")
            == null ? "Login|" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Login") + "|");
    final JLabel register = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Register")
            == null ? "Register|" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Register") + "|");
    final JLabel logout = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Logout")
            == null ? "Logout" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Logout"));
    JButton jbtn = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Go")
            == null ? "Go" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Go"));
    JTextField txfld = new JTextField ("PIC", 45);
    JLabel srch = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Search for")
            == null ? "Search for:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Search for"));
    String Cloudy = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Clouds")
            == null ? "Clouds" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Clouds");
    JLabel wel = new JLabel(LiveDB.indxlanguageTitles.get(SelectedLanguage + "Welcome" )
            == null ? "Welcome Guest" + (LiveDB.CLOUDY ? "  " + Cloudy : " Sunny")
            : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Welcome" ) + " " + custname
            + (LiveDB.CLOUDY ? " " + Cloudy : " Sunny"));
    
    JLabel Farenheit = new JLabel ("Temperature:" + LiveDB.TEMPERATURE.substring(0,8));

    JLabel Rain = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Rain")
            == null ? " Rainy" : ' ' + LiveDB.indxlanguageTitles.get(SelectedLanguage + "Rain"));

    String SearchResultsPicCodes [] = null;
    
    Object retval [] = new Object [4]; // 17th August 2012

    public RegisterPanel ()
    {
        int MF = 10;
        registerpanel = new JPanel(new GridBagLayout());
        registerpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        registerpanel.setBackground(Color.GRAY);
        registerpanel.setBounds((int)LiveDB.appframe.RIGHT_ALIGNMENT * MF -
        (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/16 * 14,
                (int)(LiveDB.appframe.TOP_ALIGNMENT * MF),
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/16 * 2,
                (int)(LensView.DEFAULT_HEIGHT)/7);

        addregisterpanel();
    }

    void addregisterpanel()
    {
        srch.setForeground(Color.DARK_GRAY);
        srch.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 10));

        jbtn.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        jbtn.setBackground(Color.ORANGE);
        jbtn.setForeground(Color.WHITE);
        jbtn.setBorder(BorderFactory.createEtchedBorder(Color.ORANGE, Color.WHITE));

        wel.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 8));
        wel.setForeground(Color.DARK_GRAY);
        Farenheit.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 8));
        Farenheit.setForeground(Color.ORANGE);
        login.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 8));
        login.setForeground(Color.BLUE);
        logout.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 8));
        logout.setForeground(Color.BLUE);
        Rain.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 8));
        Rain.setForeground(Color.RED);

        register.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 8));
        register.setForeground(Color.BLUE);

        registerpanel.add(srch, setConstraints(1,1,2,1));
        registerpanel.add(Farenheit, setConstraints(3,1,2,1));
        
        registerpanel.add(txfld, setConstraints(1,4,1,1));

        registerpanel.add(jbtn, setConstraints(4,2,1,1));
        jbtn.addMouseListener(new MouseListener()
        {
            @Override
            public void mousePressed (MouseEvent evnt)
            {
                jbtn.setForeground(Color.ORANGE);
                jbtn.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
                jbtn.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt)
            {
                jbtn.setForeground(Color.BLUE);
                jbtn.validate();
            }

            @Override
            public void mouseEntered (MouseEvent evnt)
            {
                jbtn.setForeground(Color.ORANGE);
                jbtn.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt)
            {
                jbtn.setForeground(Color.BLUE);
                jbtn.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt)
            {
                String keyword = null;
                
                if (txfld.getText().trim().length() == 0)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe,
                       "Spaces not permitted in Search Text Re-Enter.");
                    txfld.setText("PIC01");
                    txfld.setFocusable(true);
                }

                if (txfld.getText().trim().indexOf("PIC") != -1)
                {
                    // maybe a picture code to search for
                    if (LiveDB.indxpictureDatabase.get(txfld.getText().trim()) == null)
                    {
                        JOptionPane.showMessageDialog(LiveDB.appframe,
                                "Sorry cant find " + txfld.getText().trim() + '\n'
                                + " in our Search Database Re-Try");
                        txfld.setText("search word");
                        txfld.setFocusable(true);
                    }
                    else
                    {
                        JOptionPane.showMessageDialog(LiveDB.appframe,
                                "Please Wait Searching Database");
                        for (int rw = 0; rw < LiveDB.LiveSharedDB[sd].length; rw++)
                        {
                            if (((SearchDatabase)LiveDB.LiveSharedDB[sd][rw]).getKeyword()
                                 .equalsIgnoreCase(keyword))   
                            {
                                // grow this array 11th August 2012
                                SearchResultsPicCodes = SearchResultsPicCodes == null ? new String[1]:
                                        Arrays.copyOf(SearchResultsPicCodes,SearchResultsPicCodes.length + 1);
                                SearchResultsPicCodes[SearchResultsPicCodes.length -1] =
                                     ((SearchDatabase)LiveDB.LiveSharedDB[sd][rw]).getPic();  
                            }
                        }
                        // 17th August 2012
                        retval [0] = new SearchResultsPage(SearchResultsPicCodes);
                    }
                }

                // okays it could be a  keyword
                if (LiveDB.indxsearchDatabase.get(txfld.getText().trim()) == null)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe,
                                "Sorry cant find " + txfld.getText().trim() + '\n'
                                + " in our Search Database Re-Try");
                    txfld.setText("search word");
                    txfld.setFocusable(true);
                }
                else
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe,
                                "Please Wait Searching Database");
                    for (int rw = 0; rw < LiveDB.LiveSharedDB[sd].length; rw++)
                    {
                         if (((SearchDatabase)LiveDB.LiveSharedDB[sd][rw]).getKeyword()
                                 .equalsIgnoreCase(keyword))
                         {
                             // grow this array 11th August 2012
                             SearchResultsPicCodes = SearchResultsPicCodes == null ? new String[1]:
                                     Arrays.copyOf(SearchResultsPicCodes, SearchResultsPicCodes.length + 1);                           
                             SearchResultsPicCodes[SearchResultsPicCodes.length -1] =
                                     ((SearchDatabase)LiveDB.LiveSharedDB[sd][rw]).getPic();
                         }
                    }
                    // 17th August 2012
                    retval [1] = new SearchResultsPage(SearchResultsPicCodes);
                }
            }
        });

        registerpanel.add(wel, setConstraints(1,3,1,1));
        
        registerpanel.add(login, setConstraints(1,4,1,1));        
        registerpanel.add(register, setConstraints(2,4,1,1));
        registerpanel.add(logout, setConstraints(4,4,1,1));
        if (LiveDB.RAINY)
            registerpanel.add(Rain, setConstraints(5,4,1,1));

        login.addMouseListener(new MouseListener()
        {
            @Override
            public void mousePressed (MouseEvent evnt)
            {
                login.setForeground(Color.ORANGE);
                login.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
                login.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt)
            {
                login.setForeground(Color.BLUE);
                login.validate();
            }

            @Override
            public void mouseEntered (MouseEvent evnt)
            {
                login.setForeground(Color.ORANGE);
                login.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt)
            {
                login.setForeground(Color.BLUE);
                login.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt)
            {
                // 17th August 2012
                retval [2] = new LoginPage ();
            }
        });

        register.addMouseListener(new MouseListener()
        {
            @Override
            public void mousePressed (MouseEvent evnt)
            {
                register.setForeground(Color.ORANGE);
                register.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
                register.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt)
            {
                register.setForeground(Color.BLUE);
                register.validate();
            }

            @Override
            public void mouseEntered (MouseEvent evnt)
            {
                register.setForeground(Color.ORANGE);
                register.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt)
            {
                register.setForeground(Color.BLUE);
                register.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt)
            {
                // 17th August 2012
                retval [3] = new RegistrationPage ();
            }
        });   

        logout.addMouseListener(new MouseListener()
        {
            @Override
            public void mousePressed (MouseEvent evnt)
            {
                logout.setForeground(Color.RED);
                logout.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
                logout.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt)
            {
                logout.setForeground(Color.BLUE);
                login.validate();
            }

            @Override
            public void mouseEntered (MouseEvent evnt)
            {
                logout.setForeground(Color.RED);
                logout.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt)
            {
                logout.setForeground(Color.BLUE);
                logout.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt)
            {
                LoginPage.LoggedInCID = null;
                LiveDB.usersloggedin --; // 16th August 2012
                // set the customer logout time when he logs out
                // set setCustlastdate after the user is invoiced
                ((CustomerRegister)LiveDB.LiveSharedDB[LiveDB.cr][LoginPage.LoggedInCustRow]).setCustlogouttime(new Date());
                LiveDB.LiveSharedDB[LiveDB.ct][LiveDB.growMore(LiveDB.ct)] =
                new ChangeTracker ((long)LiveDB.cr,LoginPage.LoggedInCustRow, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[LiveDB.cr][LoginPage.LoggedInCustRow],
                        (long)LiveDB.LiveSharedDB[LiveDB.ct].length -1);                
            }
        });
        registerpanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();        
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
