/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package MaintainData;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.io.File;
import java.io.IOException;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import javax.swing.JOptionPane;
import javax.swing.JProgressBar;

/*
 * WIRING DIAGRAM : THREAD NAME : InstallDB.threadsysexit CLASS NAME :
 * SystemExit @LOOKSY:ChangeTracker.java @LOOKSY:InstalledTables.java
 *
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[] Dont
 * read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.SmoothExitCondition,
 * LiveDB.system_exit, LiveDB.SerializeJustOnceTable(),
 * LiveDB.tablenameidentifier, LiveDB.SendLogFileMessage(),
 * LiveDB.commit_database(), LiveDB.write_IndexFile() @LOOKSY:SystemExit.java
 * run () method
 *
 * Method Name : public void run ()
 *
 * Parameters : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Your flight is landing now a smooth touchdown sometime
 * even when there are errors on board. It is not a belly landing. So it does a
 * smooth touch down. It slow commits all tables not yet committed and then
 * writes all indexes and exits.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010 End Date: 11th May 2011
 *
 * Last Modification Date : 13th August 2012 Last Modifications : Marked as 13th
 * August 2012
 *
 * Last Modification Date : 15th Augustus 2012 Last Modification : Through out
 * this source file I have added this call to LiveDB.growMore(ct) whereever I am
 * growing the LiveDB.LiveSharedDB array with a call to new. growMore is a
 * popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash.
 * And when you cook vegetable add Harissa (mild Afrikan spice from North
 * Afrika) one ladel along with Bagar.
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna Email : pskris@sify.com Phone(s) :
 * +91-80-41689002 +91-80-23624473 Mobile : +91-9900516842 Residential Address
 * for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
final class SystemExit extends LiveDB implements Runnable, CommitDatabase {

    Lock SysExitLock = new ReentrantLock(true);
    boolean ok = true;

    @Override
    public void run() {

        int thisrow = 0;
        int thatrow = 0;



        // grow the array 13th August 2012
        ThreadController.TakeOffTimes = ThreadController.TakeOffTimes == null ? new Date[5]
                : Arrays.copyOf(ThreadController.TakeOffTimes, 11);
        ThreadController.TakeOffTimes[4] = new Date();

        if (new File(LiveDB.serializedfilespath + "daemon").canWrite()) {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                    + "daemon"));
        } else {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false) {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                        + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                //LiveDB.SmoothExitCondition.signalAll();
            }
        }

        try {
            new File(LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
                    + LiveDB.pid + LiveDB.NODENAME + ".daemon").createNewFile();
        } catch (IOException ex_YESKIA41) {
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:"
                    + LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
                    + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        } // to hell with this error it wont happen continue processing

        SysExitLock.lock();

        try {
            LiveDB.SmoothExitCondition = SysExitLock.newCondition();
            while (LiveDB.system_exit == 0) {
                try {
                    LiveDB.SmoothExitCondition.await(7L, TimeUnit.SECONDS);
                } catch (InterruptedException ex_YESKIA7) { // Spurious Interrupt
                    LiveDB.SmoothExitCondition.signalAll();
                    continue;
                }
            }
            LiveDB.SmoothExitCondition.signalAll();

            JOptionPane.showMessageDialog(appframe, LiveDB.versionControl.getApplicationName()
                    + " SHUTDOWN STARTED. THIS WILL TAKE THREE MINUTES"
                    + '\n' + "PLEASE WAIT ANOTHER MESSAGE DIALOG BOX WILL APPEAR" + '\n'
                    + "INDICATING SHUTDOWN COMPLETION.");

            // THIS PROGRESS BAR STUFF DOES NOT WORK
            // PLEASE TRY IT. IT THROWS A NULL POINTER EXCEPTION
            // CANT FIGURE OUT WHY
            //JProgressBar progressbar = new JProgressBar(0,100);    
            //progressbar.setName("SHUTDOWN STARTED/PROGRESS");
            //progressbar.setStringPainted(true);
            //progressbar.setIndeterminate(false);
            //progressbar.setFont(new Font(Font.DIALOG, Font.BOLD, 22));
            //progressbar.setBackground(Color.YELLOW);
            //progressbar.setSize(800, 100);
            //progressbar.setLocation(8, 8);
            //appframe.add(progressbar);
            //progressbar.setVisible(true); 

            System.gc(); // to avoid java.lang.OutOfMemoryError

            /*
             * First check on ChangeTracker table for flag 'I' or 'U' or 'D'
             * such tables are the only ones that need a commit all other tables
             * have been fastcomitted.
             */

            //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 1 OF 10 (10%)");
            //progressbar.validate();

            HashMap<Long, String> committables = new HashMap<Long, String>();
            Set<Long> committablesset = new HashSet<Long>();

            for (int i = (int) LiveDB.CTSR; i < LiveDB.LiveSharedDB[ct].length; i++) {
                if (((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getDmldate().after(LiveDB.today)
                        || ((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getDmldate().compareTo(LiveDB.today) == 0) {
                    if (((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'U'
                            || ((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'I'
                            || ((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'D'
                            || ((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'J'
                            || ((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'R') {
                        if (((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getPid() == LiveDB.pid) {
                            if (LiveDB.ENABLEFASTCOMMIT || LiveDB.command_line != null) {
                                committables.put(((ChangeTracker) LiveDB.LiveSharedDB[ct][i]).getTableno(), "somejunk");
                            }
                            // else ENABLEFASTCOMMIT is false and commits are under programmer control and for
                            // whatever reasons he has not commited these tables
                        }
                    }
                }
            }

            // just put one more table if it is not there
            committables.put(1L, "somejunk");
            committablesset = committables.keySet();

            //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 2 OF 10 (20%)");
            //progressbar.validate();

            for (Long v : committablesset) 
            {
                if (LiveDB.SerializeJustOnceTable(v) == false) 
                {
                    // table sc, cr are Not SerializeJustOnceTable but they will have zero entries
                    // at install time. So we skip those tables here
                    if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap")
                            || LiveDB.command_line.equalsIgnoreCase("FiXdAtAcOrRuPtIoN")) 
                    {
                        if (v == sc || v == cr) 
                            continue;
                        
                    }

                    // 24th September 2012
                    // set the Change_flag to 'C'
                    for (int rw = (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++) 
                    {
                        if (((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getTableno() == v
                                && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                                && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                                && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'D'
                                && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                                && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T') {
                            ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).setChange_flag('F');

                            // insert an entry in ChangeTracker table for this table
                            // Basically what this does is to backup this entirerow where you
                            // setChange_flag('F') otherwise database reconstruct of ChangeTracker will fail.
                            thisrow = LiveDB.growMore(ct); // 10th September 2012
                            LiveDB.LiveSharedDB[ct][thisrow] =
                                    new ChangeTracker((long) ct, rw, 'F', LiveDB.pid, new Date(),
                                    LiveDB.LiveSharedDB[ct][rw], thisrow);
                        }
                    }


                    if ((ok = commit_database(v)) == false) 
                    {
                        System.err.println(LiveDB.grassHopper("Fatal Error in commit_database()"));
                        JOptionPane.showMessageDialog(appframe, "FATAL ERROR IN COMMITING DATABASE " + "\n");
                        JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                    } 
                    else 
                    {
                        // Now do some alteration to all entries in InstalledTables
                        for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++) {
                            if (((InstalledTables) LiveDB.LiveSharedDB[it][rw]).getTableno() == v) {
                                // now insize may show negative for some tables if serialization fails
                                ((InstalledTables) LiveDB.LiveSharedDB[it][rw]).setInitialsize(((InstalledTables) LiveDB.LiveSharedDB[it][rw]).getOutsize());
                                // ChangeTracker entry for this change
                                // insert an entry in ChangeTracker table for this table                           
                                thisrow = LiveDB.growMore(ct);
                                LiveDB.LiveSharedDB[ct][thisrow] =
                                        new ChangeTracker(it, rw, 'U', LiveDB.pid, new Date(),
                                        LiveDB.LiveSharedDB[it][rw], thisrow);
                            }
                        }
                    }
                } 
                else 
                {
                    if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                            && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false) 
                    {
                        LiveDB.ALRTLVL = 1;
                        System.err.println(LiveDB.grassHopper("SerializeJustOnce Table in ChangeTracker Table:"
                                + String.valueOf(v)));
                    }
                    // dont exit continue with serialization of other tables
                }

            } // for (Long v :committablesset)


            //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 3 OF 10 (30%)");
            //progressbar.validate();
            //appframe.validate();

            System.gc();
            // Make a copy of the existing ChangeTracker.ser 


            if (LiveDB.CopyFile(LiveDB.serializedfilespath
                    + ((FileTableDataFileMap) LiveDB.LiveSharedDB[ft][ct]).getFilename() + ".ser",
                    LiveDB.serializedfilespath + ((FileTableDataFileMap) LiveDB.LiveSharedDB[ft][ct]).getFilename()
                    + ".ser" + ".copy") == false) 
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Copy Fail From:LiveDB.serializedfilespath"
                        + ((FileTableDataFileMap) LiveDB.LiveSharedDB[ft][ct]).getFilename() + ".ser"
                        + "  To File:" + LiveDB.serializedfilespath
                        + ((FileTableDataFileMap) LiveDB.LiveSharedDB[ft][ct]).getFilename() + ".ser"
                        + ".copy"));
            }


            //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 4 OF 10 (40%)");
            //progressbar.validate();        

            // Now commit also those tables which are SerializeJustOnce table if command_line equals
            // "FileTableDataFileMap" || "FiXdAtAcOrRuPtIoN"


            if (LiveDB.command_line.equals("FileTableDataFileMap") 
                    || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN")) 
            {
                for (Long v : committablesset) 
                {
                    if (LiveDB.SerializeJustOnceTable(v)) 
                    {
                        // 24th September 2012
                        // Set the Change_flag to commit
                        for (int rw = (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++) 
                        {
                            if (((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getTableno() == v
                                    && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                                    && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                                    && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'D'
                                    && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                                    && ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T') 
                            {
                                ((ChangeTracker) LiveDB.LiveSharedDB[ct][rw]).setChange_flag('F');
                                if (v == ar) 
                                {
                                    continue;
                                }
                                // insert an entry in ChangeTracker table for this table
                                // Basically what this does is to backup this entirerow where you
                                // setChange_flag('F') otherwise database reconstruct of ChangeTracker will fail.
                                thisrow = LiveDB.growMore(ct); // 10th September 2012
                                LiveDB.LiveSharedDB[ct][thisrow] =
                                        new ChangeTracker((long) ct, rw, 'F', LiveDB.pid, new Date(),
                                        LiveDB.LiveSharedDB[ct][rw], thisrow);
                            }
                        }

                        if ((ok = commit_database(v)) == false) 
                        {
                            System.err.println(LiveDB.grassHopper("Fatal Error in commit_database()"));
                            JOptionPane.showMessageDialog(appframe, "FATAL ERROR IN COMMITING DATABASE ");
                            JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME" + '\n'
                                    + "FOR THIS SESSION IS : " + '\n' + LiveDB.ErrorLogFile);
                        } 
                        else 
                        {
                            // Now do some alteration to all entries in InstalledTables
                            for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++) 
                            {
                                if (((InstalledTables) LiveDB.LiveSharedDB[it][rw]).getTableno() == v) 
                                {
                                    // now insize may show negative for some tables if serialization fails
                                    ((InstalledTables) LiveDB.LiveSharedDB[it][rw]).setInitialsize(((InstalledTables) LiveDB.LiveSharedDB[it][rw]).getOutsize());
                                    // ChangeTracker entry for this change
                                    // insert an entry in ChangeTracker table for this table
                              /*
                                     * thisrow = LiveDB.growMore(ct);
                                     * LiveDB.LiveSharedDB[ct][thisrow] = new
                                     * ChangeTracker (it,rw, 'U', LiveDB.pid,
                                     * new Date (),
                                     * LiveDB.LiveSharedDB[it][rw],thisrow);
                                     */
                                }
                            }

                        }
                    }
                }  // for (Long v :committablesset)
            } // if (LiveDB.command_line.equals("FileTableDataFileMap") || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))

            System.gc();

            //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 5 OF 10 (50%)");
            //progressbar.validate();        

            /*
             * Now Commit those report tables which are fake tables just used
             * for number crunching
             */

            for (int i = LiveDB.REALTABLES + 1; i < (LiveDB.CUSTOMREPORTSON == false ? 36 : LiveDB.tablenameidentifier.length); i++) {
                if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) > LiveDB.REALTABLES) /*
                 * start with fake table 18
                 */ {
                    if ((ok = commit_database(Integer.parseInt(LiveDB.tablenameidentifier[i][0]))) == false) {
                        System.err.println(LiveDB.grassHopper("FATAL ERROR IN COMMIT DATABASE REPORT TABLES FOR NUMBER CRUNCHING"));
                        JOptionPane.showMessageDialog(appframe, "FATAL ERROR IN COMMITING DATABASE FOR REPORT TABLES FOR NUMBER CRUNCHING" + "\n");
                        JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                    }
                }
            }



            for (int i = LiveDB.REALTABLES + 1; i < (LiveDB.CUSTOMREPORTSON == false ? 36 : LiveDB.tablenameidentifier.length); i++) {
                // Now do some alteration to all entries in InstalledTables
                for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++) {
                    if (((InstalledTables) LiveDB.LiveSharedDB[it][rw]).getTableno() == Integer.parseInt(LiveDB.tablenameidentifier[i][0])) {
                        // now insize may show negative for some tables if serialization fails
                        ((InstalledTables) LiveDB.LiveSharedDB[it][rw]).setInitialsize(((InstalledTables) LiveDB.LiveSharedDB[it][rw]).getOutsize());
                        // ChangeTracker entry for this change
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                                new ChangeTracker(it, rw, 'U', LiveDB.pid, new Date(),
                                LiveDB.LiveSharedDB[it][rw], thisrow);
                    }
                }
            }



            //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 6 OF 10 (60%)");
            //progressbar.validate();


            for (int tbl = 0; tbl < LiveDB.REALTABLES - 1; tbl++) {
                if (tbl == ar || tbl == da) {
                    continue;
                }
                if (write_IndexFile(tbl) == false) {
                    System.err.println(LiveDB.grassHopper("FATAL ERROR IN write_IndexFile for Table No :" + String.valueOf(tbl)));
                }
            }

        } finally {
            SysExitLock.unlock();
        }

        System.gc();

        // this setchangetrackerflags () will do a LiveDB.commit_database(ct) which will keep adding entries
        // to the change tracker table so I will turn on the fast commit mechanism if it is off by chance
        // to place that final full stop entry on the change tracker so by the time it goes thru the rest
        // of this code below fast commit mechanism should have done the job.

        if (LiveDB.ENABLEFASTCOMMIT == false) {
            LiveDB.ENABLEFASTCOMMIT = true;
        }


        LiveDB.LogFileSabotageCheck();


        setchangetrackerflags();

        // The progressbar gets mysteriously nullified and shows a null value at this stage
        // I have commented out the calls above to LogFileSabotageCheck (), System.gc(), 
        // setchangetrackerflags () but it still nullifies progressbar. Strange !!

        //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 7 OF 10 (70%)");
        //progressbar.validate();        


        System.gc();

        LiveDB.FASTCOMMITEXIT = true;
        // grow the array 13th August 2012
        ThreadController.LandingTimes = ThreadController.LandingTimes == null ? new Date[5]
                : Arrays.copyOf(ThreadController.LandingTimes, 11);
        ThreadController.LandingTimes[4] = new Date();

        // that fast commit mechanism may be in the middle of something so it may take a while to sense this
        // flag change. Until it senses this flag change you must not exit abruptly like a jerk !!

        // so sleep for ONE second and give that fast commit mechanism some time to sense
        // the change in status of flag LiveDB.FASTCOMMITEXIT; because by the time your thread
        // wakes up and moves into Runnable pool once again it will be a while lets say five seconds
        // And by then fast commit would have completed whatever it was doing and sense the flag and
        // exit.
        if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false) {
            try { // every five millisecond equals one second  !! Yes if you put it to sleep for 5ms
                // it will take one second to wake up perhaps two seconds
                Thread.sleep(75);
            } catch (InterruptedException ex_NOKIA14) {
            }
        }

        // buy another three seconds
        LiveDB.LogFileSabotageCheck();


        //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 8 OF 10 (80%)");
        //progressbar.validate();


        // just before exiting check the command line again and create a file on disk
        // buy another 100 milliseconds just in case !!
        if (LiveDB.command_line.equals("FileTableDataFileMap")
                || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN")) 
        {
            try {
                if (new File(LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES").createNewFile() == false)
                {
                    System.err.println(LiveDB.grassHopper("File:" + LiveDB.serializedfilespath 
                                            + "DATALOADEDFROMCHARACTERFILES" + "already exists"));
                    /*
                    if (new File(LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES").delete() == false)
                    {
                        System.err.println(LiveDB.grassHopper("Error in deleting File "
                                + LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES"));
                        //ok = false;
                    }
                    * 
                    */
                }
            } catch (SecurityException ex_NOKIA81) {
                System.err.println(LiveDB.grassHopper(ex_NOKIA81, "File "
                        + LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES"));
                System.out.println("System Exiting with false");
                ok = false;
            } catch (IOException ex_NOKIA69) {
                System.err.println(LiveDB.grassHopper(ex_NOKIA69, "File "
                        + LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES"));
                System.out.println("SYSTEM EXITING WITH FALSE");
                ok = false;
            }
        }

        if (new File(LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
                + LiveDB.pid + LiveDB.NODENAME + ".daemon").delete() == false) {
            System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:"
                    + LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
                    + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        }

        if (new File(LiveDB.serializedfilespath + "daemon").setReadOnly() == false) {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }

        // set write on a couple of directories where I have used deleteonexit
        if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false) {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "syc"));
        }
        if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false) {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }
        if (new File(LiveDB.serializedfilespath + "etc").setWritable(true, false) == false) {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "etc"));
        }
        if (new File(LiveDB.serializedfilespath + "dump").setWritable(true, false) == false) {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "dump"));
        }

        //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN STAGE 9 OF 10 (90%)");
        //progressbar.validate();


        long line = 0;
        Runtime runtime = Runtime.getRuntime();
        LiveDB.ALRTLVL = 5;
        System.err.println(LiveDB.grassHopper("At Shutdown Free Memory on JVM in bytes:" + runtime.freeMemory()));
        line = LiveDB.logerrorno -1;
        System.err.println("CONTINUATION LINE:" + line + "  MEMORY SHORTAGE ? contact Messrs:" + LiveDB.MEMORYVENDOR);
        // You should be left with anything between 720M to 779M sufficient memory remaining from
        // the inital 1320M we grabbed at startup by supplying command line arguments
        // Now email the Logfiles to proprietor of company
        if (LiveDB.SendLogFileMessage() == false) {
            System.err.println(LiveDB.grassHopper("Error Emailing " + LiveDB.ErrorLogFile + " at System Exit"));
        }
        // call moved to this place on 24th September 2012
        errfile.close();  // this is the stderr close it  
        // This threadcontroller daemon must continue to loop or run until the last second and
        // so this is where i tell it to exit by setting flag to true. ThreadController must not
        // sense the LiveDB.system_exit flag.

        LiveDB.EXITTHREADCONTROLLER = true;

        //progressbar.setString(LiveDB.versionControl.getApplicationName() + " SHUTDOWN COMPLETED STAGE 10 OF 10 (100%)");
        //progressbar.validate();

        JOptionPane.showMessageDialog(appframe, LiveDB.versionControl.getApplicationName()
                + "SHUTDOWN COMPLETED" + '\n'
                + "YOUR LOG FILE NAME FOR SESSION IS :"
                + '\n' + LiveDB.ErrorLogFile);
        if (ok) {
            System.exit(0);
        } else {
            System.out.println("System Exiting with Errors");
            System.exit(1);
        }
    } /*
     * public void run ()
     */

    // Self Explanatory
    // This will be a slow gradual touch down on the tarmac Pilot is well experienced.
    // Kripya aaap apni kursi ki peti khol kay rakhaan Unlike the announcement of the Big Boys
    // they are not confident of their landing skills.
    // You boys want some flying lessons come right over !!!
    // if only i was flying on the Mangalore route that air tragedy might have been averted

    private void setchangetrackerflags() {
        int thisrow = 0;

        for (int tuple = LiveDB.LiveSharedDB[ct].length - 1; tuple >= (int) LiveDB.CTSR; tuple--) {
            if (((ChangeTracker) LiveDB.LiveSharedDB[ct][tuple]).getChange_flag() == 'U'
                    || ((ChangeTracker) LiveDB.LiveSharedDB[ct][tuple]).getChange_flag() == 'I') {

                // but this time fake this entry to place a full stop on this ever-growing table                 
                ((ChangeTracker) LiveDB.LiveSharedDB[ct][tuple]).setChange_flag('F');

                // The following code has been commented out to avoid a java.lang.OutOfMemoryError
                // Its not all that important to backup the tuple each and every time                
                // comment it out dum dum if you get those OutOfMemory Errors

                // from here
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker(ct, tuple, 'F', LiveDB.pid, new Date(),
                        LiveDB.LiveSharedDB[ct][tuple], thisrow);
                // till here

            }
        }


        if ((ok = commit_database(ct)) == false) {
            System.err.println(LiveDB.grassHopper("ChangeTracker serialization failure"));
        }

    }

    @Override
    public boolean commit_database(long p_Tableno) {
        return LiveDB.commit_database((int) p_Tableno);
    }

    /*
     * protected boolean write_SortedFile ()
     */
    @Override
    public boolean write_SortedFile(int p_Tableno) {
        return LiveDB.write_IndexFile(p_Tableno);
    } /*
     * protected boolean write_SortedFile ()
     */


    @Override
    public boolean write_IndexFile(long p_Tableno) {
        return LiveDB.write_IndexFile((int) p_Tableno);
    }
} /*
 * class SystemExit implements Runnable, CommitDatabase
 */
