/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package PitStart;

import java.awt.EventQueue;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : PitStartI
 * @LOOKSY: PitStartII.java
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class is to be compiled as a jar file along with PitStartII.java. It is
 * meant as option II of the webstart application that will be downloaded by the user. This will
 * launch the LensView application in self-Install mode as Option II. Option I will download and
 * start up the LensView application in PRE-INSTALLED mode which is only suited for HOME_EDITION
 * users or PC Standalone mode. This will allow a self-Install or Custom Install
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : A Potrait of Louis Armstrong
 *
 * Start Date: 18th August 2010
 * End Date: 12th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class PitStartI {

    protected static PitStartII pitstartframe = null ;
    
    public static void main(String[] args)
    {
        EventQueue.invokeLater(new Runnable()
        {
           @Override
           public void run()
           {
              pitstartframe = new PitStartII(new JApplet());
              pitstartframe.setTitle("Photographic Sales Software Self Install Version");
              pitstartframe.setSize(200, 300);
              pitstartframe.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
              pitstartframe.setVisible(true);
           }
        });
        
        Process process = null;
        InputStream se = null;
        BufferedReader brse = null;
        String command = "java LensView FileTableDataFileMap";
        // command can also be java -jar /path/to/file/myprogram.jar
        String errline = null;

        try{
             process = Runtime.getRuntime().exec(command);
        }catch(IOException ex_NOKIA62){
               JOptionPane.showConfirmDialog(pitstartframe, "Failed Command:" + command);
               System.exit(1);
        }

        se = process.getErrorStream();

        brse = new BufferedReader (new InputStreamReader(se));

        try{
              if ((errline = brse.readLine()) != null)
              {
                 JOptionPane.showConfirmDialog(pitstartframe, "Standard Error for Command:" + '\n'
                         + command );
                 System.exit(1);
              }
        }catch (IOException ex_NOKIA5){
              JOptionPane.showConfirmDialog(pitstartframe, "Possible Error check stderr for command:" + '\n'
                      + command);
              System.exit(1);
        }
    }
}
