/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;
import java.io.IOException;
import java.awt.Image;
import java.io.File;
import javax.imageio.ImageIO;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.GridBagConstraints;
import java.awt.Font;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.Color;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static DatabaseEngine.FirstPage.cartpanel;
import static DatabaseEngine.FirstPage.convertCurrency;
import static DatabaseEngine.LanguagePanel.SelectedLanguage;
/**
 *
 * @author pskris
 */
public class CartPanel {

    GridBagConstraints constraints = null;
    String langstring [] = null;
    JLabel img = null;
    JLabel sb = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Shopping Basket")
            == null ? "Shopping Basket" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel empty = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your basket is empty")
            == null ? "Your basket is empty" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel full = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "You have shopped")
            == null ? "You have shopped" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel items = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Items in cart")
            == null ? "Items in cart:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JLabel total = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Total")
            == null ? "Total:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JLabel totitems = null;
    JLabel totamt = null;
    final JButton basket = new JButton(langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket")
            == null ? "View Basket" : new String(langstring[langstring.length -1].toCharArray()));
    
    public CartPanel ()
    {
        int MF = 10;

        cartpanel = new JPanel(new GridBagLayout());
        cartpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        cartpanel.setBackground(Color.WHITE);
        
        cartpanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.cataloguepanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)/MF,
                (int)(Madagascar.DEFAULT_HEIGHT)/6);

        addcartpanel();
    }
    
    void addcartpanel()
    {

        long totalitems = 0L;
        Float totalamt = 0.0F;
        Image image = null;
        int infoflags = 0;
        
        try{
            image = ImageIO.read(new File(LiveDB.serializedfilespath + LiveDB.FILESEPERATOR
                + "etc" + LiveDB.FILESEPERATOR + "cart.jpg"));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" +
            LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "etc" + LiveDB.FILESEPERATOR + "cart.jpg"));
        }

        sb.setForeground(Color.BLACK);
        sb.setFont (new Font("Dialog", Font.BOLD, 9));

        empty.setForeground(Color.BLUE);
        full.setForeground(Color.GREEN);
        items.setForeground(Color.BLUE);
        total.setForeground(Color.BLUE);

        basket.setBackground(Color.ORANGE);



        totitems = new JLabel (" " + totalitems);
        totamt = new JLabel (" " + convertCurrency(totalamt));        
        if (totalitems == 0)
        {
            totitems.setForeground(Color.RED);
            totamt.setForeground(Color.RED);
        }
        else
        {
            totitems.setForeground(Color.GREEN);
            totamt.setForeground(Color.GREEN);
        }

        
        cartpanel.add(sb,setConstraints(0,0,1,1));
        cartpanel.add(totalitems == 0 ? empty : full, setConstraints (0,1,1,1));

        // get this components graphics context and then draw dont do what that idiot wrote in the book.
        if (cartpanel.getGraphics().drawImage(image, 3, 1, 1, 1, null) == false)
        {
            cartpanel.imageUpdate(image, infoflags, 3, 1, 1, 1);
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" +
            LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "etc" + LiveDB.FILESEPERATOR + "cart.jpg"));
        }
        
        // cartpanel.imageUpdate(image, 3, 3, 1, 1, 1);
        cartpanel.add(items, setConstraints(0,2,1,1));
        cartpanel.add(totitems, setConstraints(3,2,1,1));
        cartpanel.add(total,setConstraints(0,3,1,1));
        cartpanel.add(totamt, setConstraints(3,3,1,1));
        cartpanel.add(basket, setConstraints(2,4,1,1));

        basket.addMouseListener(new MouseListener(){
            @Override
            public void mousePressed (MouseEvent evnt){
                basket.setBackground(Color.GREEN);
                basket.validate();
            }
            @Override
            public void mouseEntered (MouseEvent evnt){
                basket.setBackground(Color.GREEN);
                basket.validate();
            }
            @Override
            public void mouseClicked (MouseEvent evnt){
                // new ViewBasketPanel ();
            }
            @Override
            public void mouseReleased (MouseEvent evnt){
                basket.setBackground(Color.ORANGE);
                basket.validate();
            }
            @Override
            public void mouseExited (MouseEvent evnt){
                basket.setBackground(Color.ORANGE);
                basket.validate();
            }
        });
        cartpanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
