/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * LISTENER CLASS NAME : ChuhaAdapter extends MouseAdapter
 *
 * @LOOKSY : LoginPage.LoggedInCID, LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.appframe
 *
 * @LOOKSY : FirstPage.java
 *           ViewBasketPanel.java
 *
 * Date File : None
 *
 * Called From : public LoginPage ()
 *
 * Associated Methods : public FirstPage()
 *                      public ViewBasketPanel ()
 *
 * Constructor Parameters : final String p_piccode
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This listener class is registered as a button listener for the Login button on
 * LoginPage. It outputs Successfull login message using modal dialog and then navigates to appropriate
 * page.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class ChuhaAdapter extends MouseAdapter
{
    protected static StackTraceElement st [] = Thread.currentThread().getStackTrace();

    @Override
    public void mouseClicked (MouseEvent evnt)
    {
         // Java O/S authentication code here
         // some operating system will be there that we can assume intelligently !!
        // In the next release we will autowrite a JAAS config file to disk at install time
        // and do a double verification/login !!
        if (st.length == 0)
        {
            System.err.println(LiveDB.grassHopper("getStackTrace() returns 0 elements enable JSM"));
            JOptionPane.showMessageDialog(LiveDB.appframe, "getStackTrace() returns 0 elements enable JSM"
                    + '\n' + "Cant Proceed until problem fixed by SYSADM"
                    + '\n' + "Exiting ........");
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }
        
        if (LoginPage.LoggedInCID != null)
            JOptionPane.showMessageDialog(LiveDB.appframe, "Successfull Login");

        if (st[2].getMethodName().indexOf("FirstPage") != -1)
            new FirstPage ();
        else if (st[2].getMethodName().indexOf("ViewBasketPanel") != -1)
            ;
            // new ViewBasketPanel ();
    }
}
