/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.awt.Toolkit;
import java.util.Date;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadgui
 * CLASS NAME : LaunchGUI
 *
 * @LOOKSY: PictureOptions.java
 *          FirstPage.java
 *
 * @LOOKSY: this.TakeOffTimes[], this.LandingTimes[], this.MAX_HEIGHT, this.MAX_WIDTH, 
 *          LiveDB.fieldseperator, LiveDB.picoptssrttable, LiveDB.indx2pictureOptions,
 *          LiveDB.ALRTLVL, LiveDB.LiveSharedDB
 *
 * Method Name : public void run ()
 * Parameters : None
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is the thread that launches the entire GUI with a simple call to
 * new FirstPage (). But before that it builds some indexes from the PictureOptions table. This
 * application allows you to modify the look and feel of the GUI to a simple extent by just
 * modifying the data in the PictureOptions table. You can also change the look and feel of the
 * GUI to a large extent thru re-usable panel components defined in FirstPage and LoginPage and
 * RegistrationPage, RegisterPanel and some other source components. The entire GUI is constructed
 * as Panels (view them as a pack of cards). You can modify the source to shuffle that pack of
 * cards and re-position them on the screen as per your wishes. So when you see the first screen
 * and then you click on something it appears to navigate to a totally different screen but what
 * is actually happening is there are panels stuck like post it notes all over the screen which
 * can be removed and some other panel (post it note) stuck in its place to make the screen look
 * different. Dont worry be happy each of these components in the GUI is an independent self contained
 * unit so it is just a matter of removing a component and then adding some other component in its
 * place. If you are a novice at java proceed with caution at slow speeds not like speedy singhs !!!
 *
 * Technical Reference : None
 * Musical Accompanyments : TRAFFIC "The low spark of high heeled boys"
 *
 * Start Date: 18th October 2010
 * End Date: 11th October 2011  (siii how dumb i am)
 *
 * Last Modified : 16th October 2011
 * Last Modifications : changes to this patch of code. Tny Tiny errors
        String searchkey = null;
        String value = null;
        PictureOptions [] poarray = (PictureOptions []) LiveDB.picoptssrttable.toArray();
        String thislangcode = poarray[0].getlangCode();
        int optid = poarray[0].getOpt_id();

        // now build the index
        LiveDB.indx2pictureOptions.clear();
        for (PictureOptions element : poarray)
        {
            if (element.getlangCode().equals(thislangcode) == false)
            {
                searchkey = (optid + " ".trim() + element.getlangCode()).trim();
                searchkey = value != null ? LiveDB.indx2pictureOptions.put(searchkey,value):null;                
                value = null;
                thislangcode = element.getlangCode().trim();
                optid = element.getOpt_id();
            }
            else
            {
                //sub opt id 0 is for lang_sub_text for Options only such as Frame Color, Miscellaneous etc
                if (element.getSub_opt_id() > 0)
                    value += element.getLang_sub_text().trim() + LiveDB.fieldseperator;
            }
        }
        searchkey = value != null ? LiveDB.indx2pictureOptions.put(searchkey,value):null;
 * 
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

class LaunchGUI extends LiveDB implements Runnable {

    static int MAX_HEIGHT = (int)Toolkit.getDefaultToolkit().getScreenSize().getHeight() + 30;
    static int MAX_WIDTH = (int)Toolkit.getDefaultToolkit().getScreenSize().getWidth();

    @Override
    public void run ()
    {
        boolean ok = false;
        ThreadController.TakeOffTimes[9] = new Date ();



        new FirstPage();
                
        ThreadController.LandingTimes[9] = new Date ();
    }
}
