/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import javax.swing.JProgressBar;
import java.util.Date;
import javax.swing.JOptionPane;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JTextField;
import java.awt.Font;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import static DatabaseEngine.LanguagePanel.SelectedLanguage;
import static DatabaseEngine.FirstPage.pageonetextpanel;
import static DatabaseEngine.FirstPage.latestprodspanel;
import static DatabaseEngine.LiveDB.ar;
import static DatabaseEngine.LiveDB.cr;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : LoginPage
 *
 * @LOOKSY : ArtLeaves.java
 * @LOOKSY : CustomerRegister.java
 * @LOOKSY : RegistrationPage.java
 * 
 * @LOOKSY : LiveDB.appframe, LiveDB.serializedfilespath, LiveDB.indxlanguageTitles, LiveDB.NODENAME
 * @LOOKSY : LiveDB.ALRTLVL, LiveDB.grassHopper, FirstPage.latestprodspanel, LiveDB.USRNAME
 * @LOOKSY : LanguagePanel.SelectedLanguage, FirstPage.pageonetextpanel, LiveDB.logerrorno
 * @LOOKSY : LiveDB.versionControl, LiveDB.LiveSharedDB, LiveDB.SendNotificationEmail
 * @LOOKSY : LiveDB.indxcustomerRegister, LiveDB.PrepareAndSendMailMesg, LiveDB.versionControl
 *
 * Data File : None
 *
 * Called From : method void addregisterpanel() of RegisterPanel.java
 *
 * Associated Methods : public RegistrationPage () constructor call
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct loginpanel and present user with
 * a Login Page wherein he may login if he is already registered or click to proceed to Registration
 * page.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class LoginPage
{
                                                                         // default guest login
    // static String LoggedInCID = LiveDB.USRNAME + '@' + LiveDB.NODENAME + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();
    protected static String LoggedInCID = null; // take this as a guest login
    protected static String LoggedInUserName = null;
    
    GridBagConstraints constraints = null;
    String langstring [] = null;
    JPanel loginpanel = new JPanel (new GridBagLayout ());
    JLabel email = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Email")
            == null ? "Email:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JLabel password = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Password")
            == null ? "Password:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JPasswordField passwd = new JPasswordField ();
    JButton login = new JButton (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Login")
            == null ? "Login" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel forgot = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Forgot your password")
            == null ? "Forgot your password ?" : new String(langstring[langstring.length -1].toCharArray()) + " ?");
    JLabel loginlabel = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Login")
            == null ? "Login" : new String(langstring[langstring.length -1].toCharArray()));
    JLabel loginbelow = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Please login below")
            == null ? "Please login below:" : new String(langstring[langstring.length -1].toCharArray()) + ":");
    JTextField emailfld = null;

    JLabel needtoregister = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Need to Register")
            == null ? "Need to Register ?" : new String(langstring[langstring.length -1].toCharArray()) + " ?");
    JLabel expregis = new JLabel ("Our express registration page can be completed quickly and easily.");
    JLabel continueshopping = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Continue Shopping ?")
            == null ? "Continue Shopping ?" : new String(langstring[langstring.length -1].toCharArray()) + " ?");
    JLabel contbrowsing = new JLabel ("To continue browsing as a guest without a login, click the button below. N.B: you will not be able to make a purchase without registering first");
    JButton contshop = new JButton ("Continue Shopping");
    JButton registercont = new JButton ("Register & Continue");

    public LoginPage ()
    {
       int MF = 10;
       int X = 0, Y = 0, W = 0, H = 0;

       LiveDB.appframe.remove(latestprodspanel);

       loginpanel.setBounds( X = (int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
                             Y = (int)(pageonetextpanel.TOP_ALIGNMENT * MF),
                            W = (int)(pageonetextpanel.RIGHT_ALIGNMENT * MF)
                            - (int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
                            H = (int)(pageonetextpanel.BOTTOM_ALIGNMENT * MF)
                            - (int)(pageonetextpanel.TOP_ALIGNMENT * MF));

       LiveDB.appframe.remove(pageonetextpanel);

       loginlabel.setForeground(Color.BLUE);
       loginlabel.setFont(new Font("Dialog", Font.BOLD, 10));
       loginpanel.add(loginlabel, setConstraints (0,0,1,1));
       loginbelow.setForeground(Color.BLACK);
       loginbelow.setFont(new Font("Dialog", Font.PLAIN, 9));
       loginpanel.add(loginbelow, setConstraints (0,2,4,1));
       email.setForeground(Color.BLACK);
       email.setFont(new Font ("Dialog", Font.BOLD, 10));
       loginpanel.add(email, setConstraints((int)(loginpanel.RIGHT_ALIGNMENT * MF)/2,4,1,1));
       email.setForeground(Color.BLACK);
       email.setFont(new Font ("Dialog", Font.BOLD, 10));
       loginpanel.add(email, setConstraints((int)(loginpanel.RIGHT_ALIGNMENT * MF)/2 - 1,5,2,1));
       emailfld = new JTextField ("pskris@sify.com", 20);
       loginpanel.add(emailfld, setConstraints((int)(loginpanel.RIGHT_ALIGNMENT * MF)/2 + 2,4,3,1));

       emailfld.addInputMethodListener(new InputMethodListener ()
       {
           @Override
           public void inputMethodTextChanged(InputMethodEvent event){
                boolean fnd = false;
                JProgressBar progressBar = new JProgressBar(0,LiveDB.LiveSharedDB[cr].length);
                long logno = 0L;
                String percent = null;
                if (emailfld.getText().trim().equalsIgnoreCase("superuser"))
                {
                      // validate superuserpassword
                      ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).setSUpasswd();
                      // this call above will email a new password every time
                      JOptionPane.showMessageDialog(LiveDB.appframe,
                      " A new superuser password has been generated " + '\n' +
                      " and emailed to your notification mailbox " + '\n' +
                      ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4() +
                      "Use this new password to log in as superuser" );

                      LiveDB.ALRTLVL = 6;
                      
                      System.err.println(LiveDB.grassHopper("superuser login attempt by "
                      + LiveDB.USRNAME + " at " + LiveDB.NODENAME));
                      logno = LiveDB.logerrorno;
                      System.err.println("LINE:" + logno + " ON " + new Date().toString());
                }
                else
                {
                      progressBar.setName(LiveDB.versionControl.getApplicationName() + " LOGIN VALIDATION PROGRESS");
                      progressBar.setStringPainted(true);

                      progressBar.setString("Searching for Email ID:" + emailfld.getText().trim()) ;
                      for (int rw = 0, rows = LiveDB.LiveSharedDB[cr].length; rw < rows; rw++)
                      {
                          if (((CustomerRegister)LiveDB.LiveSharedDB[cr][rw]).getCustemail()
                                     .equalsIgnoreCase(emailfld.getText().trim()))
                               fnd = true;
                          progressBar.setValue(rw);
                          percent = " " + String.valueOf(((rw/rows) * 100)).trim()
                                  .substring(0, percent.length() >= 6 ? 7: percent.length());
                          progressBar.setString("Completed " + percent + "%");
                      }

                      if (!fnd)
                      {
                          JOptionPane.showMessageDialog(LiveDB.appframe,
                             "Sorry the Email Id:" + emailfld.getText().trim() + '\n'
                             + "Does not exist in Database try another Email");
                          emailfld.setText(" ");
                          emailfld.setFocusable(true);
                      }

                      if (LiveDB.PrepareAndSendMailMesg(null, null, emailfld.getText().trim(),
                             null, null, "EMAIL FROM " + LiveDB.USRNAME, null, null) == false)
                      {
                          JOptionPane.showMessageDialog(LiveDB.appframe, "Send to Email ID Failed");
                          emailfld.setFocusable(true);
                      }
               }
           }
           
           @Override
           public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother use mouse idiot
           }           
       });

       loginpanel.add(password, setConstraints((int)(loginpanel.RIGHT_ALIGNMENT * MF)/2 + 1,5,3,1));
       loginpanel.add(passwd, setConstraints((int)(password.RIGHT_ALIGNMENT * MF) + 1,5,3,1));

       passwd.addInputMethodListener(new InputMethodListener ()
       {
           @Override
           public void inputMethodTextChanged(InputMethodEvent event){
               long row = 0L;

                if (emailfld.getText().trim().equalsIgnoreCase("superuser"))
                {
                    // validate superuserpassword
                    if ( new String(passwd.getPassword())
                           .equals(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getSUpasswd())
                              == false )
                    {
                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                 "Super User Password Wrong Retry" + '\n'
                                 + "if you type superuser again in Email field" + '\n'
                                 + " A new superuser password will be auto generated");

                         LiveDB.SendNotificationEmail("Fail to Login as SuperUser"
                               + " on " + new Date().toString());
                         passwd.setFocusable(true);
                    }
                    else
                    {
                        LoggedInCID = "superuser";
                        LoggedInUserName = "superuser";
                    }
                }
                else
                {
                    // validate password issued at time of registration
                    // LiveDB.USRNAME + '@' + LiveDB.NODENAME + email.getText().trim();
                    // simple password for now.
                    // next release we will complificate it
                   if (LiveDB.indxcustomerRegister.get(new String(passwd.getPassword())) == null)
                   {
                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                 "Invalid Password Retry");

                         LiveDB.SendNotificationEmail("Fail to Login as " + emailfld.getText().trim()
                               + " on " + new Date().toString());
                         passwd.setFocusable(true);
                   }
                   else
                   {
                       row = LiveDB.indxcustomerRegister.get(new String(passwd.getPassword()));
                       if (emailfld.getText().trim().
                           equals(((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCustemail())
                               == false)
                       {
                           JOptionPane.showMessageDialog(LiveDB.appframe, "Invalid EmailID Retry");
                           LiveDB.SendNotificationEmail("Fail to Login as " + emailfld.getText().trim()
                               + " on" + new Date().toString());
                           passwd.setFocusable(true);
                       }
                       else
                       {
                           LoggedInCID = ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getCid();
                           LoggedInUserName = ((CustomerRegister)LiveDB.LiveSharedDB[cr][(int)row]).getUsername();                           
                       }
                   }
                }
           }
           
           @Override
           public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
           }           
       });

       login.setBackground(Color.ORANGE);
       login.setForeground(Color.WHITE);
       loginpanel.add(login, setConstraints ((int)passwd.LEFT_ALIGNMENT * MF, 7, 2, 1 ));

       login.addMouseListener(new ChuhaAdapter ());

       forgot.setForeground(Color.BLUE);
       loginpanel.add(forgot, setConstraints ((int)login.LEFT_ALIGNMENT * MF, 9, 2, 1 ));

       forgot.addMouseListener(new MouseListener (){
           @Override
           public void mouseClicked (MouseEvent evnt){
              boolean fnd = false;
              JProgressBar progressBar = new JProgressBar(0,LiveDB.LiveSharedDB[cr].length);
              progressBar.setName(LiveDB.versionControl.getApplicationName() + " PASSWORD RETRIEVAL PROGRESS");
              progressBar.setStringPainted(true); // test this later some platforms may have problems
              // Password Retrieval here
              JOptionPane.showMessageDialog(LiveDB.appframe, "Please enter your Email ID ");

              progressBar.setString("Searching for Email ID:" + emailfld.getText().trim()) ;
              for (int rw = 0, rows = LiveDB.LiveSharedDB[cr].length; rw < rows; rw++)
              {            
                  if (((CustomerRegister)LiveDB.LiveSharedDB[cr][rw]).getCustemail()
                          .equalsIgnoreCase(emailfld.getText().trim()))
                  {
                      fnd = true;
                      JOptionPane.showMessageDialog(LiveDB.appframe,
                              "Your Password Is: " +
                              ((CustomerRegister)LiveDB.LiveSharedDB[cr][rw]).getCid());
                  }
                  progressBar.setValue(rw);
                  progressBar.setString("Completed " + ((rw/rows) * 100) + "%");
              }
              if (!fnd)
              {
                  JOptionPane.showMessageDialog(LiveDB.appframe,
                          "Sorry the Email Id:" + emailfld.getText().trim() + '\n'
                          + "Does not exist in Database try another Email");
                  emailfld.setText(" ");
                  emailfld.setFocusable(true);
              }
           }
           @Override
           public void mousePressed (MouseEvent evnt){
               forgot.setForeground(Color.RED);
               forgot.validate();
           }
           @Override
           public void mouseEntered (MouseEvent evnt){
               forgot.setForeground(Color.RED);
               forgot.validate();
           }
           @Override
           public void mouseReleased (MouseEvent evnt){
               forgot.setForeground(Color.BLUE);
               forgot.validate();
           }
           @Override
           public void mouseExited (MouseEvent evnt){
               forgot.setForeground(Color.BLUE);
               forgot.validate();
           }
       });

       needtoregister.setForeground(Color.BLUE);
       needtoregister.setFont(new Font ("Dialog", Font.BOLD, 12));
       loginpanel.add(needtoregister, setConstraints(0, 10, 4, 2));
       loginpanel.add(expregis, setConstraints (0, 11, 9, 1 ));

       registercont.setBackground(Color.GREEN);
       registercont.setForeground(Color.WHITE);

       registercont.addMouseListener(new MouseListener (){
           @Override
           public void mousePressed (MouseEvent evnt){
               contshop.setBackground(Color.ORANGE);
               contshop.validate();
           }

           @Override
           public void mouseReleased (MouseEvent evnt){
               contshop.setBackground(Color.GREEN);
               contshop.validate();
           }

           @Override
           public void mouseEntered (MouseEvent evnt){
               contshop.setBackground(Color.ORANGE);
               contshop.validate();
           }

           @Override
           public void mouseClicked (MouseEvent evnt){
               new RegistrationPage ();
           }

           @Override
           public void mouseExited (MouseEvent evnt){
               contshop.setBackground(Color.GREEN);
               contshop.validate();
           }
       });

       loginpanel.add(registercont, setConstraints (0, 12, 4, 1));

       continueshopping.setForeground(Color.BLUE);
       continueshopping.setFont(new Font ("Dialog", Font.BOLD, 12));
       loginpanel.add(continueshopping, setConstraints(0, 14, 4, 2 ));

       loginpanel.add(contbrowsing, setConstraints(0, 16, 20, 1));

       contshop.setBackground(Color.ORANGE);
       contshop.setForeground(Color.WHITE);

       contshop.addMouseListener(new MouseListener (){
           @Override
           public void mousePressed (MouseEvent evnt){
               contshop.setBackground(Color.GREEN);
               contshop.validate();
           }

           @Override
           public void mouseReleased (MouseEvent evnt){
               contshop.setBackground(Color.ORANGE);
               contshop.validate();
           }

           @Override
           public void mouseEntered (MouseEvent evnt){
               contshop.setBackground(Color.GREEN);
               contshop.validate();
           }

           @Override
           public void mouseClicked (MouseEvent evnt){
                  new FirstPage ();
           }

           @Override
           public void mouseExited (MouseEvent evnt){
               contshop.setBackground(Color.ORANGE);
               contshop.validate();
           }
       });

       loginpanel.add(contshop, setConstraints (0, 18, 4, 1));

       LiveDB.appframe.add(loginpanel, setConstraints(X, Y, W, H));
       loginpanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
    
}
