/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.TreeSet;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadcontroller
 * CLASS NAME : ThreadController
 * @LOOKSY:this.TakeOffTimes[], this.LandingTimes[]
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.Action, LiveDB.NODENAME, LiveDB.pid, LiveDB.FILESEPERATOR
 * @LOOKSY:LiveDB.LiveDB.EXITTHREADCONTROLLER, LiveDB.serializedfilespath
 *
 * Method Name : public void run ()
 * Parameters : None
 * Returns : None
 *
 * Chained Methods : protected void PenguinTransmission ()
 *                   protected void AttaMaticTransmission ()
 *                   protected void ManualTransmission ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a medium duty thread which is the GearBox of your car. We have three choices
 * of transmission. By default private static boolean PenguinTransmission = true; and the other options are
 * set to false. So it runs on PenguinTransmission () which loops internally within the method. The same
 * happens with AttaMaticTransmission (); except for ManualTransmission() which is looped here by the run()
 * method. If you notice irrespective of which transmission you choose to compile that specific transmission
 * is being looped by a flag LiveDB.EXITTHREADCONTROLLER and not LiveDB.system_exit. This is because we need
 * the threadcontroller to be alive and kicking until the last second. Tomorrow you may change programming
 * programming logic whereby you may need threadcontroller until the very last second. If you look at the
 * source code of SystemExit.java run() method last few lines I am settting this flag EXITTHREADCONTROLLER
 * to true.
 *
 * Technical Reference : None
 * Musical Accompanyments : TRAFFIC "The low spark of high heeled boys"
 * Thread Dedicated to : Dhruv (My Nephew)
 *
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class ThreadController extends LiveDB implements Runnable {

    /* JOLLY GOOD CAR PLEASE BUY AND HANG OUT WITH YOUR GIRLFRIENDS AROUND STREET CORNERS */
    /* Bear Basic Necessities of Life Engine V64 Rolls Royce Phantom */
    private static long [] JoyStick; /* RESULTING BIT PATTERN AFTER USAGE OF JoyStick or even Brake or HandBrake or Cruise Control or Neutral */
    private static long [] CurrentGear = null; /* Current Gear for each thread */
    private static long [] Accelerator; /* Current Priority for each Thread */
    private static long [][] SortedAccelerator; /* [first] subscript entries and subscript[0] priority number with internal threadid [1] ASC */
    
    private long HeadLight = 0L; /* Post an Advised Speed Limit Break on Thru to the other side Break on thru PAISA MUNGTA HAI
                                  * Okay I gives $20 hint. Why do you need headlight ? To see distance, to cover distance, to reach distance
                                  * to reach destination based on upper time limit set by rally organisers. So if this dont turn your headlight
                                  * on nothing will.
                                  */
    private static long Parking = LiveDB.RevvoMeter; /* Resulting bit pattern after applying Ignition VROOM */
    private static boolean NeutralLightIndicator = false;
    private static boolean FastenSeatBeltsSign = false;
    /* Threads on Cruise Control */
    private static HashMap<Integer,Integer> Cruisers = new HashMap<Integer, Integer>(11);
    private long TailLights []; /* After foot break pressed taillight on */
    private static long TailWinds [][]; /*Its different based on landing altitude of each thread 1st subscript element 2nd subscript [0] LA, [1] thread */
    private static long LandingAltitudes [];  /* Landing Altitudes for each thread how many milliseconds left to complete full cycle */
    protected static Date [] TakeOffTimes; /* Maintain it here just in case those threads die */
    protected static Date [] LandingTimes;
    private Date Clock = setClock();
    
    /* 101 00010 00010 00010 00010 00010 00010 10100 01110 00010 00010 0000000000 */
    private static int LEFT = 63;
    private static int STRAIGHTLEFT = 31;
    private static int STRAIGHTRIGHT = 29;
    private static int RIGHT = -1;  /* For Steering Column */
    private static int STEERRIGHT = 24;
    private static int STEERLEFT =  41;
    private static int YANKLEFT = 51;
    private static int YANKRIGHT = 19;

    /* CONSOLE BUTTONS */
    private static boolean G4x4 = true;
    private static boolean CruiseControl = true;
    private boolean DualTransmission = false ; /* You can use both JoyStick as well as Automatic Transmissions
                                                * choose from AttaMatic or PenguinTransmission.
                                                */
    private boolean DynamicPulsing = true; /* With Rolls Royce Phantom Break of Dawn Release II, Break of Dawn II will also have
                                            * PRONTO Integration. What is PRONTO (Classified Project Under Secrecy). SURPRISE
                                            * with Break of Dawn II V256 Gearbox. The Break of Dawn I, II Made in IyerLand (Small
                                            * provinces of Tamilnadu consisting of Old Tanjavur, New Tanjore and Tirichy !!).
                                            */
    
    private boolean ManualTransmission = false;
    private boolean AttaMaticTransmission = false;
    private static boolean PenguinTransmission = true;
    private boolean BREAKFAIL = false;  /* Special Option fitted for FREE
                                         * Sariyana Periya Parangala Kaal la kattungoda
                                         * Sorry morse code cant be revealed.
                                         */
    private static boolean TorqueInduction = true; /* Torque Induction if you need it if not turn it off make it false
                                             * It works like this if true if you geardn it will increase priority
                                             * if true and you gear up then it will reduce priority. If false if
                                             * you geardn it will reduce priority if false and you gear up it will
                                             * increase priority.
                                             */
    int sbc = -1; /* array subscript */
    
    enum DashBoardGPS {
        THREADCONTROLLER, /* this will use three bits only so max priority 7  */
        THREADLEASH,
        THREADSRTINDX,
        THREADREFRESHDB,
        THREADSYSEXIT,
        THREADWRITETABLES,
        THREADROYAL,
        THREADLOVEALL,
        THREADSPY,
        THREADGUI,
        THREADAUTOBACKKUP                
    };

    private static Long [] ActualThreadIDs = {InstallDB.threadcontroller.getId(),InstallDB.threadleash.getId(),
         InstallDB.threadsrtindx.getId(), InstallDB.threadrefreshdb.getId(), InstallDB.threadsysexit.getId(),
         InstallDB.threadwritetables.getId(), InstallDB.threadroyal.getId(), InstallDB.threadloveall.getId(),
         InstallDB.threadspy.getId(), InstallDB.threadgui.getId(), InstallDB.threadautobackup.getId()};
    
    boolean runstat;

    @Override
    public void run () {

        TakeOffTimes[0] = new Date();        
        
        if (new File(LiveDB.serializedfilespath + "daemon").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "daemon"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }

          try
          {
              new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadcontroller"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).createNewFile();
          }catch (IOException ex_YESKIA41){
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadcontroller"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
          } // to hell with this error it wont happen continue processing
          
          LiveDB.LogFileSabotageCheck();

          if (getPenguinTransmission())
              PenguinTransmission ();
          else if (getAttaMaticTransmission())
             AttaMaticTransmission ();
          else if (getManualTransmission())
          {
               while (LiveDB.EXITTHREADCONTROLLER == false){
                  ManualTransmission();
                  PullTrigger();
               }
          }

          if (new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadcontroller"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete() == false)
          {
             System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadcontroller"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
          }

        if (new File (LiveDB.serializedfilespath + "daemon").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }
          
          LandingTimes[0] = new Date ();
    }

    /* Some Getters */

    protected long [] getJoyStick(){
        return JoyStick;
    }

    protected static long [] getCurrentGear(){
        return CurrentGear;
    }
    protected static long [] getAccelerator (){
        return Accelerator;
    }

    protected static boolean getG4x4 (){
        return G4x4;
    }
    protected static boolean getCruiseControl (){
        return CruiseControl;
    }
    protected boolean getDualTransmission (){
        return DualTransmission;
    }
    protected boolean getManualTransmission (){
        return ManualTransmission;
    }
    protected static boolean getTorqueInduction(){
        return TorqueInduction;
    }
    protected boolean getAttaMaticTransmission (){
        return AttaMaticTransmission;
    }
    protected static boolean getPenguinTransmission (){
        return PenguinTransmission;
    }
    protected boolean getDynamicPulsing (){
        return DynamicPulsing;
    }
    protected long getSignals(){
        return PowerSteering (0,9,0,Parking);  /* Use Application Pigs Interface Library */
    }
    protected boolean getBREAKFAIL (){
        return BREAKFAIL;
    }
    protected Date getClock (){
        setClock();
        return this.Clock;
    }
    protected static long getSystemThreadID(int p_Whichtrack){

        return ActualThreadIDs[p_Whichtrack];
    }
    protected static long [][] getSortedAccelerator(){
        
        return SortedAccelerator;
    }
    protected static Long [] getActualThreadIDs (){

        return ActualThreadIDs;
    }
    protected long [] getTailLights (){

        return TailLights;
    }
    protected static long [][] getTailWinds (){

        return TailWinds;
    }
    protected static long [] getLandingAltitudes(){

        return LandingAltitudes;
    }

/*
 * WIRING DIAGRAM :
 * Method Name : protected static int getcurrenthread()
 * Parameters : None
 * Returns : int -- the internal thread number used by LensView application
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a handy method that will return the internal thread id for the currently
 * executing thread. The internal thread id generated by LensView is as per enum DashBoardGPS
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static int getcurrenthread(){
        int crt = 0;
        /* What if this ThreadController thread never got a chance to run and you called this static method */
        // the threadid is generated by Java when the thread is created. The thread does not have to be
        // started for a threadid to be generated.
        
        ActualThreadIDs[0] = InstallDB.threadcontroller.getId();
        ActualThreadIDs[1] = InstallDB.threadleash.getId();
        ActualThreadIDs[2] = InstallDB.threadsrtindx.getId();
        ActualThreadIDs[3] = InstallDB.threadrefreshdb.getId();
        ActualThreadIDs[4] = InstallDB.threadsysexit.getId();
        ActualThreadIDs[5] = InstallDB.threadwritetables.getId();
        ActualThreadIDs[6] = InstallDB.threadroyal.getId();
        ActualThreadIDs[7] = InstallDB.threadloveall.getId();
        ActualThreadIDs[8] = InstallDB.threadspy.getId();
        ActualThreadIDs[9] = InstallDB.threadgui.getId();
        

        for (int c = 0; c < ThreadController.getActualThreadIDs().length; c++)
        {
            if (Thread.currentThread().getId() == ThreadController.getActualThreadIDs()[c])
            {
               crt = c;
               break;
            }
        }

        return crt;
    }
    
    /* A few Setters */
    protected static void setSortedAccelerator (){

        SortedAccelerator = SortLongsAscending(Accelerator);
    }

    protected void setG4x4 (boolean p_newvalue){
        G4x4 = p_newvalue;

    }

    protected static void setCruiseControl (boolean p_newvalue){
        CruiseControl = p_newvalue;
    }

    protected void setDualTransmission (boolean p_newvalue){
        this.DualTransmission = p_newvalue;

    }

    protected void setManualTransmission (boolean p_newvalue){
        this.ManualTransmission = p_newvalue;
    }

    protected static void setTorqueInduction (boolean p_newvalue){
        TorqueInduction = p_newvalue;
    }

    protected void setAttaMaticTransmission (boolean p_newvalue){

        if (LiveDB.OPERATINGSYSTEM.toUpperCase().indexOf(LiveDB.WINDOWS.toUpperCase()) == -1
                && p_newvalue == true)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Operating System not Windows trying to setAttaMaticTransmission to true"));
            return;
        }
        this.AttaMaticTransmission = p_newvalue;
    }

    protected void setPenguinTransmission (boolean p_newvalue){
        PenguinTransmission = p_newvalue;
    }

    protected void setDynamicPulsing (boolean p_newvalue){
        
        this.DynamicPulsing = p_newvalue;
        if (p_newvalue == true)
        {
           setDualTransmission (true);
           setManualTransmission (true);
        }
        /* else if p_newvalue == false doesent mean you turn of DualTransmission and ManualTransmission */
    }

    protected Date setClock(){
        return this.Clock = new Date();
    }

/*
 * WIRING DIAGRAM :
 * Method Name : protected static long [][] SortLongsAscending(long [] p_Accelerator)
 * Parameters : long [] p_Accelerator
 * Returns : long [][]
 *
 * Data File : None
 *
 * Called From : protected static void setSortedAccelerator ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a handy method that will sort an array of longs p_Accelerator and
 * return a sorted array of longs [][]. What it does is to take a one dim array of Accelerator []
 * This Accelerator is nothing but priorities for the internal threads zero thru ten. So it sorts
 * this one dim array ascending first and then it places it in a two dim array where element [0][0]
 * is Accelerator value followed by element [0][1] which is internal thread id for that Accelerator
 * value.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static long [][] SortLongsAscending(long [] p_Accelerator){

       long SA [][] = null;
       Long LA [] = null;

       for (int i = 0; i < p_Accelerator.length; i++)
           LA[i] = p_Accelerator[i];

       LiveDB.qsort(LA);

       for (int ent = 0, itr = 0; ent < LA.length; ent++)
       {
           SA[ent][0] = LA[0];

           for (; itr < Accelerator.length; itr++)
               if (Accelerator [itr] == LA[0])
                   break;

           SA[ent][1] = itr;
       }
       
       System.arraycopy(SA,0,SortedAccelerator,0,SA.length);

       return SortedAccelerator;
    }
    

/*
 * WIRING DIAGRAM :
 * Method Name : protected static long PowerSteering (int p_direction, int p_howmanybits,
 *                                                                  int p_bitpos, long p_fromwhere)
 * Parameters : int p_direction -- Valid directions are all int and they are as under
 *                                 LEFT = 63, STRAIGHTLEFT = 31, STRAIGHTRIGHT = 29, RIGHT = -1,
 *                                 STEERRIGHT = 24, STEERLEFT =  41, YANKLEFT = 51, YANKRIGHT = 19
 *                                 If you dont want to use any of the above pre-defined values
 *                                 then you can specify zero as a valid value.
 *              int p_howmanybits  -- 1 thru 63
 *              int p_bitpos  -- zero thru 63
 *              long p_fromwhere -- the bit pattern you want to operate on
 * Returns : long
 * Data File : None
 * Called From : just about any method
 *
 * Chained Methods : private static long getbits (int p_howmanybits, int p_bitpos, long p_fromwhere)
 * Associated Methods : protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long RightHandSignal ( long p_onwhichturn, long p_howmuch)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a handy method to Extract n Bits from Center Left or Right Bit Possition.
 * To better understand what the method does take a sample bit pattern such as the one below and read code
 * "101010000101000010000100001001010010111010110101101010000000000". You can use any of those directions
 * detailed above. If the p_direction is a right oriented direction then it extracts p_howmanybits to the
 * right and if p_direction == 0 it extracts p_howmanybits to the left. If the p_direction is left oriented
 * then it extracts p_howmanybits to the left. In either case the extracted bits p_howmanybits starting from
 * the p_direction will be surrounded by zeros on both left and/or right.
 *
 * Technical Reference :If Parking Pattern "101010000101000010000100001001010010111010110101101010000000000"
 * Each thread is represented by 5 bits Big-Endian. Of these 5 bits the FIFTH bit from left will tell you if
 * the previous time the priority was increased (1) or decreased (0). The first four bits from left will tell
 * you the current priority for the thread as in LiveDB.protected static enum Priority. The threadcontroller
 * uses just three bits for priority and no extra bit to indicate previous state. These last ten bits one each
 * from right side for each of the threads except threadcontroller to indicate (0) -- reduce priority or (1)
 * Increase priority.The threadcontroller is represented by three bits 101 from the extreme left runs at
 * static priority of 5 (NORM PRIORITY). The rest of that bit pattern represents other threads as in enum
 * DashBoardGPS. So to make bit pattern visually clearer
 * 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
 * starting extreme left
 * THREADCONTROLLER,THREADLEASH,THREADSRTINDX,THREADREFRESHDB,THREADSYSEXIT,THREADWRITETABLES,THREADROYAL,
 * THREADLOVEALL,THREADSPY,THREADGUI,THREADAUTOBACKKUP
 * starting extreme right advisory bits one bit each telling threadcontroller to bump up/bump down priority
 * THREADLEASH,THREADSRTINDX,THREADREFRESHDB,THREADSYSEXIT,THREADWRITETABLES,THREADROYAL,THREADLOVEALL,
 * THREADSPY,THREADGUI,THREADAUTOBACKKUP so ten bits in all the eleventh is unused and i am thinking of using
 * it as indicator for rotation purposes. Because in windows i dont mess with it but if I let windows run the
 * the threads with pre-emption as it does then it does not suit my purpose very well and so i may have to
 * indulge in some rotation of priorities to ensure that windows runs all threads. The main risk in windows
 * is that pre-emption will result in some threads not running at all.
 *
 * BITPATTERNS : BIG ENDIAN: Please note dont allow BIG ENDIAN to confuse you in this entire Thread.Big Endian
 * orders bits from left to right whereas little endian orders from right to left.So if you take hex 0X12345678
 * in Big endian Byte 0 will map to 0x12 and Byte 3 will map to 0x78. In little endian right to left ordering
 * right is 0x78 mapping to byte 0 and byte 3 maps to 0x12.java.nio.ByteOrder.nativeOrder() will give you the
 * underlying endianness of the O/S. All this dont matter most of times unless you are exchanging information
 * with a native C program. Big Endian in Java is used only where there are more than one bytes.
 *
 * Made In : Sweden To better understand the source code drink and read.
 *
 * Start Date: 18th October 2010
 * End Date: 9th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos, long p_fromwhere){

        // programmers can make mistakes in passing values so auto correct such errors */
        if (p_bitpos < 0)
        {
            p_bitpos = 0;
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_bitpos < 0 to PowerSteering auto corrected"));
        }
        else if (p_bitpos > 63)
        {
            p_bitpos = 63;
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_bitpos > 63 to PowerSteering auto corrected"));
        }
        if (p_howmanybits > 63)
        {
            p_howmanybits = 63;
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits > 63 to PowerSteering auto corrected"));
        }
        if (p_howmanybits < 1) 
        {
            p_howmanybits = 1;
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits < 1 to PowerSteering auto corrected"));
        }

        /* if you are using a direction p_bitpos must be zero you cant pass both params */
        if ( (p_direction == STEERRIGHT || p_direction == YANKRIGHT || p_direction == STRAIGHTRIGHT)
                && p_bitpos == 0)
        {                
                p_fromwhere = LeftIndicator (p_fromwhere, 63 - p_direction);
                p_fromwhere = RightHandSignal (p_fromwhere, 64 - p_howmanybits );
                return LeftIndicator (p_fromwhere, p_direction - p_howmanybits + 1);                
        }
        else if (p_direction == RIGHT && p_bitpos == 0)
        {
             if (p_howmanybits > 1)
             {
                 p_howmanybits = 1;
                 LiveDB.ALRTLVL = 7;
                 System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits > 1 to PowerSteering auto corrected"));                    
             }
             p_fromwhere = LeftIndicator (p_fromwhere, 63 - 0);
             p_fromwhere = RightHandSignal (p_fromwhere, 64 - p_howmanybits );
             return LeftIndicator (p_fromwhere, 0 - p_howmanybits + 1);                 
        }
        
        /* if you are not using a direction as above then p_bitpos must be zero thru 63 */
        if ( p_direction == 0 && p_bitpos >= 0 )
        {
            if (p_bitpos == 63 && p_howmanybits == 0)
            {
                p_howmanybits = 1;
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits == 0 to PowerSteering auto corrected"));
            }
            if (p_bitpos == 63 && p_howmanybits > 1)
            {
                p_howmanybits = 1;
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits > 1 to PowerSteering auto corrected"));
            }
            return getbits (p_howmanybits, p_bitpos, p_fromwhere);
        }
        return getbits (p_howmanybits, p_direction, p_fromwhere);
        
    }

/*
 * WIRING DIAGRAM :
 * Method Name : private static long getbits (int p_howmanybits, int p_bitpos, long p_fromwhere)
 * Parameters : int p_howmanybits
 *              int p_bitpos  -- zero thru 63
 *              long p_fromwhere  -- any 64 bit long
 * Returns : long
 * Data File : None
 *
 * Called From : protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                       long p_fromwhere)
 *
 * Associated Methods : protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long RightHandSignal ( long p_onwhichturn, long p_howmuch)
 * 
 * @Since Version : 1.0
 *
 * Running Commentary : Given a certain bit possition from zero thru 63 this method extracts p_howmanybits
 * to the left starting p_bitpos from the bit pattern p_fromwhere and returns it. Both sides left and/or
 * right of the extracted bits will be zero.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 9th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static long getbits (int p_howmanybits, int p_bitpos, long p_fromwhere){

        if (p_bitpos == 63 && p_howmanybits > 1)
        {
            p_howmanybits = 1;
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits > 1 to PowerSteering auto corrected"));
        }

        if (p_bitpos == 63 && p_howmanybits == 0)
        {
           p_howmanybits = 1;
           LiveDB.ALRTLVL = 7;
           System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits == 0 to PowerSteering auto corrected"));
        }

        if (p_bitpos == 0 && p_howmanybits == 0)
        {
            p_howmanybits = 1;
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits == 0 to PowerSteering auto corrected"));
        }

        if ( (p_bitpos + p_howmanybits) <= 64 )
        {
           p_fromwhere = LeftIndicator ( p_fromwhere, 64 - p_bitpos - p_howmanybits );
           p_fromwhere = RightHandSignal (p_fromwhere, 64 - p_howmanybits);
           return LeftIndicator (p_fromwhere, p_bitpos);
        }
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid args p_howmanybits + p_bitpos > 63 to getbits() correct source manually"));
            return p_fromwhere;
        }
    }
    /* Left Shift by n */
    protected static long LeftIndicator (long p_onwhichturn, long p_howmuch){ /* shift left will loose overflow bits */
        return (p_onwhichturn << (p_howmuch > 63 ? 63 : p_howmuch ));
    }
    /* Right Shift by n */
    protected static long RightIndicator (long p_onwhichturn, long p_howmuch){
        return (p_onwhichturn >> (p_howmuch > 63 ? 63 : p_howmuch ));
    }

    protected static long RightHandSignal ( long p_onwhichturn, long p_howmuch){  /* shift right will loose underflow bits */
        return (p_onwhichturn >>> (p_howmuch > 63 ? 63 : p_howmuch )); /* so restrict to 63 */
    }
    
    /* GUN CONTROL : SO PRIVATE
     * Made in Tixas United States of America.
     */
    private static void PullTrigger (){
        LiveDB.PilotLessTrigger LiveBullet;  /* You will need a SilverBullet */
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.EXITTHREADCONTROLLER, LiveDB.RevvoMeter, LiveDB.MAXTHREADS,
 * @LOOKSY:this.Parking
 * Method Name : protected void AttaMaticTransmission ()
 * Parameters : None
 * Returns : None
 * Data File : None
 *
 * Called From : ThreadController.java run() method
 *
 * Associated Methods : private static void PullTrigger ()
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected void RearViewMirror ()
 *                      protected static void EngineThrust ()
 *                      protected static boolean OnRadar (int p_whichthread)
 *                      protected void ManualTransmission ()
 *                      private void AlterPriority (int p_whichthread, int p_bump)
 *                      protected boolean getDualTransmission ()
 *                      protected boolean getManualTransmission()
 *                      protected boolean getDynamicPulsing ()
 *                      protected static long Reverse (long p_Whichaway)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If you look at the source code for the run () method there are three transmissions to
 * choose from. If you have chosen to compile this program with this AttaMaticTransmission () which is one of
 * the two automatic transmission available. Then this method launches the AttaMaticTransmission for windows
 * and keeps looping it until LiveDB.EXITTHREADCONTROLLER is set to false by SystemExit.java. In simple terms
 * this method checks LiveDB.RevvoMeter and this.Parking for changes if any. If there are any changes in the
 * bit patterns then it calls method AlterPriority (i, 1); to bump up priority indicated by 1 or 0 to bump
 * down priority. For the newbee who has just opened this source both RevvoMeter and Parking are one and the
 * same bit patterns to be used by threadcontroller. The shade of difference is that RevvoMeter is a global
 * whereas Parking is an instance variable of this thread. So any alterations by various methods are always
 * done on Parking and Parking is copied to that global intermittently. The source is somewhat confusing.
 * So it first quick checks if something has changed in RevvoMeter and Parking. If so it must AlterPriority
 * accordingly. If nothing has changed then it is safe to copy Parking to RevvoMeter and call those other
 * methods RearViewMirror (); and EngineThrust (); which will change the bit pattern in Parking. So if these
 * two method calls do change PArking bit pattern we quick check again and find out what has changed and
 * AlterPriority accordingly for each of the threads. Finally a call to method PullTrigger () is needed to
 * set the altered priorities to the threads running on windows.
 *
 * Technical Reference : None
 *
 * Made in Egypt Atta Matic 9+1+1 Gears PilotLess Mode, Supports 4X4 built in like a SUV Use Button on Console
 * to turn it off. Built in Cruise Control. Use console button to turn off
 *
 * Start Date: 18th October 2010
 * End Date: 9th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
 
    protected void AttaMaticTransmission (){

        while ( getAttaMaticTransmission() && LiveDB.EXITTHREADCONTROLLER == false)
        {
            /* nothing has changed */
            if ((PowerSteering (0,9,0,LiveDB.RevvoMeter) ^ PowerSteering (0,9,0,Parking)) == 0)
            {
                LiveDB.RevvoMeter = Parking;
                // now these two method calls may change Parking bit pattern
                RearViewMirror (); /* set the rear view mirror or else you wont clear your drivers test */
                EngineThrust ();  /* Can be used here knockit off if you find the engine too very powerfull */
            }
            
            if ((PowerSteering (0,9,0,LiveDB.RevvoMeter) ^ PowerSteering (0,9,0,Parking)) != 0) 
            {  /* something has changed */

                for (int i = 0; i < LiveDB.MAXTHREADS ; i++)
                {
                                                                                   // this 0 unused bit
                    // 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
                                                                        /* Then this bit has changed */
                    if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ PowerSteering (0,1,i,Parking)) != 0) 
                    {                                                          /* two checks to make doubly sure */
                        if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ Reverse(PowerSteering (0,1,i,Parking))) == 0 &&
                            Reverse((PowerSteering (0,1,i,LiveDB.RevvoMeter)) ^ PowerSteering (0,1,i,Parking)) == 0 )
                        {
                            /* Assuming bit to be zero in Revvometer then the bit has been set to 1 in Parking */
                            /* both are assumptions */  
                            /* so now my assumptions are true */
                            /* let us now change the priority for this thread bump up since bit has been set to 1 in Parking */
                            if (OnRadar(i) == true)
                            {
                               if ((getDualTransmission() && getManualTransmission()) || getDynamicPulsing ())
                                   ManualTransmission ();
                               AlterPriority (i, 1);
                            }
                        }                                                           /* two checks to make doubly sure */
                        else if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ Reverse(PowerSteering (0,1,i,Parking))) == 1 &&
                             Reverse((PowerSteering (0,1,i,LiveDB.RevvoMeter)) ^ PowerSteering (0,1,i,Parking)) == 1)
                        {
                            /* Assuming bit to be zero in Revvometer then the bit has been set to 0 in Parking */
                            /* both are assumptions */ /* so now my assumptions are true */
                            if (OnRadar(i) == true)
                            {
                               if ((getDualTransmission() && getManualTransmission()) || getDynamicPulsing())
                                   ManualTransmission ();
                               AlterPriority (i, 0); // bump down priority
                            }
                        }                                 /* two checks to make doubly sure dont allow slips */
                        else if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) & PowerSteering (0,1,i,Parking)) == 1 &&
                                (PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ PowerSteering (0,1,i,Parking)) == 0)
                        {
                            /* Assuming bit to be 1 in Revvometer then the bit has been set to 1 in Parking  */
                            /* both are assumptions */  /* so now my assumptions are true */
                            if (OnRadar(i) == true)
                            {
                               if ((getDualTransmission() && getManualTransmission()) || getDynamicPulsing())
                                   ManualTransmission ();
                               AlterPriority (i, 1);
                            }
                        }        /* two checks to make doubly sure dont allow slips meaning try all previous assumptions */
                        else if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) & Reverse(PowerSteering (0,1,i,Parking))) == 1 &&
                                (PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ PowerSteering (0,1,i,Parking)) == 1)
                        {
                            /* Assuming bit to be 1 in Revvometer the bit has been set to 0 in Parking  */
                            /* both are assumptions */  /* so now my assumptions are true */
                            if (OnRadar(i) == true)
                            {
                               if ((getDualTransmission() && getManualTransmission()) || getDynamicPulsing ())
                                   ManualTransmission ();
                               AlterPriority (i, 0); // bump down priority
                            }
                        }
                    }
                } /* for */
                PullTrigger();  /* BLAM */
            } /* if */
          } /* while */
    } /* protected void AttaMaticTransmission () */


/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.EXITTHREADCONTROLLER, LiveDB.RevvoMeter, LiveDB.MAXTHREADS,
 * @LOOKSY:this.Parking
 * Method Name : protected void PenguinTransmission ()
 * Parameters : None
 * Returns : None
 * Data File : None
 *
 * Called From : ThreadController.java run() method
 *
 * Associated Methods : private static void PullTrigger ()
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected void RearViewMirror ()
 *                      protected static boolean OnRadar (int p_whichthread)
 *                      protected void ManualTransmission ()
 *                      private void AlterPriority (int p_whichthread, int p_bump)
 *                      protected boolean getDualTransmission ()
 *                      protected boolean getManualTransmission()
 *                      protected boolean getDynamicPulsing ()
 *                      protected static long Reverse (long p_Whichaway)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If you look at the source code for the run () method there are three transmissions to
 * choose from. If you have chosen to compile this program with this PenguinTransmission () which is one of
 * the two automatic transmission available.Then this method launches PenguinTransmission() for windows/Linux
 * and keeps looping it until LiveDB.EXITTHREADCONTROLLER is set to false by SystemExit.java. In simple terms
 * this method checks LiveDB.RevvoMeter and this.Parking for changes if any. If there are any changes in the
 * bit patterns then it calls method AlterPriority (i, 1); to bump up priority indicated by 1 or 0 to bump
 * down priority. For the newbee who has just opened this source both RevvoMeter and Parking are one and the
 * same bit patterns to be used by threadcontroller. The shade of difference is that RevvoMeter is a global
 * whereas Parking is an instance variable of this thread. So any alterations by various methods are always
 * done on Parking and Parking is copied to that global intermittently. The source is somewhat confusing.
 * So it first quick checks if something has changed in RevvoMeter and Parking. If so it must AlterPriority
 * accordingly. If nothing has changed then it is safe to copy Parking to RevvoMeter and call that other
 * method RearViewMirror (); which will change the bit pattern in Parking. So if these two method calls do
 * change Parking bit pattern we quick check again and find out what has changed and AlterPriority accordingly
 * for each of the threads. Finally a call to method PullTrigger () is needed to apply altered priorities to
 * the threads running on windows or Linux.
 *
 * The only difference between PenguinTransmission() and AttaMaticTransmission () is that the Penguin is meant
 * for intranets using both Linux and Windows. So in the second line of source it checks if os is windows and
 * branches off smoothly.
 *
 * Technical Reference : None
 *
 * Sleep with your lover everything automated pilotless
 * Made in Finland 9 + 1 + 1 Gears PilotLess Mode, Supports 4X4 built in like a SUV Use Button on Console
 * to turn it off. Built in Cruise Control. Use console button to turn off
 *
 * Start Date: 18th October 2010
 * End Date: 10th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected void PenguinTransmission (){

       while(getPenguinTransmission() && EXITTHREADCONTROLLER == false ){  /* Deploy PenguinTransmission on Hetrogenious Intranets */
            
            if (LiveDB.OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                AttaMaticTransmission ();
            else
            {
                // nothing has changed
                if ((PowerSteering (0,9,0,LiveDB.RevvoMeter) ^ PowerSteering (0,9,0,Parking)) == 0)
                {
                   LiveDB.RevvoMeter = Parking;
                   RearViewMirror ();
                }
                
                if ((PowerSteering (0,9,0,LiveDB.RevvoMeter) ^ PowerSteering (0,9,0,Parking)) != 0) 
                {  /* something has changed */
                    for (int i = 0; i < LiveDB.MAXTHREADS ; i++)
                    {
                        if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ PowerSteering (0,1,i,Parking)) != 0) /* Then this bit has changed */
                        {
                                                                                     /* two checks to make doubly sure */
                            if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ Reverse(PowerSteering (0,1,i,Parking))) == 0 &&
                                Reverse((PowerSteering (0,1,i,LiveDB.RevvoMeter)) ^ PowerSteering (0,1,i,Parking)) == 0 )
                            {
                                /* Assuming bit to be zero in Revvometer then the bit has been set to 1 in Parking */
                                /* both are assumptions */  
                                /* so now my assumptions are true */
                                /* let us now change the priority for this thread bump up since bit has been set to 1 in Parking */
                                if (OnRadar(i) == true)
                                {
                                   if ((getDualTransmission () == true && getManualTransmission() == true) || getDynamicPulsing () == true)
                                       ManualTransmission ();
                                   AlterPriority (i, 1);
                                }
                            }                                                           /* two checks to make doubly sure */
                            else if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ Reverse(PowerSteering (0,1,i,Parking))) == 1 &&
                                    Reverse((PowerSteering (0,1,i,LiveDB.RevvoMeter)) ^ PowerSteering (0,1,i,Parking)) == 1)
                            {
                                /* Assuming bit to be zero in Revvometer then the bit has been set to 0 in Parking */
                                /* both are assumptions */ /* so now my assumptions are true */
                                if (OnRadar(i) == true)
                                {
                                   if ((getDualTransmission () == true && getManualTransmission() == true) || getDynamicPulsing () == true)
                                       ManualTransmission ();
                                   AlterPriority (i, 0); // bump down priority
                                }
                            }                                 /* two checks to make doubly sure dont allow slips */
                            else if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) & PowerSteering (0,1,i,Parking)) == 1 &&
                                     (PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ PowerSteering (0,1,i,Parking)) == 0)
                            {
                                /* Assuming bit to be 1 in Revvometer then the bit has been set to 1 in Parking  */
                                /* both are assumptions */  /* so now my assumptions are true */
                                if (OnRadar(i) == true)
                                {
                                   if ((getDualTransmission () == true && getManualTransmission() == true) || getDynamicPulsing () == true)
                                       ManualTransmission ();
                                   AlterPriority (i, 1);
                                }
                            }          /* two checks to make doubly sure dont allow slips meaning try all previous assumptions */
                            else if ((PowerSteering (0,1,i,LiveDB.RevvoMeter) & Reverse(PowerSteering (0,1,i,Parking))) == 1 &&
                                     (PowerSteering (0,1,i,LiveDB.RevvoMeter) ^ PowerSteering (0,1,i,Parking)) == 1)
                            {
                                /* Assuming bit to be 1 in Revvometer the bit has been set to 0 in Parking  */
                                /* both are assumptions */  /* so now my assumptions are true */
                                if (OnRadar(i) == true)
                                {
                                   if ((getDualTransmission () == true && getManualTransmission() == true) || getDynamicPulsing () == true)
                                       ManualTransmission ();
                                   AlterPriority (i, 0); // bump down priority
                                }
                            }
                        }
                    } /* for */
                    PullTrigger(); /* BLAM */
                } /* if */
            } /* else */
       } /* while */
       
    } /* protected void PenguinTransmission () */


/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.EXITTHREADCONTROLLER, LiveDB.RevvoMeter, LiveDB.MAXTHREADS,
 * @LOOKSY:this.Parking, this.Accelerator,this.TailWinds
 * 
 * Method Name : protected void ManualTransmission ()
 * Parameters : None
 * Returns : None
 * Data File : None
 *
 * Called From : ThreadController.java run() method
 *
 * Associated Methods : protected boolean getDynamicPulsing ()
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected void RearViewMirror ()
 *                      protected static boolean OnRadar (int p_whichthread)
 *                      protected boolean getDynamicPulsing ()
 *                      protected static long Reverse (long p_Whichaway)
 *                      protected static long GearUp ( int p_WhichTrack, long p_WhichGear )
 *                      protected static long GearDn ( int p_WhichTrack, int p_WhichGear )
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected Date getClock ()
 *                      protected void IgnitionTimingReadOut ()
 *                      protected static void CalculateTailWinds (int p_whichthread)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : If you look at the source code for the run () method there are three transmissions to
 * choose from. If you have chosen to compile this program with this ManualTransmission () then this method
 * launches ManualTransmission() for Windows/Linux & keeps looping in run() till LiveDB.EXITTHREADCONTROLLER
 * is set false by SystemExit.java. In this case it enters block of code where getDynamicPulsing() == false
 * and executes the instructions in that code block (if condition).
 * The other way is to run this ManualTransmission alongside any kind of automatic transmission like penguin.
 * For this you need to setDynamicPulsing (true); If this is done everytime your automatic transmission calls
 * ManualTransmission() it enters block of code where getDynamicPulsing() == true and executes instructions
 * in that code block.
 *
 * Technical Reference : I am using this feature putting it to good use for my own purposes but you may want to
 * a standard code template as below. You can also customize it for your use.
 *
 *       if (getDynamicPulsing () == true)
 *       {
 *           if (getClock().compareTo(myTime) >= 0)  // This is condition based on which the swing takes place
 *          { // lets fill up code now I will be using this feature while refreshing database
 *              IgnitionTimingReadOut (); // This will gives you ResponseTimes of various kinds look at LiveDB
 *
 *              // Call this and it will return a double [] with three numbers which you many want to interpret
 *              // according to your personal wishes.
 *
 *              // private double [] EngineResponseTuning(Long [] p_timing)
 *              CalculateTailWinds (0); // You might want this or knockitoff
 *              // this will fill up a two dim array called TailWinds[][]
 *              for ( int i = 0, mnts10 = 1000 * 60 * 10; i < TailWinds.length; i++ )
 *              {
 *                  if (TailWinds[i][0] > mnts10) cnt++;
 *              }
 *              // PLUG IN YOUR RALLYING CODE IN HERE
 *              // based on your rallying code you may want to set boolean expr = true
 *              expr = true;
 *
 *              // you might want to loop it here
 *              if (expr == true) { PLUG YOUR CODE HERE  ;  HERE   ;  HERE   ; }
 *              else {  PLUG YOUR CODE  ;  HERE  ;  HERE   ;}
 *              // UnComment this logic if you want it
 *              // if (getG4x4() == true) Accelerator[thisthread[z]] = CurrentGear[thisthread[z]] = rps[z] += 2L;
 *              //else Accelerator[thisthread[z]] = CurrentGear[thisthread[z]] = rps[z] += 1L; // GearUp() or GearDn()
 *              // to turn on those advisory bits uncomment the code below
 *              // for (int i = 0; i < 10; i++) Parking |= ab[i];
 *              // to turn off those advisory bits uncomment the code below
 *              // for (int i = 0; i < 10; i++) Parking &= Reverse(ab[i]);
 *           }else setDynamicPulsing (false);
 *       }
 *
 *
 * Made in Finland 9 + 1 + 1 Gears PilotLess Mode, Supports 4X4 built in like a SUV Use Button on Console
 * to turn it off. Built in Cruise Control. Use console button to turn off
 *
 * Start Date: 18th October 2010
 * End Date: 10th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected void ManualTransmission (){
                                    
        long TheRealStarHasArrived; /* for you feller a long can contain a lot many things use it free of cost */
        int z = 0; /* use this as a spare array subscript */
        int [] thisthread = null; /* i presume you may wish to do a little GearUp() and GearDn() on these threads */

        /* HERE IS HOW A BIT PATTERN  LOOKS */
        // 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
        long [] ps = null;  /* these are usefull 4 bits thread priority extracted from Parking using PowerSteering */
        long [] rps = null; /* these are above ps[] 4 bits right shifted bit patterns for readymade +=, -=, ++, -- */
        long [] lps = null; /* Left shifted bit patterns for ready use */
        long [] zoro = null; /* zoro[] |= ps [] which has been done for you in code below */
        long [] ptp = null; /* Each of fifth bits trailing the four bits of priority which tells you if previously thread priority was inc/dec */
        long [] ab = null; /* each of those one bit advisory bits totalling to ten at the far right of the above bit pattern */
        byte cnt = 0;
        Date myTime = LiveDB.FRESHOLOGY; /* you can set it as per your wishes to any time  */
        boolean expr = false;
        byte priority = 0;


        /* SOME PRESETS */
        /* i presume you may wish to do a little GearUp() and GearDn() on these threads */
        thisthread[0] = OnRadar(0) == true ? DashBoardGPS.THREADCONTROLLER.ordinal(): -1;
        thisthread[1] = OnRadar(1) == true ? DashBoardGPS.THREADLEASH.ordinal(): -1;
        thisthread[2] = OnRadar(2) == true ? DashBoardGPS.THREADSRTINDX.ordinal(): -1;
        thisthread[3] = OnRadar(3) == true ? DashBoardGPS.THREADREFRESHDB.ordinal(): -1;
        thisthread[4] = OnRadar(4) == true ? DashBoardGPS.THREADSYSEXIT.ordinal(): -1;
        thisthread[5] = OnRadar(5) == true ? DashBoardGPS.THREADWRITETABLES.ordinal(): -1;
        thisthread[6] = OnRadar(6) == true ? DashBoardGPS.THREADROYAL.ordinal(): -1;
        thisthread[7] = OnRadar(7) == true ? DashBoardGPS.THREADLOVEALL.ordinal(): -1;
        thisthread[8] = OnRadar(8) == true ? DashBoardGPS.THREADSPY.ordinal(): -1;
        thisthread[9] = -1;  /* sorry i cant permit you to mess with this GUI thread */
        thisthread[10]= OnRadar(10) == true ? DashBoardGPS.THREADSPY.ordinal(): -1;

        /* YOU MIGHT FIND THIS USEFULL I WILL SHRED APART PARKING INTO READYMADE NUMBERS FOR YOU TO USE
         * SO HERE IS YOUR SHREDDED CARROT AND APPLE SALAD WITH A GENEROUS SQUEEZE OF LIME PINCH OF SALT
         * ONE GREEN CHILLY BITS AND PIECES. EAT UP BOYS QUICKTIME RECIPE FROM HOLLAND OPTIONAL TWO SLICES
         * OF BREAD WITH A SLICE OF CHEESE TUCKED IN AND A MUG OF COFFEE FROM OFFICE CANTEEN.
         * STANDARD GRUB FOR LONG TREKS.
         */

        ps [0] = 0L;
        ptp [0] = 0L;
        ab[0] = 0L;
        lps[0] = 0L; // NOTE:- both rps and lps dont exceed 8 valid bits all other bits are zero'es
        rps[0] = 0L; // so they fit into one byte

                //57  //52  //47  //42  //37
        // 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
        for (int i = 1, j = 0; i <= LiveDB.MAXTHREADS; i++, j++)
        {           
             ps [i] = PowerSteering(0,4,j = (63 - (i * 4) + 2 + (i -1)) ,Parking);
             ptp [i] = PowerSteering(0,1,63 - (i * 5) + 2, Parking);
             ab [i] = PowerSteering(0,1,i -1,Parking); // bit zero is for internal thread 1
             rps [i] = RightIndicator (ps[i],j);
             lps [i] = LeftIndicator (rps[i], 60);
             Accelerator[i] = priority = (byte)rps[i]; 
             zoro[i] = Parking & Reverse(ps[i]); /* zero out those four bits */
        }        

      /* THIS DYNAMIC PULSING IS MEANT TO CHANGE FROM MANUAL TO AUTOMATIC OR VICE VERSA DEPENDING ON
       * CERTAIN CONDITIONS AND/OR TIMES THAT YOU MAY CHOOSE TO DETAIL HERE. IF YOU WANT TO USE IT
       * PLUG IN CODE BETWEEN THE IF BRACES. IF YOU DONT WANT TO USE IT PLUG IN CODE IN THE FALSE
       * CONDITION
       */

      /* Always use time ticker getClock() to get the most recent time. This time ticker may also be
       * a usefull tool to swing between manual and automatic transmissions. You may want it to work
       * on automatic transmission after work hours when the user load factor may be low.
       */

        /* dont loop this logic externally i am doing it for you */
        if (getDynamicPulsing () == false)
        {
            if (getClock().compareTo(myTime) != 0)
            {
               IgnitionTimingReadOut (); /* This will gives you ResponseTimes of various kinds look at LiveDB */

               /* Call this and it will return a double [] with three numbers which you many want to interpret
                * according to your personal wishes.
                */
               /* private double [] EngineResponseTuning(Long [] p_timing) */
               CalculateTailWinds (0); /* this will tell u in desc order which threads have max execution times left behind curr thread */
               /* this will fill up a two dim array called TailWinds[][] */
               for ( int i = 0, mnts10 = 1000 * 60 * 10; i < TailWinds.length; i++ )
               {
                   if (TailWinds[i][0] > mnts10) cnt++;
               }
                /* PLUG IN YOUR RALLYING CODE IN HERE */
                /* based on your rallying code you may want to set boolean expr = true */
                expr = true;

               /* you might want to loop it here */
               if (expr == true) {/* PLUG YOUR CODE HERE */ ; /* HERE */ ; /* HERE */ ; }
               else { /* PLUG YOUR CODE */ ; /* HERE */  ; /* HERE */  ;}
               /* UnComment this logic if you want it */
               /* if (getG4x4() == true) Accelerator[thisthread[z]] = CurrentGear[thisthread[z]] = rps[z] += 2L;
               else Accelerator[thisthread[z]] = CurrentGear[thisthread[z]] = rps[z] += 1L; */ /* GearUp() or GearDn() */
               /* Give me a usd $100 to fill this up a weeks pizza meals */
               /* COPY CATS I WILL KILL ALL RATS IN ME STUMICH */

               /* to turn on those advisory bits uncomment the code below */
               /* for (int i = 0; i < 10; i++) Parking |= ab[i]; */
               /* to turn off those advisory bits uncomment the code below */
               /* for (int i = 0; i < 10; i++) Parking |= Reverse(ab[i]); */

            }
            else setDynamicPulsing (true);
        }
     
        if (getDynamicPulsing () == true)
        {
            if (getClock().compareTo(myTime) >= 0)  // This is condition based on which the swing takes place
            {
                if (getG4x4())
                {
                    // protected static long GearDn ( int p_WhichTrack, int p_WhichGear )
                    if (ThreadController.getTorqueInduction())
                    {
                       GearDn (thisthread[3], (int)getCurrentGear()[thisthread[3]] - 2); // Increase the priority
                       ptp [3] |= Reverse(ptp[3]);
                    }
                    else
                    {
                       GearUp (thisthread[3], getCurrentGear()[thisthread[3]] + 1); // Increase the priority
                       ptp [3] |= Reverse(ptp[3]);
                    }
                }
                else
                {
                   // protected static long GearUp ( int p_WhichTrack, long p_WhichGear )
                    if (ThreadController.getTorqueInduction())
                    {
                      GearDn (thisthread[3], (int)getCurrentGear()[thisthread[3]] - 1); // Increase the priority
                      ptp [3] |= Reverse(ptp[3]); // this is that fifth bit we need to set to 1
                    }
                    else
                    {
                      GearUp (thisthread[3], getCurrentGear()[thisthread[3]] + 2); // Increase the priority
                      ptp [3] |= Reverse(ptp[3]);
                    }
                }
            }
            else
            {
                if (getG4x4())
                {
                    // protected static long GearDn ( int p_WhichTrack, int p_WhichGear )
                    if (ThreadController.getTorqueInduction())
                    {
                        GearUp (thisthread[3], getCurrentGear()[thisthread[3]] + 1); //reduce priority
                        ptp [3] &= Reverse(ptp[3]); // this is that fifth bit we need to set to zero
                    }
                    else
                    {
                       GearDn (thisthread[3], (int)getCurrentGear()[thisthread[3]] - 1); // reduce priority
                       ptp [3] &= Reverse(ptp[3]);
                    }
                }
                else
                {
                    // protected static long GearDn ( int p_WhichTrack, int p_WhichGear )
                    if (ThreadController.getTorqueInduction())
                    {
                        GearUp (thisthread[3], getCurrentGear()[thisthread[3]] + 2); //reduce priority
                        ptp [3] &= Reverse(ptp[3]);
                    }
                    else
                    {
                       GearDn (thisthread[3], (int)getCurrentGear()[thisthread[3]] - 2); // reduce priority
                       ptp [3] &= Reverse(ptp[3]);
                    }
                }               
            } // else for if (getClock().compareTo(myTime) >= 0)
        }      

        
        for (int i = 1; i < LiveDB.MAXTHREADS; i++)
        {
            zoro[i] = zoro[i] | ps[i];
            zoro[i] |= ptp[i];
            Parking |= zoro[i];
        }
    }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.Parking, this.Accelerator,
 * Method Name : private void AlterPriority (int p_whichthread, int p_bump)
 * Parameters : int p_whichthread
 *              int p_bump -- 0 to bump down the priority, 1 to bump up the priority
 * Returns : None
 * Data File : None
 *
 * Called From : protected void AttaMaticTransmission ()
 *               protected void PenguinTransmission ()
 *
 * Associated Methods : private static boolean getCruiseControl ()
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected static long Reverse (long p_Whichaway)
 *                      protected static long CruiseControl (int []p_OFF, int... p_whichthreads )
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static boolean getPenguinTransmission()
 *                      protected static boolean getManualTransmission()
 *                      protected static long [][] getTailWinds()
 *                      protected static void CalculateTailWinds (int p_whichthread)
 *                      protected static boolean getG4x4()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will alter the priority of the specific thread passed as a parameter
 * It will either bump up or bump down the priority of the thread as indicated by param p_bump. It could
 * happen that other threads other than the thread you specified as paramter are lagging behind in their
 * workload and have ten minutes or more to complete their workload then in that case ignore p_bump == 1
 * advice and undo the priority that you had just increased.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 10th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private void AlterPriority (int p_whichthread, int p_bump){

        long ps = 0L, rps = 0L, lps = 0L, zoro = Parking;
        int mnts10 = 1000 * 60 * 10 ; /* ten minutes */
        int bitpos = 0;
        byte cnt = 0;
        byte priority = 0;
        byte oldpriority = 0;
        
        if (getCruiseControl () == true)
            if (Cruisers.get(p_whichthread) == p_whichthread) return;
            
        // else so you can alter priority

        if (p_whichthread == DashBoardGPS.THREADCONTROLLER.ordinal())
        {
            if (getCruiseControl() == true) // Cruise control usage is permitted
            {
                // cruise control turned off
                if (Cruisers.get(p_whichthread) == null)
                {
                    CruiseControl(null,p_whichthread);  /* get this on cruise control */
                    return;
                }
            }
        }
                //57  //52  //47  //42  //37
        // 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
        ps = PowerSteering(0,4,bitpos = (63 - (p_whichthread * 4) + 2 + (p_whichthread -1)) ,Parking);
        rps = RightIndicator (ps,63 - (p_whichthread * 5) + 1);
        oldpriority = priority = (byte)rps; // grab just eight bits
        lps = LeftIndicator (rps, 60);

        Accelerator[p_whichthread] = lps ;
        
        if (p_bump == 1)  /* bump up priority */
        {
           if (getDualTransmission () == true)  /* only if this is true check G4x4 */
           {
               if (getG4x4() == true)
               {
                   priority += 2;
                   Accelerator[p_whichthread] = priority;
               }
               else
               {
                   priority += 1;
                   Accelerator[p_whichthread] = priority;
               }
           }
           else
           {
               priority += 1;
               Accelerator[p_whichthread] = priority;
           }
        }
        else   /* bump down priority */
        {
           if (getDualTransmission () == true)  /* only if this is true check G4x4 */
           {
               if (getG4x4() == true)
               {
                   priority -= 2;
                   Accelerator[p_whichthread] = priority;
               }
               else
               {
                   priority -= 1;
                   Accelerator[p_whichthread] = priority;
               }
           }
           else
           {
               priority -= 1;
               Accelerator[p_whichthread]  = priority;
           }
        }

        /* factor this in with automatic transmissions only */
        if (getManualTransmission() == false && (getPenguinTransmission() == true
                                                    || getAttaMaticTransmission() == true) )
        {
            /* this will tell you in desc order which threads have max execution times
             * left behind thread you passed as a parameter to the method call
             */
            CalculateTailWinds (p_whichthread);
            /* this will fill up a two dim array called TailWinds[][] */
            for ( int i = 0; i < getTailWinds().length; i++ )
            {
                if (getTailWinds()[i][0] > mnts10)
                    cnt++;
            }

            if ( cnt > 3)
            {
                if (p_bump == 1) /* request/advice to bump up priority IGNORE THIS */
                {
                   /* since we did a plus equals based on p_bump deduct now and ignore this */
                   if (getG4x4() == true)
                   {
                       priority -= 2;
                       Accelerator[p_whichthread] = priority;
                   }
                   else
                   {
                       priority -= 1;
                       Accelerator[p_whichthread] = priority;
                   }
                }
            }
        }

        /* now do a left shift back to its original position in the Parking bit pattern */
        lps = RightIndicator (lps,60);
        lps = LeftIndicator (lps, bitpos);
        
        zoro = Parking & Reverse(ps); /* zero out those four bits */
        zoro = zoro | PowerSteering(0,4,bitpos = 0,Accelerator[p_whichthread]);
        if (p_whichthread != 0)
        {
            if (priority < oldpriority)
                zoro &= Reverse(PowerSteering(0,1,63 - (p_whichthread * 5) + 2, Parking));
            else if (priority > oldpriority)
                zoro |= Reverse(PowerSteering(0,1,63 - (p_whichthread * 5) + 2, Parking));
        }
        Parking |= zoro;
    }

    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.RevvoMeter,
 * @LOOKSY:this.Parking, this.NeutralLightIndicator, this.G4x4, this.CurrentGear, this.JoyStick,
 * @LOOKSY:this.Accelerator
 *
 * Method Name : protected static long Neutral ()
 * Parameters : None
 * Returns : long -- the new Parking bit pattern
 * Data File : None
 *
 * Called From :  private long IgnitionOn()
 *
 * Associated Methods : private static void PullTrigger ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : All that this convenience method does is to reset the Parking bit pattern to a preset
 * depending on the flag G4X4 but before that it sets the CurrentGear for each thread. After changing Parking
 * bit pattern to a pre-set the method sets NeutralLightIndicator = true and sets other values Joystick,
 * Accelerator and finally calls PullTrigger() so that the new priorities are applied.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static long Neutral (){

        LiveDB.RevvoMeter = Parking; 
        long ps = 0, rps = 0, lps = 0;
        int bitpos = 0;
        byte priority = 0;

        CurrentGear [0] = 5L;
        for ( int i = 1; i < CurrentGear.length ; i++ )
        {
            if (G4x4 == false)
               CurrentGear[i] = 1L;
            else
            {
                // change here for other threads later
                CurrentGear[i] = 1L;
            }
        }

        if (G4x4 == false)
            Parking = Long.parseLong("1010001000010000100001000010000101010001110000100001000000000000",2);
        else
            Parking = Long.parseLong("1010001000010000100001000010000100001010010000100001000000000000",2);

        NeutralLightIndicator = true;
        for ( int i = 1; i <= LiveDB.MAXTHREADS; i++ )
        {
                    //57  //52  //47  //42  //37
            // 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
            ps = PowerSteering(0,4,bitpos = (63 - (i * 4) + 2 + (i -1)) ,Parking);
            rps = RightIndicator (ps,63 - (i * 5) + 1);
            lps = LeftIndicator (rps, 60);
            JoyStick [i] = lps;
            Accelerator [i] = priority;
        }
        
        PullTrigger();
        return Parking;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.MAXTHREADS, LiveDB.Priority
 * @LOOKSY:this.Parking, this.G4x4, this.CurrentGear, this.JoyStick, this.Accelerator, this.Cruisers
 *
 * Method Name : protected static long GearDn ( int p_WhichTrack, int p_WhichGear )
 * Parameters : int p_WhichTrack
 *              int p_WhichGear
 * Returns : long -- the new Parking bit pattern
 * Data File : None
 *
 * Called From :  protected void ManualTransmission ()
 *
 * Associated Methods : protected static boolean getCruiseControl ()
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Shift Gears 10,9,8,7,....3,2,1 (p_WhichGear) on any thread p_WhichTrack other
 *                      than thread zero.
 *
 * Technical Reference : if TorqueInduction is true then GearDn will increase priority
 *                       if G4x4 then increase priority twice else just one
 *
 *                       if TorqueInduction is false then GearDn will decrease priority
 *                       if G4x4 then decrease priority twice else just one
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static long GearDn ( int p_WhichTrack, int p_WhichGear ){

        long ps = 0L, rps = 0L, lps = 0L;  
        long zoro = Parking;
        int bitpos = 0;
        byte priority = 0;

        if (p_WhichTrack > LiveDB.MAXTHREADS) return Parking;

        if (p_WhichTrack == 0)
            return Parking;
        
       if (getCruiseControl () == true)
            if (Cruisers.get(p_WhichTrack) != null)
                return Parking;

        ps = PowerSteering(0,4,bitpos = (63 - (p_WhichTrack * 4) + 2 + (p_WhichTrack -1)) ,Parking);
        rps = RightIndicator (ps,63 - (p_WhichTrack * 5) + 1);
        lps = LeftIndicator (rps, 60);
        priority = (byte)rps;

        if (priority <= 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Zero priority auto corrected"));
            rps = (long)LiveDB.Priority.GOODSTRAIN.ordinal();  /* some error in program auto correct */
        }

        if (priority > 10)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Priority greater than ten contact service center"));
            rps = (long)LiveDB.Priority.BULLETTRAIN.ordinal(); /* some error in program auto correct */
        }

        if (p_WhichGear <= 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Less than zero gear auto corrected"));
            p_WhichGear = 2; /* Auto Correct */
        }
        else if (p_WhichGear > 10)
        {
             LiveDB.ALRTLVL = 7;
             System.err.println(LiveDB.grassHopper("More than ten gear auto corrected"));
             p_WhichGear = 9;
        }

        Accelerator[p_WhichTrack] = priority;
        CurrentGear[p_WhichTrack] = p_WhichGear;

        if (G4x4 == false)
        {
            if (CurrentGear[p_WhichTrack] != p_WhichGear)
            {
                if (getTorqueInduction())
                    priority += 1; // if torque induction GearDn increases priority
                else
                    priority -= priority > 1 ? 1: 0;  // else GearDn must decrease priority                
            }
            else
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Gear not changed"));
            }
        }
        else
        {
            if (CurrentGear[p_WhichTrack] != p_WhichGear)
            {                                
                if (getTorqueInduction())
                    priority += 2; // if torque induction GearDn increases priority
                else
                    priority -= priority > 2 ? 2: 1;  // else GearDn must decrease priority                
            }
            else
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Gear not changed"));
            } 
        }

        Accelerator[p_WhichTrack] = priority;
        JoyStick[p_WhichTrack] = lps;  /* so both sides zero */
        zoro = Parking & Reverse(ps); /* zero out those four bits for academics */
        zoro = zoro | PowerSteering (0,4,60,Accelerator[p_WhichTrack]);

        /* Reuse ps */
        ps = PowerSteering(0,1,63 - (p_WhichTrack * 5) + 2, Parking);
        if (getTorqueInduction() == false)               
            zoro &= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned off */
        else if (getTorqueInduction() == true)
            zoro |= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned ON */
                                // since if torque induction is true then a GearDn increases priority

        return Parking |= zoro;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.MAXTHREADS, LiveDB.Priority
 * @LOOKSY:this.Parking, this.G4x4, this.CurrentGear, this.JoyStick, this.Accelerator, this.Cruisers
 *
 * Method Name : protected static long GearUp ( int p_WhichTrack, long p_WhichGear )
 * Parameters : int p_WhichTrack  -- which thread
 *              int p_WhichGear  -- which gear
 * Returns : long -- the new Parking bit pattern
 * Data File : None
 *
 * Called From :  protected void ManualTransmission ()
 *
 * Associated Methods : protected static boolean getCruiseControl ()
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Shift Gears 1,2,3,4,5,6,...10 (p_WhichGear) on any thread p_WhichTrack other
 *                      than thread zero.
 *
 * Technical Reference : if TorqueInduction is true then GearUp will decrease priority
 *                       if G4x4 then decrease priority twice else just one
 *
 *                       if TorqueInduction is false then GearUp will increase priority
 *                       if G4x4 then increase priority twice else just one
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static long GearUp ( int p_WhichTrack, long p_WhichGear ){
        
        long ps = 0L, rps = 0L, lps = 0L;
        long zoro = Parking;
        int bitpos = 0;
        byte priority = 0;

        if (p_WhichTrack > LiveDB.MAXTHREADS) return Parking;

        if (p_WhichTrack == 0)
            return Parking;

        if (getCruiseControl () == true)
            if (Cruisers.get(p_WhichTrack) != null)
                return Parking;


        ps = PowerSteering(0,4,bitpos = (63 - (p_WhichTrack * 4) + 2 + (p_WhichTrack -1)) ,Parking);
        rps = RightIndicator (ps,63 - (p_WhichTrack * 5) + 1);
        lps = LeftIndicator (rps, 60);
        priority = (byte)rps;

        if (priority <= 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Zero priority auto corrected"));
            rps = (long)LiveDB.Priority.GOODSTRAIN.ordinal();  /* some error in program auto correct */
        }

        if (priority > 10)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Priority greater than ten contact service center"));
            rps = (long)LiveDB.Priority.BULLETTRAIN.ordinal(); /* some error in program auto correct */
        }

        if (p_WhichGear <= 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Less than zero gear auto corrected"));
            p_WhichGear = 2; /* Auto Correct */
        }
        else if (p_WhichGear > 10)
        {
             LiveDB.ALRTLVL = 7;
             System.err.println(LiveDB.grassHopper("More than ten gear auto corrected"));
             p_WhichGear = 9;
        }

        Accelerator[p_WhichTrack] = priority;
        CurrentGear[p_WhichTrack] = p_WhichGear;

        if (G4x4 == false)
        {
            if (CurrentGear[p_WhichTrack] != p_WhichGear)
            {
                if (getTorqueInduction() == false)
                    priority += 1; // if torque induction false GearUp increases priority
                else
                    priority -= priority > 1 ? 1: 0;  // else GearUp must decrease priority
            }
            else
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Gear not changed"));
            }
        }
        else
        {
            if (CurrentGear[p_WhichTrack] != p_WhichGear)
            {
                if (getTorqueInduction() == false)
                    priority += 2; // if torque induction false GearUp increases priority
                else
                    priority -= priority > 2 ? 2: 1;  // else GearUp must decrease priority
            }
            else
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Gear not changed"));
            }
        }

        Accelerator[p_WhichTrack] = priority;
        JoyStick[p_WhichTrack] = lps;  /* so both sides zero */
        zoro = Parking & Reverse(ps); /* zero out those four bits */
        zoro = zoro | PowerSteering (0,4,60,Accelerator[p_WhichTrack]);

        /* Reuse ps */
        ps = PowerSteering(0,1,63 - (p_WhichTrack * 5) + 2, Parking);
        if (getTorqueInduction() == true)
            zoro &= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned off */
        else if (getTorqueInduction() == false)
            zoro |= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned ON */
                                // since if torque induction is false then a GearUp increases priority

        return Parking |= zoro;
    }

    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.MAXTHREADS, LiveDB.Priority
 * @LOOKSY:this.Parking, this.TailLights, this.JoyStick, this.Accelerator, this.SortedAccelerator, this.BREAKFAIL
 *
 * Method Name : protected long Brake (int p_WhichThread)
 * Parameters : int p_WhichThread  -- which thread
 * Returns : long -- the new Parking bit pattern
 * Data File : None
 *
 * Called From :  not used as of now
 *
 * Associated Methods : protected static boolean getCruiseControl ()
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected static void setCruiseControl (boolean p_newvalue)
 *                      protected static void setSortedAccelerator ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Apply foot break. This method will bump down current thread priority to GOODSTRAIN.
 * It does a couple of checks like BREAKFAIL == true then it returns without doing anything. If BREAKFAIL
 * == false then if cruise control is true it resets cruise control to false and removes this thread from
 * Cruisers. Then it sets the threads which are tailing in descending order after which it sets Joystick,
 * zoro and Parking and that last fifth bit after every thread priority in Parking to zero.
 *
 * Technical Reference : 
 *
 * Start Date: 18th October 2010
 * End Date: 12th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */    
    
    protected long Brake (int p_WhichThread){
        
        long ps = 0, rps = 0, lps = 0;
        long zoro = Parking;
        int bitpos = 0;
        byte priority = 0;

        if (p_WhichThread > LiveDB.MAXTHREADS) return Parking;

        if (BREAKFAIL) return Parking;

        if (BREAKFAIL == false)
        {
            if (getCruiseControl())
            {
                setCruiseControl(false);
                Cruisers.remove(p_WhichThread);
            }
        }

        if (p_WhichThread < 1) p_WhichThread = 1;

        ps = PowerSteering(0,4,bitpos = (63 - (p_WhichThread * 4) + 2 + (p_WhichThread -1)) ,Parking);
        rps = RightIndicator (ps,63 - (p_WhichThread * 5) + 1);
        lps = LeftIndicator (rps, 60);
        
        Accelerator[p_WhichThread] = LiveDB.Priority.GOODSTRAIN.ordinal();
        
        setSortedAccelerator();
        
        for (int ii = 0; ii < SortedAccelerator.length ; ii++)
        {
            if (SortedAccelerator[ii][0] == Accelerator[p_WhichThread])
            {
                for (int i = ii - 1, iii=0; i >= 0; i--, iii++)
                /* Set the threads which are tailing in descending order */
                    TailLights[iii] = SortedAccelerator[i][1]; 
            }
        }
        
        JoyStick[p_WhichThread] = lps;
        zoro =  Parking & Reverse(ps); /* zero out those four bits */
        zoro = zoro | PowerSteering(0,4,(63 - (p_WhichThread * 4) + 2 + (p_WhichThread -1)),
                                                                            Accelerator[p_WhichThread]);        
        Parking |= zoro;
        /* Reuse ps */  /*TWEAK THAT FIFTH BIT ALSO */
        ps = PowerSteering(0,1,63 - (p_WhichThread * 5) + 2, Parking);
        zoro &= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned off */
        
        return Parking |= zoro;
        
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.Parking, this.JoyStick, this.Accelerator, this.BREAKFAIL
 *
 * Method Name : protected long HandBrake (boolean p_applyrelease)
 * Parameters : boolean p_applyrelease -- if true reduce priority of threadcontroller by 1
 *                                        if false set priority of threadcontroller to 5
 * Returns : long -- the new Parking bit pattern
 * Data File : None
 *
 * Called From :  not used as of now
 *
 * Associated Methods : protected static boolean getCruiseControl ()
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected static void setCruiseControl (boolean p_newvalue)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Apply hand  brake. Lower Thread Controller Priority by One Step
 *
 * Technical Reference :
 *
 * Start Date: 18th October 2010
 * End Date: 12th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
    protected long HandBrake (boolean p_applyrelease){
        long ps = 0, rps = 0, lps = 0;
        long zoro = Parking;
        byte priority = 0;

        if (BREAKFAIL) return Parking;

        if (BREAKFAIL == false)
        {
            if (getCruiseControl())
            {
                setCruiseControl(false);
            }
        }

        ps = PowerSteering(0,3,61,Parking);
        rps = RightIndicator (ps,61);
        priority = (byte)rps;

        if (p_applyrelease)
            priority -= priority > 1 ? 1:0;
        else if (p_applyrelease == false) priority = 5;
        Accelerator[0] = priority;
        lps = LeftIndicator (rps,61);
        JoyStick[0] = lps;
        zoro = Parking & Reverse(ps); /* zero out those four bits */
        zoro = zoro | PowerSteering(0,3,61, Accelerator[0]);
        return Parking |= zoro;
    }

    /* Return a bitmap which will contain the priority of
     * the requested RailRoad (Thread).
     */
    protected long RailRoad (int p_WhichOne){
        return Accelerator[p_WhichOne];
    }
    
    /* ones complement */
    protected static long Reverse (long p_Whichaway){
        return ~p_Whichaway;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.Parking, this.Cruisers, this.Accelerator, this.Joystick
 *
 * Method Name : protected static long CruiseControl (int []p_OFF, int... p_whichthreads )
 * Parameters : int []p_OFF -- turn of cruise control on these threads
 *              int... p_whichthreads -- turn on cruise control on these threads
 * Returns : long
 * Data File : None
 *
 * Called From : private void AlterPriority (int p_whichthread, int p_bump)
 *
 * Associated Methods : protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *                      protected static long LeftIndicator (long p_onwhichturn, long p_howmuch)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : What this method does is to remove all threads specified by p_OFF from cruise control
 * and turn on cruise control for all threads specified by int ... p_whichthreads. First removes all threads
 * from HashMap Cruisers containing the thread ids p_OFF[]. Then it checks the value of CruiseControl using
 * getCruiseControl(). If this is false we cant turn on cruise control on any more threads and so the method
 * returns ignoring the balance of command. So it just returns Parking. If getCruiseControl() returns true
 * then it does a put into Cruisers for all thread ids specified by p_whichthreads. Finally it sets the
 * Accelerator, Joystick and Parking value and exits. NOTE:- this zoro is nothing but Parking except that
 * this method local and Parking is an instance variable. So within a method if you have to tweak the bit
 * pattern always use zoro and then copy it to Parking.
 *
 * Technical Reference : None
 *
 * Made in California U.S.A : Scenic Route. Use sparingly since it will operate the vehicle at static speed
 * It will run the thread at a priority and not change it. Use button on console to turn off.
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
 
    protected static long CruiseControl (int []p_OFF, int... p_whichthreads ) {

        long ps = 0, rps = 0, lps = 0;
        long zoro = Parking;
        byte priority = 0;
        int bitpos = 0;

        /* called as CruiseControl(null); return */
        if (p_OFF.length == 0 && p_whichthreads.length == 0)
            return Parking; 

        for (int j = 0; j < p_OFF.length; j++)
            Cruisers.remove(p_OFF[j]);

        if (p_whichthreads.length == 0)
            return Parking; /* nothing to turn on */
        
        /* we have turned off whatever needed to be turned off
         * but if console button CruiseControl == false we cant
         * turn on CruiseControl on any more threads. We return
         * now command ignored.
         */
        if (getCruiseControl() == false)
            return Parking;


        for (int i = 0 ; i < p_whichthreads.length; i++)
        {
            if (p_whichthreads[i] > 10) p_whichthreads[i] = 10;  /* Auto Correct */
            if (p_whichthreads[i] < 1) p_whichthreads[i] = 1;
            
            /* This thread is a cruiser so set it */
            Cruisers.put(p_whichthreads[i], p_whichthreads[i]);

            if (p_whichthreads[i] != 0)
            {
                    //57  //52  //47  //42  //37
            // 101 01000 01010 00010 00010 00010 01010 01011 10101 10101 10101 0 0000000000
                ps = PowerSteering(0,4,bitpos = (63 - (p_whichthreads[i] * 4) + 2 + (p_whichthreads[i] -1)) ,Parking);
                rps = RightIndicator (ps,63 - (p_whichthreads[i] * 5) + 1);
                priority = (byte)rps; // grab just eight bits
                lps = LeftIndicator (rps, 60);
            }
            else
            {
                ps = PowerSteering(0,3,bitpos = 61,Parking);
                rps = RightIndicator (ps,61);
                priority = (byte)rps; // grab just eight bits
                lps = LeftIndicator (rps, 61);
            }
            priority = (byte)LiveDB.Priority.LASTLOCAL.ordinal();
            Accelerator[p_whichthreads[i]] = priority;
            JoyStick[p_whichthreads[i]] = lps;
            zoro = Parking & Reverse(ps); /* zero out those four bits */
            zoro = zoro | Accelerator[p_whichthreads[i]];
            Parking |= zoro;
            /* Reuse ps */  /*TWEAK THAT FIFTH BIT ALSO */
            if (p_whichthreads[i] != 0)
                ps = PowerSteering(0,1,10 + (p_whichthreads[i] * 5) -5 + 2,Parking);
            else
                ps = PowerSteering(0,1,0,Parking);
            
            zoro &= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned off */
        }

        return Parking |= zoro;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ReadResponseTimes [], LiveDB.WriteResponseTimes [], LiveDB.ReadObjResponseTimes [],
 * @LOOKSY:LiveDB.WriteObjResponseTimes [], LiveDB.FastCommitResponseTimes [], LiveDB.OtherResponseTimes [],
 * @LOOKSY:LiveDB.ReadLineResponseTimes [], LiveDB.WriteLineResponseTimes []
 * @LOOKSY:this.Parking
 *
 * Method Name : protected void RearViewMirror ()
 * Parameters : None
 * Returns : None
 * Data File : None
 *
 * Called From : protected void AttaMaticTransmission ()
 *               protected void PenguinTransmission ()
 *
 * Chained Methods : protected void IgnitionTimingReadOut ()
 *                   private double [] EngineResponseTuning(Long [] p_timing)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : All that this method does is to set the advisory bits starting far right of Parking
 * bit pattern. Zero to indicate that priority needs to be bumped down and 1 to indicate that priority needs
 * to be increased. So to set those advisory bits it first calls method IgnitionTimingReadOut() which fills
 * in the most recent numbers into the *Times array. Then each of those arrays is passed to a method call
 * EngineResponseTuning() and the return value of this method is used to set the advisory bits.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected void RearViewMirror (){
    /*
     * protected Long ReadResponseTimes [];
     * protected Long WriteResponseTimes [];
     * protected Long ReadObjResponseTimes [];
     * protected Long WriteObjResponseTimes [];
     * protected Long FastCommitResponseTimes [];
     * protected Long OtherResponseTimes [];
     * protected Long ReadLineResponseTimes [];
     * protected Long WriteLineResponseTimes [];
     */

     IgnitionTimingReadOut();    /* This will fill numbers into the arrays above */
     
     
     /* threadleash bit 0*/
     if (EngineResponseTuning(LiveDB.ReadResponseTimes)[0] >= 75)
        Parking &= Reverse(PowerSteering (0,1,0,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,0,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadsrtindx bit 1 */
     if (EngineResponseTuning(LiveDB.WriteResponseTimes)[0] >= 75)
        Parking &= Reverse(PowerSteering (0,1,1,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,1,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadrefreshdb bit 2 */  /* this is nearly 90 % readobject which is 9/10 */
     if (EngineResponseTuning(LiveDB.ReadObjResponseTimes)[0] >= (9/10 * 75))
        Parking &= Reverse(PowerSteering (0,1,2,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,2,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadsysexit bit 3 */  /* this thread is nearly 80 % write object which is 8/10 */
     if (EngineResponseTuning(LiveDB.WriteObjResponseTimes)[0] >= (8/10 * 75))
        Parking &= Reverse(PowerSteering (0,1,3,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,3,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadwritetables bit 4 */  /* this thread is 70 % fastcommit which is 7/10*/
     if (EngineResponseTuning(LiveDB.FastCommitResponseTimes)[0] >= (7/10 * 75))
        Parking &= Reverse(PowerSteering (0,1,4,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,4,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadloveall bit 6 */     /* this thread is 100 % reports */
     double db = 0.0D;
     if ((db = EngineResponseTuning(LiveDB.ReportWriterResponseTimes)[0]) >= 75)
        Parking &= Reverse(PowerSteering (0,1,6,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,6,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadroyal bit 5 */  /* this thread has just one report which is 50 % of thread */
     /* totally 33 reports on this application and so this is just 1/33rd !! */
     if (EngineResponseTuning(LiveDB.ReportWriterResponseTimes)[0] >= ((db/33) * 1/2))
        Parking &= Reverse(PowerSteering (0,1,5,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,5,Parking)); /* Increase or bump up priority since all is NOT well */

     /* threadspy bit 7 */ /* only 56.25 % of this thread consists of reports which is 1/2 */
     if (EngineResponseTuning(LiveDB.ReportWriterResponseTimes)[0] >= db/2)
        Parking &= Reverse(PowerSteering (0,1,7,Parking)); /* Reduce or bump down priority since all is well */
     else Parking |= Reverse(PowerSteering (0,1,7,Parking)); /* Increase or bump up priority since all is NOT well */

    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.LiveSharedDB
 * @LOOKSY:this.Parking
 *
 * Method Name :private double [] EngineResponseTuning(Long [] p_timing)
 * Parameters : Long [] p_timing   - The timing row'ids in PlatformClearance table
 * Returns : double [] -- array subscript [0] for min response times expressed as a percentage
 *                        array subscript [1] for mid range response times expressed as a percentage
 *                        array subscript [2] for max response times expressed as a percentage
 * 
 * Data File : None
 *
 * Called From : protected void RearViewMirror ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is just an analysis method that sperates the running times into three
 * buckets and expresses the contents of each bucket as a percentage of the whole. It runs thru a sorted
 * list of running times and seperates them into three buckets of <= 1/3rd, < 2/3rd, >= 2/3rd. Then it
 * returns contents of each of these buckets as a percentage of the whole.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private double [] EngineResponseTuning(Long [] p_timing){
        
     HashMap<Long, String> rtr = new HashMap<Long, String> ();
     TreeSet<Long> ts = new TreeSet<Long> ();
     ArrayList<Long> al = new ArrayList<Long> ();
     Long tsa [] = null;
     String somejunk = null;
     long min = 0L, max = 0L, mid = 0L;
     Long [] rtarr = null;
     int mc = 0, mxc = 0, ctr = 0;


     for (int i = 0; i < p_timing.length; i++)
     {          
         somejunk = rtr.put(((TrainRunningInformation)((PlatformClearance)
         LiveDB.LiveSharedDB[pc][(int)(long)p_timing[i]]).getTrainid()).getRunningtime(),"somejunk");         
     }
     
     rtarr = (Long [])rtr.keySet().toArray();
     for (Long v: rtarr )
               ts.add(v);

     tsa = (Long []) ts.toArray();
     min = tsa[0]; max = tsa[tsa.length -1]; mid = tsa[(int)Math.rint(tsa.length -1)];

     /* re-insert into an arraylist */
     tsa = (Long [])rtr.keySet().toArray();
     
     for (Long v: tsa )
           al.add(v);

     /* re-use tsa */
     tsa = (Long [])al.toArray();
     for (long v: tsa )  
         if (v <= tsa[(int)Math.rint(tsa.length * 1/3)]) mc++;
         else if (v > tsa[(int)Math.rint(tsa.length * 1/3)] || v < tsa[(int)Math.rint(tsa.length * 2/3)]) ctr++ ;
         else if (v >= tsa[(int)Math.rint(tsa.length * 2/3)]) mxc++;


     /* if mc minimum response time is 75 % or more all is well you can bump down
      * the priority. On the other hand if the mxc max response times is >= 50 %
      * then all is not well so bump it up. Then we have also have mid range values
      * in ctr or db[1] how you wish to interpret these values is up to you.
      */
     double db[] = null;
     db[0] = mc/al.size() * 100 ;
     db[1] = ctr/al.size() * 100 ;
     db[2] = mxc/al.size() * 100 ;

     return db;

    }

    protected void IgnitionTimingReadOut (){
        /* This enum is just a trigger which will fill numbers that you need and then since its a local variable dissapears */
        LiveDB.STATIONMASTERSREPORT = false; /* Falsify this so that station masters report is not printed again and again */
        LiveDB.Action AllTimings ;  /* Instantiate this enum it will work as a trigger and fill those numbers you want */
    }

    protected void FuelInjection (boolean p_HEAVYFUEL){
        ; /* paisa mangta hai usd $1,000 very difficult to code */
        /* actually we need to import from Finland and then pay customs duties and
         * then re-export to you and pay export duties and so we pass the bill to you
         * and keep the buck with us.
         */
          /* You wont get source code for this just a compiled Jar */
        /* you can take a made in India fuel Injection for usd $200.00 only */
        /* COPY CATS I WILL KILL ALL RATS RUNNING IN ME STUMICH */
    }

    private boolean TheLastHero (){
        /* Arrives with HeavyFuel */
        return true;
    }


    protected boolean IRobot (Object... p_atyourcommand /* PAISA MUNGTA HAI */ ){
        boolean SmackAKiss = true;
        
        return SmackAKiss;   
    }

    /* You may not use this only driver has privelleges */
    private long IgnitionOff(){
        return LiveDB.RevvoMeter = (Parking &= Reverse(Parking));
    }

    private long IgnitionOn(){
        return LiveDB.RevvoMeter = Neutral();
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.FancyNumberPlates, LiveDB.YourFancyNumberPlate
 * @LOOKSY:this.Parking
 *
 * Method Name : protected static long CustomNumberPlates (String p_YourFancyNumbers)
 * Parameters : String p_YourFancyNumbers
 * Returns : long returned by Roll()
 *
 * Called From : LiveDB::protected static long VROOM ()
 *
 * Data File : None
 *
 * Chained Methods :  private static long Roll()
 *
 *
 * @Since Version : 1.0
 *
 * Running Commentary : if you specify your own 64 bit pattern using LiveDB.YourFancyNumberPlate to start
 * LensView with such as "101010000101000010000100001001010010111010110101101010000000000". The method will
 * validate the bit pattern if p_YourFancyNumbers is null it will plug in a default bit pattern. If all is
 * ok ; all the bits of internal equivalent of LiveDB.RevvoMeter which is Parking are turned on with an |=
 * of this bit pattern. Finally the long returned by Roll () is assigned to LiveDB.RevvoMeter and returned
 * by this method.
 *
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static long CustomNumberPlates (String p_YourFancyNumbers){

        if (p_YourFancyNumbers.length() != 64)
        {
            System.err.println(LiveDB.grassHopper("VROOM ABORTED YOUR NUMBER PLATE ISNT 64 BINARY DIGITS" + p_YourFancyNumbers));
	    JOptionPane.showMessageDialog(appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
            System.exit(1); /* dont do a smooth exit here */
        }

        if (p_YourFancyNumbers == null)
        {                           //"101010000101000010000100001001010010111010110101101010000000000"
            Parking |= Long.parseLong("101010000101000010000100001001010010111010110101101010000000000",2);
            LiveDB.FancyNumberPlates = true;
        }
        else
        {
            try{
                   Parking |= Long.parseLong(p_YourFancyNumbers,2);
                   LiveDB.FancyNumberPlates = true;
               }catch (NumberFormatException ex_YESKIA57){
                   Parking |= Long.parseLong("101010000101000010000100001001010010111010110101101010000000000",2);
                   LiveDB.FancyNumberPlates = false;
               }
        }
        return LiveDB.RevvoMeter = Roll();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.Parking
 *
 * Method Name : protected static boolean AbortTakeOff (long [] p_Accelerate)
 * Parameters : long [] p_Accelerate
 * Returns : boolean true indicating abort take off
 *           boolean false indicating you may take off
 *
 * Called From : private static long Roll()
 *
 * Data File : None
 *
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method checks if there are too many high priority numbers in p_Accelerate
 * which is nothing but long [] Accelerator OR there are too many threads with same priority and priority
 * greater than or equal to five. Returns boolean true to indicate that take off must abort. Otherwise it
 * returns false to indicate that priorities in p_Accelerate are okay and one can proceed with take off.
 * Basically you just cant set any fancy numberplate it needs to comply with the rulebook that there cant
 * be five or more light weight processes with priority greater than seven. Your fancy numberplate also
 * needs to comply with the rule that five or more light weight processes with process priorities higher
 * than five cannot have the same priority.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean AbortTakeOff (long [] p_Accelerate){
        int i = 0, l = 0, p = 0 ;
        for (i = 0, l = 0, p = 0 ; i < p_Accelerate.length ; i++ )
        {
            if (p_Accelerate[i] >= 7) l++; /* too many high priority numbers ? */
            else if (p_Accelerate[i] == p_Accelerate[i+1] && p_Accelerate[i] >= 5) p++;
                          /* too many threads with same priority */
        }

        if (l > 4 || p > 4)
        {
            LiveDB.ALRTLVL = 1;
            System.err.println(LiveDB.grassHopper("Key Robber Alert TakeOff Aborted"));
            System.err.println ("LINE" +  ":" + String.valueOf(LiveDB.logerrorno) + " " + (l > 3 ? "TOO MANY HIGH PRIORITY THREADS " : p > 5 ? "TOO MANY THREAD WITH SAME PRIORITY" :
                " ") + "\n");
            return true;
        }
        else return false;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.Parking
 *
 * Method Name : private static long Roll()
 * Parameters : None
 * Returns : long this.Parking
 *
 * Called From : protected static long CustomNumberPlates (String p_YourFancyNumbers)
 *
 * Data File : None
 *
 * Chained Methods :  protected static boolean AbortTakeOff (long [] p_Accelerate)
 *                    protected static long [] TakeOffTaxiWay ()
 *
 * Associated Methods : private static void PullTrigger ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method calls AbortTakeOff() and if that returns true does a System.exit(1).
 * If AbortTakeOff () is false it calls PullTrigger() and then returns Parking. Note AbortTakeOff is
 * passed a long value returned by TakeOffTaxiWay (). That long value returned by TakeOffTaxiWay is
 * nothing but the long[] Accelerator.
 *
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static long Roll(){

        if (AbortTakeOff(TakeOffTaxiWay()) == false)
           PullTrigger();
        else
        {
            LiveDB.ALRTLVL = 1;
            System.err.println(LiveDB.grassHopper("Key Robber Alert TakeOff Aborted"));
	    JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
            System.exit(1);
        }
        return Parking;
    }

 
/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.Parking. this.FastenSeatBeltsSign, this.JoyStick, this.Accelerator
 *
 * Method Name : private static long [] TakeOffTaxiWay ()
 * Parameters : None
 * Returns : long [] Accelerator
 *
 * Called From :  private static long Roll()
 *
 * Data File : None
 *
 * Associated Methods : protected static long PowerSteering (int p_direction, int p_howmanybits, int p_bitpos,
 *                                                                                           long p_fromwhere)
 *                      protected static long RightIndicator (long p_onwhichturn, long p_howmuch)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : All that this method does is to extract from that bit pattern in Parking and set
 * the Accelerator which is nothing priority for different threads and then it returns Accelerator to the
 * calling method.
 *
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 9th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    private static long [] TakeOffTaxiWay (){

        long ps = 0L, rps = 0L, lps = 0L;  /* split it up for simplicity and readability */
        long zoro = Parking;
        int p_WhichTrack = 1;

        do{
            ps = PowerSteering(0,4,10 + (p_WhichTrack * 5) -5 + 2 -1,Parking);
            rps = RightIndicator (ps,10 + ((p_WhichTrack * 5) -5 +1));

            if (rps <= 0)
            {
                System.err.println(LiveDB.grassHopper("Zero priority auto corrected"));
                rps = (long)LiveDB.Priority.PASSENGER.ordinal(); /* some error in program auto correct */
            }
            
            if (rps > 10)
            {
                System.err.println(LiveDB.grassHopper("priority more than ten auto corrected"));
                rps = (long)LiveDB.Priority.BULLETTRAIN.ordinal(); /* some error in program auto correct */
            }
            
            Accelerator[p_WhichTrack] = rps;

            lps = LeftIndicator (rps, 10 + ((p_WhichTrack * 5) -5 + 1));
            JoyStick[p_WhichTrack] = lps;  /* so both sides zero in lps other than four priority bits */
            zoro = Parking & Reverse(ps); /* zero out those four bits */
            zoro = zoro | lps;
            Parking |= zoro;
            /* Reuse ps */
            ps = PowerSteering(0,1,10 + ((p_WhichTrack * 5) -5 + 1 -1),Parking);
            zoro |= Reverse(ps); /* that fifth bit of every sequence of bits has to be turned on */
            
        }while (++p_WhichTrack <= LiveDB.MAXTHREADS);
        FastenSeatBeltsSign = true;
        System.out.print('\b' + '\b' + '\b' + '\b' + '\b' );
        return Accelerator;
    }

    protected static long getAltitude (){
        return (new Date().getTime() - LiveDB.today.getTime());
    }

    protected static Date getTakeOffTimes (int p_whichthread){
        return TakeOffTimes[p_whichthread];
    }

    protected static long getFlyingTimes (int p_whichthread){
        
        return LandingAltitude(p_whichthread)[1];  /* This is more accurate */
        /* return TakeOffTimes[p_whichthread].getTime() - LandingTimes[p_whichthread].getTime(); */
    }

    protected static Date getLandingTimes (int p_whichthread){
        return LandingTimes[p_whichthread];
    }

/*
 * WIRING DIAGRAM :
 * Method Name : protected static boolean OnRadar (int p_whichthread)
 * Parameters : int p_whichthread -- Internal thread number
 * Returns : boolean true if this internal thread id p_whichthread has been started and has not died
 *           boolean false if this internal thread id p_whichthread has died
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Running Commentator
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean OnRadar (int p_whichthread){
        boolean Spotted = false;
        switch (p_whichthread){
            case 0:
                Spotted = InstallDB.threadcontroller.isAlive();
                break;
            case 1:
                Spotted = InstallDB.threadleash.isAlive();
                break;
            case 2:
                Spotted = InstallDB.threadsrtindx.isAlive();
                break;
            case 3:
                Spotted = InstallDB.threadrefreshdb.isAlive();
                break;
            case 4:
                Spotted = InstallDB.threadsysexit.isAlive();
                break;
            case 5:
                Spotted = InstallDB.threadwritetables.isAlive();
                break;
            case 7:
                Spotted = InstallDB.threadroyal.isAlive();
                break;

            case 8:
                Spotted = InstallDB.threadloveall.isAlive();
                break;
            case 9:
                Spotted = InstallDB.threadspy.isAlive();
                break;
            case 10:
                Spotted = InstallDB.threadgui.isAlive();
                break;
            default:
                break;
       }
       return Spotted;
   }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.LiveSharedDB
 * @LOOKSY:this.TakeOffTimes, this.LandingTimes, this.ActualThreadIDs,
 *
 * Method Name : protected static long [] LandingAltitude (int p_Witch)
 * Parameters : int p_Witch
 * Returns :long []
 *
 * Data File : None
 *
 * Calling Methods : protected static void EngineThrust ()
 *                   protected static void CalculateTailWinds (int p_whichthread)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : What this method does is to add up all the current running times for this thread
 * as flt. Then it adds up all the previous flying times in pft. Then it returns a long array where
 * subscript [0] is the pft - flt (which is the time needed to complete the request) and subscript [1]
 * as flt which is the running time for the thread still running. These calling methods use subcript [0]
 * for some processing.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 12th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static long [] LandingAltitude (int p_Witch){


       long [] retthis = null;
       if (TakeOffTimes[p_Witch] != null && LandingTimes[p_Witch] != null )
       {
           retthis[0] = -1L; retthis[1] = LandingTimes[p_Witch].getTime() - TakeOffTimes[p_Witch].getTime();
           return retthis;  /* Flight has already landed */
       }
       
       TreeSet<Date> rd = new TreeSet<Date>();

       
       boolean ok = false;
       long [] rid = null;
       int ti = 0;
       Long [] Pid = null;
       HashMap<Long,String> rpid = new HashMap<Long,String>();
       String somejunk;


       /* Get all request times after TakeOff time */
       for ( int i = 0; i < LiveDB.LiveSharedDB[pc].length; i++ )
       {
           if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getRequest_time().getTime() 
                                                 >= ThreadController.TakeOffTimes[p_Witch].getTime())
               rd.add(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getRequest_time());
       }

       Date [] rda = (Date [])rd.toArray();

       for ( int i = LiveDB.LiveSharedDB[pc].length -1; i >= 0 ; i-- )
       {
           for (int y = rda.length -1; y >= 0; y--)
           {
                if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getRequest_time() == rda[y])
                {
                    for (int k = 0; k < ActualThreadIDs.length; k++)
                    {
                        if (ActualThreadIDs[k] ==  /* we are trying to get total of current execution times for this thread so this check */
                            ((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getTrack())
                        {
                            if ((((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getITrack())
                                    == p_Witch)
                            {
                                rid [rid.length] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getRowid();
                                somejunk = rpid.put(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getSid(),"somejunk");
                                ok = true; break; /* break out of this inner loop but continue with outermost loop */
                            }
                        }
                    }
                    if (ok == true) {ok = false; break;}
                }
           }
       }

       Pid = ((Long [])rpid.keySet().toArray());
       
       long flt = 0L;  // this is flying time
       int i=0,j=0;
       
       tosearch:
       for (; i < rid.length; i++)
       {
           if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][(int)rid[i]])).getSid() == Pid [j])
           {
               if (((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc]
                       [(int)rid[i]])).getTrainid())).getAccident() != null)
               {
                   j++; continue tosearch; /* Whoops we dont want accident times get clean times */
               }
               else
               {
                   flt += ((TrainRunningInformation)(((PlatformClearance)
                           (LiveDB.LiveSharedDB[pc][(int)rid[i]])).getTrainid())).getRunningtime();
                   j = 0;
               }
           }
       }  /* WE GOT CURRENT FLYING TIME IN FLIGHT BUT WE HAVE NOT LANDED YET */       


       /* now let us get previous flying time for the same thread */
 
       rd.clear();   /* reuse */

       /* Get all request times after midnight time and before you logged in */
       for ( int p = 0; p < LiveDB.LiveSharedDB[pc].length; p++ )
       {
           if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][p])).getRequest_time().getTime() >= LiveDB.midnight.getTime()
               && ((PlatformClearance)(LiveDB.LiveSharedDB[pc][p])).getRequest_time().getTime() < LiveDB.today.getTime())
               rd.add(((PlatformClearance)(LiveDB.LiveSharedDB[pc][p])).getRequest_time());
       }
       rda = (Date [])rd.toArray();
       rid = null;
       for ( int h = LiveDB.LiveSharedDB[pc].length -1; h >= 0 ; h-- )
       {
           for (int y = rda.length -1; y >= 0; y--)
           {
                if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][h])).getRequest_time() == rda[y])
                {
                    if ((((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][h])).getTrainid())).getITrack())
                                    == p_Witch)
                    {
                        rid [rid.length] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][h])).getRowid();
                        somejunk = rpid.put(((PlatformClearance)(LiveDB.LiveSharedDB[pc][h])).getSid(),"somejunk");
                        ok = true; break; /* break out of this inner loop but continue with outermost loop */
                    }                    
                    if (ok == true) {ok = false; break;}
                }
           }
       }

       
       HashMap<Date,Date> dt = new HashMap<Date,Date>();
       HashMap<Date,Date> at = new HashMap<Date,Date>();
       Pid = ((Long [])rpid.keySet().toArray());
       i=0;j=0; /* reuse */
       long pft = 0L;
       
       tosearch:
       for (; i < rid.length; i++)
       {
           if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][(int)rid[i]])).getSid() == Pid [j])
           {
               if (((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getAccident() != null)
               {
                   j++;continue tosearch; /* Whoops we dont want accident times get clean times */
                   /* do a j++ to skip this pid which had an accident time */
               }
               else
               {
                   dt.put(((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getDeparturetime(),
                           ((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getArrivaltime());
                   at.put(((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getArrivaltime(),
                           ((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getDeparturetime());
                   pft += ((TrainRunningInformation)(((PlatformClearance)(LiveDB.LiveSharedDB[pc][i])).getTrainid())).getRunningtime();
                   j = 0;
               }
           }
       } /* WE GOT THE PREVIOUS FLYING TIME BUT HOW DO I KNOW THAT THE THREAD COMPLETED ITS FULL CYCLE ??? */

       /* we have gathered the departure and arrival times for the same thread for analysis */

       Date dta [] = (Date [])dt.keySet().toArray();  /* departure times */
       Date ata [] = (Date [])at.keySet().toArray();  /* arrival times */

       /* so based on such and such departure times these were the arrival times for this pft (flying time) */

       retthis[0] = pft - flt; retthis[1] = flt;
       return retthis; /* This is the landing altitude number interpret as you want */
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.LandingAltitudes
 *
 * Method Name : protected static void EngineThrust ()
 * Parameters : None
 * Returns : None
 * Data File : None
 *
 * Called From : protected void AttaMaticTransmission ()
 *
 * Associated Methods : protected static long [] LandingAltitude (int p_Witch)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : All that this method does is to set the advisory bits starting far right of Parking
 * bit pattern. Zero to indicate that priority needs to be bumped down and 1 to indicate that priority needs
 * to be increased. So to set those advisory bits it first calls method LandingAltitude() which fills in the
 * LandingAltitudes [] for each thread. Now check if there are less than four minutes to Land and tweak that
 * bit to 0(zero) to reduce engine thrust.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   protected static void EngineThrust (){
       /* THIS IS NOT FOR YOU KIDDOS THIS FOR EXPREIENCED BOEING COMMANDERS WHO CANT FLY !! */
       /* Just in case the pilot is a jerk and so is the Co-Pilot we take over automatically.
        * This is far superior to Attamatic/Penguin Transmission If the thread has just a few
        * thousand milliseconds worth of flight left then why increase the EngineThrust we will
        * reduce it to Land !!!
        */
        
        int mnts4 = 1000 * 60 * 4; /* 4 minutes */

        for (long i = 0; i <= LiveDB.MAXTHREADS; i++)
            LandingAltitudes[LandingAltitudes.length] = LandingAltitude((int)i)[0];

        /* Now check if there are less than 4 minutes to Land and tweak that bit to 0(zero) to reduce engine thrust */

             /* threadleash bit 0*/
        if (LandingAltitudes[0] < mnts4 && LandingAltitudes[0] >= 0)
        {
            Parking &= Reverse(PowerSteering (0,1,0,Parking)); /* Reduce or bump down priority since all is well */
        }
        else Parking |= Reverse(PowerSteering (0,1,0,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadsrtindx bit 1 */
        if (LandingAltitudes[1] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,1,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,1,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadrefreshdb bit 2 */  /* this is nearly 90 % readobject which is 9/10 */
        if (LandingAltitudes[2] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,2,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,2,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadsysexit bit 3 */  /* this thread is nearly 80 % write object which is 8/10 */
        if (LandingAltitudes[3] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,3,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,3,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadwritetables bit 4 */  /* this thread is 70 % fastcommit which is 7/10*/
        if (LandingAltitudes[4] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,4,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,4,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadloveall bit 6 */     /* this thread is 100 % reports */
        
        if (LandingAltitudes[5] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,5,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,5,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadroyal bit 5 */  /* this thread has just one report which is 50 % of thread */
        /* totally 33 reports on this application and so this is just 1/33rd !! */
        if (LandingAltitudes[6] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,6,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,6,Parking)); /* Increase or bump up priority since all is NOT well */

        /* threadspy bit 7 */ /* only 56.25 % of this thread consists of reports which is 1/2 */
        if (LandingAltitudes[7] < mnts4 && LandingAltitudes[0] >= 0)
            Parking &= Reverse(PowerSteering (0,1,7,Parking)); /* Reduce or bump down priority since all is well */
        else Parking |= Reverse(PowerSteering (0,1,7,Parking)); /* Increase or bump up priority since all is NOT well */
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.LandingAltitudes
 *
 * Method Name : protected static void CalculateTailWinds (int p_whichthread)
 * Parameters : int p_whichthread
 * Returns : None
 * Data File : None
 *
 * Called From : protected void ManualTransmission ()
 *               private void AlterPriority (int p_whichthread, int p_bump)
 *
 * Associated Methods : protected static long [] LandingAltitude (int p_Witch)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : All that this method does is to sort all other threads other than p_whichthread in
 * ascending order based on time left for arrival.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static void CalculateTailWinds (int p_whichthread){

       /* Other than this thread p_whichthread sort the rest */
       
       long tmp [] = null;
       long tmp1 [][] = null;
       long TW [][] = null;

       long LA [] = getLandingAltitudes();

       long srt [] = null;

       if ((LA = getLandingAltitudes()).length == 0)  /* Fill it Up */
       {
          for (long i = 0; i <= DashBoardGPS.THREADAUTOBACKKUP.ordinal(); i++)
              LandingAltitudes[LandingAltitudes.length] = LandingAltitude((int)i)[0];
       }

       LA = getLandingAltitudes();
       srt[0] = LA[0];
       TW[0][0] = LA[0];
       TW[0][1] = 0;
       for (int i = 0, j = 0; i < LA.length; i++)
       {
           if (i != p_whichthread)
           {
                if (LA[i] >= srt[j])
                {
                    srt[srt.length] = LA[i];
                    TW[TW.length][0] = LA[i];
                    TW[TW.length][1] = i;
                    j = srt.length -1;
                }
                else
                {
                    tmp[tmp.length] = srt[srt.length -1];
                    srt[srt.length -1] = LA[i];
                    srt[srt.length -1] = tmp[tmp.length -1];
                    tmp1[tmp1.length][0] = TW[TW.length -1][0];
                    tmp1[tmp1.length][1] = TW[TW.length -1][1];
                    TW[TW.length -1][0] = LA[i];
                    TW[TW.length -1][1] = i;
                    TW[TW.length -1][0] = tmp1[tmp1.length -1][0];
                    TW[TW.length -1][1] = tmp1[tmp1.length -1][1];
                    j = srt.length -1;
                }
          }
       } /* for */

       // the above sort is in ascending order you can return that if you want the method to return ascending OR
       // or take this descending sort
       
       for ( int i = TW.length -1, j = 0; i >= 0; i-- )
       {
           tmp1[j][0] = TW[i][0]; tmp1[j][1] = TW [i][1];           
       }
              
       System.arraycopy(tmp1, 0, TailWinds, 0, tmp1.length);
       
   } /* protected static void CalculateTailWinds () */
}
