/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.EOFException;
import java.io.Externalizable;
import java.io.File;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.io.UTFDataFormatException;

/**
 *
 * @author SAI KRISHNA
 */
public class WildLifeTypes implements Externalizable, Cloneable {
    private String scientificname;
    private String populationcount;
    private String deathcount;
    private String pregnancycount;
    private String birthcount;
    private String diseasecount;
    private String radiotags;

    private transient WildLifeTypes wld;
    private transient File srf;
    private transient int itn ;
    private transient long fieldchanges ;

    public WildLifeTypes (){
        scientificname = " ";
        populationcount = " ";
        deathcount = " ";
        pregnancycount = " ";
        birthcount = " ";
        diseasecount = " ";
        radiotags = " ";
    }

    public WildLifeTypes (String p_scient, String p_popu, String p_death, String p_preg,
           String p_birth, String p_disease, String p_radio) {
           setScientificname(p_scient);
           setPopulationcount(p_popu);
           setDeathcount(p_death);
           setPregnancycount(p_preg);
           setBirthcount(p_birth);
           setDiseasecount(p_disease);
           setRadiotags(p_radio);
    }
    
    @Override
    protected Object clone () {

        try {

            wld = (WildLifeTypes)super.clone ();
            wld.setScientificname(wld.getScientificname());
            wld.setPopulationcount(wld.getPopulationcount());
            wld.setDeathcount(wld.getDeathcount());
            wld.setPregnancycount(wld.getPregnancycount());
            wld.setBirthcount(wld.getBirthcount());
            wld.setDiseasecount(wld.getDiseasecount());
            wld.setRadiotags(wld.getRadiotags());

        }catch (CloneNotSupportedException ex_NOKIA5){
            throw new InternalError (ex_NOKIA5.toString());
        }

        return wld;
    }

    protected int SIZEOF () {
       return (scientificname.length() * 2) + (populationcount.length() * 2) + (deathcount.length() * 2)
               + (pregnancycount.length() * 2) + (birthcount.length() * 2) + (diseasecount.length() * 2)
               + (radiotags.length() * 2) ;
    }
    
    protected String getScientificname () {
        return new String (scientificname.trim().toCharArray());
    }

    protected String getPopulationcount () {
        return new String (populationcount.trim().toCharArray());
    }

    protected String getDeathcount () {
        return new String (deathcount.trim().toCharArray());
    }

    protected String getPregnancycount () {
        return new String (pregnancycount.trim().toCharArray());
    }

    protected String getBirthcount () {
        return new String (birthcount.trim().toCharArray());
    }

    protected String getDiseasecount () {
        return new String (diseasecount.trim().toCharArray());
    }

    protected String getRadiotags () {
        return new String (radiotags.trim().toCharArray());
    }

    // dont take rowlock in any of these setters dummy
    void setScientificname (String p_url) {
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        scientificname = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }

    void setPopulationcount (String p_url) {
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        populationcount = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }

    void setDeathcount (String p_url) {
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        deathcount = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }

    void setPregnancycount (String p_url) {
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        pregnancycount = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }

    void setBirthcount (String p_url){
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        birthcount = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }

    void setDiseasecount (String p_url){
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        diseasecount = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }

    void setRadiotags (String p_url) {
        if (NodalInfo.validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }

        radiotags = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
    }


    @Override
    public final void readExternal (ObjectInput stream) throws EOFException, IOException {
        try{
              scientificname = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field scientificname"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field scientificname"));
              throw new UTFDataFormatException ();
              // throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field scientificname"));
              throw new IOException ();
        }

        try{
              populationcount = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field populationcount"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field populationcount"));
              throw new UTFDataFormatException ();
              // throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field populationcount"));
              throw new IOException ();
        }

        try{
              deathcount = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field deathcount"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field deathcount"));
              throw new UTFDataFormatException ();
              //throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field deathcount"));
              throw new IOException ();
        }

        try{
              pregnancycount = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field pregnancycount"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field pregnancycount"));
              throw new UTFDataFormatException ();
              //throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field pregnancycount"));
              throw new IOException ();
        }

        try{
              birthcount = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field birthcount"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field birthcount"));
              throw new UTFDataFormatException ();
              // throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field birthcount"));
              throw new IOException ();
        }

        try{
              diseasecount = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field diseasecount"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field diseasecount"));
              throw new UTFDataFormatException ();
              // throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field diseasecount"));
              throw new IOException ();
        }

        try{
              radiotags = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal WildLifeTypes Field radiotags"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal WildLifeTypes Field radiotags"));
              throw new UTFDataFormatException ();
              // throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal WildLifeTypes Field radiotags"));
              throw new IOException ();
        }        
    }

    @Override
    public final void writeExternal (ObjectOutput stream) throws IOException {
        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(scientificname);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field scientificname"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(populationcount);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field populationcount"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(deathcount);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field deathcount"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(pregnancycount);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field pregnancycount"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(birthcount);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field birthcount"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(diseasecount);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field diseasecount"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(radiotags);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class WildLifeTypes Field radiotags"));
              throw new IOException ();
        }

    }
}
